/************************************************************************
*									*
*	Detta {r ett exempel p} hur en blanketteditor kan se ut		*
*									*
************************************************************************/
#include <stdio.h>
#include "ble.h"

/* "ble_rad" och en buffert av typen "trf" m}ste finnas: */
	int	ble_rad;	/* errorrad */
static	trf	buffert;	/* buffert foer rubriker o faelt */

main(argc,argv)
int	argc;
char	*argv[];
{
	int	err;		/* errorcode */
	FILE	*datafile;	/* filen */
	tbl	bl;		/* blanketten */
	int	i;

	if (argc < 3)		/* foer faa argument */
		printf("Usage: %s%s",argv[0]," attribute-file data-file\n");
	else {
		if ( (err = syntax(argv[1],&bl,buffert)) != 0 ) {
			printf("fel vid syntaxkontroll, felkod: %d, felrad: %d\n",err,ble_rad);
			exit(0);
		}
		if (( datafile = fopen(argv[2],"a")) == NULL) {
			printf("fel vid open av %s\n",argv[2]);
			exit(0);
		}
/* bildsk{rmen m}ste initieras f|re editering: */
		if (err = scrini() ) {	/* m}ste initieras f|re editering */
			scrrel();
			printf("fel vid init av bildsk{rm, felkod: %d\n",err);
			exit(0);
		}
/* se till att rubrikerna blir displayade: */
		bl.rubdisp = 1;
/* fyll i defaultv{rden i f{lten: */
		for ( i = 0 ; i < bl.fbuflen ; ++i )
			bl.flptr[i] = bl.dvptr[i];
/* editera en sida: */
		edit(&bl);
/* releasa bildsk{rmen: */
		scrrel();
		fwrite (bl.flptr,1,bl.fbuflen,datafile);
		fclose(datafile);
	}
}
/**/
/************************************************************************
 *									*
 *	Edittime och exit-rutirnerna					*
 *									*
 ************************************************************************/

#define	NUMRUT	((sizeof checktabell) / (sizeof(struct checkrutiner)))

char	*Dversal(),*Xdatum();

struct checkrutiner {		/* koppling mellan checkrutinernas namn	*/
	char	*namn;		/* och deras adresser, rutinernas namn	*/
	PFCP	rutin;		/* maaste boerja med D(editcheck) eller	*/
	} checktabell [] = {	/* X(exitcheck). De anropas alltid med	*/
	{"Dversal",Dversal},	/* tvaa parametrar: bl och faeltnr.	*/
	{"Xdatum",Xdatum},
	};

/**/
/****************************************************************/
/*	kontrollera om checkrutinen finns
/****************************************************************/
PFCP findcheck(str)
char	*str;
{
	int	i;
	int	eq;


	for ( i = 0 ; ( (eq = strcmp(str,checktabell[i].namn)) != 0 && i < NUMRUT ) ; ++i );

	if ( eq == 0 )
		return ( checktabell[i].rutin );
	else
		return (0);
}
/**/
/****************************************************************/
/*	konvertera till versaler				*/
/****************************************************************/
char *Dversal(bl,faeltnr)
tbl	*bl;
int	faeltnr;
{
	if ( kommando >= 'a' && kommando <= '~' )
		kommando &= 0xDF;
	return (0);

}
/**/
/****************************************************************/
/*	kontrollera att faeltet aer ett datum: AAMMDD		*/
/****************************************************************/
char *Xdatum(bl,faeltnr)
tbl	*bl;
int	faeltnr;
{
	char	*data;
	int	y,m,d;
	int	i;

	data = bl->fl[faeltnr].data;

	for ( i = 0 ; i < 6 ; ++i )
		if ( '0' > data[i] || data[i] > '9' )
			return ( "endast numeriska tecken i datum" );

	y = (data[0] & 0x0F) * 10 + (data[1] & 0x0F);
	m = (data[2] & 0x0F) * 10 + (data[3] & 0x0F);
	d = (data[4] & 0x0F) * 10 + (data[5] & 0x0F);

	if ( y < 0 || 99 < y )
		return ( "felaktigt }rtal" );
	if ( m < 1 || 12 < m )
		return ( "felaktig m}nad" );
	if ( d < 1 || 31 < d )
		return ( "felaktig dag" );

	return (0);
}
/**/
/****************************************************************/
/*	helprutin, returnerar ett meddelande som skall visas	*/
/*	paa sista raden						*/
/****************************************************************/
char *help(bl,faeltnr)
tbl	*bl;
int	faeltnr;
{
static	char	str[80];

	sprintf(str,"f{ltnr: %d l{ngd: %d",faeltnr,bl->fl[faeltnr].len);
	return(str);
}
