 Interpretatorn skall i "batch-mode" kunna hantera olika
kommandon. Vissa kommandon kan ha parametrar, parametrar anges
efter kommandot }tskillt av blank, komma eller tab. P} varje rad
f}r kommentarer skrivas efter en apostrof ('). Som parametrar
kan anges decimala eller hexadecimala v{rden eller idendifierare
definierade i FOR-kommandon, dessutom finns ett antal
f|rdefinierade identifierare. F|r vissa kommandon {r
parametrarnas v{rden begr{nsade av max och min-v{rden, om
gr{nsv{rdena |verskrids under testens g}ng utf|rs inte
kommandot, vilket {ven meddelas p} loggen. 


%title 3	Kommandofilen.

 Testsekvenserna f|r TMC-systemet ligger lagrade i en
kommandofil. Varje rad i kommandofilen inneh}ller h|gst ett
kommando. Till varje kommando kan det finnas en eller flera
parametrar. Kommandon och parametrar avskiljs med blank, tab
eller komma. Om en parameter skall best} av en textstr{ng m}ste
det vara citationstecken (") omkring texten. 

 F|re ett test s{tter i g}ng scannas kommandofilen igenom och
tv} l{nkade listor skapas, en med kommandon och en med
variabler. 

 Varje l{nk i kommandolistan inneh}ller: hela den inl{sta raden,
kommando, pekare till n{sta kommando i den l{nkade listan, ev.
pekare till annan l{nk (bara FOR och NEXT-.kommandona) och
radnummer i kommandofilen. Blankrader eller rader som bara
inneh}ller kommentarer allokerar inget minne i den l{nkade
listan. 


%title 3	Kommandon och deras parametrar. 

F|ljande kommandon finns. Parametrar inom parenteser kan utl{mmnas
och ers{tts d} ett defaultv{rde.

KOMMANDO,PARAMETRAR


FOR loopvariabel,startv{rde,stoppv{rde(,steg)

   Initierar v{rdet p} <loopvariabel> till <startv{rde> och
  kontrollerar om loopvaribelns v{rde {r st|rre {n <stoppv{rde>,
  forts{tter i s} fall till kommandot efter mots. NEXT-kommndo.
  Om <steg>-v{rdet {r negativt kontrolleras ist{llet om
  loopvariabelns v{rde {r l{gre {n slutv{rdet. For-kommandot kan
  ocks} anv{ndas om man bara vill initiera en variabels v{rde,
  vilket g|rs genom att g|ra en dummyloop som inte genoml|ps.
  Defaultv{rde f|r steg {r 1. Startv{rde, stoppv{rde och steg
  kan vara variabler eller v{rden. Det kan h|gst finnas 15
  niv}er p} for-next looparna 
%page
NEXT

   R{knar upp motsv. FOR-kommandos <loopvariabel> med <steg>.
  Repeterar testf|rloppet fr}n motsvarande FOR-kommando om
  identifierarens v{rde {r mindre {n eller lika med
  <stoppv{rde>. Om steg {r negativt g{ller att identifierarens
  v{rde skall vara st|rre eller lika med <stoppv{rde> Annars
  forts{tter testf|rloppet med n{sta kommando. 


UTSIGNAL portnr,utdata(,mask)

   Skickar kommando till mddmkontrollern med <utdata> maskat med
  <mask> och <portnr>, defaultv{rde p} <mask> {r 255. V{rdena p}
  portnummer, indata och mask skall vara mellan 0 och 255.
  Samtliga parametrar kan vara variabler eller v{rden. 


INSIGNAL portnr,indata(,mask)(,feltext)

   skickar kommando till kortet om att l{sa av <portnr>. Maskar
  l{st v{rde med <mask>, j{mf|r med <indata>, om det inte {r
  lika skrivs meddelande p} logg-listan, om <feltext> angets
  skrivs den ocks} p} loggen vid felutskrift, defaultv{rde p}
  <mask> {r 255. V{rdena p} portnummer, indata och mask skall
  vara mellan 0 och 255, de kan vara variabler eller v{rden.
  Om <feltext> angetts skall det vara en textstr{ng. 


RAMTEST (startadress,slutadress)

   Skickar kommando till mddmkontrollern att utf|ra ramtest
  mellan <startadress> och <slutadress>, om inga intervall anges
  eller b}da adresserna {r noll utf|rs ramtest p} allt ram. Om
  adresserna {r lika men inte noll utf|rs ingen test. Om testet
  misslyckas skrivs meddelande p} loggen. Parametrarnas v{rde
  m}sta vara mellan 0 och 65535, och slutadressen st|rre {n
  startadressen. B}da parametrar skall vara variabler eller
  v{rden. 


PROMTEST

   Skickar promtestkommando till mddmkontrollern och loggar om
  prommets checksumma inte {r noll. 


WATCHDOG

   Testar att WATCHDOG-funktionen p} mddmkontrollern fungerar.
  Om inget svar erh}lls fr}n kortet inom 1 min skrivs ett fel
  meddelande p} loggen. Normalt sett skall svar komma efter ca.
  20 sek 
%page
TEMP temperatur

   S{tter temperaturen till <temperatur>. Ej implementerat {nnu. 


SPANNING sp{nning

   Skickar kommando till sp{nningsaggregatet att {ndra
  sp{nningen till <sp{nning>. Om 0 volt valts kommer {ven
  sp{nnings- aggregatet att kopplas bort med hj{lp av
  kortv{xeln. Kontroll sker att sp{nning ligger mellan 0 och
  5.250 volt. Parametern kan vara en variabel eller ett v{rde. 


ANALOG analogsp{nning

   Skickar kommando till sp{nningsaggregatet att {ndra
  sp{nningen p} den analoga utg}ngen till <analogsp{nning>.
  (Dennna utg}ng anv{nds normalt f|r str|minst{llning. Eftersom
  str|mmen {r konstant anv{nds i st{llet denna utg}ng f|r test
  av analoga kretsar). Kontroll sker att sp{nning ligger mellan
  0 och 5.250 volt. Parametern kan vara en variabel eller ett
  v{rde. 


PAUS sek 

   Avbryter testen under <sek> sekunder. Kontroll sker att antal
  sekunder {r mellan 1 och 1000. 


LOGG meddelande(,meddelande...)

   Skriver ett eller flera (max 10 st) meddelanden p} loggen.
  Meddelandena kan vara en textstr{ngar, variabler eller v{rden 


OBJEKT kort

   Skickar kommando till kortv{xeln att v{xla in ett nytt kort,
  och inv{ntar att det sker, <kort> {r det logiska nummret p}
  kortet. Valt objekt m}ste vara mellan 1 och antal objekt som
  matats in (ANT_OBJ). Antal objekt som finns best{ms av hur
  m}nga id-f{lt som operat|ren fyllt i. Objekt 1 {r allts}
  f|rsta kortplats som det angetts id till och inte
  n|dv{ndigtvis hylla 1 kortplats 1. 


SETNOV

   Skickar kommando till mddmkontrollern, att skriva ett
  f|rdefinierat m|nster i nov-ram samt att g|ra en store-puls.
  Detta b|r g|ras mycket sparsamt efersom det sliter p}
  novramet. 
%page
CHKNOV

   Skickar kommando till mddmkontrollern att kontrollera om det
  fortfarande st}r samma m|nster i nov-ram som setnov har
  skrivit dit. 


RESET

   Kortet resetar sig genom att aktivera resetsignalen.
  Kontrollerar sedan att det verkligen blivit en reset. Ej
  implementerat {nnu. 


SIOTEST

   Kortet testar SIO-kretsen genom att {ndra p} sion's
  statussignaler och kontrollera dem och genom att skicka ett
  tecken p} B-sidan och kontrollera at det kommer tillbaka.
  F|ruts{tter att det finns byglingar p} RS232-kontakterna. P}
  b}de A och B-kanalen byglas stift 4-5-6 och 20-8 enbart p}
  B-kanalen byglas stift 2-3. 


IOPORT l{gstaport,h|gstaport

   Allokerar minne i PC'n f|r att kunna ha separata felr{knare
  f|r varje I/O-port p} korten. De portar som ha egna felr{knare
  anges som parametrar, de f}r inte vara variabler utan m}ste
  vara konstanter. Kommandot kan bara utf|ras en g}ng i en
  testsekvens. Om det f|rekommer fler g}nger ignoreras detta men
  felmeddelande skrivs ut. <L{gstaport> och <h|gstaport> anger
  inom vilket intervall portarna ligger. 


%title 3	Kommentarer. 

 Kommentarer inleds med apostrof ('). En rad kan best} enbart av
en kommentar, eller kan kommentaren st} efter ett kommando. 
%page
%title 3	Syntaxcheck.

 Samtidigt som den l{nkade listan byggs upp kontrolleras det om
det finns n}gra syntaxfel. Om fel uppt{cks loggas dessa fel och
testen kommer inte att starta. De fel som kontrolleras {r om det
{r giltiga kommandon, r{tt antal parametrar, att parametrarnas
v{rden {r riktiga (n{r det inte {r variabler) och att for-next
looparna {r riktigt konstruerade. Som parametrar kan anges
variabler, v{rden eller en textstr{ng. Ett variabelnamn m}ste
inledas med en bokstav, den har 10 signifikanta tecken och ingen
skillnad g|rs p} gemener och versaler. En variabel deklareras i
och med dess f|rsta referens (som i BASIC). Ett v{rde best}r av
siffror och ev. decimalpunkt. Noggrannheten {r 0.001 dvs. v{rden
mindre {n 0.0005 betraktas som noll. V{rden kan vara positiva
eller negativa. Ett v{rde kan inledas med ett "number-sign" (#)
vilket inneb{r att det tolkas som ett hexadecimalt v{rde och f}r
i s} fall inte inneh}lla n}gon decimalpunkt. En textstr{ng
inleds och avslutas med citationstecken ("). 


%title 3	Variabelhantering.

 I samband med syntaxchecken har en l{nkad lista med variablerna
skapats. I variabellistan finns f|r varje l{nk: namn (10 mest
signifikanta tecken), v{rde och pekare till n{sta l{nk i listan. 

 Ett variabelnamn m}ste inledas med en bokstav, den har 10
signifikanta tecken och ingen skillnad g|rs p} gemener och
versaler. En variabel deklareras i och med dess f|rsta referens
(som i BASIC). Noggrannheten {r 0.001 dvs. v{rden mindre {n
0.0005 betraktas som noll. 

 I systemet finns {ven f|rdefinierade variabler vars v{rde man
ej kan f|r{ndra utan endast l{sa. 

 F|rdefinierade variabler:
ANT_OBJ : antal objekt i racken, r{knas ut efer att alla kort-id
fyllts i. 
