OBS! Exempel p} loggutskrifterna finns sist i detta kapitel.

%title 3	Olika loggmedia

Vad som h{nder under testets g}ng skrivs ut p} tre olika
st{llen: 

SK[RM, PRINTER och LOGGFIL.

Dock kan printern v{ljas bort:

Ett f{lt i nedre h|gra h|rnet p} sk{rmen visar om loggning
kommer att ske {ven p} printern. Flaggan s{tts till "PrOn" vid
start av testet om printern {r p}slagen och online, annars
"PrOff". Man kan v{lja bort eller in printern med hj{lp av
escape-tangenten. 

Loggfilnamnet:

Loggfilen skapas och namnges automatiskt. Namnet anger n{r testen
startades och best}r av 8 siffror f|ljt av ".LOG". Det bildas
enligt f|ljande: 

* F|rsta siffran anger }rtalet.
* Andra siffran anger m}naden i hexadecimal form.
* Tredje och fj{rde siffran anger dag.
* Resterande siffror anger tiden i timmar och minuter.
%page
%title 3	Vad loggas

P} LOGGFIL och PRINTER skrivs exakt samma data:

* Huvud
* Egna texter
* Felutskrifter
* Statistik

P} SK[RMEN skrivs:

* Testsekvens
* Egna texter
* Felutskrifter

%title 4	Testsekvens

Kommandofilen skrivs ut som den ser ut, rad f|r rad varefter
dessa exekveras. F|r variabler skrivs dock v{rde ist{llet f|r
namn. 

%title 4	Huvud

Tv} olika huvud skrivs p} loggen:

* Ett inneh}llande datum, loggfilnamn och kommandofilnamn.

* Ett inneh}llande rubriker f|r i f|rsta hand testresultaten fr}n
  MDDM-korten. 

Vid syntaxfel och statistik skrivs endast det f|rsta
logghuvudet. Vid datumbyte under testets g}ng skrivs n{sta
rad p} ny sida. Logghuvud skrivs ut p} varje sida.

Rubrik-huvudet:

TID             : Anger tiden d} raden loggades.
F\RB.TID        : Tid sedan testet startades, syntaxcheck och
                  initieringar inr{knade. 
SP[NN           : Sp{nningen |ver korten.
H               : Hylla som kortet sitter i. 
SL              : Slot inom hyllan som kortet sitter i. 
TEXT            : H{r skrivs kort-id, vald utskrift i LOGG-
                  kommandot, parameterfel, fatala fel samt fel
                  g{llande powercontrollern.
TEST            : Vilken funktion p} kortet som testades.
RESULTAT        : Hur testet utf|ll.
TIDIGARE FELTYP : Om testet tidigare har resulterat i n}gon typ
                  av fel och nu givit ett annat resultat, talas
                  h{r om vilken typ av fel som d} upptr{dde och
                  antalet s}dana. 

%title 4	Egna texter

Med hj{lp av LOGG-kommandot kan textstr{ngar och variabler
skrivas ut. [ven i INSIGNAL-kommandot kan en textstr{ng anges,
vilken skrivs ut n{r testet ger ett negativt resultat, om detta
loggas.
%page
%title 4	Felutskrifter

Typer av felutskrifter:

* Fatala fel
* Syntaxfel (i kommandofilen)
* Parameterfel
* Testresultat

%title 5	Fatala fel

- Kommandofilstorlek
- PC-Portfel
- Bestyckningsfel
- Powercontroller-fel

Kommandofilstorlek:

N{r man startar testet b|rjar programmet med att kontrollera hur
stor kommandofilen {r. Om minnet inte r{cker till f|r att skapa
den l{nkade listan, talas detta om och testen avbryts. 

PC-portfel:

Vid start av test |ppnas och s{tts COM-portarna upp. Om detta ej
g}r bra skrivs ut vilken port det g{ller samt en statuskod som
n{rmare talar om vad som {r fel. Om detta fel f}s {r det troligen
n}got fel p} PC:n. (F|r info. om vad status-koderna betyder
h{nvisas till ASYNCH MANAGER Function open_a1.)

Bestyckningsfel:

Innan de olika funktionerna p} kortet b|rjar testas kontrolleras
att inmatade id st{mmer |verens med hur korten sitter monterade i
racket. Om inte, talas om hylla, slot och vilken typ av fel som
g{ller f|r just den kortplatsen. Endast hyllor med fel skrivs ut. 
Bestycknings-feltyper:

"Slot utan svar" : Inneb{r att id f|r kortplatsen finns inmatat
                   men att inget kort verkar finnas p} plats. 

"Slot utan id"   : Inneb{r att ett kort finns p} platsen men id
                   {r ej inmatat. 

Powercontroller-fel:

- "Ingen kontakt med PwC'n"
- "Inget svar fr}n PwC'n"
- "Uteblivet ACK fr}n Power-controllern"
- Service ReQuest (SRQ)
- Kommunikationsfel
%page
Om det brister i kommunikationen med PwC'n skrivs feltypen ut och
testet avbryts: 

"Ingen kontakt med PwC'n":

Inneb{r att denna inte {r ansluten eller att str|m-brytaren {r i
fr}n-l{ge. 

"Inget svar fr}n PwC'n":

Betyder att programmet i PwC'n inte fungerar riktigt.

"Uteblivet ACK fr}n Power-controllern":

Betyder att programmet i PwC'n inte fungerar riktigt.

Service ReQuest (SRQ):

PwC'n har f}tt ett kommando den av n}gon anledning inte gillade.
F}s om programvaran i det h{r systemet (, p} PC-sidan,) skulle
vara felaktig. F|r info. om de olika felmeddelandena h{nvisas
till Power Controller-manualen. Felmeddelande "Ok{nt" inneb{r
att typen av SRQ inte har kunnat identifieras. 

Kommunikationsfel:

(Endast i riktningen PwC - PC.) Ett bitm|nster talar om vilken
typ av kommunikations-fel som uppst}tt. Detta skrivs ut
hexadecimalt. (F|r info. om vad de olika bitarna betyder
h{nvisas till ASYNCH MANAGER Function rdch_a1.)

%title 5	Syntaxfel

Sedan det konstaterats att kommandofilen inte {r f|r stor b|rjar
programmet syntaxchecka kommandofilen. Om n}got fel uppt{cks skrivs
kommandoraden + en kort f|rklaring till vad som {r fel. 

%title 5	Parameterfel

N{r en variabel har angivits som parameter till ett kommando, och
denna under exekvering g}r utanf|r vad som {r till}tet f|r just
denna parameter. Rad, kommando och den felaktiga parametern
skrivs ut. Kommandot utf|rs ej.

%title 5	Testresultat

Ett test av en funktion p} kortet kan ge f|ljande resultat:

* Positivt
* Negativt
* Felaktigt svar
* Timeout
* Kommunikationsfel
%page
De olika svaren inneb{r:

Positivt:

Den testade funktionen p} kortet fungerade. Det loggas s}
h{r: Texten "POSITIVT skrivs. Vid INSIGNAL skrivs {ven
portnummer ut (, hexadecimalt).

Negativt:

Den testade funktionen p} kortet fungerade inte. Det loggas s}
h{r: 

CHECKNOV och WATCHDOG: Texten "NEGATIVT" skrivs.

RAMTEST: Ett bitm|nster (, hexadecimalt,) talar om vilken typ av
         fel som uppt{cktes p} kretsen. 
         De olika bitarna betyder:

	 Bit 0 : Fel uppt{ckt vid "vandrande etta".
	 Bit 1 : Fel uppt{ckt vid "vandrande nolla".
	 Bit 2 : Fel uppt{ckt vid "adresstest".

	 F|r info. om vad de olika testerna g}r ut p} h{nvisas
	 till beskrivningen av programmen p} kortet.

SIOTEST: Ett bitm|nster (, hexadecimalt,) talar om vilken typ av
         fel som uppt{cktes p} kretsen. 

	 Bit 0 : Kanal B fick inte n}got tecken.
	 Bit 1 : Kanal B fick inte tillbaka samma tecken som
        		 skickades.
	 Bit 2 : CTS-status p} A-sidan {r inte det f|rv{ntade.
	 Bit 3 : DCD-status p} A-sidan {r inte det f|rv{ntade.
	 Bit 4 : CTS-status p} B-sidan {r inte det f|rv{ntade.
	 Bit 5 : DCD-status p} B-sidan {r inte det f|rv{ntade.

	 F|r info. om vad de olika testerna g}r ut p} h{nvisas
	 till beskrivningen av programmen p} kortet.

PROMTEST: Den framr{knade checksumman skrivs ut (hexadecimalt).

INSIGNAL: Portnummer, v{rde och f|rv{ntat v{rde (hexadecimalt).

OBS! Kan ej f}s fr}n SETNOV och UTSIGNAL.

Felaktigt svar:

Kortet gav ett odefinierat svar. Texten "KORT-SVAR FEL" skrivs. 

Timeout:

Svaret uteblev.

Kommunikationsfel:

Paritetsfel o dyl. (Kontrolleras endast i riktningen MDDM - PC.) 
%page
Olika testresultat behandlas olika. F|r POSITIVT, NEGATIVT,
KORT-SVAR FEL och TIMEOUT g{ller att:

F|r att inte riskera att spr{nga disken eller g|ra slut p}
papperet loggas inte alla fel varefter de upptr{der. D{remot
skrivs alla fel ut p} sk{rmen(, i inversed video f|r att l{ttare
urskiljas). En felutskrift loggas endast n{r en f|r{ndring i
svaret fr}n kortet, g{llande en viss krets, uppt{cks. D{rf|r
loggas ocks} positiva testresultat d} det tidigare har intr{ffat
n}got fel.

KOMMUNIKATIONSFEL (mot MDDM) tas om hand p} f|ljande s{tt: 

Ett bitm|nster talar om vilken typ av kommunikations-fel som
uppst}tt. Detta skrivs ut hexadecimalt. (F|r info. om vad de
olika bitarna betyder h{nvisas till ASYNCH MANAGER Function
rdch_a1.) 

F|r varje MDDM-kort loggas kommunikationsfel h|gst 100 ggr. N{r
det 101:a felet f|r kortet intr{ffar talas om att antalet
kommunikationsfel {r st|rre {n 100 och d{refter r{knas endast en
r{knare upp. 
%page
%title 4	Statistik

Efter avslutat test skrivs en sammanfattning av testen ut.
D{r talas f|r varje kort om:

* Id
* Hylla
* Slot

samt antalet:

* Kommunikationsfel
* Tester p} varje funktion varav antal:
    - Negativa resultat
    - Felaktiga svar
    - Timeouter.

F|r I/O-portarna talas om:

* Vilka som haft separata felr{knare (enl. IOPORT-kommandot) .
* Hur m}nga fel som uppst}tt i resp I/O-port.
