Modulen inneh}ller rutiner som sk|ter meddelandehanteringen
mellan kort och PC.


Lokala statiska variabler
-------------------------

Saknas.


PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


Time
----

Biblioteksrutin i MS-Pascal.


Send_MddmMessage
----------------

Beskrivning : Skickar ett meddelande till MDDM-kort. Om det har
              kommit n}got skr{p sedan senaste meddelandet
              s{ndes rensas f|rst receive-bufferten.
              Meddelandena skickas i form av ASCII-tecken, ett i
              taget, m.h.a. WrtCh_a1. F|rst skickas ett STX,
              d{refter eventuella parametrar och slutligen
              kommandot som talar om vilken funktion som skall
              testas. Kommandot g|rs f|rst om till motsvarande
              liten bokstav. 

Anropas fr}n: Rutinerna i modul MddmKommandon.

Deklaration : Procedure Send_MddmMessage
                        ( SRec       : s_message_t;
                          Kommando   : char         )
              [PUBLIC];

    SRec     : Parametrarna och antalet s}dana.

    Kommando : Vilken funktion som skall testas.
%page
Recieve_MddmAnswer
------------------

Beskrivning : H{mtar ett svar fr}n MDDM-kort. Svaret tas emot
              tecken f|r tecken med hj{lp av RdCh_a1. Varje g}ng
              ett tecken l{ses anropas Protokoll, som
              kontrollerar tecknen. N{r STX och r{tt kommando
              har mottagits anses detta som ett svar. P} svar
              v{ntas i beg{rt antal sekunder. Har inget svar
              kommit s{tts timeoutflaggan. Om ett
              kommunikationsfel uppt{cks avbryts mottagandet.
              Under v{ntan p} svar beg{rs ocks} uppdatering av
              klockorna p} sk{rmen. 

Anropas fr}n: Rutinerna i modul MddmKommandon. 

Deklaration : Procedure Recieve_MddmAnswer
                        ( VAR RRec     : r_message_t;
                              Kommando : char         )
              [PUBLIC];

    RRec     : Returparametrarna och antalet s}dana. Tid att
               v{nta p} svar. Flagga som talar om ifall det kom
               n}got svar. Kommunikations-status.

    Kommando : Vilket kommando som har skickats. Anv{nds f|r
               j{mf|relse med svaret fr}n kortet.


Protokoll
---------

Beskrivning : Kontrollerar tecknen fr}n MDDM. N{r ett STX
              uppt{cks anses ett meddelande vara p} v{g och
              |vriga tecken b|rjar kontrolleras. Om tecknet {r
              ett semikolon |kas returparameter-r{knaren, om
              hex-tecken, (ASCII,) l{ggs det in i
              returparameter-arean. Om tecknet {r lika med s{nt
              kommando g|rs ingenting. \vriga tecken orsakar
              v{ntan p} nytt STX. 

Anropas fr}n: Recieve_MddmAnswer. (Intern procedur i densamma.)

Deklaration : Procedure Protokoll;
