%lines 61
%lang swe
%head 2
Programbeskrivning PC: Testsystem MDDM/Controller (TMC)
Rev 1.0 / 86-10-30      IND AB / AN & LOS
%pos_page 61
%margin_text 6
%margin_title 2
%margin_head 2
%pos_title 14
%rest 3

Inneh}llsf|rteckning


%title 1        Filf|rteckning

F|rteckning |ver alla de filer som beh|vs p} PC'n f|r att kunna
anv{nda TMC-programmet. 

        adp.bat - kommandofil f|r att kompilera med debugger och
              visa felen p} sk{rmen under tiden kompilering
              sker. 
        asy_pas.lib - kommunikationsbibliotek. 
        asynch.h - includefil med deklarationer f|r
              asynch-paketet. 
        asynch0.obj - kommunikationspaketet. 
        batch.h - includefil med deklarationer f|r
              batch-modulen. 
        batch.pas - pascalprogram som scannar igenom l{nkade
              kommandolistan och anropar rutiner f|r att utf|ra
              kommandona. 
        co303.tst - ett exempel p} en testsekvens. 
        decl.h - includefil med div konstanter och
              recordbeskrivningar som {r gemensamma f|r
              PC-programmen. 
        doit.bat - kommandofil som kompilerar och assemblerar
              alla moduler och skriver felen p} filen "err"
              under tiden kompilering sker. 
        dos2pas.lib - pascalbibliotek. 
        dpe.bat - kommandofil f|r att kompilerar med debugger
              och skriva felen p} filen "err" under tiden
              kompilering sker. 
        err - felutskrifter fr}n doit.bat, dpe.bat och pe.bat. 
        global.h - includefil med alla globala variabler. 
        io.asm - assemblerprogram med rutier f|r printerstatus,
              hantering av I/O-portar och viss sk{rmhantering. 
        io.h - includefil med deklarationer f|r io-modulen. 
        kbd.h - includefil med deklarationer f|r kbd-modulen. 
        kbd.pas - pascalprogram som hanterar keyboardet. 
        link - kommandofil f|r l{nkningen. 
        link.exe - l{nkaren (heter link.V2 p} diskett). 
        logg.h - includefil med deklarationer f|r logg-modulen. 
        logg.pas - pascalprogram som sk|ter om utskrifter av
              loggen. 
        loop.h - includefil med deklarationer f|r loop-modulen. 
        loop.pas - pascalprogram som hanterar FOR, NEXT och PAUS
              kommandona. 
        main.pas - huvudprogrammet i PC'n. 
        masm.exe - assemblern. 
        math.lib - pascalbibliotek. 
        mddm.h - includefil med gemensamma recordbeskrivningar
              f|r message och mddmkomn 
        mddmkomn.h - includefil med deklarationer f|r
              mddmkomn-modulen. 
        mddmkomn.pas - pascalprogram som hanterar kommandona
              till mddm. 
        message.h - includefil med deklarationer f|r
              message-modulen. 
        message.pas - pascalprogram som hanterar kommunikationen
              med mddm. 
        objekt.h - includefil med deklarationer f|r
              objekt-modulen. 
        objekt.pas - pascalprogram f|r inmatning av
              objektidentifikationer. 
        objkomn.h - includefil med deklarationer f|r
              objkomn-modulen. 
        objkomn.pas - pascalprogram som hanterar styrningen av
              rel{-kortet f|r att v{lja objekt. 
        p.bat - kommandofil f|r att kompilerar utan debugger och
              visa felen p} sk{rmen under tiden kompilering
              sker. 
        pas.exe - pascalkompilator pass 1. 
        pas2.exe - pascalkompilator pass 2. 
        pas3.exe - pascalkompilator pass 3. 
        pascal.lib - pascalbibliotek. 
        pe.bat - kommadofil f|r att kompilerar utan debugger och
              skriva felen p} filen "err" under tiden
              kompilering sker. 
        pwckomn.h - includefil med deklarationer f|r
              pwckomn-modulen. 
        pwckomn.pas - pascalprogram som hanterar kommunikationen
              med powercontrollern. 
        screen.h - includefil med deklarationer f|r
              screen-modulen. 
        screen.pas - pascalprogram med bildsk{rmhantering. 
        synt.h - includefil med deklarationer f|r synt-modulen. 
        synt.pas - pascalprogram som syntaxkontrollerar
              kommandofilen och bygger upp en l{nkad lista av
              kommandon. 
        temp.h - includefil med deklarationer f|r temp-modulen. 
        temp.pas - pascalprogram som utf|r TEMP-kommandot. 
        tid.h - includefil med deklarationer f|r tid-modulen. 
        tid.pas - pascalprogram som h}ller r{tt p} aktuell tid
              och f|rbrukad testtid. 
        tmc.exe - Programfilen p} PC'n 
        tmc.map - map fr}n l{nkningen. 
        varhandl.h - includefil med deklarationer f|r
              varhandl-modulen. 
        varhandl.pas - pascalprogram som hanterar de variabler
              som finns i kommandofilen. 
%page
%title 0
%title 1        Programutveckling

%title 2        Kompilering

F|r att kompilera pascalprogrammen anv{nds Microsoft Pascal
Compiler. 

P} PC'n finns n}gra batchfiler som kan anv{ndas vid kompilering: 

        p.bat - Kompilerar utan debugger och visar felen p}
              sk{rmen under tiden kompilering sker. 
        adp.bat - Kompilerar med debugger och visar felen p}
              sk{rmen under tiden kompilering sker. 
        pe.bat - Kompilerar utan debugger och skriver felen p}
              filen "err" under tiden kompilering sker. 
        dpe.bat - Kompilerar med debugger och skriver felen p}
              filen "err" under tiden kompilering sker. 

Samtliga ovanst}ende batchfiler tar en eller flera filnamn utan
".pas" som parameter om man som sista parameter anger "l" kommer
l{nkning att ske efter det att sist angivna modul kompilerats. 

        doit.bat - Kompilerar och assemblerar alla moduler och
              skriver felen p} filen "err" under tiden
              kompilering sker. 

De filer som inneh}ller pascalprogram och ing}r i systemet {r
f|ljande: 


        batch.pas
        kbd.pas
        logg.pas
        loop.pas
        main.pas
        mddmkomn.pas
        message.pas
        objekt.pas
        objkomn.pas
        pwckomn.pas
        screen.pas
        synt.pas
        temp.pas
        tid.pas
        varhandl.pas

F|ljande includefiler ing}r:

        asynch.h
        batch.h
        decl.h
        global.h
        io.h
        kbd.h
        logg.h
        loop.h
        mddm.h
        mddmkomn.h
        message.h
        objekt.h
        objkomn.h
        pwckomn.h
        screen.h
        synt.h
        temp.h
        tid.h
        varhandl.h


%title 2        Assemblering

F|r att assemblera anv{nds IBM PC MACRO Assembler. Det enda
assemblerprogrammet som ing}r i PC-programmvaran {r io.asm.


%title 2        L{nkning 

L{nkare som anv{nds {r Microsoft Object Linker Version 2.40, den
finns p} Pascaldisketterna och heter d{r LINK.V2. N{r man l{nkar
m}ste asynchronmodulen asynch0.obj l{nkas in f|rst (se {ven om
l{nkning i asynchpaketets manual). De bibliotek som skall anges
vid l{nkning {r DOS2PAS och ASY_PAS, switchar som beh|vs {r
DSALLOCATE, man kan {ven ange switcharna LINENUMBERS och MAP f|r
att f} ut en map som {r anv{ndbar vid debugging. 

Det finns en kommandofil f|r l{nkaren: LINK, s} f|r att dra
ig}ng en l{nkning skriver man "LINK @LINK". 

Outputen fr}n l{nkaren {r en programfil som heter TMC.EXE och
mappen TMC.EXE. 

De bibliotek som m}ste finnas vid l{nking {r: 

        DOS2PAS.LIB
        PASCAL.LIB
        MATH.LIB

som alla finns p} pascaldisketterna, och 

        ASY_PAS.LIB

som finns p} asynchronpaketets diskett. 

%title 2        Debugging

Om man beh|ver debugga programmen anv{nds Microsofts DEBUG. F|r
att hitta i minnet kan man ber{kna enl f|ljande: (<ES> {r
inneh}llet i ES-registret direkt n{r man kommer in i debuggern,
<DS> och <BS> {r inneh}llet i DS och BS-registrena n{r man har
kommit in i applikationen) ) 

        Programrad:
              Segment = programradens segment enl mappen + <ES>
              + 0010 hex, 
              Offset = programradens offset enl mappen 
        Lokal dynamisk variabel i procedur eller funktion:
              Segment = <DS>
              Offset = <BP> + offset enl. pascalprogramlistan 
        Statisk variabel i en modul
              Segment = <DS>
              Offset = offset enl. mappen
%page
%title 0
%title 1        Modulbeskrivning

%title 2        Procedur och funktionsf|rteckning

F|rteckning |ver procedurer och funktioner och i vilka moduler
de finns.

Add_MddmInfo            logg
Add_Space               logg
CheckEnparm             synt
CheckFor                synt
CheckInsignal           synt
CheckIoport             synt
CheckLogg               synt
CheckNext               synt
CheckNoparm             synt
CheckNov                mddmkomn
CheckRamtest            synt
CheckUtsignal           synt
CheckVar                varhandl
Check_Objekts           mddmkomn
Check_Printer           logg
Check_PwC_Answer        pwckomn
Choose_Objekt           objkomn
ClrEol                  screen
ClrLine                 screen
ClrScr                  io
ClrVlist                varhandl
Clr_FTangPrintFlgs      screen
Concat_Value            logg
Connect_Kort            objkomn
Cpos                    io
CposWrite               screen
CursOff                 io
CursOn                  io
Datum                   tid
DebugWrite              screen
DebugWriteLn            screen
DisConnect_Kort         objkomn
DiskLogg                logg
DisplayFel              screen
DisplayTimes            screen
DoTest                  batch
Do_For                  loop
Do_Next                 loop
ErrMsg                  screen
Exit_PwC                pwckomn
Flush_PwCBuffer         pwckomn
GetCh                   kbd
GetCPos                 io
GetObjekt               objekt
GetStr                  kbd
Get_ComFileName         objekt
Get_VarValue            varhandl
HexKonv                 logg
InByte                  io
IniTime                 tid
Init_Lista              logg
Ini_COM_Ports           batch
Ini_PwC                 pwckomn
Ini_RelaPorts           objkomn
Insignal                mddmkomn
InvVid                  screen
Ioport                  logg
KeyPressed              kbd
SioTest                 mddmkomn
Logg                    logg
Logga                   logg
Logga_MddmKomFel        logg
Logga_Msg               logg
Logga_ObjektFel         logg
Logga_ParmFel           logg
Logga_PwCErr            logg
Logga_PwCKomFel         logg
Logga_SerErr            logg
Logga_SyntErr           logg
Logga_TestFel           logg
Logga_TestOK            logg
Logga_TestResultat      logg
MakeVar                 varhandl
Make_FdefVarTab         varhandl
Make_LoggFilNamn        logg
Make_LoggHuvud          logg
Menu                    screen
NorVid                  screen
Open_KommandoFil        synt
Open_LoggFil            logg
OutByte                 io
Paus                    loop
PortNr_Ok               logg
Print                   io
PrintLn                 io
PrOff                   logg
Promtest                mddmkomn
Protokoll               message
PrStat                  io
PStatKonv               logg
Put_Times               logg
Put_VarValue            varhandl
PwCComm                 pwckomn
PwCCTS                  pwckomn
PwC_OK                  pwckomn
Ramtest                 mddmkomn
Recieve_MddmAnswer      message
Redraw                  objekt
Release_PortCnt         logg
Reset                   mddmkomn
Reset_Counters          logg
Reset_OldValue          mddmkomn
RoundX                  tid
Screen_logg             logg
Scroll                  io
ScrollWrite             screen
ScrollWriteLn           screen
SecUsed                 tid
Send_MddmMessage        message
SetNov                  mddmkomn
Set_Analog              pwckomn
Set_Spanning            pwckomn
Set_Temp                temp
ShowFileErr             screen
SkapaKommandoLista      synt
SplitLine               synt
Stall_Relaerna          objkomn
Startup                 batch
Statistik               logg
SyntaxCheck             synt
TaBortKommandoLista     synt
TaBortVariabelLista     varhandl
TimeUsed                tid
Utsignal                mddmkomn
ValOut                  synt
Watchdog                mddmkomn
WriteLine25             screen
Write_InitBild          screen
%page
%title 2        Struktur
%page
%title 2        Batch

Modulen inneh}ller testloopen som k|r igenom testsekvensen.


Lokala statiska variabler
-------------------------

        IOBuf_1 : input-output buffer f|r kommunikationsport 1 
        IOBuf_2 : input-output buffer f|r kommunikationsport 2 


PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


Ini_COM_Ports
-------------

Beskrivning : \ppnar kommunikationsportarna f|r mddmkortet
              (COM1) och powercontrollern (COM2). IOBuf_1 och
              IOBuf_2 skickas som parametrar till open f|r att
              anv{ndas som buffertat av asynch-paketet. Loggar
              om fel intr{ffar. 

Anropas fr}n: Startup i denna modul (Batch). 

Deklaration : Procedure Ini_COM_Ports;

Statiska variabler som {ndras:

    Lokala  : IOBuf_1 och IOBuf_2


Startup
-------

Beskrivning : Diverse initieringar i samband med att en
              testsekvens skall starta. Nollst{ller
              tidr{kningsvariabler och statistiktabeller,
              initierar kommunikationsportar, portar mot
              rel{kortet, powercontrollern samt nollst{ller
              tabell f|r maskning vid utsignalkommandot. 

Anropas fr}n: DoTest i denna modul (Batch). 

Deklaration : Procedure Startup;
%page
DoTest
------

Beskrivning : \ppnar kommandofilen och loggfil, l{gger upp de
              f|rdefinierade variablerna, kollar om printern {r
              ansluten, initierar rubriker i loggen och skapar
              kommandolistan. S{tter ig}ng ett test och k|r det
              i 72 timmar eller tills n}gon avbrutit testen. Vid
              varje varv i testloopen delas en rad i kommando-
              listan upp och motsv kommandoprocedur anropas utom
              f|r pauskommandot d{r DoTest sj{lv h}ller reda p}
              n{r och hur l{nge det {r paus. Efter ett kommando
              har uf|rts s{tts kommandopekaren till n{sta
              kommando, om escape trycks under testen f}r man
              chans att avbryta testen eller sl} av/p} printern
              under 15 sek. Efter testen {r klar sl{pps alla
              rel{er, 5-volten dras ner till noll och 12-volten
              kopplas bort (6 rel{er dras), statistiken skrivs
              ut, kommunikationsportarna och loggfilen st{ngs
              och minnet f|r kommando och variabel-lista l{mmnas
              tillbaka. 

Anropas fr}n: Main-programmet i modul main. 

Deklaration : Function DoTest:error_t [PUBLIC];

Returv{rdet : Felkod som anger hur testet har g}tt, kan vara:
              alla syntaxfelen, testobjekt saknas eller fel vid
              open/read av kommandofilen, 

Statiska variabler som {ndras:

    Lokala  : SerErr
%page
%title 2        Io

Modulen inneh}ller de assemblerrutiner som ing}r, de g|r s}nt
som inte kan kodas i pascal. Ing}ende delar {r dels rutiner f|r
att l{sa/skriva p} io-portar, l{sa av printerstatus och att
hantera bildsk{rmen. 


Beskrivning av assemblerrutinerna:

InByte
------

Beskrivning : L{ser en byte fr}n en io-port och returnerar det
              l{sta v{rdet. 

Anropas fr}n: Objkomn

ExternDeklaration i pascal: 
              Function InByte( Portnr:integer ):byte; EXTERN;

        Portnr : porten som skall l{sas av.


OutByte
-------

Beskrivning : Skriver en byte p} en io-port.

Anropas fr}n: Objkomn

ExternDeklaration i pascal: 
              Procedure OutByte( Portnr:integer; data:byte );
              EXTERN; 

        Portnr : porten som skall l{sas av.
        data : byten som skall srivas p} porten. 


PrStat
------

Beskrivning : L{ser av printerstatus genom att g|ra BIOS-anrop
              INT 17H. Returnerar printerstatus.

Anropas fr}n: logg

ExternDeklaration i pascal: 
              Function PrStat:byte; EXTERN;
%page
Print
-----

Beskrivning : Skriver en textstr{ng p} printern genom att g|ra
              BIOS-anrop INT 17H. Teknen skickas ett och ett.
              F|r varje tecken kollas om timeoutbiten {r satt.
              Om s} {r fallet avbryts utskriften av str{ngen.
              Som returv{rde l{mnas printerstatus. 

Anropas fr}n: logg

ExternDeklaration i pascal: 
              Function Print ( CONST Line : string ) : byte;
                       EXTERN;


PrintLn
-------

Beskrivning : Fungerar som Print men l{gger p} CR och LF.

Anropas fr}n: logg

ExternDeklaration i pascal: 
              Function PrintLn ( CONST Line : string ) : byte;
                       EXTERN;


ClrScr
------

Beskrivning : Blankar den del av sk{rmen som anv{nds som
              scroll-f|nster dvs. rad 3 tom. 21, genom
              BIOS-anrop INT 10H. 

Anropas fr}n: main

ExternDeklaration i pascal: 
              Procedure ClrScr; EXTERN;


CursOn
------

Beskrivning : T{nder cursorn genom att g|ra BIOS-anrop INT 10H. 

Anropas fr}n: kbd

ExternDeklaration i pascal: 
              Procedure CursOn; EXTERN;
%page
CursOff
-------

Beskrivning : Sl{cker cursorn genom att g|ra BIOS-anrop INT 10H. 

Anropas fr}n: kbd och main

ExternDeklaration i pascal: 
              Procedure CursOff; EXTERN;


GetCPos
-------

Beskrivning : L{ser av vilken position cursor finns p},
              returnerad rad och kolumn. 

Anropas fr}n: kbd och main

ExternDeklaration i pascal: 
              Procedure GetCPos( VAR Row, Col:integer ); EXTERN; 

        Row : vilken rad cursorn st}r p}.
        Col : vilken kolumn cursorn st}r p}. 


Cpos
----

Beskrivning : Positionerar cursorn p} bildsk{rmen. 

Anropas fr}n: kbd, main, objekt och screen

ExternDeklaration i pascal: 
              Procedure Cpos ( Rad,Kol : integer ); EXTERN;

        Rad : vilken rad cursorn skall till. 
        Kol : vilken kolumn cursorn skall till. 


Scroll
------

Beskrivning : Scrollar den del av sk{rmen som anv{nds som
              scroll-f|nster dvs. rad 3 tom. 21, genom
              BIOS-anrop INT 10H. 

Anropas fr}n: screen

ExternDeklaration i pascal: 
              Procedure Scroll; EXTERN;

%page
%title 2        Kbd

Modulen inneh}ller de rutiner som hanterar inmatning fr}n
tangentbordet 


PROCEDURE- och FUNCTION-beskrivningar

GetCh
-----

Beskrivning : v{ntar tills n}gon tangent trycks l{ser det
              tecknet utan att eka, returnerar tecknet 

Anropas fr}n: DoTest i BATCH vid printer av/p} eller avbrytning
              av test 
              GetStr i denna (KBD) modul 
              ErrMsg i SCREEN vid kvittens av felmeddelandet

Deklaration : Function GetCh : char [PUBLIC];


GetStr
------

Beskrivning : Positionerar cursorn och l{ser ett antal tecken
              fr}n keyboard, tills en godk{nd funktionstangent
              tryckts. T{nder cursorn medans inmatning sker. Om
              en funktionstangent trycks innan ett tecken {ndras
              inte inneh}llet i f{ltet. N{r f|rsta tecknet
              skrivs rensas resten av f{ltet senast inmatade
              tecken kan tas bort med backspace. 

Anropas fr}n: GetObjekt i OBJEKT vid imnatning av objektid. 
              Get_ComFileName i OBJEKT vid imnatning av
              kommandofilnamn. 
              Write_InitBild i SCREEN vid funktionstangentsval
              fr}n init-bilden. 

Deklaration : Function GetStr(
                 VAR txt  : lstring;
                     f_ok : ftang_set;
                     rad  : integer;
                     kol  : integer;
                     size : integer
                         ): ftang_t [PUBLIC];

        txt : det inskrivna f{ltet hamnar h{r 
        f_ok : vilka funktionstangenter som {r till}tna 
        rad  : vilken rad  cursorn skall positioneras p}
        kol : vilken kolumn cursorn skall positioneras p} 
        size : max laengd p} inmatningsf{ltet 

returnerar funktionstangent
%page
KeyPressed
----------

Beskrivning : kontrollerar om n}gon tangent har trycks ner, utan
              att l{sa den 

Anropas fr}n: DoTest i BATCH vid printer av/p} eller avbrytning
              av test, f|r att ta bort ev. buffrade tecken 
              ErrMsg i SCREEN f|re kvittens av felmeddelandet,
              f|r att ta bort ev. buffrade tecken 

Deklaration : Function KeyPressed : boolean [PUBLIC];

returnerar true ifall tangent tryckts annars false.
%page
%title 2        Logg

Modulen inneh}ller alla rutiner som sk|ter loggningen.


Lokala statiska variabler
-------------------------


LoggFilNamn : Namnet p} loggfilen.

HuvudStr_1  : Logghuvud pa varje sida. Datum, loggfilnamn
              kommandofilnamn och sidnummer.

HuvudStr_2  : Logghuvud, rubriker.

TextStr     : Strangen som fylls p} av olika loggrutiner och
              sedan loggas (av Logga). Skrivs oftast {ven ut p}
              sk{rm, dock i avkortad form. Tid, f|rbrukad
              testtid, sp{nning hylla och slot tas bort. Om
              str{ngen fortfarande {r l{ngre {n 80 tecken,
              kastas tecknen efter det 80:e. 

Count       : En tabell som inneh}ller alla resultat, i form av
              r{knare, av test p} korten under en k|rning.
              Anv{nds f|r att h}lla reda p} n{r n}gonting
              g{llande MDDM skall loggas samt vid den samman-
              fattande utskriften.

TmpDatum    : Anv{nds f|r att datum inte skall {ndra p} sig
              under tiden man jobbar med det. 

OldDate     : Datum d} senaste raden loggades. Anv{nds f|r att
              f} sidbyte vid nytt datum. 

Sida        : Sidnummer p} logglistan.

LineNr      : Radr{knare. F|r att f} r{tt antal rader p} sidan.

MddmHuvud   : Skall HuvudStr_2 ut p} loggen?

LowIO       : I/O-adress till port med l{gsta nummer som skall
              ha en felr{knare per ioport

HighIO      : I/O-adress till port med h|gsta nummer som skall
              ha en felr{knare per ioport

NumIO       : Antal i/o-adresser som har en felr{knare per
              ioport dvs HighIO - LowIO + 1.

IOCntAlloc  : Har minne f|r felr{knare till IO-portarna
              allokerats?
%page
PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


Time
----

Biblioteksrutin i MS-Pascal.


Open_LoggFil 
------------

Beskrivning : \ppnar loggfilen f|r skrivning. Misslyckas detta
              skrivs det ut p} sk{rmen. 

Anropas fr}n: DoTest i modul Batch

Deklaration : Procedure Open_LoggFil [PUBLIC];

Statiska variabler som {ndras:

    Globala: LoggFil


Make_LoggFilNamn
----------------

Beskrivning : Skapar ett loggfilnamn med hj{lp av datum och tid.
              F|r m}nad anv{nds hexadecimalt tecken.

Anropas fr}n: Open_LoggFil. (Intern procedur i densamma.)

Deklaration : Procedure Make_LoggFilNamn;

Statiska variabler som {ndras:

    Lokala : LoggFilNamn


PrOff 
-----

Beskrivning : Sl}r av printning och s{tter printflaggan p}
              sk{rmen till "PrOff".

Anropas fr}n: 1) DoTest i Batch vid initiering och d} operat|ren
                 v{ljer bort printning. 
              2) Check_Printer i denna modul.

Deklaration : Procedure PrOff [PUBLIC];

Statiska variabler som {ndras:

    Globala: PrintOn
%page
Check_Printer 
-------------

Beskrivning : Tittar hur printningen st}r i f|rh}llande till hur
              printern m}r. Om olika justeras detta och print-
              flaggan p} sk{rmen {ndras. 

Anropas fr}n: 1) DoTest i Batch vid initiering och d} operat|ren
                 v{ljer printning. 
              2) Logga i denna modul.

Deklaration : Procedure Check_Printer ( Status : byte )
              [PUBLIC];

    Status : Avl{st printerstatus.

Statiska variabler som {ndras:

    Globala: PrintOn


HexKonv
-------

Beskrivning : Konverterar en integer till en str{ng i hexformat.
              Ex: #FF

Anropas fr}n: 1) Insignal i modul Mddmkomn.
              2) PstatKonv i denna modul.

Deklaration : Function HexKonv ( AntNumTkn : integer;
                                 talet     : integer ): lstr5
              [PUBLIC];

    AntNumTkn : Antal numeriska tecken. Anger hur m}nga
                positioner i str{ngen som kr{vs.
    Talet     : Integern som skall konverteras.


PStatKonv
---------

Beskrivning : Konverterar PStatus till en str{ng i hexformat.
              Ex. #XX01

Anropas fr}n: 1) Procedurerna i modul Mddmkomn och
              2) PwCComm i modul Pwckomn
              vid kommunikationsfel.

Deklaration : Function PStatKonv ( PStat : integer ): lstr5
              [PUBLIC];

    PStat : PStatus
%page
Add_Space
---------

Beskrivning : Fyller TextStr med space till angiven kolumn.

Anropas fr}n: Flera av rutinerna i denna modul.

Deklaration : Procedure Add_Space ( Kolumn : byte );

    Kolumn : Till (men inte med) vilken kolumn space skall
             fyllas.

Statiska variabler som {ndras:

    Lokala : TextStr


Concat_Value
------------

Beskrivning : Plockar bort decimalerna ur en real om dessa {r
              < 0.0005 och l{gger till talet i TextStr.

Anropas fr}n: Logg och Logga_ParmFel i denna modul. Vid utskrift
              av v{rde- eller variabel-parametrar till
              kommandona i kommandofilen. 

Deklaration : Procedure Concat_Value ( ReVal  : real;
                                       HexFlg : boolean );

    ReVal  : V{rdet som skall snyggas till.
    HexFlg : Flagga som talar om ifall talet skall skrivas p}
             hexform.

Statiska variabler som {ndras:

    Lokala : TextStr


Make_LoggHuvud
--------------

Beskrivning : Skapar logghuvudena.

Anropas fr}n: Init_Lista och Logga i denna modul.

Deklaration : Procedure Make_LoggHuvud;

Statiska variabler som {ndras:

    Lokala : HuvudStr_1, HuvudStr_2 
%page
Put_Times
---------

Beskrivning : L{gger tid och f|rbrukad testtid i TextStr.

Anropas fr}n: Flera av rutinerna i denna modul.

Deklaration : Procedure Put_Times;

Statiska variabler som {ndras:

    Lokala : TmpDatum, TextStr


Add_MddmInfo
------------

Beskrivning : L{gger till hylla, slot och id till TextStr.

Anropas fr}n: Logga_MddmKomFel, Logga_TestOK och Logga_TestFel i
              denna modul. 

Deklaration : Procedure Add_MddmInfo;

Statiska variabler som {ndras:

    Lokala : TextStr


Logga_Msg
---------

Beskrivning : Loggar ett valfritt meddelande p} loggmedierna,
              skriver aktuell tid och f|rbrukad testtid f|rst p}
              raden.

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Logga_Msg ( CONST msg : string )
              [PUBLIC];

    msg      : texten som skall skrivas ut.

Statiska variabler som {ndras:

    Lokala : TextStr
%page
DiskLogg
--------

Beskrivning : Skriver ut TextStr och eventuella huvud p}
              LoggFil. Om skrivningen p} LoggFil misslyckas
              p.g.a. att disken {r full skrivs detta ut p} sk{rm
              och printer. I |vriga fall d} skrivning misslyckas
              skrivs en felkod. Meddelande att loggning
              forts{tter endast p} printer l{mnas ocks}.

Anropas fr}n: Logga i denna modul.

Deklaration : Procedure DiskLogg ( CONST msg : string );

Statiska variabler som {ndras:

    Globala: LoggFil, PrintOn
    Lokala : DiskErr


Logga
-----

Beskrivning : Ser till att sidbyten, rubriker och texter kommer
              snyggt p} loggen. Anropar DiskLogg och PrintLn f|r
              att f} ut texterna. F|r att anrop av PrintLn skall
              ske kr{vs att printning {r vald och att printern
              {r beredd att skriva. [r printern avslagen,
              offline, busy f|r l{nge, ( 15 s,) eller det blir
              fel vid skrivning, s{tts print-flaggan p} sk{rmen
              till "PrOff" och ingen printning kommer att ske
              f|rr{n printern {r OK och printning har valts p}
              nytt. 

Anropas fr}n: Flera av rutinerna i denna modul.

Deklaration : Procedure Logga;

Statiska variabler som {ndras:

    Globala: LoggFil, SerErr, PrintOn
    Lokala : OldDate, Sida, LineNr
%page
Logga_SyntErr
-------------

Beskrivning : L{gger vid syntaxfel ett felmeddelande i TextStr,
              skriver ut det och den felaktiga raden p} sk{rmen
              och loggen.

Anropas fr}n: Flera av rutinerna i Synt.

Deklaration : Procedure Logga_SyntErr ( err : error_t;
                                        ptr : komm_ptr )
              [PUBLIC];

    err : Typ av syntaxfel.
    ptr : Pekare till kommandoraden i den l{nkade listan.

Statiska variabler som {ndras:

    Lokala : TextStr, MddmHuvud


Logg
----

Beskrivning : Logg-kommandot. Skriver ut beg{rda variabler,
              v{rden och str{ngar p} loggen.

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Logg ( RadDelar : linepart_t;
                               Antal    : integer     )
              [PUBLIC];

    RadDelar : Kommandot + de olika delarna av raden i kommando-
               filen som skall skrivas ut.
    Antal    : Antal RadDelar.

Statiska variabler som {ndras:

    Lokala : TextStr
%page
Logga_ParmFel
-------------

Beskrivning : Skriver ut att en eller flera felaktiga parametrar
              har hittats i kommandofilen, typ av parameter,
              parameterv{rdet och vilken rad i kommandofilen det
              g{ller. Utskriften kommer b}de p} logg och sk{rm.
              Dock endast d} parametern {r en variabel (som g}tt
              utanf|r till}tna v{rden). (Felaktiga konstant-
              parametrar uppt{cks i syntaxchecken och loggas av
              Logga_SyntErr.) 

Anropas fr}n: 1) Paus i modul Loop.
              2) Utsignal, Insignal och Ramtest i modul
                 Mddmkomn.
              3) Choose_Objekt i modul Objkomn.
              4) Set_Spanning och Set_Analog i modul Pwckomn.

Deklaration : Procedure Logga_ParmFel
                        ( KomndStr   : element;
                          KomnRadI   : integer;
                          ErrParm    : ErrParmArea_t;
                          AntErrParm : integer        )
              [PUBLIC];

    KomndStr   : Kommandot.
    KomnRadI   : Raden i kommandofilen.
    ErrParm    : De felaktiga parametrarna.
    AntErrParm : Antal felaktiga parametrar.

Statiska variabler som {ndras:

    Lokala : TextStr


Logga_SerErr
------------

Beskrivning : Skriver p} logg och sk{rm, vid fatalt fel ut vad
              som {r fel och s{tter SerErr-variabeln om denna ej
              redan {r satt. 

Anropas fr}n: 1) Ini_COM_Ports i modul Batch.
              2) PwCCTS, PwCComm och Ini_PwC i modul Pwckomn.

Deklaration : Procedure Logga_SerErr ( ErrVarde : SerErr_t ;
                                       Status   : integer    )
              [PUBLIC];

    ErrVarde : Typ av fel.
    Status   : Eventuella statuskoder som n{rmare beskriver
               felet.

Statiska variabler som {ndras:

    Globala: SerErr
    Lokala : TextStr
%page
Reset_Counters 
--------------

Beskrivning : Nollst{ller alla r{knare och pekare i Count.
              Nollst{ller io-portsr{kneriet (LowIO, HighIO och
              NumIO).

Anropas fr}n: Startup i modul Batch.

Deklaration : Procedure Reset_Counters [PUBLIC];

Statiska variabler som {ndras:

    Lokala : Count, IOCntAlloc, LowIO, HighIO, NumIO och DiskErr


Ioport
------

Beskrivning : Allokerar minne f|r, och nollst{ller felr{knare
              f|r de io-portar som skall ha en felr{knare per
              port. Markerar detta i IOCntAlloc. Skriver ut
              felmeddelande om minne redan allokerats. Avbryter
              testet om minnet inte r{cker till. 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Ioport ( lowport, highport : real )
              [PUBLIC]; 

Statiska variabler som {ndras:

    Globala: SerErr
    Lokala : Count, IOcntAlloc, HighIO, LowIO, NumIO


Release_PortCnt
---------------

Beskrivning : Deallokerar minne f|r port-felr{knarna, och
              markerar detta i IOCntAlloc. Detta g|rs n{r en
              testsekvens k|rts f{rdigt. 

Anropas fr}n: DoTest i modul Batch. 

Deklaration : Procedure Release_PortCnt [PUBLIC]; 

Statiska variabler som {ndras:

    Lokala : Count, IOcntAlloc
%page
Init_Lista
----------

Beskrivning : Initieringar av variabler som ser till att loggen
              blir snygg.

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Init_Lista [PUBLIC];

Statiska variabler som {ndras:

    Lokala : TmpDatum, OldDate, Sida, LineNr, MddmHuvud


Logga_ObjektFel
---------------

Beskrivning : Skriver vid start av testet ut vilka kortplatser
              som inte l{mnat ngt svar trots att id f|r kort-
              platsen finns inmatat samt vilka kortplatser som
              l{mnat svar trots att id ej finns inmatat. 

Anropas fr}n: Check_Objekts i modul Mddmkomn. 

Deklaration : Procedure Logga_ObjektFel ( RackTab : RackTab_t )
                        [PUBLIC];

    RackTab : Tabell inneh}llande flagga som talar om ifall det
              finns ngt fel i just den hyllan samt en variabel,
              f|r varje kortplats, som talar om av vilken typ det
              eventuella felet {r.

Statiska variabler som {ndras:

    Lokala : TextStr
%page
Logga_TestResultat
------------------

Beskrivning : R{knar upp totalr{knaren f|r varje kort och
              funktion, och ser till att svaren fr}n korten
              loggas p} riktigt s{tt. 

Anropas fr}n: Rutinerna f|r kommandon i modul Mddmkomn.

Deklaration : Procedure Logga_TestResultat
                        ( Komnd     : char;
                          KortErr   : KortFel_t;
                          PortNr    : integer;
                          Varde     : lstr5;
                          InData    : integer    ) [PUBLIC];

Komnd     : Kommandot till MDDM-kortet. Anv{nds h{r f|r
            indexering i Count.
KortErr   : Vilken typ av svar kortet gav.
PortNr    : Inneh}ller portnummer efter INSIGNAL-test.
Varde     : Kan inneh}lla kommunikationsfeltyp (mot MDDM),
            feltyp p} RAM, feltyp p} SIO'n samt erh}llet v{rde
            efter negativt INSIGNAL-test. 
InData    : F|rv{ntat v{rde vid INSIGNAL-test.

Statiska variabler som {ndras:

    Lokala : Count


PortNr_Ok
---------

Beskrivning : Kontrollerar om den testade porten i
              insignalkommandot har egen r{knare. 

Anropas fr}n: Logga_TestResultat. (Intern procedur i densamma.)

Deklaration : Function PortNr_Ok;
%page
Logga_MddmKomFel
----------------

Beskrivning : Vid kommunikationsfel mot MDDM skrivs detta ut p}
              sk{rm och logg. F|r varje kort skrivs dock h|gst
              100 kommunikationsfel ut. Vid det 101:a felet
              talas om att antalet fel {r > 100. D{refter g|rs
              vid kommunikationsfel inget annat {n att |ka
              r{knaren. 

Anropas fr}n: Logga_TestResultat. (Intern procedur i densamma.)

Deklaration : Procedure Logga_MddmKomFel;

Statiska variabler som {ndras:

    Lokala : TextStr, Count


Logga_TestOK
------------

Beskrivning : Testad funktion fungerade, kontroll av hur testet
              p} funktionen utf|ll senast. Om n}got av:
              negativt, felaktigt svar eller timeout, skrivs,
              endast p} loggen, ut att resultatet blev positivt,
              vid INSIGNAL {ven portnummer, och tidigare feltyp
              samt antalet s}dana. 

Anropas fr}n: Logga_TestResultat. (Intern procedur i densamma.)

Deklaration : Procedure Logga_TestOK;

Statiska variabler som {ndras:

    Lokala : TextStr, Count
%page
Logga_TestFel
-------------

Beskrivning : Testad funktion fungerade ej. Om parametrarna
              PortStr, Varde eller InDataStr inneh}ller n}got,
              skrivs detta. Annars skrivs texten "NEGATIVT".
              Kontroll g|rs av hur testet p} funktionen utf|ll
              senast. Om n}got av: negativt, felaktigt svar
              eller timeout, skrivs {ven tidigare feltyp samt
              antalet s}dana. Denna utskrift g|rs alltid p}
              sk{rmen. Utskrift p} loggen sker endast om senaste
              test av funktionen gav ett annat resultat. Vid
              RAMTEST r{knas som annat resultat att typen av fel
              p} RAM {r ett annat. Vid PROMTEST skiljs ej p}
              felaktiga checksummor. Vid INSIGNAL-test tas bara
              h{nsyn till vilken port som ger det felaktiga
              v{rdet om den har en separat felr{knare enl.
              tidigare IOPORT-kommando. H{nsyn tas d} ocks} till
              senaste l{sta och f|rv{ntade v{rde f|r porten. 

Anropas fr}n: Logga_TestResultat. (Intern procedur i densamma.)

Deklaration : Procedure Logga_TestFel;

Statiska variabler som {ndras:

    Lokala : TextStr, Count


Logga_PwCErr
------------

Beskrivning : Ett "SRQ" har mottagits fr}n Power-controllern.
              Rutinen skriver, p} sk{rm och logg, ut vad PwC'n
              tyckte var fel i kommandot fr}n PC'n.

Anropas fr}n: Check_PwC_Answer i modul Pwckomn.

Deklaration : Procedure Logga_PwCErr ( BitVarde : integer )
              [PUBLIC];

Statiska variabler som {ndras:

    Lokala : TextStr
%page
Logga_PwCKomFel
---------------

Beskrivning : Skriver ut att kommunikationsfel mot PwC'n har
              uppt{ckts.

Anropas fr}n: PwCComm i modul Pwckomn.

Deklaration : Procedure Logga_PwCKomFel ( KomFelTyp : lstr5 );

Statiska variabler som {ndras:

    Lokala : TextStr


Screen_logg
-----------

Beskrivning : Skriver ut varje rad p} sk{rmen i samband med att
              den interpreteras. Variabler ers{tts med aktuellt
              v{rde (utom f|rsta variabeln i FOR-kommandot).
              Kommentarer skrivs i 40:e kolumn. 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Screen_logg (
                        raddelar : linepart_t;
                        antal    : integer;
                        raden    : komm_ptr);  [PUBLIC];

Statiska variabler som {ndras:

    Lokala : TextStr


Statistik 
---------

Beskrivning : Skriver p} loggen en sammanfattning f|r varje kort
              inneh}llande hur m}nga tester av varje funktion
              som har gjorts och d{rav antal negativa resultat,
              felaktiga svar och timeouter. F|r de portar som
              angetts i IOPORT-kommadot skrivs felr{knarna ut om
              de {r st|rre {n noll. F|r varje kort skrivs ocks}
              ut antal kommunikationsfel. 

Anropas fr}n: DoTest i modul Batch, n{r k|rningen avbryts eller
              {r klar, om n}gon funktion p} n}got kort {r
              testad. 

Deklaration : Procedure Statistik [PUBLIC];

Statiska variabler som {ndras:

    Lokala : TextStr, LinenNr, MddmHuvud
%page
%title 2        Loop

Modulen inneh}ller kommandona FOR, NEXT och PAUS.


Lokala statiska variabler
-------------------------

Saknas.


PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


Do_For
------

Beskrivning : FOR-kommandot. S{tter identifieraren till
              startv{rde. Om detta {r st|rre, vid positivt steg,
              eller mindre, vid negativt steg, {n stoppv{rdet
              s{tts kommandolista-pekaren att peka p}
              motsvarande NEXT-kommando. (F|r att sedan s{ttas
              till att peka p} kommandot efter NEXT-kommandot i
              DoTest i modul Batch.) 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Do_For ( VAR ptr      : komm_ptr;
                                     raddelar : linepart_t;
                                     antal    : integer     )
              [PUBLIC];

    ptr      : Kommandolista-pekaren. 

    RadDelar : De olika delarna av kommandoraden i kommando-
               filen. D.v.s. kommandot, identifierare, startv{rde,
               stoppv{rde och eventuellt steg. 

    Antal    : Antal RadDelar.
%page
Do_Next
-------

Beskrivning : NEXT-kommandot. S{tter, f|r att kunna h{mta
              parametrarna fr}n motsvarande FOR-kommando,
              kommandolista-pekaren att peka p} detta. \kar
              identifieraren med steg om detta {r angivet,
              annars med ett. Om identifieraren har g}tt f|rbi
              stoppv{rdet s{tts kommandolista-pekaren att }ter
              peka p} NEXT-kommandot. (F|r att sedan s{ttas till
              att peka p} kommandot efter NEXT-kommandot i
              DoTest i modul Batch.) 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Do_Next ( VAR ptr : komm_ptr ) [PUBLIC];

    ptr : Kommandolista-pekaren. 


Paus
----

Beskrivning : Om antal sekunder ligger inom gr{nsv{rdena, s{tts
              Paus till tiden d} pausen {r slut. I loopen i
              DoTest i modul Batch, utf|rs inga kommandon f|rr{n
              pausen {r slut.

Anropas fr}n: DoTest i modul Batch.

Deklaration : Function Paus ( ptr      : komm_ptr;
                              RadDelar : linepart_t ) : integer4
              [PUBLIC];

    ptr      : Kommandolista-pekaren. 

    RadDelar : De olika delarna av kommandoraden i kommando-
               filen. D.v.s. kommandot och paustiden.
%page
%title 2        Main

Huvudmodulen som startas upp n{r man k|r ig}ng programmet.


Globala statiska variabler
--------------------------

Klist       : Pekare till det f|rsta kommandot i den l{nkade
              kommandolistan. 
ComFileName : Namnet p} filen d{r testsekvensen ligger.
Ant_obj     : Totalt antal objekt under ett test (antal kort-id
              som fyllts i). 
Rack        : Beskrivning av racken med alla 50 korten i. F|r
              varje kort finns vilken hylla och vilket slot
              kortet sitter i samt id f|r kortet.
Obj         : Vilket objekt som {r valt under det att testen
              p}g}r.
Spanningflg : Flagga som {r sann n{r sp{nningen inte {r noll. 
Spanning    : Vilken sp{nning som ligger p} mddmkorten.
AnaSpanning : Vilken sp{nning som ligger p} analogutg}ngen p}
              powercontrollern. 
PrintOn     : Flagga som {r sann om printern {r aktiverad
              (invald och online).
KommandoFil : Kommandofilen (filvariabel).
LoggFil     : Loggfilen (filvariabel).
SerErr      : Indikerar om testen skall avbrytas, s{tts till en
              felkod skillt fr}n No_SerErr om ett s} allvarligt
              fel intr{ffat att det inte l{ngre {r n}gon ide att
              forts{tta testen. 
IdLength    : L{ngd p} l{ngsta id-begreppet f|r ett mddm-kort
              (f|r loggning). 
TotTid      : Totala testtiden i sekunder.


Main
----

Beskrivning : Rensar sk{rmen och kollar om prinern {r p}. S{tter
              defaultv{rden p} f|rsta objekt (1), antal objekt
              (0), testtid (72 tim) och kommandofilnamn
              (CO303.TST). L{gger ut initieringsbild och v{ntar
              p} att funktionstangent skall tryckas. Beroende p}
              funktionstangent anropas inmatning av objekt-id
              eller kommandofilnamn eller startas testen. 

Deklaration : Program Main(input,output);

Anropas fr}n: DOS
%page
%title 2        Mddmkomn

Modulen inneh}ller rutiner som beg{r test av n}gon funktion p}
MDDM-korten. 


Lokala statiska variabler
-------------------------


OldValue : Tabell med v{rden, f|r varje port/kort, som senast
           skickats ner till MDDM-korten. F|r att kunna {ndra
           endast p} enstaka bitar vid skrivning p} en port, (i
           UTSIGNAL-kommandot).


PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


Check_Objekts
-------------

Beskrivning : Kontrollerar att inmatade id st{mmer |verens med
              hur korten sitter i racken. G}r till p} s} vis att
              RAMTEST-kommandot med felaktiga parametrar skickas
              till samtliga kortplatser. Svar f|rv{ntas endast
              fr}n de platser som har f}tt ett id.P} svar v{ntas
              i h|gst 1/2 sekund. Ett svar ser ut s} h{r: FFG
              Allt annat betraktas som uteblivet svar. Allts} kan
              tv} typer av fel uppst}:
              1) Svar f}s fr}n en plats utan id,
              2) Svar fr}n en plats med id uteblir.
              Om fel uppt{cks markeras typen av fel i en tabell,
              testet avbryts och felen loggas.

Anropas fr}n: Startup i modul Batch. 

Deklaration : Procedure Check_Objekts [PUBLIC];

Statiska variabler som {ndras:

    Globala : Obj


Reset_OldValue
--------------

Beskrivning : Nollst{ller OldValue.

Anropas fr}n: Startup i modul Batch.

Deklaration : Procedure Reset_OldValue [PUBLIC];

Statiska variabler som {ndras:

    Lokala : OldValue
%page
Utsignal
--------

Beskrivning : Justerar |nskade bitar p} en port, om portnummer,
              indata och mask ligger inom till}tna gr{nser, G}r
              till p} f|ljande s{tt: Bitar som skall justeras
              maskas fram ur UtData. Bitar som inte skall r|ras
              plockas ur OldValue. Datat och portnumret
              konverteras till ASCII hex-tecken och skickas,
              m.h.a. Send_MddmMessage, tillsammans med
              UTSIGNAL-kommandot (J) till MDDM som skriver datat
              p} porten. 

              Meddelandet till kortet: portnummer ; data J
              Svar fr}n kortet       : J

              \vriga svar {r felaktiga. Kan allts} ej ge
              resultat "negativt". P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas aktuell loggrutin, (f|r eventuell
              utskrift).

Anropas fr}n: DoTest i Batch. 

Deklaration : Procedure Utsignal (     ptr      : komm_ptr;
                                   VAR RadDelar : linepart_t;
                                       Antal    : integer     )
              [PUBLIC];

    ptr      : Pekare till recordet i kommandolistan som
               inneh}ller detta UTSIGNAL-kommando. Anv{nds h{r
               f|r att vid parameterfel kunna skriva ut p}
               vilken rad den felaktiga parametern p}tr{ffades.

    RadDelar : De olika delarna av kommandoraden i kommando-
               filen.

    Antal    : Antal RadDelar.

Statiska variabler som {ndras: 

    Lokala : OldValue
%page
Insignal
--------

Beskrivning : Om portnummer, indata och mask ligger inom
              till}tna gr{nser, konverteras portnumret till
              ASCII hex-tecken och skickas, m.h.a.
              Send_MddmMessage, tillsammans med
              INSIGNAL-kommandot (I) till MDDM som l{ser p}
              porten. 

              Meddelandet till kortet: portnummer I
              Svar fr}n kortet       : l{st v{rde I

              \vriga svar {r felaktiga. Kan allts} ej ge
              resultat "negativt". P} svar v{ntas i h|gst 1
              sekund. 

              Det l{sta v{rdet maskas med masken och j{mf|rs med
              indata. 

              Aktuell loggrutin anropas, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i Batch.

Deklaration : Procedure Insignal (     ptr      : komm_ptr;
                                   VAR RadDelar : linepart_t;
                                       Antal    : integer     )
              [PUBLIC];

    Se Utsignal f|r parameterbeskrivning.
%page
Ramtest
-------

Beskrivning : Eventuella adresser mellan vilka RAM skall testas,
              konverteras till ASCII hex-tecken och skickas,
              m.h.a. Send_MddmMessage, tillsammans med
              RAMTEST-kommandot (G) till MDDM. 

              Meddelandet till kortet: (adress ; adress) G
              Svar fr}n kortet: 00 G     Om OK
                                FF G     Om felaktiga adresser
                                01-07 G  Om fel p} RAM

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 2
              sekunder. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas aktuell loggrutin, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Ramtest (     ptr      : komm_ptr;
                                  VAR RadDelar : linepart_t;
                                      Antal    : integer     )
              [PUBLIC];

    Se Utsignal f|r parameterbeskrivning.


Promtest
--------

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot
              PROMTEST (H) till MDDM. 

              Meddelandet till kortet: H
              Svar fr}n kortet       : checksumma H

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Promtest [PUBLIC];
%page
Watchdog
--------

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot
              WATCHDOG (K) till MDDM. 

              Meddelandet till kortet: K
              Svar fr}n kortet: K     Om OK
                                FF K  Om watchdog ej l|ste ut

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 30
              sekunder. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure Watchdog [PUBLIC];


Reset
-----

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot RESET
              (L) till MDDM. 

              Meddelandet till kortet: L
              Svar fr}n kortet: L     Om OK
                                FF L  Om reset inte fungerat

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 2
              sekunder. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: -  Ej implementerad.

Deklaration : Procedure Reset [PUBLIC];
%page
SetNov
------

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot SETNOV
              (M) till MDDM. 

              Meddelandet till kortet: M
              Svar fr}n kortet       : M

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure SetNov [PUBLIC];


CheckNov
--------

Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot
              CHECKNOV (N) till MDDM. 

              Meddelandet till kortet: N
              Svar fr}n kortet: 00 N  Om OK.
                                FF N  Om fel uppt{ckt.

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure CheckNov [PUBLIC];
%page
SioTest
--------
Beskrivning : Skickar, m.h.a. Send_MddmMessage, kommandot
              SIOTEST (O) till MDDM. 

              Meddelandet till kortet: O
              Svar fr}n kortet: 00 O  Om OK.
                                01-1F O Om fel p} Sio'n

              \vriga svar {r felaktiga. P} svar v{ntas i h|gst 1
              sekund. 

              Svaret fr}n kortet kontrolleras och d{refter
              anropas Logga_TestResultat, (f|r eventuell
              utskrift). 

Anropas fr}n: DoTest i modul Batch.

Deklaration : Procedure SioTest [PUBLIC];
%page
%title 2        Message

Modulen inneh}ller rutiner som sk|ter meddelandehanteringen
mellan kort och PC.


Lokala statiska variabler
-------------------------

Saknas.


PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


Time
----

Biblioteksrutin i MS-Pascal.


Send_MddmMessage
----------------

Beskrivning : Skickar ett meddelande till MDDM-kort. Om det har
              kommit n}got skr{p sedan senaste meddelandet
              s{ndes rensas f|rst receive-bufferten.
              Meddelandena skickas i form av ASCII-tecken, ett i
              taget, m.h.a. WrtCh_a1. F|rst skickas ett STX,
              d{refter eventuella parametrar och slutligen
              kommandot som talar om vilken funktion som skall
              testas. Kommandot g|rs f|rst om till motsvarande
              liten bokstav. 

Anropas fr}n: Rutinerna i modul MddmKommandon.

Deklaration : Procedure Send_MddmMessage
                        ( SRec       : s_message_t;
                          Kommando   : char         )
              [PUBLIC];

    SRec     : Parametrarna och antalet s}dana.

    Kommando : Vilken funktion som skall testas.
%page
Recieve_MddmAnswer
------------------

Beskrivning : H{mtar ett svar fr}n MDDM-kort. Svaret tas emot
              tecken f|r tecken med hj{lp av RdCh_a1. Varje g}ng
              ett tecken l{ses anropas Protokoll, som
              kontrollerar tecknen. N{r STX och r{tt kommando
              har mottagits anses detta som ett svar. P} svar
              v{ntas i beg{rt antal sekunder. Har inget svar
              kommit s{tts timeoutflaggan. Om ett
              kommunikationsfel uppt{cks avbryts mottagandet.
              Under v{ntan p} svar beg{rs ocks} uppdatering av
              klockorna p} sk{rmen. 

Anropas fr}n: Rutinerna i modul MddmKommandon. 

Deklaration : Procedure Recieve_MddmAnswer
                        ( VAR RRec     : r_message_t;
                              Kommando : char         )
              [PUBLIC];

    RRec     : Returparametrarna och antalet s}dana. Tid att
               v{nta p} svar. Flagga som talar om ifall det kom
               n}got svar. Kommunikations-status.

    Kommando : Vilket kommando som har skickats. Anv{nds f|r
               j{mf|relse med svaret fr}n kortet.


Protokoll
---------

Beskrivning : Kontrollerar tecknen fr}n MDDM. N{r ett STX
              uppt{cks anses ett meddelande vara p} v{g och
              |vriga tecken b|rjar kontrolleras. Om tecknet {r
              ett semikolon |kas returparameter-r{knaren, om
              hex-tecken, (ASCII,) l{ggs det in i
              returparameter-arean. Om tecknet {r lika med s{nt
              kommando g|rs ingenting. \vriga tecken orsakar
              v{ntan p} nytt STX. 

Anropas fr}n: Recieve_MddmAnswer. (Intern procedur i densamma.)

Deklaration : Procedure Protokoll;
%page
%title 2        Objekt

Modulen inmatningsrutiner f|r objektidentifikationer och
kommandofilnamn 


PROCEDURE- och FUNCTION-beskrivningar

GetObjekt
---------

Beskrivning : l{ser kort-id och var i racken de {r placerade.
              Skriver f|rst ev. tidigare inmatade id p} sk{rmen,
              v{ntar sedan p} inmatning av nya id. Vilka
              funktionstangenter som {r till}tna i varje f{lt
              finns beskrivna i en array d{r det finns uppr{knat
              till}tna funktionstangenter per f{lt. En lokal
              array med 50 kort-id anv{nds medans inmatning
              sker, efer f{rdig inmatning flyttas alla id till
              den globala variabeln rack. IdLength s{tts till
              l{ngden p} l{ngsta id, dock minst 22. Ant_obj
              s{tts till antal inmatade objekt-id. 

Anropas fr}n: Main

Deklaration : Function GetObjekt (
                        fn_ok : ftang_set ):ftang_t [PUBLIC];

        fn_ok : vilka funktionstangenter som skall avsluta
              imnatningen 

returnerar funktionstangent som avslutat inmatningen

Statiska variabler som {ndras:

globala: Rack, IdLength, ant_obj


redraw
------

Beskrivning : skriver ut kort-id f|r ett rack p} sk{rmen, och
              placerar cursorn f|rst i f|rsta id-f{ltet

Anropas fr}n: GetObjekt (eftersom intern procedur i densamma)

Deklaration : Procedure redraw;
%page
Get_ComFileName
---------------

Beskrivning : Inmatning av kommandofilnamn och testtid.
              Kommandofilnamnet l{ses in till ComFileName och
              har defaultv{rde CO303.TST. Testtiden {r default
              72 timmar men kan {ndras till 1-99 tim. 

Anropas fr}n: Main

Deklaration : Function Get_ComFileName (
                        fn_ok : ftang_set ):ftang_t [PUBLIC];

        fn_ok : vilka funktionstangenter som skall avsluta
              imnatningen 

returnerar funktionstangent som avslutat inmatningen

Statiska variabler som {ndras:

globala: ComFileName, TotTid
%page
%title 2        Objkomn

Modulen inneh}ller rutiner som hanterar rel{kortet f|r att kunna
v{lja in olika testobjekt 

Lokala statiska variabler
-------------------------

Det finns fyra tabeller med 50 * 3 byte i varje. De anv{nds f|r
att inte beh|va dra och sl{ppa rel{erna mer {n n|dv{ndigt. varje
element i arrayen motsv ett visst objekt (kort). f|r varje
objekt finns 6 I/O-portar. Logiskt {r det bara 2 arrayer med 50
objekt och 6 byte per objekt men pascal till}ter h|gst 256 byte
per konstant-array. vid {ndring av objekt l{ses f|rst portens
gamla v{rde det AND'as med tabell 1 och OR'as med tabell 2
resultatet skrivs tillbaka p} porten. inneh}llet i a-tabellerna
{r kopplade till I/O-adresserna #211 - #213, b-tabellerna {r
kopplade till #219 - #21B, 

Tabell 1a och 1b inneh}ller vardera 3 x 50 bytes.
Detta f|r att irrelevanta rel{er ej skall v{xlas.

Tabell 2a och 2b inneh}ller vardera 3 x 50 bytes.
Dessa v{rden anv{nds f|r att v{lja ut en viss kortplats.


PROCEDURE- och FUNCTION-beskrivningar

Ini_RelaPorts
-------------

Beskrivning : Initierar I/O-portarn f|r rel{styrning, port #210
              - #216 och #218 - #21B. (Sl{pper alla rel{er.)

Anropas fr}n: Startup och DoTest i modul BATCH
              
Deklaration : Procedure Ini_RelaPorts   [PUBLIC];


Stall_Relaerna
---------------

Beskrivning : Staller om relaerna vid val av objekt. anv{nder
              sig av rel{tabellerna f|r att avg|ra vad som skall
              skrivas i I/O-portarna. Skriver uppe till v{nster
              p} bildsk{rmen vilken hylla och vilket slot som
              har valts in. 

Anropas fr}n: Connect_Kort i denna modul (OBJKOMN)
              Choose_objekt i denna modul (OBJKOMN)

Deklaration : Procedure Stall_Relaerna;
%page
Connect_kort
------------

Beskrivning : kopplar in 12-volten genom att se till att n}got
              eller n}gra av 6 speciella rel{er {r sl{ppta. 


Anropas fr}n: Set_Spanning i modul PWCKOMN

Deklaration : Procedure Connect_Kort [PUBLIC];


DisConnect_kort
---------------

Beskrivning : Kopplar bort 12-volten genom att dra 6 speciella
              rel{er. Blankar f{lten uppe till v{nster p}
              bildsk{rmen som skall visa vilken hylla och vilket
              slot som har valts in. 

Anropas fr}n: Set_Spanning i modul PWCKOMN,
              DoTest i modul BATCH.

Deklaration : Procedure DisConnect_Kort [PUBLIC];


Choose_Objekt
-------------

Beskrivning : v{ljer ett objekt genom att koppla om rel{erna p}
              l{mpligt s{tt. Loggar om det blir fel.

Anropas fr}n: DoTest i BATCH-modulen

Deklaration : Procedure Choose_Objekt (
                        ptr      : komm_ptr;
                        RadDelar : linepart_t ) [PUBLIC];

        ptr : pekare till kommandot i den l{nkade listan 
        RadDelar : kommandoraden uppdelad i element 

Statiska variabler som {ndras:

Globala: Obj s{tts till det valda objektet. 
%page
%title 2        Pwckomn

Modulen inneh}ller rutiner som hanterar powercontrollern. 

Lokala statiska variabler
-------------------------

Modulen inneh}ller inga statiska variabler


PROCEDURE- och FUNCTION-beskrivningar

Flush_PwCBuffer
---------------

Beskrivning : T|mmer inneh}llet i inbufferten med svar fr}n
              powercontrollern genom anrop till kommunikations-
              paketet, vid ev fel skrivs felmeddelande p} loggen,

Anropas fr}n: PwCComm, innan ett kommando s{nds till PWC'n 
              PwC_OK, innan ett kommando s{nds till PWC'n 

Deklaration : Procedure Flush_PwCBuffer;


PwCCTS
------

Beskrivning : Kontrollerar om powercontrollern {r ansluten genom
              att se om det finns n}gon CTS-signal fr}n den,
              v{ntar i max 2 sekunder, om CTS inte finns skrivs
              ett felmeddelande ut p} loggen och false
              returneras, finns CTS returneras true. 

Anropas fr}n: PwCComm, innan ett kommando s{nds till PWC'n 
              PwC_OK, innan ett kommando s{nds till PWC'n 

Deklaration : Function PwCCTS : boolean;

Statiska variabler som {ndras:

Globala: SerErr s{tts till PwCContact av Logga_SerErr om pwc'n
              inte har lagt ut CTS 
%page
PwCComm
-------

Beskrivning : Skickar ett kommando till pwc'n, och v{ntar p} ett
              svar i 150 millesek, kollar f|rst att kontakt
              finns med powercontrollern. Om inget svar kommer
              anses pwc'n ha uppfattat kommandot, annars kollas
              svaret och om det {r en service request fr}n pwc'n
              loggas det och SerErr-flaggan s{tts till
              PwCCommErr. 

Anropas fr}n: Ini_Pwc, f|r att skicka initieringskommandona 
              Exit_Pwc, f|r att skicka avlsutande kommandona 
              Set_Spanning, vid sp{nnings-kommandot 
              Set_Analog, vid analogsp{nnings-kommandot 

Deklaration : Procedure PwCComm ( KomndStr : lstr10 ); 

        KomndStr : kommandostr{ngen som skall skickas

Statiska variabler som {ndras:

Globala: SerErr s{tts till PwcCommErr av Logga_SerErr om pwc'n
              har skickat SRQ 


Check_PwC_Answer
----------------

Beskrivning : Kontrollerar ett svar fr}n pwc'n och kollar om det
              {r en service request (SRQ). I s} fall s{tts
              SRQAnswer till true och SRQ-orsaken avkodas samt
              skrivs p} loggen. 

Anropas fr}n: PwCComm, eftersom den ing}r densamma 

Deklaration : Procedure Check_PwC_Answer;


PwC_OK
------

Beskrivning : Kontrollerar om powercontroller "lever", genom att
              f|rst kontrollera om pwc'n l{gger ut CTS, sedan
              skicka ett VerifySlot-kommando och v{nta p} ett
              svar. Innan kommandot skickas t|mms
              kommunikationsbufferten. Svaret skall vara 'SL1',
              om det {r det returneras true annars false. 

Anropas fr}n: Ini_PwC

Deklaration : Function PwC_OK : boolean;
%page
Ini_PwC
-------

Beskrivning : Initierar powercontrollern genom att skicka en
              upps{ttning kommandon till denna. (Vilka
              initieringar som g|rs finns beskrivna i funktions-
              beskrivningen f|r pwc'n.) Vid fel loggas detta och
              SerErr-flaggan s{tts till PwC_Init. Skriver {ven
              att sp{nningen satts till 5 volt uppe till v{nster
              p} bildsk{rmen. 

Anropas fr}n: Startup i batch-modulen.

Deklaration : Procedure Ini_PwC [PUBLIC];

Statiska variabler som {ndras:

Globala: SerErr s{tts till Pwc_Init av Logga_SerErr om pwc'n har
              skickat SRQ 
         Spanning s{tts till 5 (volt) 
         SpanningFlg s{tts till true (sp{nning <> 0 volt) 
         AnaSpanning s{tts till 0 (volt) 


Exit_PwC
--------

Beskrivning : Avslutar powercontrollern genom att skicka en
              upps{ttning kommandon till denna. (Vilka
              initieringar som g|rs finns beskrivna i funktions-
              beskrivningen f|r pwc'n.) Vid fel loggas 
              detta och SerErr-flaggan s{tts till PwC_Init. 

Anropas fr}n: Startup i batch-modulen.

Deklaration : Procedure Exit_PwC [PUBLIC];
%page
Set_Spanning
-----------

Beskrivning : S{tter sp{nningen fr}n powercontrollern genom att
              skicka ett kommando till denna. Om sp{nningen
              skall vara noll volt kopplas {ven 12-volten bort
              via rel{kortet. Kontroll sker att sp{nningsv{rdet
              ligger inom max och min-intervallen. Om fel loggas
              detta. Skriver {ven vad sp{nningen satts till uppe
              till v{nster p} bildsk{rmen. 

              OBS! F|r att kompensera sp{nningsfallet p} v{g
              till korten beg{rs alltid( ,utom vid 0 volt,) 0.3
              volt h|gre sp{nning {n den man vill ha |ver
              korten. 

Anropas fr}n: DoTest i batch-modulen.

Deklaration : Procedure Set_Spanning (
                             ptr : komm_ptr;
                        RadDelar : linepart_t ) [PUBLIC];

        ptr : pekare till kommandot i den l{nkade listan 
        RadDelar : kommandoraden uppdelad i element 

Statiska variabler som {ndras:

Globala: Spanning s{tts till sp{nningen (i volt). 
         SpanningFlg s{tts till true om sp{nningen <> noll
              annars false 


Set_Analog
----------

Beskrivning : S{tter analog-sp{nningen fr}n powercontrollern
              genom att skicka ett kommando till pwc'n. Kontroll
              sker att sp{nningsv{rdet ligger inom max och
              min-intervallen. Fel loggas p} loggen. 

Anropas fr}n: DoTest i batch-modulen.

Deklaration : Procedure Set_Analog (
                             ptr : komm_ptr;
                        RadDelar : linepart_t ) [PUBLIC]; 

        ptr : pekare till kommandot i den l{nkade listan 
        RadDelar : kommandoraden uppdelad i element 

Statiska variabler som {ndras:

Globala: AnaSpanning s{tts till sp{nningen (i volt). 
%page
%title 2        Screen

Modulen inneh}ller de rutiner som hanterar bildsk{rmen

Lokala statiska variabler
-------------------------

Printed : Talar om vilka funktionstangenter som ar "t{nda".


PROCEDURE- och FUNCTION-beskrivningar

ClrLine
-------

Beskrivning : blankar en rad p} bildsk{rmen utan att {ndra p}
              cursorpositionen 

Anropas fr}n: BATCH och MAIN

Deklaration : Procedure ClrLine ( rad : integer ) [PUBLIC];

        rad : vilken rad som skall blankas


ClrEol
------

Beskrivning : blankar fr}n cursorpositionen till slutet av raden 

Anropas fr}n: OBJEKT

Deklaration : Procedure ClrEol [PUBLIC];


InvVid
------

Beskrivning : St{ller om sk{rmen till inversed video

Anropas fr}n: BATCH, LOGG och SCREEN

Deklaration : Procedure InvVid [PUBLIC];


NorVid
------

Beskrivning : St{ller tillbaka sk{rmen till normal video 

Anropas fr}n: BATCH, LOGG och SCREEN

Deklaration : Procedure NorVid [PUBLIC];
%page
CposWrite
---------

Beskrivning : Positionerar cursorn, skriver ut en str{ng och
              positionerar tillbaka cursorn. 

Anropas fr}n: BATCH, LOGG, OBJEKT och SCREEN

Deklaration : Procedure CposWrite (
                              rad,kol : integer;
                        CONST strang  : string  ) [PUBLIC];

        rad : vilken rad
        kol : vilken kolumn
        strang : str{ngen som skall skrivas ut


ScrollWriteLn
-------------

Beskrivning : skriver ut en str{ng i scroll-f|nstret och
              scrollar vid behov 

Anropas fr}n: BATCH, LOGG och SCREEN 

Deklaration : Procedure ScrollWriteLn (
                        CONST strang : string  ) [PUBLIC];

        strang : str{ngen som skall skrivas ut


DebugWriteLn
------------

Beskrivning : skriver ut en str{ng i scroll-f|nstret och
              scrollar vid behov. Anv{nds bara f|r
              debuginformation och ers{tts av en dummyrutin vid
              produktion. 

Anropas fr}n: BATCH, LOOP, MESSAGE, PWCKOMN, SCREEN, SYNT och
              VARHANDL 

Deklaration : Procedure DebugWriteLn (
                        CONST strang : string  ) [PUBLIC];

        strang : str{ngen som skall skrivas ut
%page
ScrollWrite
-----------

Beskrivning : skriver ut en str{ng utan radframmatning i
              scroll-f|nstret 

Anropas fr}n: SCREEN 

Deklaration : Procedure ScrollWrite (
                        CONST strang : string  ) [PUBLIC];

        strang : str{ngen som skall skrivas ut


DebugWrite
----------

Beskrivning : skriver ut en str{ng i scroll-f|nstret. Anv{nds
              bara f|r debuginformation och ers{tts av en
              dummyrutin vid produktion. 

Anropas fr}n: MESSAGE och PWCKOMN 

Deklaration : Procedure DebugWrite (
                        CONST strang : string  ) [PUBLIC];

        strang : str{ngen som skall skrivas ut


DisplayFel
----------

Beskrivning : skriver ut en logg-str{ng i scroll-f|nstret med
              inverse video. F|rst tas de 29 f|rsta tecknena
              (dvs. tid, f|rbrukad testtid, hylla, slot och
              sp{nning) i str{ngen bort, max 80 tecken av det
              som blir kvar skrivs ut. 

Anropas fr}n: LOGG

Deklaration : Procedure DispayFel (
                        CONST str : string  ) [PUBLIC];

        str : str{ngen som skall skrivas ut
%page
ErrMsg
------

Beskrivning : piper, skriver ut ett meddelande i scrollf|nstret
              med inversed video samt "kvittera med valfri
              tangent". v{ntar sedan p} att det trycks p} n}gon
              tangent. 

Anropas fr}n: DoTest i BATCH 
              MAIN 
              ShowFileErr i SCREEN 

Deklaration : Procedure ErrMsg (
                        CONST str : string  ) [PUBLIC];

        str : str{ngen som skall skrivas ut


DisplayTimes
------------

Beskrivning : skriver aktuell tid och f|rbrukad testtid i |vre
              h|gra h|rnet p} bildsk{rmen. 

Anropas fr}n: - DoTest i BATCH, en g}ng f|r varje kommando i
              loopen. 
              - InitTime i TID. 
              - Recieve_MddmAnswer i MESSAGE, n{r man ligger och
              v{ntar p} ett svar fr}n mddm-kortet. 

Deklaration : Procedure DisplayTimes [PUBLIC];


ShowFileErr
-----------

Beskrivning : Skriver ut ett meddelande via ErrMsg ex:
              'Fel vid AAAA BBBB "CCCC", felkod: DD',
              d{r AAAA,BBBB, CCCC, DD {r parametrar.

Anropas fr}n: - LOGG, SCREEN och SYNT vid open, read och write
              p} filer och printer 

Deklaration : Procedure ShowFileErr(
                 CONST  action  : string;
                        filtyp  : lstr80;
                        filnamn : lstr80;
                        kod     : integer ) [PUBLIC];

        action : motsvaras av AAAA i ovanst}ende exempel
        filtyp : motsvaras av BBBB i ovanst}ende exempel
        filnamn : motsvaras av CCCC i ovanst}ende exempel
        kod : motsvaras av DD i ovanst}ende exempel
%page
Menu
----

Beskrivning : Skriver ut en meny p} sk{rmen fn. finns det bara
              objektinmatningsbilden. 

Anropas fr}n: GetObjekt i modul OBJEKT 

Deklaration : Procedure Menu( val : menu_t ) [PUBLIC]; 

        val : vilken bild man vil ha ut, kan vara m_main eller
              m_objekt 


Write_InitBild
--------------

Beskrivning : Skriver ut initieringsbilden p} sk{rmen och v{ntar
              p} att en funktionstangent skall tryckas. 

Anropas fr}n: Main

Deklaration : Function Write_InitBild (
                        fn_ok : ftang_set ) : ftang_t [PUBLIC];

        fn_ok : vilka funktionstangenter som {r till}tna 

returnerar tryckt funktionstangent. 


Clr_FTangPrintFlgs
------------------

Beskrivning : Talar om att inga funktionstangenter {r "t{nda",
              dvs. s{tter hela Printed-arrayen till false. M}ste
              g|ras samtidigt som rad 25 blankas s} att
              WriteLn25 vet vet hur rad 25 ser ut. 

Anropas fr}n: Main

Deklaration : Procedure Clr_FTangPrintFlgs [PUBLIC];
%page
WriteLine25
-----------

Beskrivning : Skriver ut vilka funktionstangenter som kan
              anv{ndas i olika situationer p} rad 25. De som
              finns markerade i Printed-arrayen {r redan
              utskrivna och beh|ver ej "t{ndas". S{tter flaggan
              i Printed-arrayen f|r varje funktionstangent som
              "t{nds", clearar flaggan f|r de tangenter som
              "sl{cks". 

Anropas fr}n: MAIN

Deklaration : Procedure WriteLine25 ( fn_ok : ftang_set )
              [PUBLIC]; 

        fn_ok : vilka funktionstangenter som skall vara "t{nda" 

Statiska variabler som {ndras:

    Lokala : Printed
%page
%title 2        Synt

Modulen inneh}ller alla rutiner som sk|ter syntaxchecken av
kommandofilen. 


PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


SplitLine
---------

Beskrivning : Delar upp en rad fr}n kommandofilen i element, d{r
              varje element {r det som avskilljs med blanka, tab
              eller kommatecken. Kontrollerar att numeriska
              v{rden {r ok, och konverterar dem till variabler.
              Returnerar felkod om det uppt{cks syntaxfel p}
              raden.

Anropas fr}n: 1) DoTest i modul Batch. (n{r kommandot utf|rs.) 
              2) Do_Next i modul Loop. (n{r ett next-kommando
              ska titta p} motsv. for-komanndo.) 
              3) SkapaKommandoLista i denna modul. (vid
              syntaxkontroll.) 

Deklaration : Procedure SplitLine (
                        VAR delarna : linepart_t;
                        VAR antal   : integer;
                        VAR err     : error_t;
                        VAR raden   : lstr80) [PUBLIC];

        Delarna : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
        antal : Antal element i delarna. 
        Err : felkod, visar om raden inneh}ller syntaxfel. 
        Raden : Raden som den ser ut i kommandofilen. 


ValOut
------

Beskrivning : Kontrollerar om ett v{rde ligger mellan ett max
              och ett minv{rde. Om v{rdet ligger mellan
              gr{nserna returnerar fall false annars true. 

Anropas fr}n: Flera av procedurerna i denna modul (Synt). 

Deklaration : Function ValOut(vaerde,lo,hi:real):boolean;

        Vaerde : V{rdet som skall kollas. 
        Lo : Undre gr{nsen. 
        Hi : \vre gr{nsen. 
%page
CheckFor
--------

Beskrivning : Syntaxkontrollerar FOR-kommandot, skapar
              loopvariabeln om den inte redan finns, loggar om
              det blir fel. Adressen till kommandot i den
              l{nkade listan l{ggs p} en stack s} att motsv.
              next-kommando skall hitta den. Kontrollerar att
              variablen inte {r en f|rdefinierad, att antal
              parametrar till for-kommandot {r tre eller fyra,
              att parametrarna {r av till}ten typ och att
              loopvariabeln inte redan anv{nds i en yttre
              for-slinga. Returnerar felkod om fel uppt{cks.

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckFor(
                        curr:komm_ptr;  
                    VAR fnstack:fornext_a;
                    VAR fnind:integer;
                    VAR lineparts:linepart_t;
                        numparts:integer;
                    VAR error:error_t);

        Curr : Adress till for-kommandot i den l{nkade listan. 
        Fnstack : For-next stacken. Anv{nds f|r att hitta motsv
              for-kommando till ett next-kommando. 
        Fnind : Index i fnstack, var nuvarande for-next loop har
              sin kontrollinformation. 
        Lineparts : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
        Numparts : Antal element i lineparts. 
        Error : felkod, visar om raden inneh}ller syntaxfel. 
%page
CheckNext
---------

Beskrivning : Syntaxkontrollerar NEXT-kommandot, kollar att det
              finns ett for-kommando p} fornext-stacken och
              kopplar i hop det med next-kommandot. Returnerar
              felkod om fel uppt{cks. Loggar om det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckNext(
                        curr:komm_ptr;  
                    VAR fnstack:fornext_a;
                    VAR fnind:integer;
                        numparts:integer;
                    VAR error:error_t);

        Curr : Adress till next-kommandot i den l{nkade listan. 
        Fnstack : For-next stacken. Anv{nds f|r att hitta motsv
              for-kommando.
        Fnind : Index i fnstack, var nuvarande for-next loop har
              sin kontrollinformation. 
        Numparts : Antal element i raden.
        Error : felkod, visar om raden inneh}ller syntaxfel. 


CheckUtsignal
-------------

Beskrivning : Syntaxkontrollerar UTSIGNAL-kommandot, kollar att
              utsignalkommandot har r{tt antal parametrar, (2
              eller 3), att de {r av r{tt typ (variabel eller
              v{rde), att de {r mellan 0 och 255 och loggar om
              det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckUtsignal(
                        curr:komm_ptr;  
                    VAR lineparts:linepart_t;
                        numparts:integer;
                    VAR error:error_t);

        Curr : Adress till utsignal-kommandot i den l{nkade
              listan. 
        Lineparts : raden uppdelad i element.
        Numparts : Antal element i raden. 
        Error : felkod, visar om raden inneh}ller syntaxfel.
%page
CheckInsignal
-------------

Beskrivning : Syntaxkontrollerar INSIGNAL-kommandot, kollar att
              Insignalkommandot har r{tt antal parametrar, (2, 3
              eller 4), att de {r av r{tt typ (variabel eller
              v{rde), att de {r mellan 0 och 255 och loggar om
              det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckInsignal(
                        curr:komm_ptr;  
                    VAR lineparts:linepart_t;
                        numparts:integer;
                    VAR error:error_t);

        Curr : Adress till Insignal-kommandot i den l{nkade
              listan. 
        Lineparts : raden uppdelad i element.
        Numparts : Antal element i raden.
        Error : felkod, visar om raden inneh}ller syntaxfel. 


CheckRamtest
------------

Beskrivning : Syntaxkontrollerar RAMTEST-kommandot, kollar att
              Ramtestkommandot har r{tt antal parametrar, (inga
              eller 2), att de {r av r{tt typ (variabel eller
              v{rde), att f|rstaparametern inte {r st|rre {n den
              andra om 2 v{rden angetts, kollar att
              parameterv{rden {r mellan 0 och 65535 och loggar
              om det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckRamtest(
                        curr:komm_ptr;  
                    VAR lineparts:linepart_t;
                        numparts:integer;
                    VAR error:error_t);

        Curr : Adress till Ramtest-kommandot i den l{nkade
              listan. 
        Lineparts : raden uppdelad i element.
        Numparts : Antal element i raden. 
        Error : felkod, visar om raden inneh}ller syntaxfel. 
%page
CheckIoport
-----------

Beskrivning : Syntaxkontrollerar IOPORT-kommandot, kollar att
              ioportkommandot har r{tt antal parametrar, (2 st),
              att de {r av r{tt typ (v{rde), att f|rsta
              parametern inte {r st|rre {n den andra, kollar att
              parameterv{rden {r mellan 0 och 65535 och loggar
              om det blir fel. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckIoport(
                        curr:komm_ptr;
                    VAR lineparts:linepart_t;
                        numparts:integer;
                    VAR error:error_t);

        Curr : Adress till Ioport-kommandot i den l{nkade
              listan. 
        Lineparts : raden uppdelad i element.
        Numparts : Antal element i raden. 
        Error : felkod, visar om raden inneh}ller syntaxfel. 


CheckNoparm
-----------

Beskrivning : Syntaxkontrollerar PROMTEST, WATCHDOG, SETNOV,
              CHECKNOV och SIOTEST dvs alla kommandon utom NEXT
              som {r parameterl|sa. Kontrollerar att de inte har
              n}gra parametrar. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckNoparm(
                        curr:komm_ptr;  
                        numparts:integer;
                    VAR error:error_t);

        Curr : Adress till kommandot i den l{nkade listan. 
        Numparts : Antal element i raden. 
        Error : felkod, visar om raden inneh}ller syntaxfel. 
%page
CheckEnparm
-----------

Beskrivning : Syntaxkontrollerar SPANNING, ANALOG, PAUS och
              OBJEKT dvs de kommandon som bara ska ha en
              parameter. Kollar att parameter inte {r en str{ng
              samt att den ligger mellan gr{nsv{rden. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckEnparm(
                        curr : komm_ptr;
                    VAR lineparts : linepart_t;
                        numparts : integer;
                    VAR error : error_t;
                        lolim : real;
                        hilim : real);

        Curr : Adress till kommandot i den l{nkade listan. 
        Lineparts : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
        Numparts : Antal element i raden. 
        Error : felkod, visar om raden inneh}ller syntaxfel. 
        Lolim : l{gsta v{rde som parametern f}r anta.
        Hilim : h|gsta v{rde som parametern f}r anta. 


CheckLogg
---------

Beskrivning : Syntaxkontrollerar LOGG-kommandot. Kollar att det
              har minst en parameter. 

Anropas fr}n: SyntaxCheck

Deklaration : Procedure CheckLogg(
                        curr : komm_ptr;
                    VAR lineparts : linepart_t;
                        numparts : integer;
                    VAR error : error_t);

        Curr : Adress till logg-kommandot i den l{nkade listan. 
        Lineparts : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
        Numparts : Antal element i raden. 
        Error : felkod, visar om raden inneh}ller syntaxfel. 
%page
SyntaxCheck
-----------

Beskrivning : Syntaxkontrollerar en rad i kommandofilen. Kollar
              att f|rsta delen av raden {r ett giltigt kommando,
              och att det inte har n}gra syntaxfel. 

Anropas fr}n: SkapaKommandoLista

Deklaration : Procedure SyntaxCheck(
                        curr:komm_ptr;
                    VAR fnstack:fornext_a;
                    VAR fnind:integer;
                    VAR lineparts:linepart_t;
                        numparts:integer;
                    VAR error:error_t);

        Curr : Adress till logg-kommandot i den l{nkade listan. 
        Fnstack : For-next stacken. Anv{nds f|r att hitta motsv
              for-kommando till ett next-kommando. 
        Fnind : Index i fnstack, var nuvarande for-next loop har
              sin kontrollinformation. 
        Lineparts : Raden fr}n kommandofilen uppdelad i
              best}ndsdelar. 
        Numparts : Antal element i raden. 
        Error : felkod, visar om raden inneh}ller syntaxfel. 


Open_KommandoFil
----------------

Beskrivning : \ppnar KommandoFil, filnamnet st}r i den globala
              variabeln ComFileName. Meddelar p} bildsk{rmen om
              |ppnandet misslyckades, samt returnerar en felkod.
              Felkoden kan vara NoError om |ppning gick bra
              annars OpenComFile. 

Anropas fr}n: DoTest i modul Batch. 

Deklaration : Open_KommandoFil( VAR errcode:error_t ) [PUBLIC];

        Errcode : Felkod, visar om det g}tt bra att |ppna filen. 

Statiska variabler som {ndras:

Globala: KommandoFil.
%page
SkapaKommandoLista
------------------

Beskrivning : Huvudrutinen i syntaxcheckaren. Initierar l{nkade
              variabel- och kommando-listorna, l{ser in en rad i
              taget fr}n kommandofilen, utf|r syntaxkontroll av
              raden, kontrollerar att det finns tillr{ckligt med
              minne, l{mnar dock utrymme motsv. 20 l{nkar s} att
              stacken f}r plats, allokerar minne f|r raden i
              l{nkade kommandolistan, ser till att fel i raden
              loggas, returnerar felkod om syntaxkontrollen inte
              g}tt bra. Klist initieras till att peka p} det
              f|rsta kommandot i den l{nkade listan. 

Anropas fr}n: DoTest i modul Batch. 

Deklaration : Procedure SkapaKommandoLista(VAR errcode:error_t)
              [PUBLIC]; 

        Errcode : Felkod, visar om det blivit n}got syntaxfel. 

Statiska variabler som {ndras:

Globala: klist.


TaBortKommandoLista
-------------------

Beskrivning : ]terl{mnar det minnet som tidigare allokerats till
              kommandolistan. Klist s{tts till NULL. 

Anropas fr}n: DoTest i modul Batch. 

Deklaration : Procedure TaBortKommandoLista [PUBLIC];

Statiska variabler som {ndras:

Globala: klist.
%page
%title 2        Temp

Modulen inneh}ller tills vidare bara en dummyprocedur som inte
g|r n}gonting, t{nkt att i framtiden kunna anv{ndas f|r att
reglera temperauren i omgivningen runt mddm-korten. 
%page
%title 2        Tid

Modulen inneh}ller rutiner som hanterar tiderna

Lokala statiska variabler
-------------------------

Last_Ant_Sec : Senaste "antal sekunder sedan 00:00"
Last_SecUsed : Senaste "forbrukad testtid" i sekunder


PROCEDURE- och FUNCTION-beskrivningar


RoundX
------

Beskrivning : avrundar ett flyttal till integer4. finns pga att
              Round4 inte klarar av att avrunda 32768 vilket
              troligtvis {r en bug i pascal. 

Anropas fr}n: MDDMKOMN och TID modulerna

Deklaration : Function RoundX ( re : real ) : integer4 [PUBLIC]; 

        re : talet som skall rundas av


Datum
-----

Beskrivning : Returnerar dagens datum i "svensk" form dvs.
              ]]-MM-DD 

Anropas fr}n: LOGG-modulen

Deklaration : Function Datum : str9 [PUBLIC]; 


SecUsed
-------

Beskrivning : Returnerar antal sekunder det g}tt sedan testen
              startades. 

Anropas fr}n: BATCH, LOGG, MESSAGE, PWCKOMN och TID-modulerna 

Deklaration : Function Datum : integer4 [PUBLIC]; 
%page
IniTime
-------

Beskrivning : initierar Last_Ant_Sec till antal sekunder sedan
              00:00 och Last_SecUsed till 0 samt skriver ut
              klockorna p} bildsk{rmen. 

Anropas fr}n: BATCH-modulen

Deklaration : Procedure IniTime [PUBLIC]

Statiska variabler som {ndras:

lokala: Last_Ant_Sec, Last_SecUsed


TimeUsed
--------

Beskrivning : H{mtar forbrukad testtid i timmar, minuter och
              sekunder. 

Anropas fr}n: SCREEN och LOGG-modulerna

Deklaration : Function TimeUsed : str9 [PUBLIC]; 
%page
%title 2        Varhandl

Modulen inneh}ller rutiner som sk|ter om de variabler som kan
definieras upp i kommandofilen 


Lokala statiska variabler
-------------------------

FdefVarTab : array med de f|rdefinierade variablerna, varje
              element inneh}ller variables namn och en pekare
              till densamma

Ant_Fdef_Var : antal f|rdefinierade variabler dvs hur m}nga av
              elementen i FdefVarTab som utnyttjas 

vlist : den l{nkade listan av variabler, d{r varje element
              inneh}ller namn, v{rde och en pekare till n{sta
              element i listan. Sista variabelns pekare {r NULL. 


PROCEDURE- och FUNCTION-beskrivningar

ClrVlist
--------

Beskrivning : nollst{ller den l{nkade listan, dvs. s{tter vlist
              till NULL. 

Anropas fr}n: SkapaKommandoLista i modul Synt

Deklaration : ClrVlist [PUBLIC]

Statiska variabler som {ndras:

lokala: vlist


Make_FdefVarTab
---------------

Beskrivning : l{gger upp alla f|rdefinierade variabler i en
              array (FdefVarTab) och antal f|rdefinierade
              variabler (Ant_Fdef_Var). 

Anropas fr}n: DoTest i modul Batch 

Deklaration : Make_FdefVarTab [PUBLIC] 

Statiska variabler som {ndras:

lokala: FdefVarTab, Ant_Fdef_Var 
%page
CheckVar
--------

Beskrivning : kontrollerar om en variabel {r f|rdefinierad dvs.
              om den finns i FdefVarTab. Returnerar
              "f|rdefinierad" eller "egendefinierad" 

Anropas fr}n: Syntaxkontrollen

Deklaration : function CheckVar ( varnamn : lstr10 ) : vartyp_t
              [PUBLIC]; 

        varnamn : namnet p} variabeln


MakeVar
-------

Beskrivning : kontrollerar om en variabel finns i variabel-
              listan, om den inte finns l{gges den upp 

Anropas fr}n: Syntaxkontrollen

Deklaration : Procedure MakeVar ( varnamn : lstr10 ) [PUBLIC] 

        varnamn : namnet p} variabeln

Statiska variabler som {ndras:

lokala: vlist


Get_VarValue
------------

Beskrivning : h{mtar v{rdet p} en variabel, kollar f|rst bland
              de f|rdefinierade variablerna, och sedan i den
              l{nkade variabellistan. Eftersom variablerna
              skapats av syntaxkollen skall alla variabler som
              refereras finnas men om en variabel inte finns
              skrivs en felutskrift ut. 

Anropas fr}n: ett flertal moduler

Deklaration : Function Get_VarValue ( varnamn : lstr10 ) : real
              [PUBLIC] 

        varnamn : namnet p} variabeln

returnerar v{rdet p} variabeln
%page
Put_VarValue
------------

Beskrivning : uppdaterar en variabels v{rde, i den l{nkade
              listan. Eftersom variablerna skapats av
              syntaxkollen skall alla variabler som refereras
              finnas men om en variabel inte finns skrivs en
              felutskrift ut. 

Anropas fr}n: FOR och NEXT-kommandot i LOOP-modulen. 

Deklaration : Procedure Put_VarValue (
                        varnamn  : lstr10;
                        varvarde : real ) [PUBLIC] 

        varnamn : namnet p} variabeln
        varvarde : v{rdet p} variabeln


TaBortVariabelLista
-------------------

Beskrivning : g}r igenom den l{nkade variabellistan och
              }terl{mmnar minnet f|r varje variabel, s{tter
              vlist till NULL 

Anropas fr}n: DoTest i batch-modulen

Deklaration : Procedure TaBortVariabelLista [PUBLIC] 
%page
%title 0
%title 1        Funktionsbeskrivning

%title 2        Struktur
%page
%title 2        Globala variabler

Detta {r de globala variabler som ing}r i PC-programmen: 


        Klist : pekare till det f|rsta kommandot i den l{nkade
              kommandolistan. Initieras till NIL vid uppstart
              och s{tts till att peka till kommandolistan av
              syntaxcheckaren, n{r ett test {r f{rdigt
              }terst{lls den till NIL. Anv{nds i f|ljande
              moduler: 

                BATCH, MAIN, SYNT

        ComFileName : namnet p} filen d{r testsekvensen ligger.
              Defaultv{rde p} filnamnet {r CO303.TST. Anv{nds i
              f|ljande moduler: 

                MAIN, OBJEKT, SYNT

        Ant_obj : totalt antal objekt under ett test (antal
              kort-id som fyllts i). Anv{nds i f|ljande moduler: 

                BATCH, MAIN, MDDMKOMN, OBJEKT, OBJKOMN, VARHANDL

        Rack : beskrivning av racken med alla 50 korten i, f|r
              varje kort finns vilken hylla och vilket slot
              kortet sitter i samt id f|r kortet. Anv{nds i
              f|ljande moduler:

                LOGG, MAIN, MDDMKOMN, OBJEKT, OBJKOMN
 
        Obj : vilket objekt (index i Rack) som {r valt under det
              att testen p}g}r. Anv{nds i f|ljande moduler: 

                LOGG, MDDMKOMN, OBJKOMN 

        Spanningflg : flagga som {r sann om sp{nning inte {r
              noll. Anv{nds i f|ljande moduler: 

                OBJKOMN, PWCKOMN

        Spanning : Vilken sp{nning som ligger p} mddmkorten,
              enligt senaste sp{nningskommando. Anv{nds i
              f|ljande moduler: 

                LOGG, PWCKOMN
 
        AnaSpanning : Vilken sp{nning som ligger p}
              analogutg}ngen p} powercontrollern, enligt senaste
              analogkommando. Anv{nds i f|ljande moduler: 

                PWCKOMN

        PrintOn : flagga som {r sann om printern {r aktiverad
              (invald och online). Anv{nds i f|ljande moduler:

                BATCH, LOGG
 
        KommandoFil : kommandofilen (filvariabel). Anv{nds i
              f|ljande moduler: 

                BATCH, SYNT

        LoggFil : loggfilen (filvariabel). Anv{nds i f|ljande
              moduler: 

                BATCH, LOGG

        SerErr : indikerar om testen skall avbrytas, s{tts till
              en felkod skillt fr}n No_SerErr om ett s}
              allvarligt fel intr{ffat att det inte l{ngre {r
              n}gon ide att forts{tta testen. Anv{nds i f|ljande
              moduler: 

                BATCH, LOGG

        IdLength : l{ngd p} l{ngsta id-begreppet f|r ett
              mddm-kort (f|r loggning). Om idbegreppen har en
              kortare l{ngd {n 22 s{tts den till 22. Anv{nds i
              f|ljande moduler: 

                LOGG, OBJEKT

        TotTid : totala testtiden i sekunder. Anv{nds i f|ljande
              moduler: 

                BATCH, MAIN, OBJEKT
%page
%title 2        Kommando-interpretator

 Interpretatorn skall i "batch-mode" kunna hantera olika
kommandon. Vissa kommandon kan ha parametrar, parametrar anges
efter kommandot }tskillt av blank, komma eller tab. P} varje rad
f}r kommentarer skrivas efter en apostrof ('). Som parametrar
kan anges decimala eller hexadecimala v{rden eller idendifierare
definierade i FOR-kommandon, dessutom finns ett antal
f|rdefinierade identifierare. F|r vissa kommandon {r
parametrarnas v{rden begr{nsade av max och min-v{rden, om
gr{nsv{rdena |verskrids under testens g}ng utf|rs inte
kommandot, vilket {ven meddelas p} loggen. 


%title 3        Kommandofilen.

 Testsekvenserna f|r TMC-systemet ligger lagrade i en
kommandofil. Varje rad i kommandofilen inneh}ller h|gst ett
kommando. Till varje kommando kan det finnas en eller flera
parametrar. Kommandon och parametrar avskiljs med blank, tab
eller komma. Om en parameter skall best} av en textstr{ng m}ste
det vara citationstecken (") omkring texten. 

 F|re ett test s{tter i g}ng scannas kommandofilen igenom och
tv} l{nkade listor skapas, en med kommandon och en med
variabler. 

 Varje l{nk i kommandolistan inneh}ller: hela den inl{sta raden,
kommando, pekare till n{sta kommando i den l{nkade listan, ev.
pekare till annan l{nk (bara FOR och NEXT-.kommandona) och
radnummer i kommandofilen. Blankrader eller rader som bara
inneh}ller kommentarer allokerar inget minne i den l{nkade
listan. 


%title 3        Kommandon och deras parametrar. 

F|ljande kommandon finns. Parametrar inom parenteser kan utl{mmnas
och ers{tts d} ett defaultv{rde.

KOMMANDO,PARAMETRAR


FOR loopvariabel,startv{rde,stoppv{rde(,steg)

   Initierar v{rdet p} <loopvariabel> till <startv{rde> och
  kontrollerar om loopvaribelns v{rde {r st|rre {n <stoppv{rde>,
  forts{tter i s} fall till kommandot efter mots. NEXT-kommndo.
  Om <steg>-v{rdet {r negativt kontrolleras ist{llet om
  loopvariabelns v{rde {r l{gre {n slutv{rdet. For-kommandot kan
  ocks} anv{ndas om man bara vill initiera en variabels v{rde,
  vilket g|rs genom att g|ra en dummyloop som inte genoml|ps.
  Defaultv{rde f|r steg {r 1. Startv{rde, stoppv{rde och steg
  kan vara variabler eller v{rden. Det kan h|gst finnas 15
  niv}er p} for-next looparna 
%page
NEXT

   R{knar upp motsv. FOR-kommandos <loopvariabel> med <steg>.
  Repeterar testf|rloppet fr}n motsvarande FOR-kommando om
  identifierarens v{rde {r mindre {n eller lika med
  <stoppv{rde>. Om steg {r negativt g{ller att identifierarens
  v{rde skall vara st|rre eller lika med <stoppv{rde> Annars
  forts{tter testf|rloppet med n{sta kommando. 


UTSIGNAL portnr,utdata(,mask)

   Skickar kommando till mddmkontrollern med <utdata> maskat med
  <mask> och <portnr>, defaultv{rde p} <mask> {r 255. V{rdena p}
  portnummer, indata och mask skall vara mellan 0 och 255.
  Samtliga parametrar kan vara variabler eller v{rden. 


INSIGNAL portnr,indata(,mask)(,feltext)

   skickar kommando till kortet om att l{sa av <portnr>. Maskar
  l{st v{rde med <mask>, j{mf|r med <indata>, om det inte {r
  lika skrivs meddelande p} logg-listan, om <feltext> angets
  skrivs den ocks} p} loggen vid felutskrift, defaultv{rde p}
  <mask> {r 255. V{rdena p} portnummer, indata och mask skall
  vara mellan 0 och 255, de kan vara variabler eller v{rden.
  Om <feltext> angetts skall det vara en textstr{ng. 


RAMTEST (startadress,slutadress)

   Skickar kommando till mddmkontrollern att utf|ra ramtest
  mellan <startadress> och <slutadress>, om inga intervall anges
  eller b}da adresserna {r noll utf|rs ramtest p} allt ram. Om
  adresserna {r lika men inte noll utf|rs ingen test. Om testet
  misslyckas skrivs meddelande p} loggen. Parametrarnas v{rde
  m}sta vara mellan 0 och 65535, och slutadressen st|rre {n
  startadressen. B}da parametrar skall vara variabler eller
  v{rden. 


PROMTEST

   Skickar promtestkommando till mddmkontrollern och loggar om
  prommets checksumma inte {r noll. 


WATCHDOG

   Testar att WATCHDOG-funktionen p} mddmkontrollern fungerar.
  Om inget svar erh}lls fr}n kortet inom 1 min skrivs ett fel
  meddelande p} loggen. Normalt sett skall svar komma efter ca.
  20 sek 
%page
TEMP temperatur

   S{tter temperaturen till <temperatur>. Ej implementerat {nnu. 


SPANNING sp{nning

   Skickar kommando till sp{nningsaggregatet att {ndra
  sp{nningen till <sp{nning>. Om 0 volt valts kommer {ven
  sp{nnings- aggregatet att kopplas bort med hj{lp av
  kortv{xeln. Kontroll sker att sp{nning ligger mellan 0 och
  5.250 volt. Parametern kan vara en variabel eller ett v{rde. 


ANALOG analogsp{nning

   Skickar kommando till sp{nningsaggregatet att {ndra
  sp{nningen p} den analoga utg}ngen till <analogsp{nning>.
  (Dennna utg}ng anv{nds normalt f|r str|minst{llning. Eftersom
  str|mmen {r konstant anv{nds i st{llet denna utg}ng f|r test
  av analoga kretsar). Kontroll sker att sp{nning ligger mellan
  0 och 5.250 volt. Parametern kan vara en variabel eller ett
  v{rde. 


PAUS sek 

   Avbryter testen under <sek> sekunder. Kontroll sker att antal
  sekunder {r mellan 1 och 1000. 


LOGG meddelande(,meddelande...)

   Skriver ett eller flera (max 10 st) meddelanden p} loggen.
  Meddelandena kan vara en textstr{ngar, variabler eller v{rden 


OBJEKT kort

   Skickar kommando till kortv{xeln att v{xla in ett nytt kort,
  och inv{ntar att det sker, <kort> {r det logiska nummret p}
  kortet. Valt objekt m}ste vara mellan 1 och antal objekt som
  matats in (ANT_OBJ). Antal objekt som finns best{ms av hur
  m}nga id-f{lt som operat|ren fyllt i. Objekt 1 {r allts}
  f|rsta kortplats som det angetts id till och inte
  n|dv{ndigtvis hylla 1 kortplats 1. 


SETNOV

   Skickar kommando till mddmkontrollern, att skriva ett
  f|rdefinierat m|nster i nov-ram samt att g|ra en store-puls.
  Detta b|r g|ras mycket sparsamt efersom det sliter p}
  novramet. 
%page
CHKNOV

   Skickar kommando till mddmkontrollern att kontrollera om det
  fortfarande st}r samma m|nster i nov-ram som setnov har
  skrivit dit. 


RESET

   Kortet resetar sig genom att aktivera resetsignalen.
  Kontrollerar sedan att det verkligen blivit en reset. Ej
  implementerat {nnu. 


SIOTEST

   Kortet testar SIO-kretsen genom att {ndra p} sion's
  statussignaler och kontrollera dem och genom att skicka ett
  tecken p} B-sidan och kontrollera at det kommer tillbaka.
  F|ruts{tter att det finns byglingar p} RS232-kontakterna. P}
  b}de A och B-kanalen byglas stift 4-5-6 och 20-8 enbart p}
  B-kanalen byglas stift 2-3. 


IOPORT l{gstaport,h|gstaport

   Allokerar minne i PC'n f|r att kunna ha separata felr{knare
  f|r varje I/O-port p} korten. De portar som ha egna felr{knare
  anges som parametrar, de f}r inte vara variabler utan m}ste
  vara konstanter. Kommandot kan bara utf|ras en g}ng i en
  testsekvens. Om det f|rekommer fler g}nger ignoreras detta men
  felmeddelande skrivs ut. <L{gstaport> och <h|gstaport> anger
  inom vilket intervall portarna ligger. 


%title 3        Kommentarer. 

 Kommentarer inleds med apostrof ('). En rad kan best} enbart av
en kommentar, eller kan kommentaren st} efter ett kommando. 
%page
%title 3        Syntaxcheck.

 Samtidigt som den l{nkade listan byggs upp kontrolleras det om
det finns n}gra syntaxfel. Om fel uppt{cks loggas dessa fel och
testen kommer inte att starta. De fel som kontrolleras {r om det
{r giltiga kommandon, r{tt antal parametrar, att parametrarnas
v{rden {r riktiga (n{r det inte {r variabler) och att for-next
looparna {r riktigt konstruerade. Som parametrar kan anges
variabler, v{rden eller en textstr{ng. Ett variabelnamn m}ste
inledas med en bokstav, den har 10 signifikanta tecken och ingen
skillnad g|rs p} gemener och versaler. En variabel deklareras i
och med dess f|rsta referens (som i BASIC). Ett v{rde best}r av
siffror och ev. decimalpunkt. Noggrannheten {r 0.001 dvs. v{rden
mindre {n 0.0005 betraktas som noll. V{rden kan vara positiva
eller negativa. Ett v{rde kan inledas med ett "number-sign" (#)
vilket inneb{r att det tolkas som ett hexadecimalt v{rde och f}r
i s} fall inte inneh}lla n}gon decimalpunkt. En textstr{ng
inleds och avslutas med citationstecken ("). 


%title 3        Variabelhantering.

 I samband med syntaxchecken har en l{nkad lista med variablerna
skapats. I variabellistan finns f|r varje l{nk: namn (10 mest
signifikanta tecken), v{rde och pekare till n{sta l{nk i listan. 

 Ett variabelnamn m}ste inledas med en bokstav, den har 10
signifikanta tecken och ingen skillnad g|rs p} gemener och
versaler. En variabel deklareras i och med dess f|rsta referens
(som i BASIC). Noggrannheten {r 0.001 dvs. v{rden mindre {n
0.0005 betraktas som noll. 

 I systemet finns {ven f|rdefinierade variabler vars v{rde man
ej kan f|r{ndra utan endast l{sa. 

 F|rdefinierade variabler:
ANT_OBJ : antal objekt i racken, r{knas ut efer att alla kort-id
fyllts i. 
%page
%title 2        Interface mot mddm

%title 3        Kommunikationsprocedur.

Informationsutbytet mellan PC och testat kort sker med ett
enhetligt protokoll, likadant i b}da riktningarna. Protokollet
best}r av starttecken, ev parametrar och kommando. Innan man
skickar ett kommando till mddm-kortet t|mmer man ev. tecken som
har kommit till PC'n (skr{ptecken som kan ha kommit n{r man
v{xlat mellan kort). Efter det att ett kommando har skickats
v{ntar man mellan 1 och 2 sekunder p} att ett svar skall komma
fr}n mddm, om inget svar kommit under den tiden betraktas det
som en timout vilket kommer att loggas. 

- Starttecken {r alltid STX, hexadecimalt 02. 

- Parametrar. 0 till 10 st. 1 - 4 st ASCII-tecken, 0 - 9, a - f
eller A - F. Parametrarna }tskiljs med semikolon. 

- Komando. 1 ASCII-tecken, g - z eller G - Z. 

%title 3        Koder.

RAMTEST:
        Anropas med : (adress ; adress) G

        Svarar      : 00 G      Om OK
                    : FF G      Om felaktiga parametrar
                    : 01-07* G  Om fel p} RAM

        *)      Bit 0 satt om fel uppt{ckt vid "Adresstest"
                 "  1   -       "       -      "Vandrande etta"
                 "  2   -       "       -      "Vandrande nolla"

PROMTEST:
        Anropas med : H

        Svarar      : framr{knad checksumma H

INSIGNAL:
        Anropas med : (port) I

        Svarar      : l{st v{rde I

UTSIGNAL:
        Anropas med : (port)(; data) J

        Svarar      : J

WATCHDOGTEST:
        Anropas med : K

        Svarar      : K         Om OK
                    : FF K      Om Watchdog inte fungerat

RESETTEST:
        Anropas med : L

        Svarar      : L         Om OK
                    : FF L      Om Reset inte fungerat

SETNOV:
        Anropas med : M

        Svarar      : M

CHKNOV:
        Anropas med : N

        Svarar      : 00 N      Om OK
                    : FF N      Om fel uppt{ckt

SIOTEST:
        Anropas med : O

        Svarar      : 00 O      Om OK
                    : 01-3F* O  Om fel uppt{ckt

                *) de olika bitarna har f|ljande betydelse:

         Bit 0 : Kanal B fick inte tillbaka n}got tecken. 
         Bit 1 : Kanal B fick inte tillbaka samma tecken som 
                 skickades.
         Bit 2 : CTS-status p} A-sidan {r inte det f|rv{ntade. 
         Bit 3 : DCD-status p} A-sidan {r inte det f|rv{ntade. 
         Bit 4 : CTS-status p} B-sidan {r inte det f|rv{ntade. 
         Bit 5 : DCD-status p} B-sidan {r inte det f|rv{ntade. 
%page
%title 2        Interface mot power-controllern

%title 3        Kommunikationsprocedur.

PWC'n (powercontroller PC4400) styrs via ett RS232-interface,
och {r kopplat till kommunikationsport 2 p} PC'n. 

I PWC'n finns tv} slot med kort:

Slot 1 anv{nds f|r att styra sp{nningen till mddm-korten med
kommandot SPANNING.

OBS! F|r att kompensera sp{nningsfallet p} v{g till korten
beg{rs alltid( ,utom vid 0 volt,) 0.3 volt h|gre sp{nning {n den
man vill ha |ver korten. 

Slot 2 f|r f|r att l{gga ut en analog sp{nning med kommandot
ANALOG. 

Innan ett kommando skickas till PWC'n sker kontroll att
kontakten {r ansluten genom att titta p} CTS-signalen fr}n
PWC'n. Dessutom skickas ett ETX till PWC'n efter varje kommando,
vilken PWC'n skall svara ett ACK p}. Om kommunikationen med
PWC'n av n}gon anledning inte fungerar kommer testet inte att
forts{tta eftersom det inte {r n}gon id` d} man ju inte vet
vilken sp{nning den l{gger ut. 

F|rsta kommandot som skickas till PWC'n {r bara f|r att kolla
att den lever och det {r kommandot VS1 (Verify Slot 1), som
skall ge ett svar som b|rjar med SL1 om man inte f}r det
beraktas PWC'n inte ansluten och testet kommer inte att s{tta
ig}ng. 

Innan testet s{tter ig}ng skickas en upps{ttning kommandon till
PWC'n f|r att initiera den, f|ljande upps{ttning g|rs: 

        - 'ERIN1'       Enable Error interrupt
        - 'INTNNNN'     Disable Interrupt
        - 'SL1'         V{lj slot 1 i PWC'n
        - 'MV15.00'     Max voltage = 15 volt
        - 'OVP5.800'    Output voltage protection = 5.8 volt
        - 'V5.300'      Sp{nning = 5.3 volt
        - 'SL2'         V{lj slot 2 i PWC'n
        - 'MV10.00'     Max voltage = 10 volt
        - 'OVP9.000'    Output voltage protection = 9 volt
        - 'V0.000'      Sp{nning = 0 volt

Efter det att ett test {r f{rdigt dras sp{nningarna ner till noll
med f|ljande kommndon: 

        - 'SL1'         V{lj slot 1 i PWC'n
        - 'V0.000'      Sp{nning = 0 volt
        - 'SL2'         V{lj slot 2 i PWC'n
        - 'V0.000'      Sp{nning = 0 volt
%page
%title 3        Koder. 

De kommandon som anv{nds {r f|ljande:

        SLn - V{ljer ett slot mellen 1 och 4. I v}r
              configuration finns bara slot 1 och 2 i PWC'n.
        ERINn - S{tter error interrupt. Enablar eller disablar
              errorhanteringen, om den s{tts till ett kommer fel
              att resultera i att PWC'n skickar SRQ (Service
              ReQuest) n{r det bli fel. 
        INTaaaa - S{tter interruptniv} f|r slot 1 - 4. I v}r
              configuration anv{nder vi oss inte av interrupt
              och d{rf|r disablas de allihop.
        VSn - Returnerar status f|r ett slot i PWC'n. Anv{nds
              bara en g}ng under initieringsfasen f|r att kolla
              att kontakt finns med PWC'n. 
        MVnnn.nnn - Max Voltage. S{tter vilket som {r den
              maximala outputen fr}n PWC'n. Skall vara samma som
              den man st{llt in p} det kraftaggregatet som styrs
              av PWC'n, vilket i v}rt fall blir 15 volt f|r
              powercontrollerns slot 1 och 10 volt f|r slot 2. 
        Vnnn.nnn - Voltage. S{tter sp{nningen. kan i v}rt fall
              variera mellan: 0 och 5.25 v f|r slot 1, 0 och 9
              volt f|r slot 2.
        OVPnnn.nnn - Over Voltage Protection. S{tter vilken
              sp{nning som {r den h|gsta till}tna. Om
              sp{nningskommandon h|gre {n denna sedan skickas
              till PWC'n kommer den att svara med en SRQ.


Ut|ver dessa kommandon har PWC'n ett flertal kommandon till. De
finns beskrivna i PWC-manualen, d{r det {ven finns mer
detaljerad beskrivning om ovanst}ende kommandon. 

%title 3        Feltyper

De feltyper som kan f|rekomma {r att man inte f}r kontakt med
PWC'n eller att den inte svarar med ACK p} ETX eller att den
skickar ett SRQ. Om kontakt ej erh}lles {r kontakterna ej
anslutna eller felaktiga. Om ACK uteblir {r det troligtvis fel
p} PWC'n. Om PWC'n skickar SRQ {r det troligaste felet
programvaran i PC'n, vilket allts} i princip aldrig kommer att
intr{ffa. 
%page
%title 2        Interface mot rel{-kortet

Rel{kortet anv{nds f|r att v{xla in det kort som valts med
OBJEKT-kommandot. Det styrs med hj{lp av 2 st I/O-portar, 8255
med vardera 3 bytes (8 bitar). I/O-portarna initieras s} att
samtliga anslutningar fungerar som utg}ngar. portarna ligger p}
f|ljande I/O-adresser i PC'n: 

I/O-adresser:   kontrollport 1  - 210 hex
                dataport 1a     - 213 hex
                dataport 1b     - 212 hex
                dataport 1c     - 211 hex

I/O-adresser:   kontrollport 2  - 218 hex
                dataport 2a     - 21B hex
                dataport 2b     - 21A hex
                dataport 2c     - 219 hex

Kontrollportarna initieras med hex 80 vid systemstart, bitarna i
kontrollportarna har f|ljade funktion: 

        d0 = port c lower output
        d1 = port b output
        d2 = group b mode 0
        d3 = port c upper output
        d4 = port a output
        d5 = group a mode 0
        d6 = group a mode 0
        d7 = mode definition

I de 6 dataportarna motsvarar varje bit ett rel{. Om en bit {r
ett motsvarar det att rel{et {r sl{ppt och en nolla att det {r
draget. Alla bitar i dataportarna initieras till ett, dvs alla
rel{er sl{pps. 

%title 3 Tabellhanteringen 

F|r att v{lja in ett kort kr{vs att vissa rel{n {r dragna och
vissa sl{ppta. Eftersom det bara {r n}gra f} rel{n som har
betydelse vid varje kortval beh|ver man inte p}verka mer {n
dessa rel{n vid varje kortv{xling. F|r att styra detta finns tv}
tabeller som markerar vilka rel{n som m}ste vara dragna och
vilka som m}ste vara sl{ppta. P} grund av begr{nsningar i
pascalen har varje tabell tvingats delas upp i tv} (det kan max
vara 256 bytes i en konstant), s} varje tabell har bara
information f|r tre I/O-portar. F|r att endast p}verka de r{tta
rel{erna AND'ar man bitm|nstret i I/O-portarna med inneh}llet i
ena tabellen (and-tabellen) och OR'ar med inneh}llet i den andra
(or-tabellen). 

F|r ytterligare information om hur styrningen av I/O-portarna
fungerar h{nvisas till manualen f|r Scientific Solutions "Base
Board" och "Opto-Isolation Out Daughter Board". 
%page
%title 2        Asynch-paketet

Eftersom hantering av asynkron kommunikation i Microsoft Pascal
i stort sett {r obefintlig anv{nds ett separat
kommunikationspaket: "ASYNCH MANAGER" fr}n Blaise Computer INC.
Det {r anpassat till pascal och f{rdiga rutiner finns f|r att
hantera den asynkrona kommunikationen. I det finns ett flertal
rutiner men endast en del av dessa anv{nds i TMC-systemet. 

De rutiner som anv{nds:

        open_a1 - \ppnar en kommunikationsport. 
        close_a1 - St{nger en port. 
        wrtch_a1 - skriver ett tecken p} en port. 
        wrtst_a1 - skriver en str{ng p} en port. 
        rdch_a1 - l{ser ett tecken fr}n en port. 
        rdst_a1 - l{ser en str{ng fr}n en port. 
        qsize_a1 - tar reda p} antal tecken i en ports ink|. 
        iflsh_a1 - rensar en ports ink|. 
        setop_a1 - s{tter upp kommunikationsparametrar f|r en
              port. 
        time_a1 - tar reda p} hur m}nga sekunder det g}tt sedan
              kl 00:00:00. 
        wait_a1 - v{ntar ett antal sekunder (0.055 sekunders
              nogrannhet). 
        stat_a1 - l{ser av en ports status. 


F|r ytterligare information om hur det asynkrona
kommunikationspaketet fungerar h{nvisas till manualen:
"ASYNCH MANAGER for PASCAL Version 1.0". 
%page
%title 2        PC-assembler

F|r vissa maskinn{ra operationer har pascal inte instruktioner,
d{rf|r har vissa programsnuttar skrivits i assembler. Interfacet
mellan pascal och assembler beskrivs i pascalmanualen. I
assemblerrutinerna g|rs anrop till BIOS-funktionerna PRINTER_IO
och VIDEO_IO samt l{sning och skrivning p} I/O-portar. 

N{r testet k|rs anv{nds bara en del av bildsk{rmen som
scroll-area, detta sker med hj{lp av VIDEO_IO rutiner.

F|r att kunna avg|ra om det finns en printer tillg{nglig l{ses
printerns status med hj{lp av PRINTER_IO. De olika bitarna i
printerstatus har f|ljande betydelse: 

        bit 0: Time out
        bit 1: Unused 
        bit 2: Unused 
        bit 3: I/O error
        bit 4: Selected
        bit 5: Out of paper
        bit 6: Acknowledge
        bit 7: Not busy
%page
%title 2        Loggning

OBS! Exempel p} loggutskrifterna finns sist i detta kapitel.

%title 3        Olika loggmedia

Vad som h{nder under testets g}ng skrivs ut p} tre olika
st{llen: 

SK[RM, PRINTER och LOGGFIL.

Dock kan printern v{ljas bort:

Ett f{lt i nedre h|gra h|rnet p} sk{rmen visar om loggning
kommer att ske {ven p} printern. Flaggan s{tts till "PrOn" vid
start av testet om printern {r p}slagen och online, annars
"PrOff". Man kan v{lja bort eller in printern med hj{lp av
escape-tangenten. 

Loggfilnamnet:

Loggfilen skapas och namnges automatiskt. Namnet anger n{r testen
startades och best}r av 8 siffror f|ljt av ".LOG". Det bildas
enligt f|ljande: 

* F|rsta siffran anger }rtalet.
* Andra siffran anger m}naden i hexadecimal form.
* Tredje och fj{rde siffran anger dag.
* Resterande siffror anger tiden i timmar och minuter.
%page
%title 3        Vad loggas

P} LOGGFIL och PRINTER skrivs exakt samma data:

* Huvud
* Egna texter
* Felutskrifter
* Statistik

P} SK[RMEN skrivs:

* Testsekvens
* Egna texter
* Felutskrifter

%title 4        Testsekvens

Kommandofilen skrivs ut som den ser ut, rad f|r rad varefter
dessa exekveras. F|r variabler skrivs dock v{rde ist{llet f|r
namn. 

%title 4        Huvud

Tv} olika huvud skrivs p} loggen:

* Ett inneh}llande datum, loggfilnamn och kommandofilnamn.

* Ett inneh}llande rubriker f|r i f|rsta hand testresultaten fr}n
  MDDM-korten. 

Vid syntaxfel och statistik skrivs endast det f|rsta
logghuvudet. Vid datumbyte under testets g}ng skrivs n{sta
rad p} ny sida. Logghuvud skrivs ut p} varje sida.

Rubrik-huvudet:

TID             : Anger tiden d} raden loggades.
F\RB.TID        : Tid sedan testet startades, syntaxcheck och
                  initieringar inr{knade. 
SP[NN           : Sp{nningen |ver korten.
H               : Hylla som kortet sitter i. 
SL              : Slot inom hyllan som kortet sitter i. 
TEXT            : H{r skrivs kort-id, vald utskrift i LOGG-
                  kommandot, parameterfel, fatala fel samt fel
                  g{llande powercontrollern.
TEST            : Vilken funktion p} kortet som testades.
RESULTAT        : Hur testet utf|ll.
TIDIGARE FELTYP : Om testet tidigare har resulterat i n}gon typ
                  av fel och nu givit ett annat resultat, talas
                  h{r om vilken typ av fel som d} upptr{dde och
                  antalet s}dana. 

%title 4        Egna texter

Med hj{lp av LOGG-kommandot kan textstr{ngar och variabler
skrivas ut. [ven i INSIGNAL-kommandot kan en textstr{ng anges,
vilken skrivs ut n{r testet ger ett negativt resultat, om detta
loggas.
%page
%title 4        Felutskrifter

Typer av felutskrifter:

* Fatala fel
* Syntaxfel (i kommandofilen)
* Parameterfel
* Testresultat

%title 5        Fatala fel

- Kommandofilstorlek
- PC-Portfel
- Bestyckningsfel
- Powercontroller-fel

Kommandofilstorlek:

N{r man startar testet b|rjar programmet med att kontrollera hur
stor kommandofilen {r. Om minnet inte r{cker till f|r att skapa
den l{nkade listan, talas detta om och testen avbryts. 

PC-portfel:

Vid start av test |ppnas och s{tts COM-portarna upp. Om detta ej
g}r bra skrivs ut vilken port det g{ller samt en statuskod som
n{rmare talar om vad som {r fel. Om detta fel f}s {r det troligen
n}got fel p} PC:n. (F|r info. om vad status-koderna betyder
h{nvisas till ASYNCH MANAGER Function open_a1.)

Bestyckningsfel:

Innan de olika funktionerna p} kortet b|rjar testas kontrolleras
att inmatade id st{mmer |verens med hur korten sitter monterade i
racket. Om inte, talas om hylla, slot och vilken typ av fel som
g{ller f|r just den kortplatsen. Endast hyllor med fel skrivs ut. 
Bestycknings-feltyper:

"Slot utan svar" : Inneb{r att id f|r kortplatsen finns inmatat
                   men att inget kort verkar finnas p} plats. 

"Slot utan id"   : Inneb{r att ett kort finns p} platsen men id
                   {r ej inmatat. 

Powercontroller-fel:

- "Ingen kontakt med PwC'n"
- "Inget svar fr}n PwC'n"
- "Uteblivet ACK fr}n Power-controllern"
- Service ReQuest (SRQ)
- Kommunikationsfel
%page
Om det brister i kommunikationen med PwC'n skrivs feltypen ut och
testet avbryts: 

"Ingen kontakt med PwC'n":

Inneb{r att denna inte {r ansluten eller att str|m-brytaren {r i
fr}n-l{ge. 

"Inget svar fr}n PwC'n":

Betyder att programmet i PwC'n inte fungerar riktigt.

"Uteblivet ACK fr}n Power-controllern":

Betyder att programmet i PwC'n inte fungerar riktigt.

Service ReQuest (SRQ):

PwC'n har f}tt ett kommando den av n}gon anledning inte gillade.
F}s om programvaran i det h{r systemet (, p} PC-sidan,) skulle
vara felaktig. F|r info. om de olika felmeddelandena h{nvisas
till Power Controller-manualen. Felmeddelande "Ok{nt" inneb{r
att typen av SRQ inte har kunnat identifieras. 

Kommunikationsfel:

(Endast i riktningen PwC - PC.) Ett bitm|nster talar om vilken
typ av kommunikations-fel som uppst}tt. Detta skrivs ut
hexadecimalt. (F|r info. om vad de olika bitarna betyder
h{nvisas till ASYNCH MANAGER Function rdch_a1.)

%title 5        Syntaxfel

Sedan det konstaterats att kommandofilen inte {r f|r stor b|rjar
programmet syntaxchecka kommandofilen. Om n}got fel uppt{cks skrivs
kommandoraden + en kort f|rklaring till vad som {r fel. 

%title 5        Parameterfel

N{r en variabel har angivits som parameter till ett kommando, och
denna under exekvering g}r utanf|r vad som {r till}tet f|r just
denna parameter. Rad, kommando och den felaktiga parametern
skrivs ut. Kommandot utf|rs ej.

%title 5        Testresultat

Ett test av en funktion p} kortet kan ge f|ljande resultat:

* Positivt
* Negativt
* Felaktigt svar
* Timeout
* Kommunikationsfel
%page
De olika svaren inneb{r:

Positivt:

Den testade funktionen p} kortet fungerade. Det loggas s}
h{r: Texten "POSITIVT skrivs. Vid INSIGNAL skrivs {ven
portnummer ut (, hexadecimalt).

Negativt:

Den testade funktionen p} kortet fungerade inte. Det loggas s}
h{r: 

CHECKNOV och WATCHDOG: Texten "NEGATIVT" skrivs.

RAMTEST: Ett bitm|nster (, hexadecimalt,) talar om vilken typ av
         fel som uppt{cktes p} kretsen. 
         De olika bitarna betyder:

         Bit 0 : Fel uppt{ckt vid "vandrande etta".
         Bit 1 : Fel uppt{ckt vid "vandrande nolla".
         Bit 2 : Fel uppt{ckt vid "adresstest".

         F|r info. om vad de olika testerna g}r ut p} h{nvisas
         till beskrivningen av programmen p} kortet.

SIOTEST: Ett bitm|nster (, hexadecimalt,) talar om vilken typ av
         fel som uppt{cktes p} kretsen. 

         Bit 0 : Kanal B fick inte n}got tecken.
         Bit 1 : Kanal B fick inte tillbaka samma tecken som
                         skickades.
         Bit 2 : CTS-status p} A-sidan {r inte det f|rv{ntade.
         Bit 3 : DCD-status p} A-sidan {r inte det f|rv{ntade.
         Bit 4 : CTS-status p} B-sidan {r inte det f|rv{ntade.
         Bit 5 : DCD-status p} B-sidan {r inte det f|rv{ntade.

         F|r info. om vad de olika testerna g}r ut p} h{nvisas
         till beskrivningen av programmen p} kortet.

PROMTEST: Den framr{knade checksumman skrivs ut (hexadecimalt).

INSIGNAL: Portnummer, v{rde och f|rv{ntat v{rde (hexadecimalt).

OBS! Kan ej f}s fr}n SETNOV och UTSIGNAL.

Felaktigt svar:

Kortet gav ett odefinierat svar. Texten "KORT-SVAR FEL" skrivs. 

Timeout:

Svaret uteblev.

Kommunikationsfel:

Paritetsfel o dyl. (Kontrolleras endast i riktningen MDDM - PC.) 
%page
Olika testresultat behandlas olika. F|r POSITIVT, NEGATIVT,
KORT-SVAR FEL och TIMEOUT g{ller att:

F|r att inte riskera att spr{nga disken eller g|ra slut p}
papperet loggas inte alla fel varefter de upptr{der. D{remot
skrivs alla fel ut p} sk{rmen(, i inversed video f|r att l{ttare
urskiljas). En felutskrift loggas endast n{r en f|r{ndring i
svaret fr}n kortet, g{llande en viss krets, uppt{cks. D{rf|r
loggas ocks} positiva testresultat d} det tidigare har intr{ffat
n}got fel.

KOMMUNIKATIONSFEL (mot MDDM) tas om hand p} f|ljande s{tt: 

Ett bitm|nster talar om vilken typ av kommunikations-fel som
uppst}tt. Detta skrivs ut hexadecimalt. (F|r info. om vad de
olika bitarna betyder h{nvisas till ASYNCH MANAGER Function
rdch_a1.) 

F|r varje MDDM-kort loggas kommunikationsfel h|gst 100 ggr. N{r
det 101:a felet f|r kortet intr{ffar talas om att antalet
kommunikationsfel {r st|rre {n 100 och d{refter r{knas endast en
r{knare upp. 
%page
%title 4        Statistik

Efter avslutat test skrivs en sammanfattning av testen ut.
D{r talas f|r varje kort om:

* Id
* Hylla
* Slot

samt antalet:

* Kommunikationsfel
* Tester p} varje funktion varav antal:
    - Negativa resultat
    - Felaktiga svar
    - Timeouter.

F|r I/O-portarna talas om:

* Vilka som haft separata felr{knare (enl. IOPORT-kommandot) .
* Hur m}nga fel som uppst}tt i resp I/O-port.

%page
%title 3        Loggutskrifter
