{$title:'MODULE: ObjKomn' $pagesize:41 $linesize:106}

Module ObjKomn;

{*******************************************************}
{	Denna modul innehaaller				}
{	rutiner som jobbar mot relakortet.		}
{*******************************************************}

{$Include:'decl.h'}
{$Include:'global.h'}
{$Include:'varhandl.h'}
{$Include:'io.h'}
{$Include:'logg.h'}
{$Include:'screen.h'}
{$Include:'asynch.h'}

TYPE
    PortNr_t	= array [1..3]  OF byte;
    ObjNr_t	= array [1..50] OF PortNr_t;
    LP_VP_t	= array [1..6] OF integer;	{ koppling mellan logiskt och verkligt portnummer }

CONST
		{ koppling mellan logiskt och verkligt portnummer }
		{  1a    1b    1c    2a    2b    2c  }   
LP_VP = LP_VP_t ( #213,	#212, #211, #21B, #21A, #219 );

{$page+}

 { or-tabell, ettst{ll (sl{pp) rel{er } 

			{ Port :    1a   1b   1c }

RelaTab1A = ObjNr_t (	PortNr_t ( #c0, #00, #d0 ), { Objekt 1 }
			PortNr_t ( #c0, #00, #d0 ),
			PortNr_t ( #c0, #00, #d0 ),
			PortNr_t ( #c0, #00, #d0 ),
			PortNr_t ( #c0, #80, #c0 ), { Objekt 5 }
			PortNr_t ( #c0, #80, #c0 ),
			PortNr_t ( #c0, #80, #c0 ),
			PortNr_t ( #c0, #80, #c0 ),
			PortNr_t ( #c8, #10, #80 ),
			PortNr_t ( #c8, #10, #80 ), { Objekt 10 }
			PortNr_t ( #c8, #10, #80 ),
			PortNr_t ( #c8, #10, #80 ),
			PortNr_t ( #c8, #40, #80 ),
			PortNr_t ( #c8, #40, #80 ),
			PortNr_t ( #c8, #40, #80 ), { Objekt 15 }
			PortNr_t ( #c8, #40, #80 ),
			PortNr_t ( #50, #20, #a0 ),
			PortNr_t ( #50, #20, #a0 ),
			PortNr_t ( #50, #20, #a0 ),
			PortNr_t ( #50, #20, #a0 ), { Objekt 20 }
			PortNr_t ( #50, #04, #a0 ),
			PortNr_t ( #50, #04, #a0 ),
			PortNr_t ( #50, #04, #a0 ),
			PortNr_t ( #50, #04, #a0 ),
			PortNr_t ( #41, #08, #a0 ), { Objekt 25 }
			PortNr_t ( #41, #08, #a0 ),
			PortNr_t ( #41, #08, #a0 ),
			PortNr_t ( #41, #08, #a0 ),
			PortNr_t ( #41, #00, #a4 ),
			PortNr_t ( #41, #00, #a4 ), { Objekt 30 }
			PortNr_t ( #41, #00, #a4 ),
			PortNr_t ( #41, #00, #a4 ),
			PortNr_t ( #64, #01, #80 ),
			PortNr_t ( #64, #01, #80 ),
			PortNr_t ( #64, #01, #80 ), { Objekt 35 }
			PortNr_t ( #64, #01, #80 ),
			PortNr_t ( #64, #02, #80 ),
			PortNr_t ( #64, #02, #80 ),
			PortNr_t ( #64, #02, #80 ),
			PortNr_t ( #64, #02, #80 ), { Objekt 40 }
			PortNr_t ( #62, #00, #82 ),
			PortNr_t ( #62, #00, #82 ),
			PortNr_t ( #62, #00, #82 ),
			PortNr_t ( #62, #00, #82 ),
			PortNr_t ( #62, #00, #81 ), { Objekt 45 }
			PortNr_t ( #62, #00, #81 ),
			PortNr_t ( #62, #00, #81 ),
			PortNr_t ( #62, #00, #81 ),
			PortNr_t ( #40, #00, #88 ),
			PortNr_t ( #40, #00, #88 ) ); { Objekt 50 }

{$page+}

 { or-tabell, ettst{ll (sl{pp) rel{er } 

			{ Port :    2a   2b   2c }

RelaTab1B = ObjNr_t (	PortNr_t ( #e0, #00, #e0 ), { Objekt 1 }
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e0, #00, #e0 ), { Objekt 5 }
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e0, #00, #e0 ), { Objekt 10 }
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e8, #00, #e0 ),
			PortNr_t ( #e8, #00, #e0 ),
			PortNr_t ( #f0, #00, #e0 ), { Objekt 15 }
			PortNr_t ( #f0, #00, #e0 ),
			PortNr_t ( #e1, #00, #e0 ),
			PortNr_t ( #e1, #00, #e0 ),
			PortNr_t ( #e4, #00, #e0 ),
			PortNr_t ( #e4, #00, #e0 ), { Objekt 20 }
			PortNr_t ( #e2, #00, #e0 ),
			PortNr_t ( #e2, #00, #e0 ),
			PortNr_t ( #e0, #00, #f0 ),
			PortNr_t ( #e0, #00, #f0 ),
			PortNr_t ( #e0, #80, #e0 ), { Objekt 25 }
			PortNr_t ( #e0, #80, #e0 ),
			PortNr_t ( #e0, #10, #e0 ),
			PortNr_t ( #e0, #10, #e0 ),
			PortNr_t ( #e0, #40, #e0 ),
			PortNr_t ( #e0, #40, #e0 ), { Objekt 30 }
			PortNr_t ( #e0, #20, #e0 ),
			PortNr_t ( #e0, #20, #e0 ),
			PortNr_t ( #e0, #04, #e0 ),
			PortNr_t ( #e0, #04, #e0 ),
			PortNr_t ( #e0, #08, #e0 ), { Objekt 35 }
			PortNr_t ( #e0, #08, #e0 ),
			PortNr_t ( #e0, #00, #e4 ),
			PortNr_t ( #e0, #00, #e4 ),
			PortNr_t ( #e0, #01, #e0 ),
			PortNr_t ( #e0, #01, #e0 ), { Objekt 40 }
			PortNr_t ( #e0, #02, #e0 ),
			PortNr_t ( #e0, #02, #e0 ),
			PortNr_t ( #e0, #00, #e2 ),
			PortNr_t ( #e0, #00, #e2 ),
			PortNr_t ( #e0, #00, #e1 ), { Objekt 45 }
			PortNr_t ( #e0, #00, #e1 ),
			PortNr_t ( #e0, #00, #e8 ),
			PortNr_t ( #e0, #00, #e8 ),
			PortNr_t ( #e0, #00, #e0 ),
			PortNr_t ( #e0, #00, #e0 ) ); { Objekt 50 }

{$page+}

 { and-tabell, nollst{ll (dra) rel{er } 

			{ Port :    1a   1b   1c }

RelaTab2A = ObjNr_t (	PortNr_t ( #ff, #ff, #ff ), { Objekt 1 }
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ff, #ef ),
			PortNr_t ( #ff, #ff, #ef ),
			PortNr_t ( #ff, #ff, #bf ), { Objekt 5 }
			PortNr_t ( #ff, #ff, #bf ),
			PortNr_t ( #ff, #7f, #bf ),
			PortNr_t ( #ff, #7f, #bf ),
			PortNr_t ( #7f, #ff, #ff ),
			PortNr_t ( #7f, #ff, #ff ), { Objekt 10 }
			PortNr_t ( #7f, #ef, #ff ),
			PortNr_t ( #7f, #ef, #ff ),
			PortNr_t ( #77, #ff, #ff ),
			PortNr_t ( #77, #ff, #ff ),
			PortNr_t ( #77, #bf, #ff ), { Objekt 15 }
			PortNr_t ( #77, #bf, #ff ),
			PortNr_t ( #bf, #ff, #ff ),
			PortNr_t ( #bf, #ff, #ff ),
			PortNr_t ( #bf, #df, #ff ),
			PortNr_t ( #bf, #df, #ff ), { Objekt 20 }
			PortNr_t ( #af, #ff, #ff ),
			PortNr_t ( #af, #ff, #ff ),
			PortNr_t ( #af, #fb, #ff ),
			PortNr_t ( #af, #fb, #ff ),
			PortNr_t ( #bf, #ff, #df ), { Objekt 25 }
			PortNr_t ( #bf, #ff, #df ),
			PortNr_t ( #bf, #f7, #df ),
			PortNr_t ( #bf, #f7, #df ),
			PortNr_t ( #be, #ff, #df ),
			PortNr_t ( #be, #ff, #df ), { Objekt 30 }
			PortNr_t ( #be, #ff, #db ),
			PortNr_t ( #be, #ff, #db ),
			PortNr_t ( #ff, #ff, #7f ),
			PortNr_t ( #ff, #ff, #7f ),
			PortNr_t ( #ff, #fe, #7f ), { Objekt 35 }
			PortNr_t ( #ff, #fe, #7f ),
			PortNr_t ( #fb, #ff, #7f ),
			PortNr_t ( #fb, #ff, #7f ),
			PortNr_t ( #fb, #fd, #7f ),
			PortNr_t ( #fb, #fd, #7f ), { Objekt 40 }
			PortNr_t ( #df, #ff, #7f ),
			PortNr_t ( #df, #ff, #7f ),
			PortNr_t ( #df, #ff, #7d ),
			PortNr_t ( #df, #ff, #7d ),
			PortNr_t ( #dd, #ff, #7f ), { Objekt 45 }
			PortNr_t ( #dd, #ff, #7f ),
			PortNr_t ( #dd, #ff, #7e ),
			PortNr_t ( #dd, #ff, #7e ),
			PortNr_t ( #bf, #ff, #7f ),
			PortNr_t ( #bf, #ff, #77 ) ); { Objekt 50 }

{$page+}

 { and-tabell, nollst{ll (dra) rel{er } 

			{ Port :    2a   2b   2c }

RelaTab2B = ObjNr_t (	PortNr_t ( #ff, #ff, #ff ), { Objekt 1 }
			PortNr_t ( #bf, #ff, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ff, #7f ),
			PortNr_t ( #ff, #ff, #ff ), { Objekt 5 }
			PortNr_t ( #7f, #ff, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ff, #df ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #df, #ff, #ff ), { Objekt 10 }
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ff, #bf ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #f7, #ff, #ff ),
			PortNr_t ( #ff, #ff, #ff ), { Objekt 15 }
			PortNr_t ( #ef, #ff, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #fe, #ff, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #fb, #ff, #ff ), { Objekt 20 }
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #fd, #ff, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ff, #ef ),
			PortNr_t ( #ff, #ff, #ff ), { Objekt 25 }
			PortNr_t ( #ff, #7f, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ef, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #bf, #ff ), { Objekt 30 }
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #df, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #fb, #ff ),
			PortNr_t ( #ff, #ff, #ff ), { Objekt 35 }
			PortNr_t ( #ff, #f7, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ff, #fb ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #fe, #ff ), { Objekt 40 }
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #fd, #ff ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ff, #fd ),
			PortNr_t ( #ff, #ff, #ff ), { Objekt 45 }
			PortNr_t ( #ff, #ff, #fe ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ff, #f7 ),
			PortNr_t ( #ff, #ff, #ff ),
			PortNr_t ( #ff, #ff, #ff ) ); { Objekt 50 }



{$page+}
{*******************************************************}
{	Ini_RelaPorts:					}
{	Initierar portarna mot relakortet.		}
{*******************************************************}

Procedure Ini_RelaPorts	[PUBLIC];

BEGIN	{ Ini_RelaPorts }

    OutByte ( #210,     #80 );		{ I/O-Port 1 }
    OutByte ( LP_VP[1], #FF );		{ 1a }
    OutByte ( LP_VP[2], #FF );		{ 1b }
    OutByte ( LP_VP[3], #FF );		{ 1c }

    OutByte ( #218,     #80 );		{ I/O-Port 2 }
    OutByte ( LP_VP[4], #FF );		{ 2a }
    OutByte ( LP_VP[5], #FF );		{ 2b }
    OutByte ( LP_VP[6], #FF );		{ 2c }

END;	{ Ini_RelaPorts }

{$page+}
{*******************************************************}
{	Stall_Relaerna:					}
{	Staller om relaerna vid val av objekt.		}
{*******************************************************}

Procedure Stall_Relaerna ( Hylla : integer;
			   Slot  : integer ) [PUBLIC];

TYPE
    PortNr_t	= array [1..6]  OF byte;

VAR
    LPortNr	: integer;		{ Logiskt portnummer }
    PortVarde	: byte;
    ANDTab	: PortNr_t;		{ Vid val av AND-tabell }
    ORTab	: PortNr_t;		{ Vid val av OR-tabell }
    Kortplats	: integer;
    i		: integer;
    str		: lstr4;

BEGIN	{ Stall_Relaerna }

    Kortplats := (Hylla - 1)*10 + Slot;
    FOR i := 1 TO 3 DO BEGIN
    	ORTab[i] := RelaTab1A[Kortplats,i];
	ANDTab[i] := RelaTab2A[Kortplats,i];
    END;
    FOR i := 1 TO 3 DO BEGIN
    	ORTab[i+3] := RelaTab1B[Kortplats,i];
	ANDTab[i+3] := RelaTab2B[Kortplats,i];
    END;
    FOR LPortNr := 1 TO 6 DO BEGIN
	PortVarde := InByte ( LP_VP[LPortNr] );
	PortVarde := ( PortVarde ) OR  ORTab [LPortNr];
	PortVarde := ( PortVarde ) AND ANDTab[LPortNr];
	OutByte ( LP_VP[LPortNr], PortVarde );
    END; { FOR }

    Eval ( Encode ( str, hylla :1 ) );
    CposWrite(1, 17, str );
    Eval ( Encode ( str, slot :-2 ) );
    CposWrite(1, 23, str );

    Wait_a1 ( 0.100 );	{ v{nta tills rel{erna har stabiliserat sig }

END;	{ Stall_Relaerna }

{$page+}
{*******************************************************}
{	Connect_Kort:					}
{	Kopplar in kraftaggregatet.			}
{*******************************************************}

Procedure Connect_Kort [PUBLIC];

TYPE
    PortNr_t	= array [1..6]  OF byte;

CONST
	    { Port :     1a   1b   1c   2a   2b   2c }

    OnTab  = PortNr_t ( #00, #00, #00, #e0, #00, #e0 );
	     { For att sla pa kraftaggregat ( enbart OR ) }

VAR
    LPortNr	: integer;		{ Logiskt portnummer }
    PortVarde	: byte;

BEGIN	{ Connect_Kort }

    FOR LPortNr := 1 TO 6 DO BEGIN
	PortVarde := InByte ( LP_VP[LPortNr] );
	PortVarde := ( PortVarde ) OR ( OnTab[LPortNr] );
	OutByte ( LP_VP[LPortNr], PortVarde );
    END; { FOR }
    Stall_Relaerna(rack[Obj].hyllnr, rack[Obj].slotnr);{Koppla in valt objekt}

END;	{ Connect_Kort }

{$page+}
{*******************************************************}
{	DisConnect_Kort:				}
{	Kopplar bort kraftaggregatet ( nar spanning	}
{	satts till 0 volt ).				}
{*******************************************************}

Procedure DisConnect_Kort [PUBLIC];

TYPE
    PortNr_t	= array [1..6]  OF byte;

CONST
	    { Port :     1a   1b   1c   2a   2b   2c }

    OffTab = PortNr_t ( #ff, #ff, #ff, #1f, #ff, #1f );
	     { For att stanga av kraftaggregat ( enbart AND ) }

VAR
    LPortNr	: integer;		{ Logiskt portnummer }
    PortVarde	: byte;

BEGIN	{ DisConnect_Kort }

    FOR LPortNr := 1 TO 6 DO BEGIN
	PortVarde := InByte ( LP_VP[LPortNr] );
	PortVarde := ( PortVarde ) AND ( OffTab[LPortNr] );
	OutByte ( LP_VP[LPortNr], PortVarde );
    END; { FOR }

    CposWrite(1, 17, ' ' );	{ Blanka hylla och slot }
    CposWrite(1, 23, '  ');


END;	{ DisConnect_Kort }

{$page+}
{*******************************************************}
{	Choose_Objekt:					}
{	OBJEKT-kommandot.				}
{*******************************************************}

Procedure Choose_Objekt	( ptr	   : komm_ptr;
			  RadDelar : linepart_t ) [PUBLIC];

VAR
    ErrParm	: ErrParmArea_t;	{ For felaktiga parametrar }
    AntErrParm	: integer;		{ Antal felaktiga parametrar }
    ObjTmp	: integer;		{ Innan man vet om objektet finns }

BEGIN	{ Choose_Objekt }

    IF RadDelar[2].typ = variabel THEN	{ Parametern till OBJEKT-kommandot }
	RadDelar[2].vaerde := Get_VarValue ( RadDelar[2].txt );
    ObjTmp := Round ( RadDelar[2].vaerde );
    IF ( 1 <= ObjTmp ) AND ( ObjTmp <= Round (ant_obj) ) THEN BEGIN
    	Obj := ObjTmp;		 	{Koppla in valt objekt}
        IF SpanningFlg THEN BEGIN
	    Stall_Relaerna(rack[Obj].hyllnr, rack[Obj].slotnr);
	END { IF }; END { IF }
    ELSE BEGIN				{ Logga felaktig parameter }
	ErrParm[1].ParmTyp := ObjNrParm;
	ErrParm[1].Varde := ObjTmp;
	Logga_ParmFel ( RadDelar[1], ptr^.linenr, ErrParm, 1 );
    END; { ELSE }

END;	{ Choose_Objekt }

END.	{ module }
