  Testprogram F|r Rel{l}da                                     Sida 1
  Rev 1.0 / 86-12-05      IND AB / AN



      Inneh}llsf|rteckning


  1.          Allm{nt
  2.          Filf|rteckning
  3.          Kompilering och l{nkning
  4.          PROCEDURE- och FUNCTION-beskrivningar
  5.          Globala variabler 
  6.          Handhavande
!!
  Testprogram F|r Rel{l}da                                     Sida 2
  Rev 1.0 / 86-12-05      IND AB / AN


  1.          Allm{nt

      Rel{kortet kan testas med hj{lp av rel{testprogrammet, reltest.
      Principen {r att man slingkopplar s{nd och mottag data i stativet
      f|r en kortplats i taget. Med hj{lp av rel{testprogrammet kan
      man styra rel{l}dan att koppla in det valda kortet. Programmet
      s{nder en teckensekvens och presenterar den teckenstr|m som
      mottages. P} detta s{tt kan st|rre delen av TMC testas. 


  2.          Filf|rteckning

      F|rteckning |ver alla de filer som beh|vs p} PC'n f|r att kunna
      anv{nda Rel{testprogrammet.

          err         - felutskrifter fr}n rel.bat.
          rel.bat     - kommandofil som kompilerar och l{nkar
                        rel{testprogrammet, skriver felen p} filen
                        "err" under tiden kompilering sker. 
          rellink     - kommandofil f|r l{nkningen. 
          reltest.exe - programmet som k|r rel{testen.
          reltest.pas - k{ll-koden till programmet som k|r rel{testen. 


      Filer som anv{nds fr}n TMC-programmen, skall inte {ndras i.

          asynch.h    - includefil med deklarationer f|r
                        asynch-paketet. 
          decl.h      - includefil med div konstanter och
                        recordbeskrivningar som {r gemensamma f|r
                        PC-programmen. 
          io.h        - includefil med deklarationer f|r io-modulen. 

          io.obj      - assemblerprogram med rutiner f|r
                        printerstatus, hantering av I/O-portar och
                        viss sk{rmhantering. 
          kbd.h       - includefil med deklarationer f|r kbd-modulen. 
          kbd.obj     - pascalprogram som hanterar keyboardet. 
          objkomn.h   - includefil med deklarationer f|r
                        objkomn-modulen. 
          objkomn.obj - pascalprogram som hanterar styrningen av
                        rel{-kortet f|r att v{lja objekt. 
          screen.h    - includefil med deklarationer f|r
                        screen-modulen. 
          screen.obj  - pascalprogram med bildsk{rmhantering. 

      Kommunikationspaket, bibliotek, kompilator och l{nkare:

          asy_pas.lib - kommunikationsbibliotek. 
          asynch0.obj - kommunikationspaketet. 
          dos2pas.lib - pascalbibliotek. 
          link.exe    - l{nkaren (heter link.V2 p} MS-pascal diskett).
          math.lib    - pascalbibliotek. 
          pas.exe     - pascalkompilator pass 1. 
          pas2.exe    - pascalkompilator pass 2. 
          pas3.exe    - pascalkompilator pass 3. 
          pascal.lib  - pascalbibliotek. 

!!
  Testprogram F|r Rel{l}da                                     Sida 3
  Rev 1.0 / 86-12-05      IND AB / AN



  3.          Kompilering och l{nkning

      F|r att kompilera programmet anv{nds Microsoft Pascal Compiler.
      En del rutiner anv{nds fr}n TMC-systemet. De {r: asynch.h decl.h
      io.h io.obj kbd.h kbd.obj objkomn.h objkomn.obj screen.h och
      screen.obj. 

      Det f|ruts{tts att det finns tillg}ng till dessa filer f|r att
      kunna kompilera och l{nka. 

      F|r att kompilera och l{nka ger man kommandot REL. F|r att bara
      l{nka: LINK @RELLINK. 

      Outputen fr}n l{nkaren {r en programfil som heter RELTEST.EXE
      och mappen RELTEST.MAP. 

      De bibliotek som m}ste finnas vid l{nking {r: 

              DOS2PAS.LIB
              PASCAL.LIB
              MATH.LIB

      som alla finns p} pascaldisketterna, och 

              ASY_PAS.LIB

      som finns p} asynchronpaketets diskett. 


  4.          PROCEDURE- och FUNCTION-beskrivningar

      Ini_COM_Ports
      -------------

      Beskrivning : \ppnar kommunikationsportarna f|r mddmkortet
                    (COM1). IOBuf_1 skickas som parametrar till open
                    f|r att anv{ndas som buffer av asynch-paketet.
                    Skriver felutskrift p} sk{rmen om fel intr{ffar. 

      Startup
      -------

      Beskrivning : Initierar kommunikation och rel{portarna.


      Get_VarValue
      ------------

      Beskrivning : Dummy-rutin som m}ste finnas eftersom den finns
                    refererad i de objektmoduler som l{nkas in fr}n
                    TMC-systemet. Vid anrop skrivs ett felmeddelande
                    ut. Den returnerar v{rdet 0. 


      TimeUsed
      --------

!!
  Testprogram F|r Rel{l}da                                     Sida 4
  Rev 1.0 / 86-12-05      IND AB / AN


      Beskrivning : Dummy-rutin som m}ste finnas eftersom den finns
                    refererad i de objektmoduler som l{nkas in fr}n
                    TMC-systemet. Vid anrop skrivs ett felmeddelande
                    ut. Den returnerar v{rdet "00:00:00 ". 

      Logga_parmFel
      -------------

      Beskrivning : dummy-rutin som m}ste finnas eftersom den finns
                    refererad i de objektmoduler som l{nkas in fr}n
                    TMC-systemet. Vid anrop skrivs ett felmeddelande
                    ut.

      Skriv_portstatus
      ----------------

      Beskrivning : L{ser av de I/O-portar som visar i vilket l{ge
                    rel{erna st}r i och skriver ut det p} rad 23 p}
                    sk{rmen. 


      HUVUDPROGRAMMET: G|r div. initieringar v{ntar sedan p} kommando
                    fr}n operat|r. uf|r kommandot och v{ntar p} ett
                    nytt. Om kommando f|r att testa ett kort har getts
                    g|rs det tills annat kommando ges. P} sk{rmen
                    presenteras i vilket l{ge rel{erna st}r, om och
                    is}fall vad det kommer f|r tecken fr}n
                    kommunikationen, vilket kort som {r inkopplat, om
                    12-volten {r inkopplad eller inte. 

                    Det kommando som skickas till mddm-kortet vid
                    kort-test {r ett ramtestkommando med felaktiga
                    parametrar: <stx>1;1g och som svar skall det komma
                    en felkod: <stx>FFG om det {r ett TMC-program i
                    mddmkortet. P} sk{rmen visas det erh}llna svaret i
                    inversed video (<stx> visas som en glad gubbe) om
                    det inte {r FFG. 


  5.          Globala variabler 

      De enda av de globala variablerna som anv{nds {r:


              Rack : beskrivning av racken med alla 50 korten i, f|r
                    varje kort finns vilken hylla och vilket slot
                    kortet sitter i samt id f|r kortet. 
                    f|ljande moduler:
       
              Obj : vilket objekt (index i Rack) som {r valt under det
                    att testen p}g}r. 


!!
  Testprogram F|r Rel{l}da                                     Sida 5
  Rev 1.0 / 86-12-05      IND AB / AN


  6.          Handhavande

      Programmat startas genom att man skriver RELTEST till PC'n, d}
      visas f|ljande bild: 

                      Testprogram f|r rel{l}dan
      ________________________________________________________________










      ---------------------------------------------------------------
      1a:FF 1b:FF 1c:FF  2a:FF 2b:FF 2c:FF   hylla:  slot:    pwr: on
      _______________________________________________________________
      >

      Det som visas nederst p} sk{rmen {r l{get p} rel{erna d{r 1a-1c,
      1b-3b {r de olika dataportarna. I de 6 dataportarna motsvarar
      varje bit ett rel{. Om en bit {r ett motsvarar det att rel{et {r
      sl{ppt och en nolla att det {r draget. Alla bitar i dataportarna
      initieras till ett, dvs alla rel{er sl{pps. Dataportarna
      motsvarar f|ljande I/O-adresser i PC'n: 

                      dataport 1a     - 213 hex
                      dataport 1b     - 212 hex
                      dataport 1c     - 211 hex
                      dataport 2a     - 21B hex
                      dataport 2b     - 21A hex
                      dataport 2c     - 219 hex

      Hylla och slot visar vilken kortplats som {r invald. Pwr visar
      om 12-volten {r inkopplad eller inte. 

      Operat|ren kan} ge n}got av kommandona 1..50, HELP, OFF, ON,
      EXIT, S, NOLL och ETT. De olika kommandona utf|r f|ljande: 

      1..50 : Om man bara skriver ett v{rde mellan 1 och 50 kommer
                    motsvarande kortplats att testas. Testet g}r till
                    s} att ett RAMTEST-kommando med felaktiga
                    parametrar skickas till mddm-kortet, det skall d}
                    svara med en felkod som {r FF, p} sk{rmen loggas
                    den d} <stx>FFG (d{r <stx> motsv en glad gubbe),
                    om annat svar erh}lls skrivs det med inversed
                    video. De olika kortplatserna {r numrerade enl
                    f{ljande: 

                    Hylla 1 plats 1-10 = kortplats 1-10
                    Hylla 2 plats 1-10 = kortplats 11-20
                    Hylla 3 plats 1-10 = kortplats 21-30
                    Hylla 4 plats 1-10 = kortplats 31-40
                    Hylla 5 plats 1-10 = kortplats 41-50

!!
  Testprogram F|r Rel{l}da                                     Sida 6
  Rev 1.0 / 86-12-05      IND AB / AN


      HELP : l{gger ut en ledtext med vilka kommandon som finns:
              1..50  - Siffra mellan 1 och 50 kopplar in motsv. kort
              HELP   - Denna text
              OFF    - Disconnect kort
              ON     - Connect kort
              EXIT   - Avsluta testningen
              S p v  - s{tt port p till v{rde v
              noll   - Nollst{ll alla portar
              ett    - ettst{ll alla portar

      OFF : Kopplar bort 12-volts kraften till mddmkorten genom att
                    {ndra p} 6 speciella rel{er. En flagga l{ngst ned
                    till h|ger p} sk{rmen visar om kraften {r av eller
                    p}. 

      ON : Kopplar in 12-volts kraften till mddmkorten genom att {ndra
                    p} 6 speciella rel{er. En flagga l{ngst ned till
                    h|ger p} sk{rmen visar om kraften {r av eller p}. 

      EXIT : Avsluta programmet, }terg} till DOS.

      S : S{tter en viss dataport till ett best{mt v{rde, dvs s{tter
                    manuellt om en grupp p} 8 rel{er skall vara,
                    slutna eller dragna. anges genom att skriva t.ex.
                    S 1a B6, vilket inneb{r att det kommer att skrivas
                    B6 i port 1A (I/O-adress 213).

      NOLL : Nollst{ller samtliga dataportar.

      ETT : Ettst{ller samtliga dataportar.
