#include	<sgtty.h>
#include	<stdio.h>

#define	SIZE	128
#define	CAN	24
#define	EOT	4

/*	Programmet f|r |ver filer till IBM-PC
	motsv. pgm p} PC {r ZCOM		*/

FILE	*fp_out,	*fopen();
int	fp_com;
struct	sgttyb	tyt, *tytp = &tyt;
struct	sgttyb	tyto, *tytop = &tyto;

char	ack[]	= "\06";
char	syn[]	= "\026";

main(argc, argv)
int	argc;
char	*argv[];

{
int	cnt;
char	ca[SIZE+1], *c;

	cominit();

	if ((fp_out = fopen (*++argv, "w")) == NULL ) {
		fprintf (stderr, "fcom: can't open %s\n", *argv);
		comback();	/* }terst{ll terminal */
		exit (1);
	}

	write(fp_com,ack,1);

	cnt = 0;
	c = ca;
	ca[SIZE] = NULL;

	read(fp_com,c,1);
	while ( *c != EOT ) {
		if ( *c == CAN ) {	/* kommer blocket att saendas om ?? */
			if ( c != ca ) {	/* om can aer foersta tecken - strunta i det */
				c = ca;
				cnt = 0;
				write(fp_com,syn,1);	/* acka cancel */
			}
		} else {
			c++;
			if ( ++cnt == SIZE ) {
				fputs(ca,fp_out);
				c = ca;
				cnt = 0;
				write(fp_com,ack,1);
			}
		}
		read(fp_com,c,1);
	}

	if ( cnt != 0 ) {
		ca[cnt] = NULL;
		fputs(ca,fp_out);
	}

	fclose(fp_out);

	comback();	/* }terst{ll terminal */
}



cominit()			/* Initialize the terminal driver */
{
	char	*tname;
	char	*ttyname();


	if ((tname=ttyname (0)) == NULL) {
		fprintf(stderr,"fcom: stdin ej tty\n");
		exit(1);
	}

	/* set terminal in proper mode */

	if((fp_com = open(tname,2)) == -1) {
		fprintf(stderr,"fcom: open tty funkar ej\n");
		exit(-1);
	}

	if ( gtty(fp_com,tytp) == -1 ) {
		fprintf(stderr,"fcom: gtty funkar ej\n");
		exit(-1);
	}

	tytp->sg_flags &= ~ECHO;
	tytp->sg_flags |= CBREAK;

	if ( gtty(fp_com,tytop) == -1 ) {	/* spara gamla v{rden */
		fprintf(stderr,"fcom: gtty funkar ej\n");
		exit(-1);
	}

	if ( stty(fp_com,tytp) == -1 ) {
		fprintf(stderr,"fcom: stty funkar ej\n");
		exit(-1);
	}
}

comback()			/* set terminal back to defaults */
{
	stty(fp_com,tytop);
	close(fp_com);
}
