/*

  Detta program printar alla rader i inputen som inneh}ller 

	1:   "P "   f|rst p} raden
	2:   ","    n}gonstans i raden
	3:   "#"    ingenstans i raden

  Avsikten {r att tipsa om dom st{llen i ett z8-program d{r man
  kan ha gl|mt att anv{nda # i tilldelningar, exvis

	ld	r0,pelle

  i st{llet f|r

	ld	r0,#pelle


  Obs att listfilen ska anv{ndas

*/
/**/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

#define MAXL		1000

char	line[MAXL];
/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen();
	char	*instr();

	if (argc == 1) {
		filelist(stdin);
	} else
		while (--argc > 0)
			if ((fp = fopen(*++argv,"r")) == NULL) {
				fprintf(stderr,"nohash: cannot open %s\n",*argv);
 			} else {
				char *string();

				printf("\n%s:\n\n",*argv);

				filelist(fp);
				fclose(fp);
			}
}
/**/
filelist(fp)
FILE	*fp;
{

	while((fgets(line, MAXL, fp)) != NULL) {
		if(instr(line, "P ") == line)			/* b|rjar p} P */
			if(instr(line, ",") != NULL)		/* inneh}ller , */
				if(instr(line, "#") == NULL)	/* inte # */
					printf("%s", line);
	}
}
/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
