#include <sgtty.h>
#include <stdio.h>

#define FALSE		0
#define	TRUE		1

#define	DEL		' '
#define	ETX		3
#define	ACK		6
#define	BUFFZ		75
#define MAXL		1000

#define DELAD		0x1
#define	NYSID		0x2

#define isbp(l)		(instr((l),".bp") != NULL || instr((l),"!!") != NULL)
#define isbl(l)		(instr((l),".bl") != NULL)

int	fd;				/* utfil */
struct	sgttyb	tyt, *tytp = &tyt;
int	out;				/* utest}ende buffrar */
int	flags;				/* statusflaggor */
int	autoff;
int	omigen;
char	line[MAXL];			/* inrad */
char	*utpos;

/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*inf;
	char	*instr();

	set();				/* upps{ttning av tty7 f|r diablo */
	autoff = FALSE;

	while (instr(*++argv, "-")) {
		if (strncmp(*argv, "-f",2) == 0)
			autoff = TRUE;

		--argc;
	}

	if (argc == 1)
		file(stdin);

	else
		while (--argc > 0) {
			omigen = TRUE;
			while (omigen)
				if ((inf = fopen(*argv,"r")) == NULL) {
					fprintf(stderr,"dia: cannot open %s\n",*argv);
					exit(1);
				}

				else {
					file(inf);
					fclose(inf);
				}

			argv++;
		}
}
/**/
set()
{

	if((fd = open("/dev/tty7",2)) == -1) {
		fprintf(stderr,"dia: can nicht open diablo\n");
		exit(-1);
	}

	else if(gtty(fd,tytp) == -1) {
		fprintf(stderr,"dia: can icke read settning\n");
		exit(-1);
	}

	else {
		tytp->sg_flags &= ~ECHO;
		tytp->sg_flags |= CBREAK;
		tytp->sg_ispeed = B1200;
		tytp->sg_ospeed = B1200;
	}

	if(stty(fd,tytp) == -1) {
		fprintf(stderr,"dia: can njet change settning\n");
		exit(1);
	}
}
/**/
file(f)
FILE	*f;
{
	char	ca[1], *c = ca;
	int	len;
	char	*instr();

	flags = NYSID;
	utpos = line;			/* t|m inbuffer */

	for(;;) {
		if(flags & NYSID) {
			for(;;) {
				read(fd,c,1);
				if (*c == DEL) {
					del(c);
					return;
				}

				if (*c == ACK && out > 0)
					out--;

				else if (*c == '\n') {
					flags &= ~NYSID;
					break;
				}
			}
		}
/**/
		while (out == 2) {
			read(fd,c,1);
			if (*c == DEL) {
				del(c);
				return;
			}

			if (*c == ACK)
				out--;
		}

		if (utpos == line) {
			if ((fgets(line, MAXL, f)) == NULL) {
				while (out > 0) {
					read(fd,c,1);
					if (*c == DEL) {
						del(c);
						return;
					}

					if(*c == ACK)
						out--;
				}

				write(fd, "\n", 1);
				break;
			}
/**/
			else if(isbp(line)) {
				if (autoff)
					write(fd, "\f", 1);

				else
					flags = NYSID;

				utpos = line;
				*line = '\0';
			}

			else if(isbl(line)) {
				utpos = line;
				*line = '\0';
				write(fd,"\33D\33D\33B\33B\33B\33B\33B\33B",16);
			}
		}
/**/
		len = strlen(utpos);
		if(len > 0) {
			if(len > BUFFZ) {
				write(fd,line,BUFFZ);
				utpos += BUFFZ;
			}

			else {
				write(fd,utpos,len);
				utpos = line;
			}

			out++;
			*c = ETX;
			write(fd,c,1);
		}
	}

	omigen = FALSE;
}
/**/
del(c)
char	*c;
{
	for(;;) {
		read(fd, c, 1);
		if (*c == ACK)
			out--;

		else
			break;
	}

	if (*c == DEL) {
		write(fd, "\n", 1);
		omigen = FALSE;
	}
}
/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}

	return(NULL);
}
