/**********************************************************************
*
*  Snutt f|r s|kning efter ett ord i telefonlista
*  Listan f|ruts{tts finnas i /z/telefonlista
*  Versaler o gemena behandlas lika
*  Det g}r att ha ett (1) s|kord p} kommandoraden och i s} fall
*  sker genast exit efter presentation.
*  V och W behandlas lika.
*
*  Rev:
*	Sun Jan 12 15:58:42 1986	S|kord p} kommandoraden
*	Thu Jan 16 14:16:58 1986	Exit efter en s|kning om s|kordet
*					p} komandoraden funnet /GBm
*	Wed Jan 22 16:21:19 1986	V och W behandlas lika /UI
*
**********************************************************************/

#include <stdio.h>

#define MAXL		300

char	line[MAXL], ord[MAXL];

/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	if ( argc > 1)
		if (sok(argv[1]) != 0)
			exit(0);
	for(;;) {
		printf("S|kord: ");
		if (gets(ord) == NULL) {
			printf("\n");
			exit(0);
		}

		if (*ord == '\0')
			exit(0);

		sok(ord);
	}
}
/**/
sok(p)
char	*p;
{
int	funna = 0;

	FILE	*telfile, *fopen();
	char	*instr();

	if ((telfile = fopen("/z/telefonlista", "r")) == NULL) {
		fprintf(stderr, "tel: ingen telefonlista\n");
		exit(1);
	}

	while (fgets(line, MAXL, telfile) != NULL) 
		if (instr(line, p) != NULL) {
			*(line + strlen(line) - 1) = '\0';
			puts(line);
			funna++;
		}

	printf("\n");
	fclose(telfile);
	return(funna);
}

/**/
char	*
instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && toupp(*j) == toupp(*k); 
								j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}

toupp(c)
int	c;
{
	c = c >= 'A' && c <= ']' ? c : c - 0x20;
	c = c == 'W' ? c - 1 : c;
	return(c);
}
