#include <stdio.h>
#include "lon.h"

/**/
char	line[MAXL], workl[MAXL];
char	accrader[MAXNAMN + 1] [SMALL];
char	namn[SMALL];
double	sumlon, sumskatt;
double	acclon, accskatt;
double	data[12];			/* l|nedataarray */

/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*afp, *dfp, *fopen();

/*
	while (instr(*++argv, "-")) {
		if (strncmp(*argv, "-i",2) == 0)
			ibmlst = TRUE;

		else if (strncmp(*argv, "-s", 2) == 0) {
			set(SA4);
		}

		--argc;
	}
*/
	if (argc != 3) {
		fprintf(stderr, "acc: parameterfel\n");
		exit(-1);
	}

	if ((afp = fopen(*++argv,"r")) == NULL) {
			fprintf(stderr,"acc: cannot open %s\n",*argv);
			exit(-1);
		}

	if ((dfp = fopen(*++argv,"r")) == NULL) {
		fprintf(stderr,"acc: cannot open %s\n",*argv);
		exit(-1);
	}

	readacc(afp);
	fclose(afp);
	mkacc(dfp);
}
/**/
readacc(afp)
FILE	*afp;
{
	int	rad;
	char	*strcpy();

	rad = 0;
	*accrader[rad] = '\0';
	while ((fgets(line, MAXL, afp)) != NULL) {
		*(line + strlen(line) - 1) = '\0';	/* ta bort LF */
		strcpy(accrader[rad], line);
		rad++;
		*accrader[rad] = '\0';
	}
}

/**/
mkacc(dfp)
FILE	*dfp;
{
	int	i, rad;

	for (i = 1; i <= BERHEAD; i++)
		if ((fgets(line, MAXL, dfp)) == NULL) {
			fprintf(stderr, "acc: Ej komplett ber-fil\n");
			exit(-1);
		}

	for(;;) {
		rad = 1;
		while ((rad <= 13 && fgets(line, MAXL, dfp)) != NULL) {
			*(line + strlen(line) - 1) = '\0';	/* ta bort LF */
	
			switch(rad) {
				case 1:
					strcpy(namn, line);
					break;
	
				case 2:
					val(ML);
					break;
	
				case 3:
					val(OT1);
					break;
	
				case 4:
					val(OT2);
					break;
	
				case 5:
					val(SEM);
					break;
	
				case 6:
					val(TJL);
					break;
	
				case 7:
					val(SJDGR);
					break;
	
				case 8:
					val(PERDAG);
					break;
	
				case 9:
					val(SKATT);
					break;
			}
	
			rad++;
		}

		if (rad <= 13)
			break;

		skrivut();
	}
}

/**/
val(x)
int	x;
{
	sscanf(line, "%lf", &data[x]);
}


skrivut()
{
	int	rad;
	char	*p;

	sumlon = data [ML] + data [OT1] + data [OT2] + 
		 data [SEM] - data [TJL] - (data [SJDGR] * data [PERDAG]);

	sumskatt = data [SKATT];

	rad = 0;
	while(*accrader[rad] != '\0') {
		strcpy(workl, accrader[rad]);
		p = workl;
		while (*p != ' ')
			p++;

		*p = '\0';
		if (strcmp(workl, namn) == 0)
			break;

		rad++;
	}

	p = accrader[rad];
	while (*p != ' ')
		p++;

	sscanf(p, "%lf %lf", &acclon, &accskatt);
	acclon += sumlon;
	accskatt += sumskatt;

	printf("%s %-0.0f %-0.0f\n", workl, acclon, accskatt);
}
