PAGE	60,132
INCLUDE B:BIG.INC
INCLUDE B:SDB.EQU
;/****************************************************************
;*        MTOS 86 DIAGNOSTIC V1.0                                *
;*                                                               *
;*        COPYRIGHT 1982 BY     INDUSTRIAL PROGRAMMING,INC.      *
;*                              100 JERICHO QUADRANGLE           *
;*                              JERICHO, NEW YORK  11753         *
;*                                                               *
;*        THIS SOFTWARE IS FURNISHED TO THE PURCHASER UNDER      *
;*        A LICENSE WHICH FORBIDS REPRODUCTION IN WHOLE OR       *
;*        PART EXCEPT AS PROVIDED IN WRITING BY INDUSTRIAL       *
;*        PROGRAMMING,INC.                                       *
;*****************************************************************
;MODULE: D_ASSEMBLY_UTILITIES_MOD
;FILE: DASMUT.ASM
;
;THIS MODULE CONTAINS ALL THE ASSEMBLY LANGUAGE PROCEDURES
;WHICH ARE PART OF THE DIAGNOSTIC. FIRST IT INITIALIZES
;PL/M VARIABLES WITH THE DIAGNOSTIC SYSTEM PARAMETERS.
;****************************************************************/
;
NAME	D_ASSEMBLY_UTILITIES_MOD
;
;/*-------------------------GLOBAL-DATA-------------------------*/
;
MTOS_DS		SEGMENT	PARA PUBLIC
		EXTRN	X_NUM_DIAG_TASKS:ABS
		EXTRN	X_DIAG_DEVICE:ABS
		EXTRN	X_DIAG_UNIT:ABS
		EXTRN	X_DIAG_CP:ABS
		EXTRN	X_DIAG_GEF_GRP:ABS
		EXTRN	X_DIAG_SEMA:ABS
		EXTRN	X_DIAG_MEM:ABS
		EXTRN	X_DIAG_DSCRTE:ABS
		EXTRN	X_DIAG_MAILBOX:ABS
		EXTRN	X_DIAG_MAIN_TASK:ABS
;
MTOS_DS ENDS
;
;/*-------------------------------------------------------------*/
;
DIAG86_CS	SEGMENT	PARA PUBLIC
;
XSTATICTASKS	DW	X_STATIC_TASKS
XDISCRETENUM	DW	X_DISCRETE_NUM
XUNITNUM	DW	X_UNIT_NUM
XMAILBOXNUM	DW	X_MAILBOX_NUM
XCONTROLNUM	DW	X_CONTROL_NUM
XGEFNUM     	DW	X_GEF_NUM
XMEMPOOLNUM	DW	X_MEM_POOL_NUM
XSEMANUM	DW	X_SEMA_NUM
XNUMDIAGTASKS	DW	X_NUM_DIAG_TASKS
XDIAGMAINTASK	DW	X_DIAG_MAIN_TASK
XDIAGDEVICE	DW	X_DIAG_DEVICE
XDIAGUNIT	DW	X_DIAG_UNIT
XDIAGCP		DW	X_DIAG_CP
XDIAGGEFGRP	DW	X_DIAG_GEF_GRP
XDIAGSEMA	DW	X_DIAG_SEMA
XDIAGMEM	DW	X_DIAG_MEM
XDIAGDSCRTE	DW	X_DIAG_DSCRTE
XDIAGMAILBOX	DW	X_DIAG_MAILBOX
XTCBTABLEADDR	DD	X_TCB_TABLE
XTCDTABLEADDR	DD	X_TCD_TABLE
XMPDTABLEADDR	DD	X_MPD_TABLE
DIAG86DS	DW	DIAG86_DS
;
		PUBLIC	XSTATICTASKS
		PUBLIC	XDISCRETENUM
		PUBLIC	XUNITNUM
		PUBLIC	XMAILBOXNUM
		PUBLIC	XCONTROLNUM
		PUBLIC	XGEFNUM
		PUBLIC	XMEMPOOLNUM
		PUBLIC	XSEMANUM
		PUBLIC	XNUMDIAGTASKS
		PUBLIC	XDIAGMAINTASK
		PUBLIC	XDIAGDEVICE
		PUBLIC	XDIAGUNIT
		PUBLIC	XDIAGCP
		PUBLIC	XDIAGGEFGRP
		PUBLIC	XDIAGSEMA
		PUBLIC	XDIAGMEM
		PUBLIC	XDIAGDSCRTE
		PUBLIC	XDIAGMAILBOX
		PUBLIC	XTCBTABLEADDR
		PUBLIC	XTCDTABLEADDR
		PUBLIC	XMPDTABLEADDR
		PUBLIC	DIAG86DS
;
DIAG86_CS	ENDS
;/*------------------------GLOBAL-VARIABLES---------------------*/
DIAG86_DS	SEGMENT PARA PUBLIC
;
XTGTSFLAG	DW	?
XTGTINCVAL	DW	?
XTGTSETVLP	DW	?
XTGTSETVHP	DW	?
XTGTERSTRT	DW	?
XTGTERTERM	DW	?
XTGTPSFLAG	DW	?
XTGTRCLPRI	DW	?
XTGTRCMATH	DW	?
XTGTDALOC	DW	?
XTGTCP		DW	?
XTGTCPSFLG	DW	?
XTGTSEF		DW	?
XTGTSMSFLG	DW	?
XTGTSMPAUS	DW	?
XTGTDYNPRI	DW	?
XTGTTGTAX	DW	?
XTGTTCDPAR	DW	?
TASKID		DW	?
CALLERAX	DW	?
TARGETAX	DW	?
;
		PUBLIC	XTGTSFLAG
		PUBLIC	XTGTINCVAL
		PUBLIC	XTGTSETVLP
		PUBLIC	XTGTSETVHP
		PUBLIC	XTGTERSTRT
		PUBLIC	XTGTERTERM
		PUBLIC	XTGTPSFLAG
		PUBLIC	XTGTRCLPRI
		PUBLIC	XTGTRCMATH
		PUBLIC	XTGTDALOC
		PUBLIC	XTGTCP
		PUBLIC	XTGTCPSFLG
		PUBLIC	XTGTSEF
		PUBLIC	XTGTSMSFLG
		PUBLIC	XTGTSMPAUS
		PUBLIC	XTGTDYNPRI
		PUBLIC	XTGTTGTAX
		PUBLIC	XTGTTCDPAR
		PUBLIC	TASKID
		PUBLIC	CALLERAX
		PUBLIC	TARGETAX
;
		PUBLIC	DIAG_MAIN_SP
		PUBLIC	T1SP,T2SP,T3SP,T4SP,T5SP,T6SP,T7SP,T8SP,T9SP
		PUBLIC	T10SP,T11SP,T12SP,T13SP,T14SP,T15SP,T16SP
		PUBLIC	T17SP,T18SP
;
DIAG86_DS	ENDS
;/*------------------------GLOBAL-PROCEDURES--------------------*/
DIAG86_CS	SEGMENT PARA PUBLIC
;
		PUBLIC		WTENDAX
		PUBLIC		TGTAX
;
		ASSUME		CS:DIAG86_CS,DS:DIAG86_DS
;
;/*----------------------THE-SDB'S------------------------------*/
;
WTEND_TGTAX	DB	01,043H
WTEND_ID	DW	0
		DB	0
		DW	0,0
END_TASK:	ENDT
;
DIAG86_DS 	SEGMENT PARA PUBLIC
;
;	STACK FOR THE DIAGNOSTIC MAIN TASK:
;
		DW	128 DUP (?)
DIAG_MAIN_SP	EQU	THIS WORD
;
;	STACKS FOR THE 18 TASKS CREATED BY THE MAIN TASK:
;
		DW	64 DUP (?)
T1SP		EQU	THIS WORD
		DW	64 DUP (?)
T2SP		EQU	THIS WORD
		DW	64 DUP (?)
T3SP		EQU	THIS WORD
		DW	64 DUP (?)
T4SP		EQU	THIS WORD
		DW	64 DUP (?)
T5SP		EQU	THIS WORD
		DW	64 DUP (?)
T6SP		EQU	THIS WORD
		DW	64 DUP (?)
T7SP		EQU	THIS WORD
		DW	64 DUP (?)
T8SP		EQU	THIS WORD
		DW	64 DUP (?)
T9SP		EQU	THIS WORD
		DW	64 DUP (?)
T10SP		EQU	THIS WORD
		DW	64 DUP (?)
T11SP		EQU	THIS WORD
		DW	64 DUP (?)
T12SP		EQU	THIS WORD
		DW	64 DUP (?)
T13SP		EQU	THIS WORD
		DW	64 DUP (?)
T14SP		EQU	THIS WORD
		DW	64 DUP (?)
T15SP		EQU	THIS WORD
		DW	64 DUP (?)
T16SP		EQU	THIS WORD
		DW	64 DUP (?)
T17SP		EQU	THIS WORD
		DW	64 DUP (?)
T18SP		EQU	THIS WORD
;
DIAG86_DS 	ENDS
;
;/*****************************************************************
;PROCEDURE: WTENDAX
;
;THIS PROCEDURE IS CALLED BY THE STRT TEST TO TEST WHETHER THE
;TARGET'S AX REGISTER IS RETURNED TO THE CALLER WHEN THE TARGET
;IS STARTED WITH SEQUENTIAL EXECUTION.
;
;OUTPUT: CALLERAX(WORD)=THE VALUE IN AX WHEN CALLER REGAINS CONTROL
;        TARGETAX(WORD)=THE VALUE IN AX WHEN THE TARGET ENDS
;******************************************************************/
;
WTENDAX		PROC	FAR
		PUSH	DS
		MOV	AX,DIAG86_DS
		MOV	DS,AX
		MOV	AX,XTGTTGTAX	;GET ID OF INTENDED TARGET,
		MOV	WTEND_ID,AX	;PUT IT INTO THE STRT SDB,
		SVC	WTEND_TGTAX	;START THE TASK.
		MOV	CALLERAX,AX
		POP	DS
		RET
WTENDAX		ENDP
;
;/******************************************************************
;PROCEDURE: TGTAX
;
;THIS TASK STORES THE AX REGISTER IN TARGETAX AND ENDS.
;
;OUTPUT: TARGETAX(WORD)=VALUE IN AX WHEN TARGET ENDS.
;*******************************************************************/
;
TGTAX		PROC	FAR
		MOV	TARGETAX,AX
		SVC	END_TASK
TGTAX		ENDP
;
DIAG86_CS	ENDS
;
END
