;*****************************************************************
;*     MTOS-86xx V3.0:   ADD DIAGNOSTIC TO APPLIC.LIB.           *
;*     F. W. PORRETTO, DECEMBER 3, 1982                          *
;*     FOR INDUSTRIAL PROGRAMMING, INC.                          *
;*****************************************************************
;
;     THIS PROCEDURE ADDS THE OBJECT MODULES FOR THE STANDARD
;     MTOS DIAGNOSTIC TO THE APPLIC.LIB LIBRARY FILE USED BY THE
;     TARGET SYSTEM GENERATION PROCEDURE. NOTE THAT APPLIC.LIB IS 
;     PRESUMED ALREADY TO EXIST; SEE THE APLGEN.CSD PROCEDURE.
;
;     INPUT:  %0 SPECIFIES THE SOURCE DEVICE FOR THE DIAGNOSTIC OBJECTS,
;             %1 SPECIFIES THE RESIDENCE DEVICE FOR APPLIC.LIB.
;     OUTPUT: APPLIC.LIB, WITH THE DIAGNOSTIC SNUGLY IN IT.
;
LIB86
ADD %0DCLOCK.OBJ,%0DCP.OBJ,%0DFLAG.OBJ,%0DHUMIN.OBJ,&
%0DINOUT.OBJ,%0DINRES.OBJ,%0DMAIL.OBJ,%0DMAIN.OBJ,&
%0DMEM.OBJ,%0DMSG.OBJ,%0DPLMUT.OBJ,%0DSEMA.OBJ,&
%0DSPEC.OBJ,%0DTASK.OBJ,%0DTCDS.OBJ,%0DTESTS.OBJ,%0DTGT.OBJ,&
%0DTIME.OBJ,%0DASMUT.OBJ TO %1APPLIC.LIB
LIST %1APPLIC.LIB
EXIT
;
