*L OFF
;FILE:    EQU.CTC
;UPDATED: 800513 / PH
 
;=======
; CTC EQUATES
;
; SOME USEFUL EQUATES CONCERNING CTC-INITIALIZATION
; USAGE:  LD  A,C_CTRL+C_IE+C_TIM+C_P16+C_TC
;         OUT (CTC2),A
;=======
 
C_IE		EQU	80H		;INTERRUPTS ENABLED
C_ID  	EQU	0		;INTERRUPTS DISABLED
C_CNT	EQU	40H		;COUNTER-MODE
C_TIM	EQU	0		;TIMER-MODE
C_P256	EQU	20H		;PRESCALER 256  (TIMER MODE ONLY)
C_P16	EQU	0		;PRESCALER  16  (TIMER MODE ONLY)
C_POS	EQU	10H		;POSITIVE EDGE
C_NEG	EQU	0		;NEGATIVE EDGE
C_XTRG	EQU	8		;EXTERNAL TRIGGER (TIMER)
C_TC		EQU	4		;TIME-CONSTANT WILL FOLLOW
C_NOTC	EQU	0		;NO TIME-CONSTANT WILL FOLLOW
C_STOP	EQU	2		;STOP COUNTING
C_CTRL	EQU	1		;CONTROL-BYTE
 
*L ON
