*L OFF
;FILE:    RTZ.CON.EQU.S
;UPDATED: 811201 / PH
;REV:     2.00
 
;-------
; STTTAB - OFFSETS IN STATUS-TABLE
;-------
 
CHRDEL	EQU	0
LINDEL	EQU	1
INPDEL	EQU	2
ANC   	EQU	3		;ACCEPT NEXT CHARACTER
SUSPND	EQU	4
RESUME	EQU	5
KILL  	EQU	6
LFCNT 	EQU	7
NULLCT	EQU	8
ECHO  	EQU	9
DRUM  	EQU	10		;^TAB DRUM
EDRUM 	EQU	12
 
KEYSM 	EQU	14
KEYSAV	EQU	16
SCHR  	EQU	18
GCHR  	EQU	20
CONSTT	EQU	22
OUTSTT	EQU	23
CURSOR	EQU	24
 
IQ    	EQU	26
TIQ   	EQU	28
FIQ   	EQU	30
EIQ   	EQU	32
LIQ   	EQU	34
 
;-------
; BITS IN CONSTT
;-------
 
B_READ	EQU	3		;BIT 3 IN CONSTT
ECHOCR	EQU	4		;    4
IA    	EQU	6		;    6  (1="READ", 0="WRITE")
HFDUP 	EQU	7		;    7
 
;-------
; HELP EQUATES
;-------
 
LSTT  	EQU	14		;LENGTH OF USER ACCESSIBLE STATUS-TABLE
EOFMRK	EQU	0FFH
 
;=======
; ASCII-characters
;=======
 
ASCEOT	EQU	4		;^D
ASCIBS	EQU	8		;^H
ASCIHT	EQU	9		;^I  (TAB)
ASCILF	EQU	0AH
ASCICR	EQU	0DH
ASCESC	EQU	1BH		;ESCAPE
ASCDEL	EQU	7FH		;DELETE
 
*L ON
