*H RTZ.DBG.RAM
;UPDATED: 821028 / PH
;REV:     2.01
 
;-------
; COMMON VARIABLES
;-------
 
	global	Z$P1,Z$P2,Z$INSP,Z$DFLG,Z$TPCB,Z_TQUE
	global	Z$IBUF,Z$PTY,Z$TTYS,Z$BPCB,Z$OBUF
 
Z$P1  	DEFS	2		;1ST PARAMETER IN COMMAND
Z$P2  	DEFS	2		;2ND PARAMETER IN COMMAND
Z$INSP	DEFS	2		;GROUND VALUE FOR DBG-SP
Z$DFLG	DEFS	1		;STATUS BITS
Z$BPCB	DEFS	2		;LAST BREAKED PCB
Z$TPCB	DEFS	0		;^PCB FOR TRACED PROCESS
Z_TQUE	DEFS	2		;HEAD OF TRACE QUEUE
Z$TTYS	DEFS	1		;SET BY ^C-PROCESS
Z$PTY 	DEFS	1		;DEBUGGER PRIORITY
      	DEFS	1
Z$IBUF	DEFS	100
Z$OBUF	DEFS	200
 
;-------
; BREAK
;-------
 
	global	Z$SBTB,Z$WBTB,Z$BRET
 
Z$SBTB	DEFS	1
      	DEFS	2*10		;TABLE OF SIGNAL BREAKPOINTS
Z$WBTB	DEFS	1
      	DEFS	2*10		;TABLE OF WAIT BREAKPOINTS
Z$BRET	DEFS	2
 
;-------
; CPU
;-------
 
	global	Z$REGF,Z$OBPT,Z$OOBP,Z$OREG,Z$$PC,Z$$SP
	global	Z$$A,Z$$F,Z$$BC,Z$$DE,Z$$HL,Z$$IX,Z$$IY
 
Z$$A   	DEFS	1
Z$$BC  	DEFS	2
Z$$DE  	DEFS	2
Z$$HL  	DEFS	2
Z$$F   	DEFS	1
Z$$IX  	DEFS	2
Z$$IY  	DEFS	2
Z$$SP  	DEFS	2
Z$$PC 	DEFS	2
 
Z$REGF	DEFS	1		;
Z$OBPT	DEFS	2		;
Z$OOBP	DEFS	2		;
Z$OREG	DEFS	15		;LATEST VALUE DISPLAYED
 
;-------
; TRACE
;-------
 
	global	Z$UREG,Z$BC,Z$C,Z$B,Z$DE,Z$E,Z$D,Z$HL
	global	Z$L,Z$H,Z$AF,Z$FLAG,Z$A,Z$IX,Z$IY,Z$SP
	global	Z$TRCF,Z$TRCT,Z$DBSP,Z$ERAM
	global	Z$PC,Z$FFIX,Z$ADDR,Z$IPC,Z$ICMD
 
Z$UREG
Z$BC
Z$C   	DEFS	1		;USER C
Z$B   	DEFS	1		;USER B
Z$DE
Z$E   	DEFS	1		;USER E
Z$D   	DEFS	1		;USER D
Z$HL
Z$L   	DEFS	1		;USER L
Z$H   	DEFS	1		;USER H
Z$AF
Z$FLAG	DEFS	1		;USER FLAGS
Z$A   	DEFS	1		;USER A
Z$IX  	DEFS	2		;USER IX
Z$IY  	DEFS	2		;USER IY
Z$SP  	DEFS	2		;USER SP
Z$PC  	DEFS	2		;USER PC
 
Z$DBSP	DEFS	2		;DEBUGGER SP
Z$TRCF	DEFS	1		;TRACE FLAG
Z$TRCT	DEFS	55		;TRACE POINT TABLE
Z$ERAM	DEFS	7		;EXECUTION AREA FOR "STEP"
Z$ICMD	DEFS	1		;LATEST INTERPRET COMMAND
Z$ADDR	DEFS	2		;TEMP.STORAGE FOR "PC"
Z$IPC 	DEFS	2		;LAST INTERPRETED INSTRUCTION
Z$FFIX	DEFS	6		;RAM FOR FLAG-FIX CODE
 
	global	Z$PRRG
 
Z$PRRG	DEFS	1
 
;-------
; RTZ-ORIENTED RAM
;-------
 
	global	Z_DBSM,Z$DWRS,Z_BPOL,Z$BMSG,Z$DMSG
 
Z_DBSM	DEFS	6		;DEBUGGER EVENT-SEMAPHORE
Z$DWRS	DEFS	6		;DEBUGGER WRITE RESPONSE SEM
Z_BPOL	DEFS	6		;POOL FOR BREAK-MESSAGES
      	DEFS	2		;STORAGE FOR CHECKPOINT ADDRESS
Z$BMSG	DEFS	14		;BREAKPOINT-MESSAGE
      	DEFS	(2+14)*5	;ANOTHER 5 BREAK-MESSAGES
Z$DMSG	DEFS	8		;dummy message for .E Z_SGNL 53CB
 
;-------
; PROM-MIRROR
;-------
 
	global	Z$PMIR,Z$PMSG,Z$CONM
 
Z$PMIR
      	DEFS	2		;STORAGE FOR CHECKPOINT ADDRESS
Z$PMSG	DEFS	14		;PROMPT MESSAGE
      	DEFS	2		;STORAGE FOR CHECKPOINT ADDRESS
Z$CONM	DEFS	14		;CONSOLE MESSAGE
  
      	END
