
exsecond.s               exsecond                                              BLER     Tue Feb  7 14:19:35 1984
1

                     1              2	;Updated: 821202 / PH
                     2              3	;Created: 821201 / PH
                     3              4	 
                     4              5	;=======
                     5              6	; SECINI
                     6              7	; This initialization routine disables time display,
                     7              8	; builds the message-pool and prepares the real-time
                     8              9	; clock for executing DOESEC every one second.
                     9             10	;
                    10             11	; Accepts: none (can be called from PLZ)
                    11             12	;=======
                    12             13	 
                    13             14	;File:    rtzdecls.s
                    14            157	;File:    exequ.s
                    15            174	 
                    16            175		global	SECINI
                    17            176		external	SEC_SM,CLKMSG,Z_A0SM,SECRSM,SECMSG
                    18            177		external	CLKBUF,CLOKEN,Z_SECS,Z_CKUP,POOLSM,POOLMG
                    19            178	 
                    20            179	SECINI
         0  0000    21 dd e5      180		PUSH	IX			;save IX (for PLZ)
         0  0002    22 af         181		XOR	A			;start with no time display
         0  0003    23 32 00 00   182		LD	(CLOKEN),A
         0  0006    24 06 08      183		LD	B,8			;build POOLSM
         0  0008    25 11 00 00   184		LD	DE,POOLSM
         0  000b    26 dd 21 00   185		LD	IX,POOLMG
                                             00      
                    27            186	SECI10
         0  000f    28 dd 36 04   187		LD	(IX+MSGLEN),14
                                             0e      
         0  0013    29 dd 36 05   188		LD	(IX+MSGLEN+1),0
                                             00      
         0  0017    30 dd e5      189		PUSH	IX			;HL:=^message
         0  0019    31 e1         190		POP	HL
         0  001a    32 11 00 00   191		LD	DE,POOLSM
         0  001d    33 cd 00 00   192		CALL	Z_SGNL
         0  0020    34 11 0e 00   193		LD	DE,MSGBCN+2
         0  0023    35 dd 19      194		ADD	IX,DE
         0  0025    36 10 e8      195		DJNZ	SECI10
                    37            196	 
         0  0027    38 3e 02      197		LD	A,ZQCWRA		;set up CLKMSG
         0  0029    39 32 02 00   198		LD	(CLKMSG+MSGRQC),A
         0  002c    40 21 0e 00   199		LD	HL,14
         0  002f    41 22 04 00   200		LD	(CLKMSG+MSGLEN),HL
         0  0032    42 21 00 00   201		LD	HL,SECRSM
         0  0035    43 22 06 00   202		LD	(CLKMSG+MSGRSM),HL
         0  0038    44 21 00 00   203		LD	HL,CLKBUF
         0  003b    45 22 08 00   204		LD	(CLKMSG+MSGBAD),HL
         0  003e    46 21 14 00   205		LD	HL,CLKBFZ
         0  0041    47 22 0a 00   206		LD	(CLKMSG+MSGBSZ),HL
         0  0044    48 11 00 00   207		LD	DE,SECRSM
         0  0047    49 21 00 00   208		LD	HL,CLKMSG
         0  004a    50 cd 00 00   209		CALL	Z_SGNL
         0  004d    51 21 56 00   210		LD	HL,DOESEC		;enable time display
         0  0050    52 22 00 00   211		LD	(Z_CKUP),HL
         0  0053    53 dd e1      212		POP	IX
         0  0055    54 c9         213		RET


exsecond.s               exsecond                                              BLER     Tue Feb  7 14:19:35 1984
1

exsecond.s               exsecond                                              BLER     Tue Feb  7 14:19:35 1984
2

                    55            215	 
                    56            216	;=======
                    57            217	; DOESEC
                    58            218	; This routine is executed periodically every one second.
                    59            219	; It's invoked by the real-time clock (RTZ.RTC) and runs
                    60            220	; as a subroutine to this process. Time is displayed, if
                    61            221	; enabled, and a message is sent to SEC_SM. This message
                    62            222	; makes it possible for one process, waiting at SEC_SM in
                    63            223	; its idle-phase, to run periodically.
                    64            224	;=======
                    65            225	 
                    66            226	DOESEC
         0  0056    67 3a 00 00   227		LD	A,(CLOKEN)	;time display enabled ?
         0  0059    68 b7         228		OR	A
         0  005a    69 28 3f      229		JR	Z,DOES10		;..no
         0  005c    70 11 00 00   230		LD	DE,SECRSM		;check if last display ready
         0  005f    71 21 00 00   231		LD	HL,0			;..poll
         0  0062    72 cd 00 00   232		CALL	Z_WAIT
         0  0065    73 7d         233		LD	A,L
         0  0066    74 b4         234		OR	H
         0  0067    75 28 32      235		JR	Z,DOES10		;it wasn't ready, skip it now
         0  0069    76 e5         236		PUSH	HL			;save ^message
         0  006a    77 11 08 00   237		LD	DE,MSGBAD		;HL:=^buffer
         0  006d    78 19         238		ADD	HL,DE
         0  006e    79 7e         239		LD	A,(HL)
         0  006f    80 23         240		INC	HL
         0  0070    81 66         241		LD	H,(HL)
         0  0071    82 6f         242		LD	L,A
         0  0072    83 11 02 00   243		LD	DE,Z_SECS+2	;DE:=hours in BCD
         0  0075    84 06 03      244		LD	B,3			;store time in buffer (ASCII)
                    85            245	DOES05
         0  0077    86 1a         246		LD	A,(DE)
         0  0078    87 cb 3f      247		SRL	A			;first high nibble
         0  007a    88 cb 3f      248		SRL	A
         0  007c    89 cb 3f      249		SRL	A
         0  007e    90 cb 3f      250		SRL	A
         0  0080    91 f6 30      251		OR	30H
         0  0082    92 77         252		LD	(HL),A
         0  0083    93 23         253		INC	HL
         0  0084    94 1a         254		LD	A,(DE)		;then low nibble
         0  0085    95 e6 0f      255		AND	0FH
         0  0087    96 f6 30      256		OR	30H
         0  0089    97 77         257		LD	(HL),A
         0  008a    98 23         258		INC	HL
         0  008b    99 36 3a      259		LD	(HL),':'
         0  008d   100 23         260		INC	HL
         0  008e   101 1b         261		DEC	DE			;next time
         0  008f   102 10 e6      262		DJNZ	DOES05
         0  0091   103 2b         263		DEC	HL			;terminate string with <CR>
         0  0092   104 36 0d      264		LD	(HL),0DH
         0  0094   105 11 00 00   265		LD	DE,Z_A0SM
         0  0097   106 e1         266		POP	HL
         0  0098   107 cd 00 00   267		CALL	Z_SGNL
                   108            268	DOES10
         0  009b   109 11 00 00   269		LD	DE,SEC_SM		;send this message every second
         0  009e   110 21 00 00   270		LD	HL,SECMSG
         0  00a1   111 cd 00 00   271		CALL	Z_SGNL
         0  00a4   112 c9         272		RET

exsecond.s               exsecond                                              BLER     Tue Feb  7 14:19:35 1984
2

exsecond.s               exsecond                                              BLER     Tue Feb  7 14:19:35 1984
3

                   113            273	 
         0  00a5   114            274		end





the number of errors detected in this assembly is 0



















































exsecond.s               exsecond                                              BLER     Tue Feb  7 14:19:35 1984
3
