/* rtzdecls.h */
 
	struct	SEMAPHORE {
		int *SEMMGQ;
		PCB *SEMPRQ;
		SEMAPHORE *SEMSEM; };
 
	struct	IPCB {
		char IPCNAM [6];
		int IPCENT;
		int IPCSTZ;
		char IPCPTY; };
 
	struct	PCB {
		PCB *PCBLNK;
		int PCBDLY;
		PCB *PCBDLK;
		SEMAPHORE *PCBSEM;
		int PCBSP;
		char PCBPTY;
		char PCBSTT;
		IPCB *PCBNAM;
		int PCBRND;
		PCB *PCBPCB; };
 
/*extern
	P_CPRO procedure (IPCB_PTR ^IPCB)
	P_CSEM procedure (SEMAPHORE_PTR ^SEMAPHORE)
	P_EWAI procedure (SEMAPHORE_PTR ^SEMAPHORE)
		returns (MESSAGE_PTR W_PTR)
	P_LDCW procedure (CONTROL W_PTR)
	P_SEVC procedure (LEVEL int VECTOR W_PTR)
	P_SGNL procedure (SEMAPHORE_PTR ^SEMAPHORE MESSAGE_PTR W_PTR)
	P_SPTY procedure (PCB_PTR ^PCB PRIORITY char)
	P_WAIT procedure (SEMAPHORE_PTR ^SEMAPHORE TIME_LIMIT int)
		returns (MESSAGE_PTR W_PTR)
 */
extern
	PCB *Z_RUNP;
	char Z_SLCF,Z_SLCT,Z_SLCP,Z_EOMF;
 
	SEMAPHORE Z_00SM,Z_01SM,Z_02SM,Z_03SM;
	SEMAPHORE Z_04SM,Z_05SM,Z_06SM,Z_07SM;
	SEMAPHORE Z_08SM,Z_09SM,Z_10SM,Z_11SM,Z_12SM,Z_13SM;
	SEMAPHORE Z_14SM,Z_15SM,Z_16SM,Z_17SM,Z_18SM,Z_19SM;
 
#define	ZRCINT 	 0     /* INTERRUPT MESSAGE */
#define ZRCMIS 	 0x44   /* MISSED INTERRUPT */
#define ZRCTO  	 0x80   /* TIME-OUT MESSAGE */
 
	struct	RTZ_CON_MSGLNK {
		int *MESSAGE
		char MSGRQC
		char  MSGRC
		int MSGLEN
		SEMAPHORE *MSGRSM
		char *MSGBAD
		int MSGBSZ
		int MSGBCN }
 
	RTZ_CON_MESSAGE_PTR ^RTZ_CON_MESSAGE
 
	RTZ_RTC_MESSAGE {
		MSGLNK ^int
		MSGRQC char
		MSGRC  char
		MSGLEN int
		MSGRSM ^SEMAPHORE
		MSGSEC char
		MSGMIN char
		MSGHRS char }
 
	RTZ_RTC_MESSAGE_PTR ^RTZ_RTC_MESSAGE
 
	RTZ_MGR_MESSAGE {
		MSGLNK ^int
		MSGRQC char
		MSGRC  char
		MSGLEN int
		MSGRSM ^SEMAPHORE
		MSGWL  int
		MSGSPC W_PTR }
 
	RTZ_MGR_MESSAGE_PTR ^RTZ_MGR_MESSAGE
 
constant
	ZQCRDC 	 0x61	/* GET TIME */
#define ZQCWRC 	 0x62	/* SET TIME */
#define ZQCWAT 	 0x63	/* WAKE ME AT ... */
#define ZQCWAF 	 0x64	/* WAKE ME AFTER ... */
 
#define ZQCMCF 	 0x68	/* CONDITIONAL, FAST */
#define ZQCMCB 	 0x69	/* CONDITIONAL, BEST */
#define ZQCMUF 	 0x6A	/* INCONDITIONAL, FAST */
#define ZQCMUB 	 0x6B	/* INCONDITIONAL, BEST */
 
#define ZQCRDA 	 1	/* READ ASCII */
#define ZQCRDB 	 5	/* READ BINARY */
#define ZQCWRA 	 2	/* WRITE ASCII */
#define ZQCWRB 	 6	/* WRITE BINARY */
#define ZQCRDS 	 9	/* READ STATUS */
#define ZQCWRS 	 0xA	/* WRITE STATUS */
 
#define ZRCOK  	 0	/* NORMAL TERMINATION */
#define ZRCUNK 	 0x41	/* UNKNOWN REQUEST CODE */
#define ZRCERR 	 0x42	/* UNSPECIFIED ERROR */
#define ZRCBSY 	 0x43	/* DEVICE BUSY */
#define ZRCOVF 	 0x45	/* DATA OVERFLOW */
#define ZRCEOF 	 0x46	/* END OF FILE */
#define ZRCDWN 	 0x47	/* DEVICE OFF LINE */
#define ZRCEOM 	 0x48	/* END OF MEDIA */
 
*/-------*/
*/ END OF RTZ-UTILITY DECLARATIONS */
/*-------*/
 
