{ NOTICE OF COPYRIGHT AND OWNERSHIP OF SOFTWARE:

  Copyright 1986 by Oregon Software, Inc.
  All Rights Reserved.

  This computer program is the property of Oregon Software, Inc.
  of Portland, Oregon, U.S.A., and may be used
  and copied only as specifically permitted under written
  license agreement signed by Oregon Software, Inc.

  Whether this program is copied in whole or in part and whether this
  program is copied in original or in modified form, ALL COPIES OF THIS
  PROGRAM MUST DISPLAY THIS NOTICE OF COPYRIGHT AND OWNERSHIP IN FULL.

  Release version: 0013  Level: 1
  Processor: iAPX86
  System: MS-DOS

  Interface definitions file.

 Last modified by JAN on 15-Sep-1986 12:22:41
 Purpose:

}

const
  bw40 = 0;
  c40 = 1;
  bw80 = 2;
  c80 = 3;
  black = 0;
  blue = 1;
  green = 2;
  cyan = 3;
  red = 4;
  magenta = 5;
  brown = 6;
  lightgray = 7;
  darkgray = 8;
  lightblue = 9;
  lightgreen = 10;
  lightcyan = 11;
  lightred = 12;
  lightmagenta = 13;
  yellow = 14;
  white = 15;
  blink = 16;
  pi = 3.1415926536;

type
  strng = string [255];
  Word = 0..65535;
  HWord = 0..32767;
  byte = 0..255;
  colorrange = 0..31;


function frac(r: real): real;
  external;


function frac_d(r: real): real;
  external;


function int(r: real): real;
  external;


function int_d(r: real): real;
  external;


procedure CrtInit;
  external;


procedure CrtExit;
  external;


procedure ClrEol;
  external;


procedure ClrScr;
  external;


procedure DelLine;
  external;


procedure GotoXY(x, y: HWord);
  external;


procedure InsLine;
  external;


function WhereX: HWord;
  external;


function WhereY: HWord;
  external;


procedure ChDir(Path: strng);
  external;


procedure Delay(mS: Word);
  external;


procedure FillChar(var Dest: univ char;
                   Length: Word;
                   Data: char);
  external;


procedure halt;
  external;


procedure GetDir(Drv: Byte;
                 var Path: univ Strng);
  external;


procedure MkDir(Path: Strng);
  external;


procedure Move(var Source, Dest: univ char;
               length: Word);
  external;


procedure Randomize;
  external;


procedure RmDir(Path: Strng);
  external;


function KeyPressed: boolean;
  external;


procedure ReadKbd(var ch: char);
  external;


function ParamCount: Byte;
  external;


function ParamStr(N: Byte): Strng;
  external;


function random(Range: Word): Word;
  external;


function random_f: real;
  external;


function random_d: real;
  external;


function Swap(i: Word): Word;
  external;


function Hi(i: Word): byte;
  external;


function Lo(i: Word): byte;
  external;


function UpCase(ch: char): char;
  external;


function FilePos(var f: univ text): Integer;
  external;


function inp(port: Word): byte;
  external;


function inpw(port: Word): Word;
  external;


procedure out(port: Word;
              val: byte);
  external;


procedure outw(port: Word;
               val: Word);
  external;


procedure SetTextMode(color: colorrange);
  external;


procedure TextMode;
  external;

{ the next 5 routines use escape sequences based on ANSI.SYS }


procedure LowVideo;
  external;


procedure NormVideo;
  external;


procedure HighVideo;
  external;


procedure TextBackground(color: colorrange);
  external;


procedure TextColor(color: colorrange);
  external;


procedure sound(i: HWord);
  external;


procedure nosound;
  external;


procedure Window(x1, y1, x2, y2: HWord);
  external;


function SeekEof(var f: text): boolean;
  external;


function SeekEoln(var f: text): boolean;
  external;


function MaxAvail: Word;
  external;


function MemAvail: Word;
  external;


function IOresult: ShortInt;
  external;
