%lines 61
%lang swe
%head 2
PEAB SLAN, MasterTestSystem (MTS) i PC
Rev 1.0 / 86-11-06      IND AB / AN & LOS
%pos_page 61
%margin_text 6
%margin_title 2
%margin_head 2
%pos_title 14







            PPPPP   EEEEEE     AA     BBBBB
            P    P  E         A  A    B    B
            P    P  E        A    A   B    B
            PPPPP   EEEEE    AAAAAA   BBBBB
            P       E        A    A   B    B
            P       E        A    A   B    B
            P       EEEEEE   A    A   BBBBB


             SSSS   L          AA     N    N
            S       L         A  A    NN   N
            S       L        A    A   N N  N
             SSSS   L        AAAAAA   N  N N
                 S  L        A    A   N   NN
                 S  L        A    A   N    N
             SSSS   LLLLLL   A    A   N    N




              MASTER TEST SYSTEM (MTS) I PC
             ===============================





























Inneh}llsf|rteckning


%title 1        Allm{nt


%title 2        Syfte med testsystemet

Syftet med att koppla in en PC {r att underl{tta anv{ndandet av
MTS-programmet i testh}rdvaran (STH): Kommandofiler med
sekvenser av kommandon kan skapas och sparas p} fil. Tidigare
skapade kommandosekvenser kan anv{ndas upprepade g}nger.
Loggning av kommunikationen p} fil och/eller printer. Selektiv
loggning av kommunikationen med STH, t.ex. bara felaktiga svar
skrivs p} loggmedierna. Man kan {ven direkt i programmet skapa
och skicka kommandon till STH.

%page
%title 0
%title 1        H}rdvara

- IBM PC/XT eller kompatibel utrustning.
- Asynkron kommunikationsport i PC'n.
- Tillsatskort GPIB.
- Skrivare, IBM PC-kompatibel.


%page
%title 0
%title 1        Programvara


%title 2        Spr}k och utvecklingsmilj|

Programutvecklingen kommer att ske p} IBM-PC eller kompatibel.
Programspr}k som kommer att anv{ndas {r Microsoft Pascal, Oregon
Pascal-II eller Lattice C. F|r kommunikationen |ver GPIB och
RS232 anv{nds f{rdiga paket. Mer om dessa under "Interface mot
STH".


%title 2        Operat|rsinterface

Systemet {r menyorienterat. Beroende p} vilken meny man befinner
sig i kan olika saker utf|ras med hj{lp av funktions-tangenterna.
I nederkanten p} varje meny finns en liten ruta f|r varje
funktionstangent som talar om vad denna utf|r. Samma saker kan
ocks} utf|ras med hj{lp av kommandon som anges p} en speciell
kommandorad. Generellt g{ller att kommandona kan anges oberoende
av i vilken meny man befinner sig.

Menysystemet ser ut enl. nedan:

                    +-----------+
                    ! Huvudmeny !
                    +-----+-----+
                          !
    +---------------------+-----------------------+
    !                     !                       !
+---+---+        +--------+--------+        +-----+-----+
! Setup !        ! Interaktiv test !        ! Batchtest !
+-------+        +-----------------+        +-----------+

Val av undermeny g|rs med funktions-tangenterna. ]terg}ng till
huvudmenyn med escape-tangenten.


%title 3        Kommandon och deras parametrar

De h{r {r de kommandon man kan ange dels med hj{lp av funktions-
tangenterna, dels p} kommandoraden.


%title 3        Setup-meny

H{r v{ljer man:

* Om man vill k|ra p} GPIB eller RS232.
* Olika upps{ttningar f|r respektive kommunikationsport.
* Vad loggfilen skall heta. (Dock finns ett defaultnamn:
  "MTS.LOG".)
* Hur l{nge man skall v{nta p} svar efter s{nt meddelande. Anges
  i ms/f|rv{ntat svar.
* Vilka typer av utskrifter man vill ha ut p} loggen.


%title 3        Interaktivt test

Vid interaktivt test skickas kommandona precis som de skrivs.
F|r att inte beh|va skriva ett kommando varje g}ng man vill
skicka det finns en buffert d{r kommandona sparas. Redigering av
denna buffert sker med en i programmet inbyggd editor.


%title 4        Editorn

H{r skriver man in det eller de kommandon man vill skicka. Man
kan h|gst skriva in 20 rader med kommandon. Raderna f}r vara
h|gst 80 tecken l}nga.

Editerings-m|jligheter:

Cursorn f|rflyttas med hj{lp av piltangenterna en position i
taget. Med funktions-tangenterna kan man:

* Spara bufferten p} fil.
* L{s in fil i buffert. (Max 20 rader.)
* V{lja insert eller overwrite mode.
* Ta bort ett tecken, med backspace och delete.
* Ta bort en rad.
* L{gga tillbaka borttagen rad.


%title 4        K|rning

Med hj{lp av funktions-tangenterna skickar man vad man har i
bufferten. Man kan s{nda hela bufferten(, dock v{ntas p} svar
mellan kommandona,) eller delar av den. P} en rad i nederkanten
p} bilden visas hela tiden vilken rad i bufferten som f|r
tillf{llet {r invald.

Olika s{ndningsm|jligheter:

* Skicka vald rad.
* Skicka hela bufferten 1 g}ng.
* Skicka f.o.m. vald rad tills stopp beg{rs.( N{r sista raden i
  bufferten {r skickad forts{tter man med f|rsta raden.)
* Bl{ddra fram och tillbaka mellan raderna( med upp}t- och
  ned}tpil).


%title 3        Test med hj{lp av batch-fil

M|jlighet att k|ra en l{ngre (, > 20 rader, )testsekvens som
tidigare {r skriven i n}gon editor utanf|r systemet finns ocks}.

Test med hj{lp av batch-fil g}r till p} s{tt att man med hj{lp
av funktions-tangenterna:

* Anger vilken testsekvens(=filnamn) som skall k|ras. Filen
  l{ses d} in, syntaxkontrolleras och l{ggs upp som en l{nkad
  lista.
* K|r igenom testsekvensen.


%title 4        Batch-filen

I batch-filen skriver man, med en liten skillnad, kommandona p}
samma s{tt som n{r man k|r interaktivt. F|re sj{lva kommandot
anges med ett numeriskt v{rde hur m}nga svar som f|rv{ntas. Om
inget numeriskt v{rde anges tolkas det som att endast ett svar
f|rv{ntas. Detta f|r att veta hur l{nge som skall v{ntas p} svar
innan n{sta kommando i sekvensen skall s{ndas. H{r kan ocks}
anges speciella batch-kommandon och kommentarer.


%title 5        Speciella batch-kommandon

Dessa kommandon skickas inte iv{g utan talar endast om hur
testsekvensen skall k|ras och om det {r n}got speciellt som
skall skrivas ut under testets g}ng.

* FOR <antal varv>

  K|r sekvesen som ligger mellan detta kommando och motsvarande
  NEXT-kommando beg{rt antal g}nger. Om antal varv utel{mnas har
  man en evighetsloop.

* NEXT

  Se FOR-kommandot.

* PAUS <antal sek>

  G|r en paus i testandet under beg{rd paustid. Om ingen tid
  anges v{ntas tills kvittens med tangenttryckning.

* STOP

  Testet avbryts.

* ECHO text

  Skriver en text p} sk{rmen.

* LOGG text

  Skriver en text p} sk{rmen, printern och loggfilen.


%title 5        Kommentarer

F|r att t.ex. veta vad som {r avsikten med ett visst kommando
kan sist p} varje rad ocks} skrivas kommentarer. Dessa f|reg}s
av en apostrof ('). Under k|rning visas {ven dessa p} sk{rmen
med undantag f|r rader som endast inneh}ller kommentarer.


%title 4        Syntaxkontroll

I samband med att batchfilnamnet anges sker syntaxkontroll av
den. I denna kontrolleras att man anv{nt sig av till}tna
kommandon och parametrar. Om fel uppt{cks skrivs radnummer,
raden och en kort kommentar till vad som {r fel.


%title 4        L{nkad lista

I samband med att syntaxkonrtollen gj|rs skapas en l{nkad lista.
Endast rader som inneh}ller kommandon l{nkas med i listan.


%title 4        K|rning

Sekvensen kan sedan k|ras p} f|ljande s{tt:

* Starta fr}n b|rjan.
* ]terstarta p} samma st{lle man tidigare stannat.
* K|ra igenom sekvensen rad f|r rad med tangenttryckning mellan
  varje.

Sekvensen kan stannas p} f|ljande s{tt:

* Genom att man tidigare angivit vilken tid testet skall stannas.
* PAUS- eller STOP-kommando angivits i testsekvensen.
* Med hj{lp av funktions-tangent.


%title 3        Loggning


%title 4        Olika loggmedia

Vad som h{nder under testets g}ng skrivs ut p} tre olika
st{llen: 

Sk{rm, printer och loggfil.

Dock kan printern v{ljas bort:

Ett f{lt p} sk{rmen visar om loggning kommer att ske {ven p}
printern. Flaggan s{tts till "PrOn" vid start av testet om
printern {r p}slagen och online, annars "PrOff". Man kan v{lja
bort eller in printern med hj{lp av en funktionstangent. 

Loggfilnamnet:

Loggfilen kommer att d|pas till "MTS.LOG" om inget annat
angivits i setupmenyn. 


%title 4        Vad loggas

P} loggfil och printer skrivs exakt samma data:

* Huvud
* Kommandon till STH
* Meddelanden fr}n STH
* Egna texter
* Felutskrifter
* Statistik

P} sk{rmen skrivs:

* Batch-kommandon
* Kommandon till STH
* Meddelanden fr}n STH
* Egna texter
* Felutskrifter


%title 5        Batch-kommandon

Av batch-kommandona skrivs FOR, NEXT, PAUS och STOP ut p}
sk{rmen varefter dessa exekveras. 


%title 5        Kommandon till STH

Rader inneh}llande kommandon att s{nda till STH skrivs ut som de
ser ut, rad f|r rad varefter de exekveras. P} sk{rmen skrivs
dessa rader med l}g ljusintensitet. P} printer och loggfil
skrivs f|re varje s{nd rad:

*** S *** (Send) - Till STH s{nt kommando.


%title 5        Huvud

Tv} olika huvud skrivs p} loggen:

* Ett inneh}llande datum, loggfilnamn och kommandofilnamn.

* Ett inneh}llande rubriker f|r testresultaten.

Vid syntaxfel och statistik skrivs endast det f|rsta
logghuvudet. Vid datumbyte under testets g}ng skrivs n{sta
rad p} ny sida. Logghuvud skrivs ut p} varje sida.


%title 5        Egna texter

Med hj{lp av LOGG-kommandot kan texter skrivas ut p} alla
medierna. Med ECHO-kommandot kommer texten endast p} sk{rmen. 


%title 5        Meddelande fr}n STH

Meddelanden fr}n testh}rdvaran skrivs ut som de ser ut. P}
loggfil och printer skrivs dock n}gra specialtecken och 1-2
bokst{ver ut framf|r meddelandet f|r att markera vilken typ av
meddelande det g{ller: 

=== AR === (Answer Received)    - Svar p} s{nt kommando.
+++ SR +++ (Spontanous Receive) - Spontant meddelande fr}n STH.
??? UR ??? (Unexpected Receive) - Ov{ntat svar p} s{nt kommando.


%title 5        Felutskrifter

Felutskrifter p} loggen f|reg}s av:

&&& E  &&& (Error) - Vid n}gon av f|ljande feltyper:

Kommandofilstorlek:

Om minnet inte r{cker till f|r att skapa den l{nkade listan,
talas detta om och testen avbryts. 

Syntaxfel:

Om n}got fel uppt{cks under syntaxkontrollen skrivs p}
loggmedierna den felaktiga kommandoraden + en kort f|rklaring
av felet. 

PC-portfel:

Vid val av RS232 |ppnas och s{tts COM1-porten upp. Om detta ej
g}r bra skrivs detta ut samt en statuskod som n{rmare talar om
vad som {r fel. Om detta fel f}s {r det troligen n}got fel p}
PC:n. (F|r info. om vad status-koderna betyder h{nvisas till
ASYNCH MANAGER Function open_a1.) 

Timeout: 

F|rv{ntat svar fr}n testh}rdvaran uteblev.

Kommunikationsfel:

RS232: Ett bitm|nster talar om vilken typ av kommunikations-fel
som uppst}tt. Detta skrivs ut hexadecimalt. ( Info. om vad de
olika bitarna betyder finns i ASYNCH MANAGER Function rdch_a1.) 


%title 5        Statistik

Efter avslutat test skrivs f|r var och en av de olika
utskriftstyperna ut hur m}nga som gjorts. [ven de utskriftstyper
som loggningen {r bortvald p} kommer med h{r.


%title 2        Interface mot STH


%title 3        GPIB

P} marknaden finns 3 olika expansionskort med GPIB-interface
inklusive drivrutiner f|r PC: Scientific solutions, Philips och
HP. Eftersom varken Philips eller HP har visat n}gon som helst
vilja att s{lja sina kort, f|resl}r vi Scientific solutions
"IEEE488 GPIB Interface Board". Den inneh}ller det som beh|vs i
detta system, b}de mjuk och h}rdvara.


%title 3        RS232

F|r den asynkrona kommunikationen p} PC finns ett utm{rkt
programpaket (som IND har anv{nt tidigare och vet att det
fungerar), "ASYNCH MANAGER" fr}n Blaise Computer INC. Det finns
}tminst}nde f|r pascal och C (troligtvis {ven f|r fler vanliga
program spr}k). I den finns f{rdig bufferthantering,
flowcontrol, klockfunktioner och andra finesser. F|r ytterligare
information om hur det asynkrona kommunikationspaketet fungerar
h{nvisas till manualen: "ASYNCH MANAGER for PASCAL Version 1.0".


%title 3        Kommunikationsprocedur

Kommunikationsproceduren {r lite annorlunda beroende p} om
programmet k|rs i interaktiv resp. batch mode. I interaktiv mode
kontolleras kontinuerligt om det kommit n}got meddelande fr}n
STH. I batch mode v{ntar man p} svar efter varje s{nt kommando.
V{ntetiden beror p} hur l}ng timeout som satts upp och hur m}nga
svar som f|rv{ntats. Under v{ntetiden tas naturligtvis spontana
meddelanden ocks} emot och loggas.

Formatet p} kommandona till och fr}n STH finns beskrivet i "PEAB
SLAN, Master Test System".
