%lines 61
%lang swe
%head 2
Handhavade: Testsystem MDDM/Controller (TMC)
Rev 1.0 / 86-09-22      IND AB / AN & LOS
%pos_page 61
%margin_text 6
%margin_title 2
%margin_head 2
%pos_title 14
Inneh}llsf|rteckning


%title 1        Programmet i PC'n


Programmat startas genom att man skriver TMC till PC'n, och d}
visas f|ljande bild: 

                Testsystem F|r MDDM Controller
________________________________________________________________











_______________________________________________________________

F1 - Objektid    F2 - Sekvens    F3 - Start       F10 - EXIT

Man kan d} v{lja F1, F2 eller F10. Om F3 v{ljs direkt utan att
n}gra kortid matats in kommer testen inte att starta utan
ist{llet visas objektid-bilden. 


%title 2        Funktionstangenter 

De funktionstangenter som anv{nds {r F1, F2, F3 och F10 och de
anv{nds innan testen s{tter ig}ng. L{ngst ner p} bilkdsk{rmen
visas de funktionstangenter som f|r tillf{llet kan anv{ndas. 

        F1  - Inmatning av kortidentitet p} kort som skall testas 
        F2  - Val av testsekvens samt l{ngden p}}ng testtiden 
        F3  - Starta testen
        F10 - ]terg} till DOS
%page
%title 3        Objektinmatning

Innan testet startar m}ste man ange identiteter p} de kort som
skall testas. N{r man v{ljer objektinmatning (F1) dvs. inmatning
av kortidentiteter f|r de kort som skall testas f}r man upp
f|ljande bild: 


                Testsystem F|r MDDM Controller
________________________________________________________________
HYLLA: 1        SLOT  1:

                SLOT  2:

                SLOT  3:

                SLOT  4:

                SLOT  5:

                SLOT  6:

                SLOT  7:

                SLOT  8:

                SLOT  9:

                SLOT 10:
_______________________________________________________________

                F2 - Sekvens    F3 - Start       F10 - EXIT


Totalt finns det 5 sidor att fylla i. F|r varje rack finns det
en bildsk{rmssida med 10 rader (en f|r varje slot). Varje
kortidentitet kan best} av upp till 40 tecken. De
editeringstangenter som kan anv{ndas {r f|ljande: 

        PgUp    - bl{ddrar till f|reg}ende sida (rack)
        PgDn    - bl{ddrar till n{sta sida
        upp}tpil- flyttar cursorn till f|reg}ende f{lt (slot) 
        ned}tpil- flyttar cursorn till n{sta f{lt
        Home    - flyttar cursorn till f|rsta f{ltet p} sidan 
        End     - flyttar cursorn till sista f{ltet p} sidan
        CR      - samma som ned}tpil
        BS(<--) - tar bort senast inmatade tecken

Om man vill ta bort ett redan inmatat id kan man blanka det
f{ltet genom att fylla i enbart blanktecken. 
Om inte inmatade id st{mmer med var det finns kort i racket
kommmer testet inte att startas. 


%title 3        Val av testsekvens och testtid

N{r man v{ljer att mata in testsekvens (F2) f}r man upp f|ljande
bild: 

                Testsystem F|r MDDM Controller
________________________________________________________________





                TESTSEKVENS     : CO303.TST

                TOTAL TESTTID   : 72





_______________________________________________________________

F1 - Objektid                   F3 - Start       F10 - EXIT


Testsekvens {r namnet p} en fil som inneh}ller de kommandon som
skall utf|ras under testets g}ng. Testsekvensen kan {ndras om
man vill, som default testsekvens {r fil: CO303.TST. Total
testtiden kan anges i timmar 1-99, default testtid {r 72 timmar,
testen kommer dock att avbrytas innan testtiden slut om slutet
p} testsekvensen n}tts. F|rflyttning mellan f{lten sker med
upp}t- resp. ned}t-pilarna. 


%title 3        Start av test

Testet startas genom att trycka p} F3. P} sk{rmen kommer d}
loggfilnamnet visas till v{nster p} 23:e raden och i loggfilen
hamnar alltid all logginformation, {ven om printern g}r s|nder.
L{ngst ner till h|ger visas om printern {r p} eller inte, PrOn =
printer p}, PrOff = printer av. Inom scrollomr}det kommer sedan
efterhand visas vilka initieringsfaser systemet befinner sig i. 

Initieringsfaserna:

        - Max antal exekverbara rader i kommandofilen : nnn 

              Talar om hur m}nga rader det maximalt kan vara i
              kommandofilen f|r att den skall rymmas i minnet.
              Om minnet inte r{cker till kommer testen inte att
              starta. Om kommandofilen inte finns meddelas det
              p} sk{rmen. Efter kvittens kommer man tillbaka
              till bilden f|r val av testsekvens. 

        - Syntaxcheck av kommandofilen 

              Varje rad i kommandofilen scannas igenom och
              kontrolleras, om felaktigheter uppt{cks loggas
              dessa och testet kommer inte att starta. Om
              syntaxchecken hittar fel i kommandofilen skrivs
              dessa p} loggen och testet kommer inte att starta. 

        - Nollst{llning av tid

              Klockan som r{knar f|rbrukad testtid nollst{lls
              och visas l{ngst upp i h|gra h|rnet p}
              bildsk{rmen, samtidigt visas ocks} aktuell tid
              bredvid. Klockorna g}r lite knackigt den f|rsta
              minuten under det att initieringarna sker, men s}
              fort testen startat skall de g} riktigt. 

        - Nollst{llning av statistiken

              Alla r{knare som h}ller reda p} hur m}nga av de
              olika felen som intr{ffat nollst{lls.

        - Initiering av COM-portarna

              Kommunikationsportarna f|r den asynkrona
              kommunikationen med powercontrollern och
              mddm-kortet initieras. Om det inte g}r bra (tex
              porten trasig) loggas felet och testen startas
              inte. 

        - Initiering av Power-controllern

              Kontroll sker att kontakt finns med
              powercontrollern, om det inte finns startas inte
              testen. 

        - Initiering av rel{-portarna

              Sl{pper alla rel{er i kortv{xeln.

        - Kontroll av samtliga kortplatser

              Ett testkommando skicks till samtliga 50
              kortplatser. Kontroll sker att bara de kort som
              har id ifyllda svarar. Om ifyllda id och svarande
              kort inte st{mmer |verrens kommer testet inte att
              starta. Om man har gl|mt att fylla i n}got id {r
              det bara att fylla i det i objektinmatningsbilden
              eftersom alla tidigare ifyllda id ligger kvar i
              bilden. 

        - Nollst{llnig av masktabell f|r utsignal.

              Tabellen som hanterar maskningen av utsignaler
              initieras till noll. 

Om dessa initieringar g}tt bra (tar ca 1/2 - 1 min) skrivs
"Testen startar" p} sk{rmen och programmet b|rjar scanna igenom
kommandolistan. 


%title 3        Exit

Om man trycker p} Exit-tangenten (F10) avbryts exekveringen av
programmet. Det kan bara ske n{r F10 visas l{ngst ner p}
sk{rmen, allts} innan ett test satt ig}ng, eller efter ett test
avslutats. 


%title 2        N{r test p}g}r

Under testets g}ng sker utskrifter p} sk{rm, printer och
loggfil. Funktionstangenterna kan ej anv{ndas, endast
escape-tangenten. 


%title 3        Sk{rmhantering

Under tiden ett test p}g}r visas samtidigt inom scrollomr}det p}
sk{rmen vilket kommando som utf|rs. F|r n{rmare information om
vad de olika kommandona utf|r h{nvisas till beskrivningen av
kommandona. Om ett test inte g}r bra kommer resultatet att visas
p} sk{rmen i inversed video, alla felaktiga resultat visas p}
sk{rmen till skillnad fr}n p} loggen (fil + printer) d{r de bara
skivs vid f|r{ndring. Strax efter att ett test har startat kan
bildsk{rmen se ut ungef{r s} h{r: 

                    Testsystem F|r MDDM Controller 
Sp{nn: 5.005  H: 1  SL: 1                   14:34:57  00:01:13
---------------------------------------------------------------
Max antal exekverbara rader i kommandofilen ca. 219
Syntaxcheck av kommandofil
Nollst{llning av tid
Nollst{llning av statistiken
Initiering av COM-portarna
Initiering av Power-controllern
Initiering av rel{-portarna
Kontroll av samtliga kortplatser
Nollst{llnig av masktabell f|r utsignal

Testen startar

FOR             obj, 1, 50
SPANNING        5.005
OBJEKT          1               'V{lj in ett objekt
WATCHDOG
---------------------------------------------------------------
LOGGFIL: 6A291434.LOG       KOMMANDOFIL: CO303.TST
                                                       PrOn

Under testets g}ng visas p} sk{rmen: 
        Uppe i v{nstra h|rnet: Sp{nning, Hylla och Slot. 
        Uppe i h|gra h|rnet: Aktuell tid samt hur l{nge testen
              p}g}tt. 
        Nertill: Logg- och Kommando-filnamnen samt om printern
              {r p} eller inte. 
        I scrollomr}det (mellan strecken): Kommandona som utf|rs
              samt ev. felutskrifter.

%title 3        Escape-tangenten

Om man tycker p} Escape-tangenten medans test p}g}r visas en
ledtext "P: printer p}, S: printer av, Q: avbryt test". Eftersom
tangentbordet bara scannas mellan varje utf|rt kommando kan det
dr|ja det ett tag innan ledtexten kommer om man k|r ett l}ngsamt
kommando (t.ex. WATCHDOG som tar ca. 20 sek.). Genom att trycka
p} P, S ellet Q kan man d} sl} av/p} printer eller avbryta test.
P, S och Q har f|ljande funktioner. 

        P - Ser till att det som loggas {ven kommer att loggas
              p} printern. T{nder PrOn-markeringen nere till
              h|ger p} sk{rmen. Printningen kommer ej ig}ng och
              PrOn-markeringen kommer ej att t{ndas om inte
              printern {r on-line. 

        S - Ser till att loggning inte kommer att ske till
              printern. PrOff kommer att markeras nere till
              h|ger p} sk{rmen. Oavsett om printern {r p} eller
              inte kommer dock alltid loggning att ske p}
              loggfilen. 

        Q - Avbryter testet.


%title 3        Uppeh}ll i testandet

Under testets g}ng kan testet tillf{lligt stoppas genom att man
trycker p} Ctrl-NumLock. Det inneb{r att programmet tv{rstannar
och kan startas igen genom att valfri tangent trycks. Detta s{tt
att tillf{lligt stoppa testen ligger utanf|r pascalprogrammens
"ansvarsomr}de" och inneb{r att det kan ge upphov till timeouter
om programmet stoppas strax efter det ett kommando skickats till
mddm-kortet. 


%title 3        Hur anv{nds printern 

Under testets g}ng sker loggning dels p} loggfilen och dels p}
printern. Om printern blir off-line (tex. pappret tar slut),
sl}s printningen av (PrOff). Med ESC-p kan man f} ig}ng printern
igen efter det man st{llt den on-line. Avst{ngning av printning
manuellt kan g|ras med ESC-s. 


%title 3        Felmeddelanden

Under testets g}ng skrivs de fel som intr{ffar p} loggfil och
printer, d{r skriv dock bara {ndringar i fel-statusen dvs. n{r
ett test g}r fel loggas det, men sedan loggas inget f|rr{n det
testet g}tt bra igen. P} sk{rmen d{remot, skrivs alltid alla fel
(med inversed video). Vissa typer av fel inneb{r att testet
kommer att avbrytas, eftersom det kan inte anses meningsfullt
att forts{tta testet i de situationerna. De fel som avbryter
testet finns beskrivna i kapitlet om fatala fel i loggen.


%title 3        Inmatningsfel

Om felaktiga data matats in i n}got f{lt kan man {ndra det med
att antingen ta bort senast inmatade tecken med "backspace"
eller att g} till f{ltet p} nytt och b|rja skriva in nytt data.
N{r ett tecken skrivs i f|rsta position i ett f{lt suddas resten
av f{ltet ut, s} f|r att rensa ett f{lt kan man st{lla sig i
f|rsta pos och skriva ett blank-tecken. 
%page
%title 1        MDDM-kortet

P} mddmkortet skall prommet med TMC-programmet sitta i den
prom-kretsh}llare som sitter l{ngst bort fr}n processorn. F|r
att watchdogen skall vara aktiverad kr{vs att switch 2 p} SW2 p}
kortet skall vara "closed" 