Modulen inneh}ller testloopen som k|r igenom testsekvensen.


Lokala statiska variabler
-------------------------

	IOBuf_1 : input-output buffer f|r kommunikationsport 1 
	IOBuf_2 : input-output buffer f|r kommunikationsport 2 


PROCEDURE- och FUNCTION-beskrivningar
-------------------------------------


Ini_COM_Ports
-------------

Beskrivning : \ppnar kommunikationsportarna f|r mddmkortet
              (COM1) och powercontrollern (COM2). IOBuf_1 och
              IOBuf_2 skickas som parametrar till open f|r att
              anv{ndas som buffertat av asynch-paketet. Loggar
              om fel intr{ffar. 

Anropas fr}n: Startup i denna modul (Batch). 

Deklaration : Procedure Ini_COM_Ports;

Statiska variabler som {ndras:

    Lokala  : IOBuf_1 och IOBuf_2


Startup
-------

Beskrivning : Diverse initieringar i samband med att en
              testsekvens skall starta. Nollst{ller
              tidr{kningsvariabler och statistiktabeller,
              initierar kommunikationsportar, portar mot
              rel{kortet, powercontrollern samt nollst{ller
              tabell f|r maskning vid utsignalkommandot. 

Anropas fr}n: DoTest i denna modul (Batch). 

Deklaration : Procedure Startup;
%page
DoTest
------

Beskrivning : \ppnar kommandofilen och loggfil, l{gger upp de
              f|rdefinierade variablerna, kollar om printern {r
              ansluten, initierar rubriker i loggen och skapar
              kommandolistan. S{tter ig}ng ett test och k|r det
              i 72 timmar eller tills n}gon avbrutit testen. Vid
              varje varv i testloopen delas en rad i kommando-
              listan upp och motsv kommandoprocedur anropas utom
              f|r pauskommandot d{r DoTest sj{lv h}ller reda p}
              n{r och hur l{nge det {r paus. Efter ett kommando
              har uf|rts s{tts kommandopekaren till n{sta
              kommando, om escape trycks under testen f}r man
              chans att avbryta testen eller sl} av/p} printern
              under 15 sek. Efter testen {r klar sl{pps alla
              rel{er, 5-volten dras ner till noll och 12-volten
              kopplas bort (6 rel{er dras), statistiken skrivs
              ut, kommunikationsportarna och loggfilen st{ngs
              och minnet f|r kommando och variabel-lista l{mmnas
              tillbaka. 

Anropas fr}n: Main-programmet i modul main. 

Deklaration : Function DoTest:error_t [PUBLIC];

Returv{rdet : Felkod som anger hur testet har g}tt, kan vara:
              alla syntaxfelen, testobjekt saknas eller fel vid
              open/read av kommandofilen, 

Statiska variabler som {ndras:

    Lokala  : SerErr
