Modulen inneh}ller de assemblerrutiner som ing}r, de g|r s}nt
som inte kan kodas i pascal. Ing}ende delar {r dels rutiner f|r
att l{sa/skriva p} io-portar, l{sa av printerstatus och att
hantera bildsk{rmen. 


Beskrivning av assemblerrutinerna:

InByte
------

Beskrivning : L{ser en byte fr}n en io-port och returnerar det
              l{sta v{rdet. 

Anropas fr}n: Objkomn

ExternDeklaration i pascal: 
	      Function InByte( Portnr:integer ):byte; EXTERN;

	Portnr : porten som skall l{sas av.


OutByte
-------

Beskrivning : Skriver en byte p} en io-port.

Anropas fr}n: Objkomn

ExternDeklaration i pascal: 
	      Procedure OutByte( Portnr:integer; data:byte );
              EXTERN; 

	Portnr : porten som skall l{sas av.
	data : byten som skall srivas p} porten. 


PrStat
------

Beskrivning : L{ser av printerstatus genom att g|ra BIOS-anrop
              INT 17H. Returnerar printerstatus.

Anropas fr}n: logg

ExternDeklaration i pascal: 
	      Function PrStat:byte; EXTERN;
%page
Print
-----

Beskrivning : Skriver en textstr{ng p} printern genom att g|ra
              BIOS-anrop INT 17H. Teknen skickas ett och ett.
              F|r varje tecken kollas om timeoutbiten {r satt.
              Om s} {r fallet avbryts utskriften av str{ngen.
              Som returv{rde l{mnas printerstatus. 

Anropas fr}n: logg

ExternDeklaration i pascal: 
	      Function Print ( CONST Line : string ) : byte;
                       EXTERN;


PrintLn
-------

Beskrivning : Fungerar som Print men l{gger p} CR och LF.

Anropas fr}n: logg

ExternDeklaration i pascal: 
	      Function PrintLn ( CONST Line : string ) : byte;
                       EXTERN;


ClrScr
------

Beskrivning : Blankar den del av sk{rmen som anv{nds som
              scroll-f|nster dvs. rad 3 tom. 21, genom
              BIOS-anrop INT 10H. 

Anropas fr}n: main

ExternDeklaration i pascal: 
	      Procedure ClrScr; EXTERN;


CursOn
------

Beskrivning : T{nder cursorn genom att g|ra BIOS-anrop INT 10H. 

Anropas fr}n: kbd

ExternDeklaration i pascal: 
	      Procedure CursOn; EXTERN;
%page
CursOff
-------

Beskrivning : Sl{cker cursorn genom att g|ra BIOS-anrop INT 10H. 

Anropas fr}n: kbd och main

ExternDeklaration i pascal: 
	      Procedure CursOff; EXTERN;


GetCPos
-------

Beskrivning : L{ser av vilken position cursor finns p},
              returnerad rad och kolumn. 

Anropas fr}n: kbd och main

ExternDeklaration i pascal: 
	      Procedure GetCPos( VAR Row, Col:integer ); EXTERN; 

	Row : vilken rad cursorn st}r p}.
	Col : vilken kolumn cursorn st}r p}. 


Cpos
----

Beskrivning : Positionerar cursorn p} bildsk{rmen. 

Anropas fr}n: kbd, main, objekt och screen

ExternDeklaration i pascal: 
	      Procedure Cpos ( Rad,Kol : integer ); EXTERN;

	Rad : vilken rad cursorn skall till. 
	Kol : vilken kolumn cursorn skall till. 


Scroll
------

Beskrivning : Scrollar den del av sk{rmen som anv{nds som
              scroll-f|nster dvs. rad 3 tom. 21, genom
              BIOS-anrop INT 10H. 

Anropas fr}n: screen

ExternDeklaration i pascal: 
	      Procedure Scroll; EXTERN;

