%title 3	Kommunikationsprocedur.

Informationsutbytet mellan PC och testat kort sker med ett
enhetligt protokoll, likadant i b}da riktningarna. Protokollet
best}r av starttecken, ev parametrar och kommando. Innan man
skickar ett kommando till mddm-kortet t|mmer man ev. tecken som
har kommit till PC'n (skr{ptecken som kan ha kommit n{r man
v{xlat mellan kort). Efter det att ett kommando har skickats
v{ntar man mellan 1 och 2 sekunder p} att ett svar skall komma
fr}n mddm, om inget svar kommit under den tiden betraktas det
som en timout vilket kommer att loggas. 

- Starttecken {r alltid STX, hexadecimalt 02. 

- Parametrar. 0 till 10 st. 1 - 4 st ASCII-tecken, 0 - 9, a - f
eller A - F. Parametrarna }tskiljs med semikolon. 

- Komando. 1 ASCII-tecken, g - z eller G - Z. 

%title 3	Koder.

RAMTEST:
	Anropas med : (adress ; adress) G

	Svarar	    : 00 G	Om OK
		    : FF G	Om felaktiga parametrar
		    : 01-07* G	Om fel p} RAM

	*)	Bit 0 satt om fel uppt{ckt vid "Adresstest"
		 "  1	-	"	-      "Vandrande etta"
		 "  2	-	"	-      "Vandrande nolla"

PROMTEST:
	Anropas med : H

	Svarar	    : framr{knad checksumma H

INSIGNAL:
	Anropas med : (port) I

	Svarar	    : l{st v{rde I

UTSIGNAL:
	Anropas med : (port)(; data) J

	Svarar	    : J

WATCHDOGTEST:
	Anropas med : K

	Svarar	    : K		Om OK
		    : FF K	Om Watchdog inte fungerat

RESETTEST:
	Anropas med : L

	Svarar	    : L		Om OK
		    : FF L	Om Reset inte fungerat

SETNOV:
	Anropas med : M

	Svarar	    : M

CHKNOV:
	Anropas med : N

	Svarar	    : 00 N	Om OK
		    : FF N	Om fel uppt{ckt

SIOTEST:
	Anropas med : O

	Svarar	    : 00 O	Om OK
		    : 01-3F* O	Om fel uppt{ckt

		*) de olika bitarna har f|ljande betydelse:

	 Bit 0 : Kanal B fick inte tillbaka n}got tecken. 
	 Bit 1 : Kanal B fick inte tillbaka samma tecken som 
		 skickades.
	 Bit 2 : CTS-status p} A-sidan {r inte det f|rv{ntade. 
	 Bit 3 : DCD-status p} A-sidan {r inte det f|rv{ntade. 
	 Bit 4 : CTS-status p} B-sidan {r inte det f|rv{ntade. 
	 Bit 5 : DCD-status p} B-sidan {r inte det f|rv{ntade. 
