%title 3	Kommunikationsprocedur.

PWC'n (powercontroller PC4400) styrs via ett RS232-interface,
och {r kopplat till kommunikationsport 2 p} PC'n. 

I PWC'n finns tv} slot med kort:

Slot 1 anv{nds f|r att styra sp{nningen till mddm-korten med
kommandot SPANNING.

OBS! F|r att kompensera sp{nningsfallet p} v{g till korten
beg{rs alltid( ,utom vid 0 volt,) 0.3 volt h|gre sp{nning {n den
man vill ha |ver korten. 

Slot 2 f|r f|r att l{gga ut en analog sp{nning med kommandot
ANALOG. 

Innan ett kommando skickas till PWC'n sker kontroll att
kontakten {r ansluten genom att titta p} CTS-signalen fr}n
PWC'n. Dessutom skickas ett ETX till PWC'n efter varje kommando,
vilken PWC'n skall svara ett ACK p}. Om kommunikationen med
PWC'n av n}gon anledning inte fungerar kommer testet inte att
forts{tta eftersom det inte {r n}gon id` d} man ju inte vet
vilken sp{nning den l{gger ut. 

F|rsta kommandot som skickas till PWC'n {r bara f|r att kolla
att den lever och det {r kommandot VS1 (Verify Slot 1), som
skall ge ett svar som b|rjar med SL1 om man inte f}r det
beraktas PWC'n inte ansluten och testet kommer inte att s{tta
ig}ng. 

Innan testet s{tter ig}ng skickas en upps{ttning kommandon till
PWC'n f|r att initiera den, f|ljande upps{ttning g|rs: 

	- 'ERIN1'	Enable Error interrupt
	- 'INTNNNN'	Disable Interrupt
	- 'SL1'		V{lj slot 1 i PWC'n
	- 'MV15.00'	Max voltage = 15 volt
	- 'OVP5.800'	Output voltage protection = 5.8 volt
	- 'V5.300'	Sp{nning = 5.3 volt
	- 'SL2'		V{lj slot 2 i PWC'n
	- 'MV10.00'	Max voltage = 10 volt
	- 'OVP9.000'	Output voltage protection = 9 volt
	- 'V0.000'	Sp{nning = 0 volt

Efter det att ett test {r f{rdigt dras sp{nningarna ner till noll
med f|ljande kommndon: 

	- 'SL1'		V{lj slot 1 i PWC'n
	- 'V0.000'	Sp{nning = 0 volt
	- 'SL2'		V{lj slot 2 i PWC'n
	- 'V0.000'	Sp{nning = 0 volt
%page
%title 3	Koder. 

De kommandon som anv{nds {r f|ljande:

	SLn - V{ljer ett slot mellen 1 och 4. I v}r
              configuration finns bara slot 1 och 2 i PWC'n.
	ERINn - S{tter error interrupt. Enablar eller disablar
              errorhanteringen, om den s{tts till ett kommer fel
              att resultera i att PWC'n skickar SRQ (Service
              ReQuest) n{r det bli fel. 
	INTaaaa - S{tter interruptniv} f|r slot 1 - 4. I v}r
              configuration anv{nder vi oss inte av interrupt
              och d{rf|r disablas de allihop.
	VSn - Returnerar status f|r ett slot i PWC'n. Anv{nds
              bara en g}ng under initieringsfasen f|r att kolla
              att kontakt finns med PWC'n. 
	MVnnn.nnn - Max Voltage. S{tter vilket som {r den
              maximala outputen fr}n PWC'n. Skall vara samma som
              den man st{llt in p} det kraftaggregatet som styrs
              av PWC'n, vilket i v}rt fall blir 15 volt f|r
              powercontrollerns slot 1 och 10 volt f|r slot 2. 
	Vnnn.nnn - Voltage. S{tter sp{nningen. kan i v}rt fall
              variera mellan: 0 och 5.25 v f|r slot 1, 0 och 9
              volt f|r slot 2.
	OVPnnn.nnn - Over Voltage Protection. S{tter vilken
              sp{nning som {r den h|gsta till}tna. Om
              sp{nningskommandon h|gre {n denna sedan skickas
              till PWC'n kommer den att svara med en SRQ.


Ut|ver dessa kommandon har PWC'n ett flertal kommandon till. De
finns beskrivna i PWC-manualen, d{r det {ven finns mer
detaljerad beskrivning om ovanst}ende kommandon. 

%title 3	Feltyper

De feltyper som kan f|rekomma {r att man inte f}r kontakt med
PWC'n eller att den inte svarar med ACK p} ETX eller att den
skickar ett SRQ. Om kontakt ej erh}lles {r kontakterna ej
anslutna eller felaktiga. Om ACK uteblir {r det troligtvis fel
p} PWC'n. Om PWC'n skickar SRQ {r det troligaste felet
programvaran i PC'n, vilket allts} i princip aldrig kommer att
intr{ffa. 
