Modulen inneh}ller de rutiner som hanterar bildsk{rmen

Lokala statiska variabler
-------------------------

Printed : Talar om vilka funktionstangenter som ar "t{nda".


PROCEDURE- och FUNCTION-beskrivningar

ClrLine
-------

Beskrivning : blankar en rad p} bildsk{rmen utan att {ndra p}
              cursorpositionen 

Anropas fr}n: BATCH och MAIN

Deklaration : Procedure ClrLine ( rad : integer ) [PUBLIC];

	rad : vilken rad som skall blankas


ClrEol
------

Beskrivning : blankar fr}n cursorpositionen till slutet av raden 

Anropas fr}n: OBJEKT

Deklaration : Procedure ClrEol [PUBLIC];


InvVid
------

Beskrivning : St{ller om sk{rmen till inversed video

Anropas fr}n: BATCH, LOGG och SCREEN

Deklaration : Procedure InvVid [PUBLIC];


NorVid
------

Beskrivning : St{ller tillbaka sk{rmen till normal video 

Anropas fr}n: BATCH, LOGG och SCREEN

Deklaration : Procedure NorVid [PUBLIC];
%page
CposWrite
---------

Beskrivning : Positionerar cursorn, skriver ut en str{ng och
              positionerar tillbaka cursorn. 

Anropas fr}n: BATCH, LOGG, OBJEKT och SCREEN

Deklaration : Procedure CposWrite (
			      rad,kol : integer;
			CONST strang  : string  ) [PUBLIC];

	rad : vilken rad
	kol : vilken kolumn
	strang : str{ngen som skall skrivas ut


ScrollWriteLn
-------------

Beskrivning : skriver ut en str{ng i scroll-f|nstret och
              scrollar vid behov 

Anropas fr}n: BATCH, LOGG och SCREEN 

Deklaration : Procedure ScrollWriteLn (
			CONST strang : string  ) [PUBLIC];

	strang : str{ngen som skall skrivas ut


DebugWriteLn
------------

Beskrivning : skriver ut en str{ng i scroll-f|nstret och
              scrollar vid behov. Anv{nds bara f|r
              debuginformation och ers{tts av en dummyrutin vid
              produktion. 

Anropas fr}n: BATCH, LOOP, MESSAGE, PWCKOMN, SCREEN, SYNT och
              VARHANDL 

Deklaration : Procedure DebugWriteLn (
			CONST strang : string  ) [PUBLIC];

	strang : str{ngen som skall skrivas ut
%page
ScrollWrite
-----------

Beskrivning : skriver ut en str{ng utan radframmatning i
              scroll-f|nstret 

Anropas fr}n: SCREEN 

Deklaration : Procedure ScrollWrite (
			CONST strang : string  ) [PUBLIC];

	strang : str{ngen som skall skrivas ut


DebugWrite
----------

Beskrivning : skriver ut en str{ng i scroll-f|nstret. Anv{nds
              bara f|r debuginformation och ers{tts av en
              dummyrutin vid produktion. 

Anropas fr}n: MESSAGE och PWCKOMN 

Deklaration : Procedure DebugWrite (
			CONST strang : string  ) [PUBLIC];

	strang : str{ngen som skall skrivas ut


DisplayFel
----------

Beskrivning : skriver ut en logg-str{ng i scroll-f|nstret med
              inverse video. F|rst tas de 29 f|rsta tecknena
              (dvs. tid, f|rbrukad testtid, hylla, slot och
              sp{nning) i str{ngen bort, max 80 tecken av det
              som blir kvar skrivs ut. 

Anropas fr}n: LOGG

Deklaration : Procedure DispayFel (
			CONST str : string  ) [PUBLIC];

	str : str{ngen som skall skrivas ut
%page
ErrMsg
------

Beskrivning : piper, skriver ut ett meddelande i scrollf|nstret
              med inversed video samt "kvittera med valfri
              tangent". v{ntar sedan p} att det trycks p} n}gon
              tangent. 

Anropas fr}n: DoTest i BATCH 
	      MAIN 
	      ShowFileErr i SCREEN 

Deklaration : Procedure ErrMsg (
			CONST str : string  ) [PUBLIC];

	str : str{ngen som skall skrivas ut


DisplayTimes
------------

Beskrivning : skriver aktuell tid och f|rbrukad testtid i |vre
              h|gra h|rnet p} bildsk{rmen. 

Anropas fr}n: - DoTest i BATCH, en g}ng f|r varje kommando i
              loopen. 
	      - InitTime i TID. 
	      - Recieve_MddmAnswer i MESSAGE, n{r man ligger och
              v{ntar p} ett svar fr}n mddm-kortet. 

Deklaration : Procedure DisplayTimes [PUBLIC];


ShowFileErr
-----------

Beskrivning : Skriver ut ett meddelande via ErrMsg ex:
	      'Fel vid AAAA BBBB "CCCC", felkod: DD',
	      d{r AAAA,BBBB, CCCC, DD {r parametrar.

Anropas fr}n: - LOGG, SCREEN och SYNT vid open, read och write
              p} filer och printer 

Deklaration : Procedure ShowFileErr(
		 CONST	action	: string;
			filtyp	: lstr80;
			filnamn	: lstr80;
			kod	: integer ) [PUBLIC];

	action : motsvaras av AAAA i ovanst}ende exempel
	filtyp : motsvaras av BBBB i ovanst}ende exempel
	filnamn : motsvaras av CCCC i ovanst}ende exempel
	kod : motsvaras av DD i ovanst}ende exempel
%page
Menu
----

Beskrivning : Skriver ut en meny p} sk{rmen fn. finns det bara
              objektinmatningsbilden. 

Anropas fr}n: GetObjekt i modul OBJEKT 

Deklaration : Procedure Menu( val : menu_t ) [PUBLIC]; 

	val : vilken bild man vil ha ut, kan vara m_main eller
              m_objekt 


Write_InitBild
--------------

Beskrivning : Skriver ut initieringsbilden p} sk{rmen och v{ntar
              p} att en funktionstangent skall tryckas. 

Anropas fr}n: Main

Deklaration : Function Write_InitBild (
			fn_ok : ftang_set ) : ftang_t [PUBLIC];

	fn_ok : vilka funktionstangenter som {r till}tna 

returnerar tryckt funktionstangent. 


Clr_FTangPrintFlgs
------------------

Beskrivning : Talar om att inga funktionstangenter {r "t{nda",
              dvs. s{tter hela Printed-arrayen till false. M}ste
              g|ras samtidigt som rad 25 blankas s} att
              WriteLn25 vet vet hur rad 25 ser ut. 

Anropas fr}n: Main

Deklaration : Procedure Clr_FTangPrintFlgs [PUBLIC];
%page
WriteLine25
-----------

Beskrivning : Skriver ut vilka funktionstangenter som kan
              anv{ndas i olika situationer p} rad 25. De som
              finns markerade i Printed-arrayen {r redan
              utskrivna och beh|ver ej "t{ndas". S{tter flaggan
              i Printed-arrayen f|r varje funktionstangent som
              "t{nds", clearar flaggan f|r de tangenter som
              "sl{cks". 

Anropas fr}n: MAIN

Deklaration : Procedure WriteLine25 ( fn_ok : ftang_set )
              [PUBLIC]; 

	fn_ok : vilka funktionstangenter som skall vara "t{nda" 

Statiska variabler som {ndras:

    Lokala : Printed
