Modulen inneh}ller rutiner som sk|ter om de variabler som kan
definieras upp i kommandofilen 


Lokala statiska variabler
-------------------------

FdefVarTab : array med de f|rdefinierade variablerna, varje
              element inneh}ller variables namn och en pekare
              till densamma

Ant_Fdef_Var : antal f|rdefinierade variabler dvs hur m}nga av
              elementen i FdefVarTab som utnyttjas 

vlist : den l{nkade listan av variabler, d{r varje element
              inneh}ller namn, v{rde och en pekare till n{sta
              element i listan. Sista variabelns pekare {r NULL. 


PROCEDURE- och FUNCTION-beskrivningar

ClrVlist
--------

Beskrivning : nollst{ller den l{nkade listan, dvs. s{tter vlist
              till NULL. 

Anropas fr}n: SkapaKommandoLista i modul Synt

Deklaration : ClrVlist [PUBLIC]

Statiska variabler som {ndras:

lokala: vlist


Make_FdefVarTab
---------------

Beskrivning : l{gger upp alla f|rdefinierade variabler i en
              array (FdefVarTab) och antal f|rdefinierade
              variabler (Ant_Fdef_Var). 

Anropas fr}n: DoTest i modul Batch 

Deklaration : Make_FdefVarTab [PUBLIC] 

Statiska variabler som {ndras:

lokala: FdefVarTab, Ant_Fdef_Var 
%page
CheckVar
--------

Beskrivning : kontrollerar om en variabel {r f|rdefinierad dvs.
              om den finns i FdefVarTab. Returnerar
              "f|rdefinierad" eller "egendefinierad" 

Anropas fr}n: Syntaxkontrollen

Deklaration : function CheckVar ( varnamn : lstr10 ) : vartyp_t
              [PUBLIC]; 

	varnamn : namnet p} variabeln


MakeVar
-------

Beskrivning : kontrollerar om en variabel finns i variabel-
              listan, om den inte finns l{gges den upp 

Anropas fr}n: Syntaxkontrollen

Deklaration : Procedure MakeVar ( varnamn : lstr10 ) [PUBLIC] 

	varnamn : namnet p} variabeln

Statiska variabler som {ndras:

lokala: vlist


Get_VarValue
------------

Beskrivning : h{mtar v{rdet p} en variabel, kollar f|rst bland
              de f|rdefinierade variablerna, och sedan i den
              l{nkade variabellistan. Eftersom variablerna
              skapats av syntaxkollen skall alla variabler som
              refereras finnas men om en variabel inte finns
              skrivs en felutskrift ut. 

Anropas fr}n: ett flertal moduler

Deklaration : Function Get_VarValue ( varnamn : lstr10 ) : real
              [PUBLIC] 

	varnamn : namnet p} variabeln

returnerar v{rdet p} variabeln
%page
Put_VarValue
------------

Beskrivning : uppdaterar en variabels v{rde, i den l{nkade
              listan. Eftersom variablerna skapats av
              syntaxkollen skall alla variabler som refereras
              finnas men om en variabel inte finns skrivs en
              felutskrift ut. 

Anropas fr}n: FOR och NEXT-kommandot i LOOP-modulen. 

Deklaration : Procedure Put_VarValue (
			varnamn  : lstr10;
			varvarde : real ) [PUBLIC] 

	varnamn : namnet p} variabeln
	varvarde : v{rdet p} variabeln


TaBortVariabelLista
-------------------

Beskrivning : g}r igenom den l{nkade variabellistan och
              }terl{mmnar minnet f|r varje variabel, s{tter
              vlist till NULL 

Anropas fr}n: DoTest i batch-modulen

Deklaration : Procedure TaBortVariabelLista [PUBLIC] 
