/***********************************************************************
*
*  Mindre snutt f|r att skriva en lista av namn p} C5- eller C4-kuvert, 
*  lagom justerat till adressf{lt. Huruvida C5- eller C4-justering ska
*  anv{ndas best{ms av hur programmet {r anropat, c5 eller c4.
*
*  Listan ska se ut s}lunda:
*
*	Namn
*	Adress
*	.
*	.  (osv)
*	!!
*	N{sta namn
*	.
*	. (osv)
*
*  !! f}r p} vanligt vis diablon att stanna och v{nta p} CR. Under
*  tiden kan man slinka in ett nytt kuvert.
*
***********************************************************************/

#include <stdio.h>

#define	TRUE		1
#define	FALSE		0

#define MAXL		1000
#define LAGOMC5		50		/* lagom f|r C5 */
#define LAGOMC4		70		/* lagom f|r C4 */

int	lagom;
char	line[MAXL], blank[MAXL];
FILE	*put;

/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen(), *popen();
	char	*instr();
	char	namn[MAXL];
	char	*strcpy();

	strcpy(namn, argv[0]);

	if (strcmp(namn, "c5") == 0)
		lagom = LAGOMC5;

	else
		lagom = LAGOMC4;

	if ((put = popen("dia", "w")) == NULL) {
		fprintf(stderr, "%s: someone har knyckt dia\n", namn);
		exit(-1);
	}

	if (argc == 1)
		filelist(stdin);

	else
		while (--argc > 0)
			if (( fp = fopen(*++argv, "r")) == NULL) {
				fprintf(stderr, "%s: cannot open %s\n", namn, *argv);
				exit(-1);
 			} 

			else {
				filelist(fp);
				fclose(fp);
			}
}
/**/
filelist(fp)
FILE	*fp;
{
	int	i;
	char	*p;

	for (i = 1, p = blank; i <= lagom; i++)
		*p++ = ' ';

	while((fgets(line, MAXL, fp)) != NULL) {
		if (instr(line, "!!")) {
			fprintf(put, "\f\n");
			fprintf(put, "%s", line);
		}

		else {
			fprintf(put, blank);
			fprintf(put, "%s", line);
		}
	}

	fprintf(put, "\f\n");
}

/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
