#include <stdio.h>

#define	LINEBYTES	16

/*	dumpar en fil i hex och ascii-format	*/


char	hexarr[] = "0123456789abcdef";
char	utbuff[BUFSIZ];

main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen();

	setbuf(stdout, utbuff);

	if (argc == 1)
		file(stdin);

	else
		while (--argc > 0)
			if ((fp = fopen(*++argv,"r")) == NULL) {
				fprintf(stderr,"dp: cannot open %s\n",*argv);
				exit(1);
			}

 			else {
				file(fp);
				fclose(fp);
			}
		exit(0);
}
/**/
file(fp)
register FILE	*fp;
{
	register int	len, cnt, c;
	register long	adr = 0;
	char	buf[LINEBYTES+1];

	for(;;) {
		for (len = 0; len < LINEBYTES; len++)
			if ((c = getc(fp)) != EOF)
				buf[len] = c;
			else
				break;

		if (len > 0) {
			cnt = 0;

			printf("%8.8lx  ", adr);
			adr += 0x10;

			while ( cnt < len) {
				c = buf[cnt];
				putchar(hexarr[((c >> 4) & 0x0F)]);
				putchar(hexarr[(c & 0x0F)]);
				putchar(' ');

				if (buf[cnt] < 0x20 || buf[cnt] > 0x7E)
					buf[cnt] = '.';

				cnt++;
			}

			buf[cnt] = '\0';

			while (cnt++ < LINEBYTES)
				printf("   ");

			printf("  \"%s\"\n", buf);
		}

		else
			break;
	}
}
