/*
  Detta program listar en fil p} printerporten p} JULIA 200.
*/

#include <stdio.h>

#define PRINT_ON	"\33W"		/* printer on */
#define PRINT_OFF	"\33X\33X"	/* printer off */
#define MAXL		256

char	line[MAXL+1];

main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen();

	if (argc == 1)
		filelist(stdin);

	else
		while (--argc > 0)
			if ((fp = fopen(*++argv,"r")) == NULL)
				fprintf(stderr,"em: cannot open %s\n",*argv);

			else {
				filelist(fp);
				fclose(fp);
			}
}
/**/
filelist(fp)
FILE	*fp;
{
	printf(PRINT_ON);

	while((fgets(line, MAXL, fp)) != NULL)
		printf(line);

	printf(PRINT_OFF);
}
