#include <stdio.h>
#include <ctype.h>

#define MAXL		1000
#define MAXLEVEL	10

FILE	*stack[MAXLEVEL], *fp;
char	line[MAXL];
int	level;			/* ??????? */

main()
{
	FILE	*fopen(), *push();
	char	*inclpos, *instr();

	fp = stdin;

	for(;;) {
		while((fgets(line, MAXL, fp)) != NULL) {
			if((inclpos = instr(line, "#include")) != NULL)
				fp = push(inclpos);
			else
				printf("%s", line);
		}
		if(fp == stdin)
			exit(0);
		else {
			fclose(fp);
			fp = stack[--level];
		}
	}
}
/**/
FILE	*push(pos)
char	*pos;
{
	FILE	*f;
	char	file[MAXL], *filepos;

	if(level == MAXLEVEL) {
		printf("%s", line);
		return(fp);
	} else {
		filepos = file;
		pos += strlen("#include");

		while(isspace(*pos))
			pos++;

		while(!isspace(*pos))
			*filepos++ = *pos++;
		*filepos = '\0';

		if((f = fopen(file,"r")) == NULL) {
			printf("%s", line);
			return(fp);
		} else {
			stack[level++] = fp;
			return(f);
		}
	}
}
/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
