#include <stdio.h>
#include "lon.h"

/**/
char	line[MAXL], workl[MAXL];
char	namnrad[MAXL];		/* alla aktuella namnkoder */
char	*namnkod[MAXNAMN];	/* pekar in i namnrad */
char	period[SMALL];
char	utbetdag[SMALL];
double	data[MAXNAMN] [12];	/* l|nedataarray */
int	antnamn;		/* antal namn */

/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen();

/*
	while (instr(*++argv, "-")) {
		if (strncmp(*argv, "-i",2) == 0)
			ibmlst = TRUE;

		else if (strncmp(*argv, "-s", 2) == 0) {
			set(SA4);
		}

		--argc;
	}
*/
	if (argc == 1) {
		mkber(stdin);
	}

	else
		while (--argc > 0) {
			if ((fp = fopen(*++argv,"r")) == NULL) 
				fprintf(stderr,"ber: cannot open %s\n",*argv);

			else 
				mkber(fp);
		}
}
/**/
mkber(fp)
FILE	*fp;
{
	int	i, rad;

	for (i = 1; i <= STARTBLANK; i++)
		if ((fgets(line, MAXL, fp)) == NULL) {
			fprintf(stderr, "ber: Ej komplett MP-fil\n");
			exit(-1);
		}

	rad = 1;
	while ((fgets(line, MAXL, fp)) != NULL && rad < 18) {
		*(line + strlen(line) - 2) = '\0';	/* ta bort CRLF */

		switch(rad) {
			case 1:
				nmkod();
				break;

			case 3:
				val(ML);
				break;

			case 4:
				val(OT1);
				 break;

			case 5:
				val(OT2);
				break;

			case 6:
				val(SEM);
				break;

			case 7:
				val(TJL);
				break;

			case 8:
				val(SJDGR);
				break;

			case 9:
				val(PERDAG);
				break;

			case 11:
				val(SKATT);
				break;

			case 13:
				val(KVARSK);
				break;

			case 14:
				val(RIKSK);
				break;

			case 16:
				val(UTL);
				break;

			case 17:
				val(RESER);
				break;
		}

		rad++;
	}

	if (rad < 18) {
		fprintf(stderr, "ber: F|r kort MP-fil\n");
		exit(-1);
	}

	mkskatt();
	skrivut();
}

/**/
nmkod()
{
	char	*strncpy(), *strcpy(), *p;
	int	i;

	strncpy(period, line + LEFTBLANK, 4);
	*(period + 4) = '\0';

	strncpy(utbetdag, line + LEFTBLANK, 6);
	*(utbetdag + 6) = '\0';

	strcpy(namnrad, line + LEFTBLANK + TABS);

	for (p = namnrad, i = 0; i < MAXNAMN; i++) {
		while (*p == ' ')
			p++;

		if (*p == '\0')
			break;

		else {
			namnkod[i] = p++;
			while (*p != ' ' && *p != '\0')
				p++;

			if (*p == '\0') {
				i++;		/* ett till namn klart */
				break;
			}

			else
				*p++ = '\0';
		}
	}

	if (i == 0) {
		fprintf(stderr, "ber: inga namn\n");
		exit(-1);
	}

	antnamn = i;
}	

/**/
val(x)
int	x;
{
	int	i, j;
	char	*p = line + LEFTBLANK + TABS;
	char	*strncpy();

	for (i = 0; i < antnamn; i++) {
		strncpy(workl, p + i * TABS, TABS);
		*(workl + TABS) = '\0';
		for (j = 0; j < TABS; j++)
			if (*(workl + j) != ' ')
				break;

		if (j == TABS) {
			*workl = '0';
			*(workl + 1) = '\0';
		}

		sscanf(workl, "%lf", &data[i] [x]);

	}
}

/**/
mkskatt()
{
	int	sum, lim, i;
	char	*p;
	FILE	*tfp;

	for (i = 0; i < antnamn; i++) {
		sum = (int)(data [i] [ML] + data [i] [OT1] + data [i] [OT2] + 
		      data [i] [SEM] - data [i] [TJL] - 
		      (data [i] [SJDGR] * data [i] [PERDAG]));

		if (data [i] [SKATT] < 1) {
			sum = (int)(sum * data [i] [SKATT]);
			data [i] [SKATT] = (double)sum;
		}

		else if (data [i] [SKATT] < 35) {
			sprintf(workl, "t%d", (int)data [i] [SKATT]);
			if ((tfp = fopen(workl, "r")) == NULL) {
				fprintf(stderr, "ber: Ingen tabell %s\n", workl);
				exit(-1);
			}

			while (fgets(line, MAXL, tfp) != NULL) {
				*(line + strlen(line) - 1) = '\0';
				p = line;
				while (*p != '\t')
					p++;

				*p++ = '\0';		/* l|negr{ns i line */
							/* skatt i p */

				sscanf(line, "%d", &lim);
				if (lim >= sum)
					break;
			}

			sscanf(p, "%lf", &data[i] [SKATT]);
		}
	}
}

/**/
skrivut()
{
	int	i;

	printf("%s\n", period);
	printf("%s\n", utbetdag);

	for (i = 0; i < antnamn; i++) {
		printf("%s\n", namnkod[i]);
		printf("%-10.0f\n", data [i] [ML]);
		printf("%-10.0f\n", data [i] [OT1]);
		printf("%-10.0f\n", data [i] [OT2]);
		printf("%-10.0f\n", data [i] [SEM]);
		printf("%-10.0f\n", data [i] [TJL]);
		printf("%-10.0f\n", data [i] [SJDGR]);
		printf("%-10.0f\n", data [i] [PERDAG]);
		printf("%-10.0f\n", data [i] [SKATT]);
		printf("%-10.0f\n", data [i] [KVARSK]);
		printf("%-10.0f\n", data [i] [RIKSK]);
		printf("%-10.0f\n", data [i] [UTL]);
		printf("%-10.0f\n", data [i] [RESER]);
	}
}

