/*
Moddar:
	Mon Nov 24 15:07:26 1986	Kundreg i /z/ind/f/p/kundreg
	Fri May 16 13:45:20 1986	Kreditnota (.KR) inf|rd UI
	Thu May 15 21:03:03 1986	Valuta (.VA) inf|rd UI
	Fri Jan 16 13:35:51 1987	]terst{llning av kreditflagga /UI
	Thu Feb  5 13:08:05 1987	H{mtar nummer vid kreditering (.KR)
	Mon Sep 14 12:43:06 1987	Bytt firmanamn /GB
*/
/**/
#include <stdio.h>

#define KUNDREG		"/z/ind/f/p/kundreg"

#define MOMS3		0.2346

#define	TRUE		1
#define	FALSE		0
#define TABS		8

#define	SMALL		30
#define MAXL		300
#define LINES		72
#define COLS		75

#define	L		0
#define	R		1
#define	M		2
/**/
#define	MPOSIN		40
#define	EPOSIN		48
#define	APOSIN		56
#define	MOPOSIN		64

#define	ARTOUT		1
#define	MPOSOUT		40
#define	EPOSOUT		45
#define	APOSOUT		60
#define	RPOSOUT		72
#define	MOPOSUT		55
#define S3POSUT		18
#define	S0POSUT		43
#define TOTPOSUT	72

#define TOTL		63

#define	LART		29
#define LARTMAX		55

#define	LRANTA		58
#define CRANTA		1

#define	FNL		6
#define	FNC		70
#define	DAL		6
#define	DAC		50
#define LAL		11
#define LAC		1
#define	KUL		11
#define	KUC		38
#define	VRL		20
#define	VRC		1
#define	ERL		23
#define	ERC		1
#define	LTL		20
#define	LTC		20
#define	GML		20
#define	GMC		32
#define	BVL		20
#define	BVC		54
#define	ORL		23
#define	ORC		20
#define	TRL		23
#define	TRC		32
#define	LVL		23
#define	LVC		54
#define	LAL		11
#define	LAC		1
#define VAL		TOTL
#define VAC		63
/**/
char	line[MAXL], workl[MAXL];
char	immage[LINES * COLS];

int	artline;		/* n{sta rad f|r ariklar */
int	eng;			/* flagga f|r engelsk text */
int	kredit;			/* flagga f|r kreditnota */

double	sum0;			/* summa ej momspliktigt */
double	sum3;			/* summa momspliktigt */
double	moms;			/* summa moms */

/**/
main(argc, argv)
int	argc;
char	*argv[];
{
	FILE	*fp, *fopen();
	char	*instr();

	if (argc == 1) {
		mkimmage(stdin);
	}

	else
		while (--argc > 0) {
			if ((fp = fopen(*++argv,"r")) == NULL) 
				fprintf(stderr,"fakt: cannot open %s\n",*argv);

			else 
				mkimmage(fp);
		}
}
/**/
mkimmage(fp)
FILE	*fp;
{
	char		*p, *instr();
	register int	i;

	for (p = immage, i = 1; i <= (LINES * COLS); p++, i++)
		*p = ' ';

	artline = LART;
	sum0 = sum3 = moms = 0;
	eng = FALSE;
	kredit = FALSE;

	while ((fgets(line, MAXL, fp)) != NULL) {
		*(line + strlen(line) - 1) = '\0';

		if (instr(line, "(") == line)
			continue;

		else if (instr(line, ".FN") == line) 
			mk(line, FNL, FNC, R);		/* fakturanr */

		else if (instr(line, ".DA") == line) 
			mk(line, DAL, DAC, R);		/* datum */

		else if (instr(line, ".KU") == line) 
			mkku(line);			/* kundnummer */

		else if (instr(line, ".VR") == line) 
			mk(line, VRL, VRC, L);		/* v}r ref */

		else if (instr(line, ".ER") == line) 
			mk(line, ERL, ERC, L);		/* er ref */

		else if (instr(line, ".LT") == line) 
			mk(line, LTL, LTC, L);		/* levtid */

		else if (instr(line, ".GM") == line) 
			mk(line, GML, GMC, L);		/* godsm{rke */

		else if (instr(line, ".BV") == line) 
			mk(line, BVL, BVC, L);		/* betvillkor */

		else if (instr(line, ".OR") == line) 
			mk(line, ORL, ORC, L);		/* ordernummer */

		else if (instr(line, ".TR") == line) 
			mk(line, TRL, TRC, L);		/* transports{tt */

		else if (instr(line, ".LV") == line) 
			mk(line, LVL, LVC, L);		/* levvillkor */

		else if (instr(line, ".LA") == line) 
			mkla(line);			/* levadress */

		else if (instr(line, ".FT") == line) 
			mkft(line);			/* fri text */

		else if (instr(line, ".EN") == line) 
			eng = TRUE;			/* engelsk text */

		else if (instr(line, ".VA") == line) 
			mkva(line);			/* valuta */

		else if (instr(line, ".KR") == line) {
			mk(line, FNL, FNC, R);		/* fakturanr */
			kredit = TRUE;			/* kreditnota */
		}

		else
			decode(line);			/* artikelrad */
	}

	mksum();
	mktxt();
	outimmage();
}
/**/
mk(str, li, co, a)
char	*str;		/* str{ng */
int	li;		/* rad */
int	co;		/* kolumn */
int	a;		/* justrering, L=v{, annars =h| */
{
	char	*strins();

	str += 3;
	while (*str == ' ' || *str == '\t')
		if (*str == '\0')
			return;

		else
			str++;

	strins(immage, cur(li, co), str, a);
}
/**/
mkku(str)
char	*str;
{
#define	OUTADDR		0
#define INADDR		1
#define INNO		3

	FILE	*kfp;
	int	kul = KUL;
	int	state;

	str += 3;
	while (*str == ' ' || *str == '\t')
		if (*str == '\0')
			return;

		else
			str++;

	if ((kfp = fopen(KUNDREG, "r")) == NULL) {
		fprintf(stderr, "kunderna f|rsvunna\n");
		exit(1);
	}

	state = OUTADDR;

	while (fgets(workl, MAXL, kfp) != NULL) {
		*(workl + strlen(workl) - 1) = '\0';
		if (state == INADDR)
			if (*workl == '<')
				break;

			else {
				strins(immage, cur(kul, KUC), workl, L);
				kul++;
			}

		else if (*workl == '<')
			state = INNO;

		else if (state = INNO)
			if (strcmp(str, workl) == 0) 
				state = INADDR;

			else
				state = OUTADDR;
	}

	fclose(kfp);
}
/**/
mkla(str)
char	*str;
{
	int	lal = LAL;
	int	inline = TRUE;
	char	*p;

	str += 3;
	while (*str == ' ' || *str == '\t')
		if (*str == '\0')
			return;

		else
			str++;

	strins(immage, cur(LAL - 2, LAC), "Leveransadress:", L);
	while (inline) {
		for (p = workl; *str != '<'; p++, str++) {
			if (*str == '\0') {
				inline = FALSE;
				break;
			}

			*p = *str;
		}

		*p = '\0';
		strins(immage, cur(lal, LAC), workl, L);
		lal++;
		str++;
	}
}
/**/
mkft(str)
char	*str;
{
	char	*strins();

	str += 3;
	while (*str == ' ' || *str == '\t')
		if (*str == '\0')
			return;

		else
			str++;

	strins(immage, cur(artline, 1), str, L);

	if (artline < LARTMAX)
		artline++;
}
/**/
mkva(str)	/* valuta */
char	*str;
{
	str += 3;
	while (*str == ' ' || *str == '\t')
		if (*str == '\0')
			return;

		else
			str++;

	strins(immage, cur(VAL, VAC), str, R);
}
/**/
mktxt()
{
	if (kredit) {
		strins(immage, cur(3, 30), "\33CKREDITNOTA\33Z", L);
		strins(immage, cur(61, 72), "Er till godo", R);
	}

	else {
		strins(immage, cur(3, 36), "\33CFAKTURA\33Z", L);
		strins(immage, cur(58, 1), "Vid betalning efter f|rfallodagen debiteras r{nta med 10 procentenheter", L);

		strins(immage, cur(59, 1), "|ver g{llande diskonto", L);
		strins(immage, cur(61, 72), "Att betala", R);
	}

	strins(immage, cur(3, 1), "\33CAdvance Tech\33Z", L);
	strins(immage, cur(4, 1), "Consulting AB", L);
	strins(immage, cur(5, 1), "Box 2066", L);
	strins(immage, cur(7, 1), "175 02  J[RF[LLA", L);

	strins(immage, cur(5, 45), "Datum", L);
	strins(immage, cur(5, 70), "Nummer", R);

	strins(immage, cur(26, 1), "Ben{mning", L);
	strins(immage, cur(26, 40), "M{ngd", R);
	strins(immage, cur(26, 45), "Enh", L);
	strins(immage, cur(26, 60), "a'pris", R);
	strins(immage, cur(26, 72), "Summa", R);


	strins(immage, cur(61, 18), "Momsplikt. belopp", R);
	strins(immage, cur(61, 43), "Ej momsplikt. belopp", R);
	strins(immage, cur(61, 55), "Moms", R);

	strins(immage, cur(66, 1), "Bankgiro \33C716-0435\33Z         Postgiro \33C433 00 69-8\33Z", L);

	strins(immage, cur(69, 1), "Momsregnummer 556220-9667", L);
	strins(immage, cur(69, 30), "Telefon 0758 - 520 25", L);

}
/**/
mksum()
{
	char	tmpstr[SMALL];
	double	tot;

	sprintf(tmpstr, "%-20.0f", sum3);
	strins(immage, cur(TOTL, S3POSUT), tmpstr, R);

	sprintf(tmpstr, "%-20.0f", sum0);
	strins(immage, cur(TOTL, S0POSUT), tmpstr, R);

	moms = sum3 * MOMS3;
	sprintf(tmpstr, "%-20.0f", moms);
	strins(immage, cur(TOTL, MOPOSUT), tmpstr, R);

	tot = sum0 + sum3 + moms;
	sprintf(tmpstr, "%-20.0f", tot);
	strins(immage, cur(TOTL, TOTPOSUT), tmpstr, R);
}
/**/
decode(str)
char	*str;
{
	char	*strins();
	char	tmpstr[SMALL];
	int	mangdfinns = FALSE;
	int	aprisfinns = FALSE;
	double	mangd;
	double	enh;
	double	apris;
	double	radpris = 0;
	int	i;

	detab(str, workl);
	str = workl;
	for (i = 0; *str != '\0'; i++, str++)
		;

	for (; i <= MOPOSIN + 2; i++, str++)
		*str = ' ';

	str = workl;

	*(str + MPOSIN - 1) = '\0';
	*(str + EPOSIN - 1) = '\0';
	*(str + APOSIN - 1) = '\0';
	*(str + MOPOSIN - 1) = '\0';
	*(str + MOPOSIN + 1) = '\0';

	strins(immage, cur(artline, ARTOUT), str, L);

	if (*(str + MPOSIN) != ' ') {
		mangdfinns = TRUE;
		sscanf(str + MPOSIN, "%lf", &mangd);
		strins(immage, cur(artline, MPOSOUT), str + MPOSIN, R);
	}

	if (*(str + EPOSIN) != ' ') {
		sscanf(str + EPOSIN, "%lf", &enh);
		strins(immage, cur(artline, EPOSOUT), str + EPOSIN, L);
	}

	if (*(str + APOSIN) != ' ') {
		aprisfinns = TRUE;	
		sscanf(str + APOSIN, "%lf", &apris);
	}

	if (mangdfinns) {
		if (aprisfinns) {
			radpris = mangd * apris;
			strins(immage, cur(artline, APOSOUT), str + APOSIN, R);
			sprintf(tmpstr, "%-20.0f", radpris);
			strins(immage, cur(artline, RPOSOUT), tmpstr, R);
		}
	}

	else if (aprisfinns) {
			radpris = apris;
			sprintf(tmpstr, "%-20.0f", radpris);
			strins(immage, cur(artline, RPOSOUT), tmpstr, R);
		}

	if (*(str + MOPOSIN) == '3')
		sum3 +=radpris;

	else
		sum0 += radpris;


	if (artline < LARTMAX)
		artline++;
}
/**/
outimmage()
{
	char	*p;
	int	i, j;

	for (i = 0; i < LINES; i++)
		for (j = COLS - 1; j >= 0; j--) {
			p = immage + j + i * COLS;
			if ( *p == ' ')
				*p = '\0';

			else
				break;
		}

	for (i = 0; i < LINES; i++)
		puts(immage + i * COLS);
}
/**/
detab(l, ut)
char	*l;
char	*ut;
{
	register int	cnt;

	cnt = 0;

	while (*l != '\0' ) {
		if (cnt == TABS)
			cnt = 0;

		if (*l == '\n') {
			cnt = 0;
			*ut++ = *l++;
		}

		else if (*l == '\t') {
			while (cnt++ < TABS)
				*ut++ = ' ';

			cnt = 0;
			l++;
		}

		else {
			*ut++ = *l++;
			cnt++;
		}
	}

	*ut = '\0';
}
/**/
/***************************************************************************
*
*  Strins:	String insert. S{tter in str{ngen part i str{ngen base
*		p} pos. Om a = L sker v{nsterjustering, annars h|ger.
*
*		Returnerar en pointer till det sist insatta tecknet + 1.
*
***************************************************************************/

char	*
strins(base, pos, part, a)
register char	*base, *part;
register int	pos;
int		a;
{
	int	i;

	if (a == L)
		base += pos;

	else {
		for (i = strlen(part) - 1; *(part + i) == ' ' && i >= 0; i--)
			*(part + i) = '\0';

		base += (pos - strlen(part) + 1);
	}

	for (; *part != '\0'; part++, base++)
		*base = *part;

	return(base + 1);
}
/**/
cur(li, col)
int	li;
int	col;
{
	return((li - 1) * COLS + col - 1);
}
/**/
char	*instr(s1, s2)
char	*s1, *s2;
{
	register char	*i, *j, *k;

	for(i = s1; *i != '\0'; i++) {
		for(j = i, k = s2; *k != '\0' && *j == *k; j++, k++)
			;
		if(*k == '\0')
			return(i);
	}
	return(NULL);
}
/**/
char	*string(s, n, c)
register char	*s;
register int	n;
register char	c;
{
	while(n-- > 0)
		*s++ = c;
	*s = '\0';
	return(s);
}
