;*******************************************************
;*     MTOS-86xx V3.0:  APPLICATION LIBRARY GENERATOR  *
;*     F. W. PORRETTO, NOVEMBER 19, 1982               *
;*     FOR INDUSTRIAL PROGRAMMING, JERICHO, N.Y.       *
;*                                                     *
;*     NO MODIFICATIONS REQUIRED FOR MTOS-86xx V3.1    *
;*                                                     *
;*******************************************************
;
; THIS SMALL COMMAND FILE CREATES THE APPLICATIONS LIBRARY FROM XROM.OBJ
; AND XRAM.OBJ. IT IS USEFUL AS A STARTUP PHASE WHEN PRODUCING TEST SYSTEMS,
; ESPECIALLY IF CONFIGURING THE DIAGNOSTIC. AFTER EXECUTING THIS PROCEDURE,
; IT IS COMMON TO EXECUTE DLIB.CSD, TO PUT THE DIAGNOSTIC OBJECT MODULES
; INTO THE FRESHLY CREATED APPLIC.LIB.
;
; INPUT:  %0 SPECIFIES THE DRIVE FROM WHICH TO GET THE OBJECT FILES,
;         %1 SPECIFIES THE DRIVE ON WHICH TO BUILD APPLIC.LIB,
; OUTPUT: APPLIC.LIB, THE APPLICATION OBJECT LIBRARY.
;
DELETE %1APPLIC.LIB
LIB86
CREATE %1APPLIC.LIB
ADD %0XROM.OBJ,%0XRAM.OBJ,%0DEBG86.OBJ TO %1APPLIC.LIB
LIST %1APPLIC.LIB
EXIT
;
