;*******************************************************
;*    MTOS-86xx V3.0:  TARGET SYSTEM GENERATION        *
;*    F. W. PORRETTO, NOVEMBER 19,1982                 *
;*    FOR INDUSTRIAL PROGRAMMING, JERICHO, N.Y.        *
;*                                                     *
;*    NO MODIFICATIONS REQUIRED FOR MTOS-86xx V3.1     *
;*                                                     *
;*******************************************************
;
; INPUT:  %0 SPECIFIES THE DRIVE ON WHICH RESIDE MTOS86.LNK AND APPLIC.LIB,
;         %1 SPECIFIES THE DRIVE ON WHICH TO BUILD TARGET.LNK AND TARGET.SYS,
;         %2 SPECIFIES THE MAP DESTINATIONS FOR LINK86 AND LOC86.
; OUTPUT: TARGET.LNK, THE UN-LOCATED FULLY LINKED SYSTEM/APPLICATION,
;         TARGET.SYS, THE FULLY LOCATED VERSION OF TARGET.LNK.
;
DELETE %1TARGET.LNK,%1TARGET.SYS
LINK86 %0APPLIC.LIB(MTOS_ROM_STRUCTURES),%0MTOS86.LNK,%0APPLIC.LIB &
TO %1TARGET.LNK NAME(RUNTIME_IMAGE) LINES MAP PRINT(%2)
;
; HAVING PRODUCED THE FULLY-LINKED PACKAGE, BIND IT TO THE DESIRED ADDRESSES.
;
LOC86 %1TARGET.LNK TO %1TARGET.SYS MAP SC(3) PRINT(%2) &
PRINTCONTROLS(NOLINES,NOSYMBOLS) OBJECTCONTROLS(NOLINES,NOSYMBOLS) &
RESERVE(0200H TO 07FFH)
;
;  ** END OF PROCEDURE **
;
