;	FILE	 : TEST.ASM
;	FUNCTION : A sample task which outputs a message to the console.
;	AUTHOR	 : PETER H{LLSTR|M
;	DATE	 : 860515
;	SITE	 : IND, J{rf{lla

INCLUDE   SDB.EQU
;---------------------------------------------------------------------------
;    Public Declarations
;
        PUBLIC  TASK_0B_STACK,TASK_0B_ENTRY,TASK_1B_STACK,TASK_1B_ENTRY
;        PUBLIC  TASK_2B_STACK,TASK_2B_ENTRY,TASK_3B_STACK,TASK_3B_ENTRY
;        PUBLIC  TASK_4B_STACK,TASK_4B_ENTRY
;
;---------------------------------------------------------------------------
;    Stack Definition
;
TEST_SS	SEGMENT	PUBLIC
;
        DW      50 DUP(?)
TASK_0B_STACK LABEL WORD
        DW      50 DUP(?)
TASK_1B_STACK LABEL WORD
        DW      50 DUP(?)
TASK_2B_STACK LABEL WORD
        DW      50 DUP(?)
TASK_3B_STACK LABEL WORD
        DW      50 DUP(?)
TASK_4B_STACK LABEL WORD
;
TEST_SS	ENDS
;
;---------------------------------------------------------------------------
;    Data Definition
;
TEST_DS	SEGMENT	PUBLIC
;
CR              EQU     13
LF              EQU     10
STATUS		DD	0				; four byte status
CLRSCR          DD      CLS                             ; console parm list
BLLINE          DD      BLL                             ; console parm list
CPARMS0		DD	TASK0   			; console parm list
CPARMS1		DD	TASK1   			; console parm list
CPARMS2		DD	TASK2   			; console parm list
CPARMS3		DD	TASK3   			; console parm list
CPARMS4		DD	TASK4   			; console parm list
CPARMSCO	DD	CTRL    			; console parm list
CPARMSAC	DD	ACTIVE   			; console parm list
CPARMSRE	DD	READY   			; console parm list
CPARMSBL	DD	BLOCKED   			; console parm list
CPARMSDO	DD	DORMANT 			; console parm list
CPARMSWA	DD	WAITING 			; console parm list
CPARMSSE	DD	SETTING 			; console parm list
CPARMSTIM	DD	TIMESTR 			; console parm list
TIMEPTR         DD      ACTTIME 			; console parm list
		DW	80
;
; UTSKRIFTS STR[NGAR 
;
CLS     DB      CR,LF,CR,LF,CR,LF,CR,LF,CR,LF,CR,LF,CR,LF,CR,LF,CR,LF,0
BLL     DB      CR,LF,0
;
TASK0   DB      'INIT   :   ',CR,LF,0
TASK1   DB      'TASK 1 :   ',CR,LF,0
TASK2   DB      'TASK 2 :   ',CR,LF,0
TASK3   DB      'TASK 3 :   ',CR,LF,0
TASK4   DB      'TASK 4 :   ',CR,LF,0
CTRL    DB      'CONTRL :   ',CR,LF,0
;
ACTIVE  DB      'ACTIVE     ',CR,LF,0
READY   DB      'READY      ',CR,LF,0
BLOCKED DB      'BLOCKED    ',CR,LF,0
DORMANT DB      'DORMANT    ',CR,LF,0
WAITING DB      'WAITING FOR EVENT FLAG TO BE SET',CR,LF,0
SETTING DB      'SETTING EVENT FLAG',CR,LF,0
ACTTIME DB      '15-MAY-1986 14:50',0
TIMESTR DB      17 DUP(?)
;
;       SDB     AREOR
;
L_ENDR1         LABEL BYTE
                ENDR    0,SEC,1
L_ENDR10        LABEL BYTE
                ENDR    0,SEC,10
L_ENDR60        LABEL BYTE
                ENDR    0,SEC,60
;
L_STRT1         LABEL BYTE
                STRT    0,3,3,0,0,0
L_STRT2         LABEL BYTE
                STRT    0,4,3,0,0,0
L_STRT3         LABEL BYTE
                STRT    0,5,3,0,0,0
L_STRT4         LABEL BYTE
                STRT    0,6,3,0,0,0
;
L_PAUSE1        LABEL BYTE
                PAUSE   SEC,1
L_PAUSE3        LABEL BYTE
                PAUSE   SEC,3
L_PAUSE5        LABEL BYTE
                PAUSE   SEC,5
;
L_CNTRL0        LABEL BYTE
                CNTRL   0,0
L_CNTRL1        LABEL BYTE
                CNTRL   1,0
;
SET_TIME        LABEL BYTE
                STIME   0,TIMEPTR
REQ_TIME        LABEL BYTE
                TIME    0,CPARMSTIM
;
SET_EV_FL       LABEL BYTE
                SEF     1,1
RESET_EV_FL     LABEL BYTE
                REF     1,1
WAIT_EV_FL      LABEL BYTE
                WEF     1,1,1
;
DISPLAY_CLS	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CLRSCR
DISPLAY_BLL	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,BLLINE
DISPLAY_IN	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMS0
DISPLAY_T1	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMS1
DISPLAY_T2	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMS2
DISPLAY_T3	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMS3
DISPLAY_T4	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMS4
DISPLAY_CO	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMSCO
DISPLAY_AC	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMSAC
DISPLAY_RE	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMSRE
DISPLAY_BL	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMSBL
DISPLAY_DO	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMSDO
DISPLAY_WA	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMSWA
DISPLAY_SE	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMSSE
DISPLAY_TIM	LABEL	BYTE				; console output SDB
		RIO  043H,0,0,0,0FFFFH,STATUS,CPARMSTIM
;
END_IT		LABEL	BYTE				; end task SDB
		ENDT
;
TEST_DS	ENDS
;
;---------------------------------------------------------------------------
;    Task Definition
;
TEST_CS	SEGMENT	PARA	PUBLIC
ASSUME	CS:TEST_CS; DS:TEST_DS; ES:TEST_DS; SS:TEST_SS
;
TASK_0B_ENTRY PROC FAR    ; INIT TASK
;
	MOV	DX,TEST_DS			; set up data segment
	MOV	DS,DX
;
	SVC	DISPLAY_CLS
	SVC	DISPLAY_CLS
	SVC	DISPLAY_CLS			; display CLEARSCREEN
;
;        MOV     AX,3                            ; rad
;        MOV     BX,69                           ; pos
;        CALL    PRINTXY
	SVC	DISPLAY_IN			; display INIT   :
        SVC   	DISPLAY_RE
        SVC   	DISPLAY_AC                      ; display ACTIVE
        SVC   	SET_TIME
        SVC   	REQ_TIME
        SVC   	DISPLAY_TIM
        SVC   	L_PAUSE5
        SVC   	DISPLAY_BL     
        SVC     L_STRT1                         ; start task 1
        SVC   	L_PAUSE1
        SVC   	DISPLAY_BLL     
	SVC	DISPLAY_IN			; display INIT   :
	SVC	DISPLAY_WA			
        SVC     WAIT_EV_FL               	; wait for event flag 
;
        SVC   	DISPLAY_BLL     
	SVC	DISPLAY_IN			; display INIT   :
        SVC   	DISPLAY_AC                      ; display ACTIVE
        SVC     RESET_EV_FL               	; reset event flag 
        SVC   	L_PAUSE5
	SVC	DISPLAY_DO
        SVC   	REQ_TIME
        SVC   	DISPLAY_TIM
        SVC     END_IT				; terminate task 0
;
 TASK_0B_ENTRY ENDP
;
;
;        ASSUME  CS:TEST_CS,DS:TEST_DS
;
TASK_1B_ENTRY PROC FAR    ; INIT TASK
	MOV	DX,TEST_DS			; set up data segment
       	MOV	DS,DX
;        
        SVC   	DISPLAY_BLL     
	SVC	DISPLAY_T1			; display TASK 1 :
        SVC   	DISPLAY_RE
;
        SVC   	L_PAUSE1
;
        SVC   	DISPLAY_BLL     
	SVC	DISPLAY_T1			; display TASK 1 :
        SVC   	DISPLAY_AC
;
        SVC   	L_PAUSE5
;
	SVC	DISPLAY_SE			
        SVC   	DISPLAY_DO
        SVC     SET_EV_FL               	; set event flag 
;
        SVC     END_IT				; terminate  task 1
;
TASK_1B_ENTRY ENDP
;
;
;        ASSUME  CS:TEST_CS,DS:TEST_DS
;
;TASK_2B_ENTRY PROC FAR    ; INIT TASK
	MOV	DX,TEST_DS			; set up data segment
	MOV	DS,DX
;        MOV     AX,CS
;        MOV     DS,AX
;
;        LEA     SI,READY
;        MOV     AX,3            ;RAD
;        MOV     BX,69           ;POS
;        CALL    PRINTXY
;
;        LEA     SI,BLOCKED
;        MOV     AX,3            ;RAD
;        MOV     BX,69           ;POS
;        CALL    PRINTXY
;
;        MOV     BP, OFFSET L_CNTRL1
;        CALL    SVC_1
;        CALL    CONTROL
;
;        MOV     BP,OFFSET L_ENDR1
;        CALL    SVC_1
;
;TASK_2B_ENTRY ENDP
;
;
;TASK_3B_ENTRY PROC FAR    ; 
	MOV	DX,TEST_DS			; set up data segment
	MOV	DS,DX
;        MOV     AX,CS
;        MOV     DS,AX
;
;        LEA     SI,READY
;        MOV     AX,4            ;RAD
;        MOV     BX,69           ;POS
;        CALL    PRINTXY
;
;        LEA     SI,BLOCKED
;        MOV     AX,4            ;RAD
;        MOV     BX,69           ;POS
;        CALL    PRINTXY
;
;        MOV     BP, OFFSET L_CNTRL1
;        CALL    SVC_1
;        CALL    CONTROL
;
;        MOV     BP,OFFSET L_ENDR60
;        CALL    SVC_1
;
;TASK_3B_ENTRY ENDP
;
;
;        ASSUME  CS:TEST_CS,DS:TEST_DS
;
;TASK_4B_ENTRY PROC FAR    ; INIT TASK
	MOV	DX,TEST_DS			; set up data segment
	MOV	DS,DX
;        
;        LEA     SI,READY
;        MOV     AX,5            ;RAD
;        MOV     BX,69           ;POS
;        CALL    PRINTXY
;
;        MOV     BP,OFFSET L_PAUSE2
;        CALL    SVC_1
;
;        LEA     SI,DORMANT
;        MOV     AX,5            ;RAD
;        MOV     BX,69           ;POS
;        CALL    PRINTXY
;
;        MOV     BP,OFFSET L_ENDT
;        CALL    SVC_1
;
;TASK_4B_ENTRY ENDP
;
;
;        ASSUME  CS:TEST_CS,DS:TEST_DS
;;
;;       KONTROLL PROCEDURE
;;
;;
;CONTROL PROC    NEAR
;        
;        LEA     SI,RUNNING
;        MOV     AX,6            ;RAD
;        MOV     BX,69           ;POS
;        CALL    PRINTXY
;
;        MOV     BP, OFFSET L_PAUSE3
;        CALL    SVC_1
;        
;        LEA     SI,NOT_RUN
;        MOV     AX,6            ;RAD
;        MOV     BX,69           ;POS
;        CALL    PRINTXY
;
;        MOV     BP, OFFSET L_CNTRL1
;        CALL    SVC_1
;        RET
;CONTROL ENDP
;;
        ASSUME  CS:TEST_CS,DS:TEST_CS
;       
;       SKRIVER UT EN STR[NG P] SK[RMEN
;
;       IN :    AX= RAD
;               BX= POS
;
BLANK   DB      'blank ',0
;
PRINTXY PROC    NEAR
        PUSH    ES
        PUSH    DX
;
	MOV	DX,TEST_CS			; set up data segment
	MOV	DS,DX
;
        LEA     SI,BLANK
;
        MOV     DL, 80*2    
        MUL     DL
        SHL     BX, 1           ; MUL 2
        ADD     AX, BX      
        MOV     DI, AX
;
        MOV     AX, 0B800H
        MOV     ES, AX
;
        CLD
R:      LODSB
        CMP     AL,00
        JZ      EXIT
        STOSB
;
        MOV     BYTE PTR ES:[DI], 07
        INC     DI
        JMP     R
;
EXIT:   POP     DX
        POP     ES
        RET
PRINTXY ENDP
;
TEST_CS	ENDS
;
END

