*H RTZ.PLZ
;UPDATED: 811124 / PH
;REV:     2.00
 
;=======
; P_WAIT - INTERFACE FROM PLZ TO "WAIT"
;
; PTR := P_WAIT (^SEMAPHORE,TIME_LIMIT)
;=======
 
	GLOBAL	P_WAIT
 
P_WAIT
	POP	BC			;BC:=RETURN ADDRESS
	POP	HL			;HL:=TIME-LIMIT
	POP	DE			;DE:=^SEMAPHORE
	POP	AF			;SKIP PLACE FOR OUT-PARAMS
	PUSH	BC			;SAVE RETURN ADDRESS
	CALL	Z_WAIT		;HL:=^MESSAGE
	EX	(SP),HL		;TS:=^MSG  HL:= RET.ADDR
	JP	(HL)			;RETURN TO CALLER
 
;=======
; P_SGNL - INTERFACE FROM PLZ TO "SIGNAL"
;=======
 
	GLOBAL	P_SGNL
 
P_SGNL
	POP	BC			;BC:=RETURN ADDRESS
	POP	HL			;HL:=^MESSAGE
	POP	DE			;DE:=^SEMAPHORE
	PUSH	BC
	JP	Z_SGNL
 
;=======
; P_EWAI
;=======
 
	GLOBAL	P_EWAI
 
P_EWAI
	POP	BC			;BC:=RETURN ADDRESS
	POP	DE			;DE:=^SEMAPHORE
	POP	AF			;SKIP PLACE FOR OUT-PARAMS
	PUSH	BC			;SAVE RETURN ADDRESS
	CALL	Z_EWAI		;HL:=^MESSAGE
	EX	(SP),HL		;TS:=^MSG  HL:= RET.ADDR
	JP	(HL)			;RETURN TO CALLER
 
;=======
; P_CPRO
;=======
 
	GLOBAL	P_CPRO
 
P_CPRO
	POP	HL			;HL:=RETURN ADDRESS
	POP	DE			;DE:=^IPCB
	CALL	Z_CPRO
	JP	(HL)
 
;=======
; P_CSEM
;=======
 
	GLOBAL	P_CSEM
 
P_CSEM
	POP	HL			;HL:=RETURN ADDRESS
	POP	DE			;DE:=^SEMAPHORE
	CALL	Z_CSEM
	JP	(HL)
 
;=======
; P_LDCW
;=======
 
	GLOBAL	P_LDCW
 
P_LDCW
	POP	HL			;HL:=RETURN ADDRESS
	POP	DE			;DE:=^CONTROL-WORD VECTOR
	CALL	Z_LDCW
	JP	(HL)
 
;=======
; P_SEVC
;=======
 
	GLOBAL	P_SEVC
 
P_SEVC
	POP	BC			;BC:=RETURN ADDRESS
	POP	HL			;HL:=^VECTOR
	POP	DE			;DE:=INTERRUPT LEVEL
	PUSH	BC
	JP	Z_SEVC
 
;=======
; P_SPTY
;=======
 
	GLOBAL	P_SPTY
 
P_SPTY
	POP	BC			;BC:=RETURN ADDRESS
	POP	HL			;L:=PPTY
	POP	DE			;DE:=^PCB
	PUSH	BC
	JP	Z_SPTY
