
exalarm.s                exalarm                                               LER     Tue Feb  7 14:24:36 1984
1

                     1              2	;Updated: 821130 / PH
                     2              3	;Created: 821130 / PH
                     3              4	 
                     4              5	;=======
                     5              6	; PROCESS ALARM
                     6              7	; This process waits for a command message at the sema-
                     7              8	; phore LARMSM. Three request codes are honored. Unrecog-
                     8              9	; nized messages are just returned to the pool (POOLSM).
                     9             10	;
                    10             11	; ZQCWAT - ring the bells if alarm enabled
                    11             12	; AQCEN  - enable alarm
                    12             13	; AQCDIS - disable alarm
                    13             14	;=======
                    14             15	 
                    15             16	;File:    rtzdecls.s
                    16            159	;File:    exequ.s
                    17            176	 
                    18            177		global	ALARM
                    19            178		external	LARMSM,Z_A0SM,LARMEN,POOLSM
                    20            179	 
                    21            180	ALARM
         0  0000    22 11 00 00   181		LD	DE,LARMSM		;wait for any event
         0  0003    23 cd 00 00   182		CALL	Z_EWAI
         0  0006    24 e5         183		PUSH	HL			;IX:=^received message
         0  0007    25 dd e1      184		POP	IX
         0  0009    26 dd 7e 02   185		LD	A,(IX+MSGRQC)	;find out what to do
         0  000c    27 fe 63      186		CP	ZQCWAT
         0  000e    28 20 42      187		JR	NZ,LARM10
                    29            188	 
                    30            189	; handle alarm time-out
                    31            190	 
         0  0010    32 3a 00 00   191		LD	A,(LARMEN)	;check if enabled
         0  0013    33 b7         192		OR	A
         0  0014    34 28 50      193		JR	Z,RETURN		;it's not, return the message
         0  0016    35 dd 36 02   194		LD	(IX+MSGRQC),ZQCWRB;build a display message
                                             06      
         0  001a    36 11 00 00   195		LD	DE,POOLSM
         0  001d    37 dd 73 06   196		LD	(IX+MSGRSM),E
         0  0020    38 dd 72 07   197		LD	(IX+MSGRSM+1),D
         0  0023    39 11 3c 00   198		LD	DE,XHONK		;^string
         0  0026    40 dd 73 08   199		LD	(IX+MSGBAD),E
         0  0029    41 dd 72 09   200		LD	(IX+MSGBAD+1),D
         0  002c    42 dd 36 0a   201		LD	(IX+MSGBSZ),XHONKZ
                                             16      
         0  0030    43 dd 36 0b   202		LD	(IX+MSGBSZ+1),0
                                             00      
         0  0034    44 11 00 00   203		LD	DE,Z_A0SM
         0  0037    45 cd 00 00   204		CALL	Z_SGNL
         0  003a    46 18 c4      205		JR	ALARM
                    47            206	 
                    48            207	XHONK
         0  003c    49 07 07      208		DEFW	0707H		;6 ^G
         0  003e    50 07 07      209		DEFW	0707H
         0  0040    51 07 07      210		DEFW	0707H
         0  0042    52 2a 2a      211		text	'*** alarm ***'
         0  0044       2a 20   
         0  0046       61 6c   
         0  0048       61 72   

exalarm.s                exalarm                                               LER     Tue Feb  7 14:24:36 1984
1

exalarm.s                exalarm                                               LER     Tue Feb  7 14:24:36 1984
2

         0  004a       6d 20   
         0  004c       2a 2a   
         0  004e       2a 20   
         0  0050    53 0d ff      212		DEFW	0FF0DH
                    54 00 16      213	XHONKZ	equ	$-XHONK
                    55            214	 
                    56            215	LARM10
         0  0052    57 fe 80      216		CP	AQCEN
         0  0054    58 20 07      217		JR	NZ,LARM20
                    59            218	 
                    60            219	; handle alarm enable
                    61            220	 
         0  0056    62 3e ff      221		LD	A,ON
         0  0058    63 32 00 00   222		LD	(LARMEN),A
         0  005b    64 18 09      223		JR	RETURN
                    65            224	 
                    66            225	LARM20
         0  005d    67 fe 81      226		CP	AQCDIS
         0  005f    68 20 05      227		JR	NZ,RETURN
                    69            228	 
                    70            229	; handle alarm  disable
                    71            230	 
         0  0061    72 3e 00      231		LD	A,OFF
         0  0063    73 32 00 00   232		LD	(LARMEN),A
                    74            233	 
                    75            234	RETURN
         0  0066    76 11 00 00   235		LD	DE,POOLSM
         0  0069    77 cd 00 00   236		CALL	Z_SGNL
         0  006c    78 18 92      237		JR	ALARM
                    79            238	 
         0  006e    80            239		end





the number of errors detected in this assembly is 0






















exalarm.s                exalarm                                               LER     Tue Feb  7 14:24:36 1984
2
