	title	'exconfig'
;Updated: 821201 / PH
;Created: 821201 / PH
 
;-------
; Define Processes
;-------
 
NPROC	DEFL	0	

	IPCB	Z_CON0,90,100
	IPCB	Z_RTCK,50,40
	IPCB	Z_DBG,90,0
	IPCB	CMDHDL,200,140
	IPCB	TIMER,50,100
	IPCB	ALARM,50,80
 
;-------
; Define Semaphores
;-------
 
NSEM	DEFL	0

	ISEM	POOLSM
	ISEM	CMDRSM
	ISEM	SECRSM
	ISEM	SEC_SM
	ISEM	TMR_SM
	ISEM	LARMSM
	ISEM	Z_C0SM
	ISEM	Z_A0SM
	ISEM	Z_CKSM
	ISEM	Z_01SM
	ISEM	Z_02SM
	ISEM	Z_03SM
 
;-------
; End Of Initialization Tables
;-------
 
	CRTAB
 
;-------
; Hardware Constants
;-------
 
	GLOBAL	Z_CTC0,Z_SYLV,Z_TICK,Z_RTCP

Z_RTCP	DEFB	8		;prescaler for Z_RTCK

Z_TICK	DEFB	240		;Time-constant for a 25 ms tick
Z_SYLV	DEFB	3		;CTC-channel used as system clock
Z_CTC0	DEFB	0D4H		;CTC-addresses
      	DEFB	0D5H
      	DEFB	0D6H
      	DEFB	0D7H
 
	end
