
rtz.s                                                      Z80 CROSS-ASSEMBLER     Tue Feb  7 17:21:34 1984
1

                     1 20           1	RTZSIZ	equ	32


























































rtz.s                                                      Z80 CROSS-ASSEMBLER     Tue Feb  7 17:21:34 1984
1

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
2

                     2              3	;Updated: 840207 / PH
                     3              4	;Created: <820120 / Peter Holmgren, DIGITAILOR AB
                     4              5	 
                     5              6	;=======
                     6              7	; RTZ - A REAL-TIME EXECUTIVE FOR Z-80 APPLICATIONS
                     7              8	;
                     8              9	; COPYRIGHT: DIGITAILOR AB, SWEDEN
                     9             10	;
                    10             11	; VER. 2.00: Released 8111xx
                    11             12	;      2.10: Released 8402xx
                    12             13	;=======
                    13             14	 
                    14             15	;FILE:    RTZ.EQU.S
                    15             16	;UPDATED: 820120 / PH
                    16             17	 
                    17             18	;=======
                    18             19	; ALL INTERNAL EQUATES FOR RTZ/2
                    19             20	;=======
                    20             21	 
                    21             22	;-------
                    22             23	; Initial Process Control Block
                    23             24	;-------
                    24             25	 
                    25 00          26	IPCNAM	EQU	0		;PROCESS NAME
                    26 06          27	IPCENT	EQU	6		;PROCESS ENTRY
                    27 08          28	IPCSTZ	EQU	8		;STACK SIZE
                    28 0a          29	IPCPTY	EQU	10		;PROCESS PRIORITY
                    29             30	 
                    30             31	;-------
                    31             32	; Initial Semaphore
                    32             33	;-------
                    33             34	 
                    34 00          35	ISMADR	EQU	0		;SEMAPHORE ADDRESS
                    35             36	 
                    36             37	;-------
                    37             38	; Configuration Table - Z$CRTB
                    38             39	;-------
                    39             40	 
                    40 00          41	CNFIPT	EQU	0		;^INITIAL PROCESS TABLE
                    41 02          42	CNFNOP	EQU	2		;# OF IPCB:S IN IPT
                    42 03          43	CNFIST	EQU	3		;^INITIAL  SEMAPHORE TABLE
                    43 05          44	CNFNOS	EQU	5		;# OF ISEM:S IN IST
                    44             45	 
                    45             46	;-------
                    46             47	; Process Control Block
                    47             48	;-------
                    48             49	 
                    49 00          50	PCBLNK	EQU	0		;LINK FIELD
                    50 02          51	PCBDLY	EQU	2		;DELAY TIME
                    51 04          52	PCBDLK	EQU	4		;DELAY LINK FIELD
                    52 06          53	PCBSEM	EQU	6		;SEMAPHORE
                    53 08          54	PCBSP 	EQU	8		;STACK POINTER
                    54 0a          55	PCBPTY	EQU	10		;PROCESS PRIORITY
                    55 0b          56	PCBSTT	EQU	11		;STATUS BITS
                    56 0c          57	PCBNAM	EQU	12		;^NAME
                    57 0e          58	PCBRND	EQU	14		;RANDOM FIELD
                    58 10          59	PCBPCB	EQU	16		;STATIC PCB-LINK
                    59             60	 

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
2

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
3

                    60             61	;-------
                    61             62	; Semaphore
                    62             63	;-------
                    63             64	 
                    64 00          65	SEMMGQ	EQU	0		;MESSAGE QUEUE
                    65 02          66	SEMPRQ	EQU	2		;PROCESS (WAITING) QUEUE
                    66 04          67	SEMSEM	EQU	4		;STATIC SEMAPHORE-LINK
                    67             68	 
                    68 06          69	SEMIMG	EQU	6		;INTERRUPT MESSAGE
                    69             70	 
                    70             71	;-------
                    71             72	; Minimum Message
                    72             73	;-------
                    73             74	 
                    74 00          75	MSGLNK	EQU	0		;QUEUE LINK
                    75 02          76	MSGRQC	EQU	2		;REQUEST CODE
                    76 03          77	MSGRC 	EQU	3		;RETURN CODE
                    77 04          78	MSGLEN	EQU	4		;LENGTH
                    78 06          79	MSGRSM	EQU	6		;RESPONSE SEMAPHORE
                    79             80	 
                    80             81	;-------
                    81             82	; Device Request Message
                    82             83	;-------
                    83             84	 
                    84 08          85	MSGBAD	EQU	8		;BUFFER ADDRESS
                    85 0a          86	MSGBSZ	EQU	10		;BUFFER SIZE
                    86 0c          87	MSGBCN	EQU	12		;BYTE COUNT
                    87             88	 
                    88 08          89	MSGSEC	EQU	8		;SECONDS
                    89 09          90	MSGMIN	EQU	9		;MINUTES
                    90 0a          91	MSGHRS	EQU	10		;HOURS
                    91             92	 
                    92 08          93	MSGWL 	EQU	8		;WANTED LENGTH
                    93 0a          94	MSGSPC	EQU	10		;MAX SPACE OR ^FREE SPACE
                    94             95	 
                    95             96	;-------
                    96             97	; Device Request Bits
                    97             98	;-------
                    98             99	 
                    99 01         100	ZQBRD 	EQU	1		;00.. ..01 READ
                   100            101	;ZQbRD 	EQU	0
                   101 02         102	ZQBWRT	EQU	2		;00.. ..10 WRITE
                   102            103	;ZQbWRT	EQU	1
                   103 00         104	ZQBASC	EQU	0		;00.. .0.. ASCII
                   104 04         105	ZQBBIN	EQU	4		;00.. .1.. BINARY
                   105            106	;ZQbBIN	EQU	2
                   106 08         107	ZQBSTT	EQU	8		;00.. 1... STATUS
                   107            108	;ZQbSTT	EQU	4
                   108            109	 
                   109            110	;-------
                   110            111	; Device Request Codes
                   111            112	;-------
                   112            113	 
                   113            114	      						;00xx xxxx COMMON CODES
                   114 01         115	ZQCRDA	EQU	ZQBRD+ZQBASC		;READ ASCII
                   115 05         116	ZQCRDB	EQU	ZQBRD+ZQBBIN		;READ BINARY
                   116 02         117	ZQCWRA	EQU	ZQBWRT+ZQBASC		;WRITE ASCII
                   117 06         118	ZQCWRB	EQU	ZQBWRT+ZQBBIN		;WRITE BINARY

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
3

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
4

                   118 09         119	ZQCRDS	EQU	ZQBRD+ZQBSTT		;READ STATUS
                   119 0a         120	ZQCWRS	EQU	ZQBWRT+ZQBSTT		;WRITE STATUS
                   120            121	 
                   121            122	      				;01xx xxxx COMMAND CODES
                   122 61         123	ZQCRDC	EQU	61H		;READ CLOCK
                   123 62         124	ZQCWRC	EQU	62H		;WRITE CLOCK
                   124 63         125	ZQCWAT	EQU	63H		;WAKE AT
                   125 64         126	ZQCWAF	EQU	64H		;WAKE AFTER
                   126            127	 
                   127 68         128	ZQCMCF	EQU	68H		;CONDITIONAL, FAST
                   128 69         129	ZQCMCB	EQU	69H		;CONDITIONAL, BEST
                   129 6a         130	ZQCMUF	EQU	6AH		;UNCONDITIONAL, FAST
                   130 6b         131	ZQCMUB	EQU	6BH		;UNCONDITIONAL, BEST
                   131            132	 
                   132            133	;-------
                   133            134	; System Return Codes
                   134            135	;-------
                   135            136	 
                   136 00         137	ZRCINT	EQU	0		;INTERRUPT MESSAGE
                   137 44         138	ZRCMIS	EQU	44H		;MISSED INTERRUPT
                   138 00 80      139	ZRCTO 	EQU	80H		;1... .... TIME-OUT
                   139            140	 
                   140            141	;-------
                   141            142	; Device Return Codes
                   142            143	;-------
                   143            144	 
                   144 00         145	ZRCOK 	EQU	0		;NORMAL TERMINATION
                   145 41         146	ZRCUNK	EQU	41H		;UNKNOWN REQUEST CODE
                   146 42         147	ZRCERR	EQU	42H		;UNSPECIFIED ERROR
                   147 43         148	ZRCBSY	EQU	43H		;DEVICE BUSY
                   148 45         149	ZRCOVF	EQU	45H		;DATA OVERFLOW
                   149 46         150	ZRCEOF	EQU	46H		;END OF FILE
                   150 47         151	ZRCDWN	EQU	47H		;DEVICE OFF LINE
                   151 48         152	ZRCEOM	EQU	48H		;END OF MEDIA
                   152            153	 
                   153            154	;-------
                   154            155	; HELP EQUATES
                   155            156	;-------
                   156            157	 
                   157 03         158	STTDLY	EQU	3		;BIT 3 IN PCBSTT
                   158 08         159	STCKAF	EQU	8		;OFFSET TO AF IN STACK
                   159 0a         160	STCKHL	EQU	10		;OFFSET TO HL IN STACK
                   160 0c         161	STCKPC	EQU	12		;OFFSET TO PC IN STACK
                   161 32         162	SZISTK	EQU	50		;SIZE OF IDLE STACK
                   162            163	 
                   163            164	;FILE:    EQU.CTC
                   164            165	;UPDATED: 800513 / PH
                   165            166	 
                   166            167	;=======
                   167            168	; CTC EQUATES
                   168            169	;
                   169            170	; SOME USEFUL EQUATES CONCERNING CTC-INITIALIZATION
                   170            171	; USAGE:  LD  A,C_CTRL+C_IE+C_TIM+C_P16+C_TC
                   171            172	;         OUT (CTC2),A
                   172            173	;=======
                   173            174	 
                   174 00 80      175	C_IE		EQU	80H		;INTERRUPTS ENABLED
                   175 00         176	C_ID  	EQU	0		;INTERRUPTS DISABLED

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
4

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
5

                   176 40         177	C_CNT	EQU	40H		;COUNTER-MODE
                   177 00         178	C_TIM	EQU	0		;TIMER-MODE
                   178 20         179	C_P256	EQU	20H		;PRESCALER 256  (TIMER MODE ONLY)
                   179 00         180	C_P16	EQU	0		;PRESCALER  16  (TIMER MODE ONLY)
                   180 10         181	C_POS	EQU	10H		;POSITIVE EDGE
                   181 00         182	C_NEG	EQU	0		;NEGATIVE EDGE
                   182 08         183	C_XTRG	EQU	8		;EXTERNAL TRIGGER (TIMER)
                   183 04         184	C_TC		EQU	4		;TIME-CONSTANT WILL FOLLOW
                   184 00         185	C_NOTC	EQU	0		;NO TIME-CONSTANT WILL FOLLOW
                   185 02         186	C_STOP	EQU	2		;STOP COUNTING
                   186 01         187	C_CTRL	EQU	1		;CONTROL-BYTE
                   187            188	 
                   188            189	 
                   189            190		GLOBAL	Z_RTZB
                   190            191		EXTERNAL	Z_CRTB,Z_CTC0,Z_TICK,Z_SYLV












































rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
5

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
6

                   191            193	 
                   192            194	Z_RTZB
         0  0000   193 f3         195		DI				;ENTRY-POINT FOR RTZ
         0  0001   194 18 08      196		JR	INIT03
         0  0003   195 52 54      197		text	'RTZ 2.10'
         0  0005       5a 20   
         0  0007       32 2e   
         0  0009       31 30   
                   196            198	 
                   197            199	; CLEAR RTZ VARIABLES
                   198            200	 
                   199            201	INIT03
         0  000b   200 21 00 00   202		LD	HL,Z_00VC
         0  000e   201 11 01 00   203		LD	DE,Z_00VC+1
         0  0011   202 01 b1 00   204		LD	BC,71H+2*RTZSIZ;SIZE OF RAM !!
         0  0014   203 36 00      205		LD	(HL),0
         0  0016   204 ed b0      206		LDIR
                   205            207	 
                   206            208	; BUILD EXECUTION-QUEUE
                   207            209	 
         0  0018   208 21 90 00   210		LD	HL,Z$FPCB-PCBPCB
         0  001b   209 22 a2 00   211		LD	(Z$LPCB),HL	;INITIATE PCB-LIST
         0  001e   210 21 46 00   212		LD	HL,Z$IRAM		;LINK IDLE PROC. TO Z$XQUE
         0  0021   211 22 00 00   213		LD	(Z_HEAP),HL
         0  0024   212 dd 21 d7   214		LD	IX,IDLIPC		;IX:=^IPCB IDLE
                                             01      
         0  0028   213 31 00 00   215		LD	SP,Z_HEAP+14
         0  002b   214 cd e6 00   216		CALL	INIPCB
         0  002e   215 ed 43 40   217		LD	(Z$XQUE),BC	;IDLE TO XQUE
                                             00      
                   216            218	 
         0  0032   217 21 02 00   219		LD	HL,Z_HEAP+2	;INITIATE FREE SPACE POINTER
         0  0035   218 22 00 00   220		LD	(Z_HEAP),HL
                   219            221	 
                   220            222	; SET UP PROCESS CONTROL BLOCK
                   221            223	 
         0  0038   222 31 46 00   224		LD	SP,Z$IRAM+18+14
         0  003b   223 dd 2a 00   225		LD	IX,(Z_CRTB+CNFIPT);IX:=^IPT.1ST (=^FIRST IPCB)
                                             00      
         0  003f   224 3a 02 00   226		LD	A,(Z_CRTB+CNFNOP);A:=# OF PROCESSES
                   225            227	INIT05
         0  0042   226 f5         228		PUSH	AF
         0  0043   227 dd e5      229		PUSH	IX
         0  0045   228 cd e6 00   230		CALL	INIPCB
         0  0048   229 cd 81 02   231		CALL	Z$TOXQ		;LINK BC^ TO XQUE
         0  004b   230 dd e1      232		POP	IX
         0  004d   231 f1         233		POP	AF
         0  004e   232 11 0b 00   234		LD	DE,11		;NO
         0  0051   233 dd 19      235		ADD	IX,DE		;IX:=^NEW ITEM IN IPT
         0  0053   234 3d         236		DEC	A
         0  0054   235 20 ec      237		JR	NZ,INIT05
                   236            238	 
                   237            239	; SET UP SEMAPHORE LINK
                   238            240	 
         0  0056   239 21 a0 00   241		LD	HL,Z$FSEM-SEMSEM
         0  0059   240 22 a6 00   242		LD	(Z$LSEM),HL	;INITIATE SEM-LIST
         0  005c   241 dd 2a 03   243		LD	IX,(Z_CRTB+CNFIST);IX:=^IST.1ST
                                             00      

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
6

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
7

         0  0060   242 3a 05 00   244		LD	A,(Z_CRTB+CNFNOS);C:=# OF SEMAPHORES
         0  0063   243 4f         245		LD	C,A
                   244            246	INIT10
         0  0064   245 dd 6e 00   247		LD	L,(IX+0)		;HL:=^SEM
         0  0067   246 dd 66 01   248		LD	H,(IX+1)
         0  006a   247 cd 56 01   249		CALL	INISEM
         0  006d   248 dd 23      250		INC	IX
         0  006f   249 dd 23      251		INC	IX
         0  0071   250 0d         252		DEC	C
         0  0072   251 20 f0      253		JR	NZ,INIT10
                   252            254	 
                   253            255	;INITIATE RTZ VARIABLES
                   254            256	 
         0  0074   255 3e 08      257		LD	A,8
         0  0076   256 32 ab 00   258		LD	(Z_SLCT),A	;TIME
         0  0079   257 3e c8      259		LD	A,200
         0  007b   258 32 ac 00   260		LD	(Z_SLCP),A	;PROCESS PRIORITY FOR SLICING
                   259            261	 
                   260            262	; FIX INTERRUPT SEMAPHORES
                   261            263	 
         0  007e   262 21 cd 07   264		LD	HL,ISEMTB		;HL:=^TABLE OF I-SEMAPHORES
         0  0081   263 3e 20      265		LD	A,ISEMCT		;A:=# OF I-SEMAPHORES
         0  0083   264 01 06 00   266		LD	BC,SEMIMG		;BC:=OFFSET TO I-MESSAGE
                   265            267	INIT40
         0  0086   266 5e         268		LD	E,(HL)		;DE:=^SEMAPHORE
         0  0087   267 23         269		INC	HL
         0  0088   268 56         270		LD	D,(HL)
         0  0089   269 23         271		INC	HL
         0  008a   270 eb         272		EX	DE,HL		;HL:=^SEMAPHORE
         0  008b   271 09         273		ADD	HL,BC		;HL:=^SEM.IMG
         0  008c   272 36 00      274		LD	(HL),0		;CLEAR SEM.IMG.LNK
         0  008e   273 23         275		INC	HL
         0  008f   274 36 00      276		LD	(HL),0
         0  0091   275 23         277		INC	HL
         0  0092   276 23         278		INC	HL
         0  0093   277 36 00      279		LD	(HL),ZRCINT	;SEM.IMG.RC
         0  0095   278 23         280		INC	HL
         0  0096   279 36 06      281		LD	(HL),6		;SEM.IMG.LEN
         0  0098   280 23         282		INC	HL
         0  0099   281 36 00      283		LD	(HL),0
         0  009b   282 eb         284		EX	DE,HL
         0  009c   283 3d         285		DEC	A
         0  009d   284 20 e7      286		JR	NZ,INIT40
                   285            287	 
                   286            288	; FIX INTERRUPT VECTORS
                   287            289	 
         0  009f   288 ed 5e      290		IM	2
         0  00a1   289 21 a3 04   291		LD	HL,R00RPT		;SET UP SYSTEM INTERRUPTS
         0  00a4   290 22 00 00   292		LD	(Z_00VC),HL
         0  00a7   291 01 15 00   293		LD	BC,RPTSIZ		;SIZE OF SYSTEM I-HANDLER
         0  00aa   292 11 09 05   294		LD	DE,R01RPT
         0  00ad   293 21 02 00   295		LD	HL,Z_00VC+2
         0  00b0   294 3e 1f      296		LD	A,RTZSIZ-1
                   295            297	INIT50
         0  00b2   296 73         298		LD	(HL),E
         0  00b3   297 23         299		INC	HL
         0  00b4   298 72         300		LD	(HL),D
         0  00b5   299 23         301		INC	HL

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
7

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
8

         0  00b6   300 eb         302		EX	DE,HL
         0  00b7   301 09         303		ADD	HL,BC
         0  00b8   302 eb         304		EX	DE,HL
         0  00b9   303 3d         305		DEC	A
         0  00ba   304 20 f6      306		JR	NZ,INIT50
         0  00bc   305 21 00 00   307		LD	HL,Z_00VC		;INITIALIZE ^RUPT VECTORS
         0  00bf   306 7c         308		LD	A,H			;  A:=HIGHBYTE OF Z_00VC
         0  00c0   307 ed 47      309		LD	I,A
         0  00c2   308 3a 00 00   310		LD	A,(Z_CTC0)	;C:=ADDRESS TO CTC0
         0  00c5   309 4f         311		LD	C,A
         0  00c6   310 ed 69      312		OUT	(C),L
         0  00c8   311 3a 00 00   313		LD	A,(Z_SYLV)	;GET SYS-CLOCK INTERRUPT-LEVEL
         0  00cb   312 47         314		LD	B,A
         0  00cc   313 b7         315		OR	A
         0  00cd   314 28 05      316		JR	Z,INIT25
                   315            317	INIT20
         0  00cf   316 0c         318		INC	C
         0  00d0   317 23         319		INC	HL
         0  00d1   318 23         320		INC	HL
         0  00d2   319 10 fb      321		DJNZ	INIT20
                   320            322	INIT25
         0  00d4   321 11 f6 03   323		LD	DE,SYSRPT
         0  00d7   322 73         324		LD	(HL),E		;LOAD SYSRPT VECTOR
         0  00d8   323 23         325		INC	HL
         0  00d9   324 72         326		LD	(HL),D
         0  00da   325 3e a5      327		LD	A,C_CTRL+C_IE+C_TIM+C_P256+C_TC
         0  00dc   326 ed 79      328		OUT	(C),A
         0  00de   327 3a 00 00   329		LD	A,(Z_TICK)	;SYTEM TICK:=TC*256*Z_TICK
         0  00e1   328 ed 79      330		OUT	(C),A		;  AT 2 MHZ
                   329            331	 
         0  00e3   330 c3 6d 01   332		JP	Z$SCED		;BEGIN EXECUTION
                   331            333	 
                   332            334	;-------
                   333            335	; SET UP PCB AND LINK IT TO PCB-LIST
                   334            336	;
                   335            337	; ACCEPTS: IX = ^IPCB
                   336            338	;
                   337            339	; RETURNS: BC = ^PCB
                   338            340	;
                   339            341	; AFFECTS: A,BC,DE,HL,IX,IY,SP
                   340            342	;-------
                   341            343	 
                   342            344	INIPCB
         0  00e6   343 21 12 00   345		LD	HL,18		;ALLOCATE PCB
         0  00e9   344 cd b9 02   346		CALL	Z_GETM
         0  00ec   345 e5         347		PUSH	HL			;IY:=^PCB
         0  00ed   346 fd e1      348		POP	IY
         0  00ef   347 af         349		XOR	A			;A:=0
         0  00f0   348 fd 77 00   350		LD	(IY+PCBLNK),A	;=== PCBLNK ===
         0  00f3   349 fd 77 01   351		LD	(IY+PCBLNK+1),A
         0  00f6   350 fd 77 04   352		LD	(IY+PCBDLK),A	;=== PCBDLK ===
         0  00f9   351 fd 77 05   353		LD	(IY+PCBDLK+1),A
         0  00fc   352 fd 77 0b   354		LD	(IY+PCBSTT),A	;=== STATUS ===
         0  00ff   353 dd 7e 0a   355		LD	A,(IX+IPCPTY)	;=== PRIORITY ===
         0  0102   354 fd 77 0a   356		LD	(IY+PCBPTY),A
         0  0105   355 dd 6e 08   357		LD	L,(IX+IPCSTZ)	;=== STACK ===
         0  0108   356 dd 66 09   358		LD	H,(IX+IPCSTZ+1);HL:=STACK SIZE
         0  010b   357 4d         359		LD	C,L			;BC:=STACK SIZE

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
8

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
9

         0  010c   358 44         360		LD	B,H
         0  010d   359 cd b9 02   361		CALL	Z_GETM		;HL:=STACK TOP
         0  0110   360 0b         362		DEC	BC			;SAVE TWO BYTES FOR PLZ
         0  0111   361 0b         363		DEC	BC
         0  0112   362 5d         364		LD	E,L			;DE:=STACK TOP + 1
         0  0113   363 54         365		LD	D,H
         0  0114   364 13         366		INC	DE			;FILL STACK WITH C7H
         0  0115   365 36 aa      367		LD	(HL),0AAH
         0  0117   366 ed b0      368		LDIR
         0  0119   367 e5         369		PUSH	HL			;SAVE SP
         0  011a   368 36 bb      370		LD	(HL),0BBH		;MARK EXTRA TWO BYTES OF --
         0  011c   369 ed a0      371		LDI				;STACK (FOR PLZ)
         0  011e   370 dd 5e 06   372		LD	E,(IX+IPCENT)	;=== PC ===
         0  0121   371 dd 56 07   373		LD	D,(IX+IPCENT+1);DE:=PC (START VALUE)
         0  0124   372 e1         374		POP	HL
         0  0125   373 2b         375		DEC	HL			;INITIAL PC TO STACK
         0  0126   374 72         376		LD	(HL),D
         0  0127   375 2b         377		DEC	HL
         0  0128   376 73         378		LD	(HL),E
         0  0129   377 11 f4 ff   379		LD	DE,-12		;LOCATE SPACE FOR REGISTERS
         0  012c   378 19         380		ADD	HL,DE
         0  012d   379 fd 75 08   381		LD	(IY+PCBSP),L
         0  0130   380 fd 74 09   382		LD	(IY+PCBSP+1),H
         0  0133   381 dd e5      383		PUSH	IX			;=== FIX ^IPCB ===
         0  0135   382 e1         384		POP	HL			;HL:=^IPCB
         0  0136   383 fd 75 0c   385		LD	(IY+PCBNAM),L
         0  0139   384 fd 74 0d   386		LD	(IY+PCBNAM+1),H
         0  013c   385 fd 36 10   387		LD	(IY+PCBPCB),0	;=== PCB-LINK ===
                                             00      
         0  0140   386 fd 36 11   388		LD	(IY+PCBPCB+1),0;LAST PCB IN PCB-LIST
                                             00      
         0  0144   387 fd e5      389		PUSH	IY			;BC:=^PCB
         0  0146   388 c1         390		POP	BC
         0  0147   389 fd 2a a2   391		LD	IY,(Z$LPCB)	;LINK BC^ TO PCB-LIST
                                             00      
         0  014b   390 fd 71 10   392		LD	(IY+PCBPCB),C
         0  014e   391 fd 70 11   393		LD	(IY+PCBPCB+1),B
         0  0151   392 ed 43 a2   394		LD	(Z$LPCB),BC	;^LAST PCB IN PCB-LIST
                                             00      
         0  0155   393 c9         395		RET
                   394            396	 
                   395            397	 
                   396            398	;-------
                   397            399	; INITIATE SEMAPHORE POINTERS
                   398            400	;
                   399            401	; ACCEPTS: HL = ^SEMAPHORE
                   400            402	;
                   401            403	; AFFECTS: A,B,IY
                   402            404	;-------
                   403            405	 
                   404            406	INISEM
         0  0156   405 e5         407		PUSH	HL
         0  0157   406 af         408		XOR	A			;A:=0
         0  0158   407 06 06      409		LD	B,6
                   408            410	CSEM1
         0  015a   409 77         411		LD	(HL),A		;CLEAR ALL POINTERS
         0  015b   410 23         412		INC	HL
         0  015c   411 10 fc      413		DJNZ	CSEM1

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
9

rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
10

         0  015e   412 e1         414		POP	HL
         0  015f   413 fd 2a a6   415		LD	IY,(Z$LSEM)	;IY:=^LAST SEM
                                             00      
         0  0163   414 fd 75 04   416		LD	(IY+SEMSEM),L	;INSERT NEW SEM
         0  0166   415 fd 74 05   417		LD	(IY+SEMSEM+1),H
         0  0169   416 22 a6 00   418		LD	(Z$LSEM),HL
         0  016c   417 c9         419		RET




















































rtz.s                    RTZ.INIT                                                  Tue Feb  7 17:21:34 1984
10

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
11

                   418            421	;UPDATED: 820107 / PH
                   419            422	;REV:     2.00
                   420            423	 
                   421            424	;=======
                   422            425	; Z$SCED - MAIN SCHEDULER
                   423            426	;=======
                   424            427	 
                   425            428		GLOBAL	Z$SCED
                   426            429	 
                   427            430	Z$SCED
         0  016d   428 dd 2a 40   431		LD	IX,(Z$XQUE)	;IX:=^PROC TO BE RUNNING
                                             00      
         0  0171   429 21 8b 00   432		LD	HL,Z$ICNT
         0  0174   430 f3         433		DI
         0  0175   431 7e         434		LD	A,(HL)
         0  0176   432 b7         435		OR	A			;ANY PENDING RUPTS
         0  0177   433 20 15      436		JR	NZ,SCED10		;YES
         0  0179   434 32 8a 00   437		LD	(Z$STAT),A	;NO, NOT IN RTZ!
         0  017c   435 dd 6e 08   438		LD	L,(IX+PCBSP)	;HL:=SP (RUNNING PROC)
         0  017f   436 dd 66 09   439		LD	H,(IX+PCBSP+1)
         0  0182   437 f9         440		LD	SP,HL
         0  0183   438 fd e1      441		POP	IY
         0  0185   439 dd e1      442		POP	IX
         0  0187   440 d1         443		POP	DE
         0  0188   441 c1         444		POP	BC
         0  0189   442 f1         445		POP	AF
         0  018a   443 e1         446		POP	HL
         0  018b   444 fb         447		EI
         0  018c   445 ed 4d      448		RETI				;AND DISPATCH TO USER PROC.
                   446            449	SCED10
         0  018e   447 3d         450		DEC	A			;ONE PENDING RUPT LESS
         0  018f   448 77         451		LD	(HL),A
         0  0190   449 21 8c 00   452		LD	HL,Z$ISTK		;HL:=^STACK OF PENDING RUPTS
         0  0193   450 85         453		ADD	A,L
         0  0194   451 6f         454		LD	L,A
         0  0195   452 30 01      455		JR	NC,SCED12
         0  0197   453 24         456		INC	H
                   454            457	SCED12
         0  0198   455 5e         458		LD	E,(HL)
         0  0199   456 fb         459		EI
         0  019a   457 16 00      460		LD	D,0
         0  019c   458 1c         461		INC	E			;SYSTEM CLOCK ?
         0  019d   459 ca 04 04   462		JP	Z,SYSCLK		;YES
         0  01a0   460 21 cb 07   463		LD	HL,ISEMTB-2	;-2 FOR COMPENSATION OF "INC E"
         0  01a3   461 19         464		ADD	HL,DE		;HL:=^POS. # "DE" IN ISEMTB
         0  01a4   462 19         465		ADD	HL,DE
         0  01a5   463 5e         466		LD	E,(HL)		;DE:=Z_xxSM
         0  01a6   464 23         467		INC	HL
         0  01a7   465 56         468		LD	D,(HL)
         0  01a8   466 d5         469		PUSH	DE			;IX:=Z_RXSM
         0  01a9   467 dd e1      470		POP	IX
         0  01ab   468 c3 b2 04   471		JP	R00R05
                   469            472	 
                   470            473	;=======
                   471            474	; Z$SREG - SAVE ALL REGISTERS
                   472            475	;
                   473            476	; RETURNS: IX = ^PCB for running process
                   474            477	;

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
11

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
12

                   475            478	; AFFECTS: A,F
                   476            479	;=======
                   477            480	 
                   478            481		GLOBAL	Z$SREG
                   479            482	 
                   480            483	Z$SREG
         0  01ae   481 e3         484		EX	(SP),HL		;PUSH HL, HL:=RETURN ADDRESS
         0  01af   482 f5         485		PUSH	AF
         0  01b0   483 3e ff      486		LD	A,0FFH		;IN RTZ !!
         0  01b2   484 32 8a 00   487		LD	(Z$STAT),A
         0  01b5   485 fb         488		EI
         0  01b6   486 c5         489		PUSH	BC
                   487            490	SREGDE
         0  01b7   488 d5         491		PUSH	DE
         0  01b8   489 dd e5      492		PUSH	IX
         0  01ba   490 fd e5      493		PUSH	IY
         0  01bc   491 e5         494		PUSH	HL			;PUSH RETURN ADDRESS
         0  01bd   492 21 02 00   495		LD	HL,2			;HL:=SP (RUNNING)
         0  01c0   493 39         496		ADD	HL,SP
         0  01c1   494 dd 2a 40   497		LD	IX,(Z$XQUE)	;IX:=^RUNNING PROCESS
                                             00      
         0  01c5   495 dd 75 08   498		LD	(IX+PCBSP),L	;SAVE SP IN PCB
         0  01c8   496 dd 74 09   499		LD	(IX+PCBSP+1),H
         0  01cb   497 21 0c 00   500		LD	HL,STCKHL+2	;RESTORE HL
         0  01ce   498 39         501		ADD	HL,SP
         0  01cf   499 7e         502		LD	A,(HL)
         0  01d0   500 23         503		INC	HL
         0  01d1   501 66         504		LD	H,(HL)
         0  01d2   502 6f         505		LD	L,A
         0  01d3   503 c9         506		RET
                   504            507	 
                   505            508	;=======
                   506            509	; Z$IDLE - IDLE PROCESS
                   507            510	;=======
                   508            511	 
                   509            512	Z$IDLE
         0  01d4   510 76         513		HALT
         0  01d5   511 18 fd      514		JR	Z$IDLE
                   512            515	 
                   513            516	;-------
                   514            517	; IDLIPC - IPCB OF IDLE PROCESS
                   515            518	;-------
                   516            519	 
                   517            520	IDLIPC
         0  01d7   518 5a 24      521		text	'Z$IDLE'
         0  01d9       49 44   
         0  01db       4c 45   
         0  01dd   519 d4 01      522		DEFW	Z$IDLE
         0  01df   520 32 00      523		DEFW	SZISTK		;STACK SIZE
         0  01e1   521 ff         524		DEFB	255			;PTY
                   522            525	 
                   523            526	;=======
                   524            527	; Z$TODQ - LINK TO TIME-QUEUE
                   525            528	;
                   526            529	; ACCEPTS: BC = ^PROC TO BE LINKED
                   527            530	;          DE = TIME-LIMIT
                   528            531	;
                   529            532	; WARNING! CY-flag assumed to be cleared after label

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
12

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
13

                   530            533	;          LINK.
                   531            534	;=======
                   532            535	 
                   533            536	Z$TODQ
         0  01e2   534 fd 21 40   537		LD	IY,Z$DQUE-PCBDLK
                                             00      
         0  01e6   535 2a 44 00   538		LD	HL,(Z$DQUE)	;CHECK IF ANY PROC IN Z$DQUE
         0  01e9   536 c5         539		PUSH	BC
         0  01ea   537 01 00 00   540		LD	BC,0			;INIT ACCUMULATED DELAY
                   538            541	TODQ10
         0  01ed   539 e5         542		PUSH	HL			;IX:=^Z$DQUE.CURRENT
         0  01ee   540 dd e1      543		POP	IX
         0  01f0   541 7d         544		LD	A,L
         0  01f1   542 b4         545		OR	H
         0  01f2   543 28 20      546		JR	Z,TODQ50		;NO PROC LEFT
         0  01f4   544 dd 6e 02   547		LD	L,(IX+PCBDLY)	;HL:=TIME-LIMIT (CURRENT)
         0  01f7   545 dd 66 03   548		LD	H,(IX+PCBDLY+1)
         0  01fa   546 09         549		ADD	HL,BC		;HL:=TIME-LIMIT (ACCUM.)
         0  01fb   547 ed 52      550		SBC	HL,DE		;HL:=TIME-LIMIT DIFFERENCE
         0  01fd   548 30 0f      551		JR	NC,TODQ20
         0  01ff   549 19         552		ADD	HL,DE		;RESTORE HL
         0  0200   550 4d         553		LD	C,L			;UPDATE ACCUMULATED DELAY
         0  0201   551 44         554		LD	B,H
         0  0202   552 dd 6e 04   555		LD	L,(IX+PCBDLK)	;HL:=^NEXT ITEM IN Z$DQUE
         0  0205   553 dd 66 05   556		LD	H,(IX+PCBDLK+1)
         0  0208   554 dd e5      557		PUSH	IX			;IY:=^PREDECESSOR
         0  020a   555 fd e1      558		POP	IY
         0  020c   556 18 df      559		JR	TODQ10
                   557            560	TODQ20
         0  020e   558 dd 75 02   561		LD	(IX+PCBDLY),L	;ADJUST DELAYTIME FOR ITEM
         0  0211   559 dd 74 03   562		LD	(IX+PCBDLY+1),H;  AFTER INSERTED
                   560            563	TODQ50
         0  0214   561 eb         564		EX	DE,HL		;HL:=TIME-LIMIT FOR INSERTED
         0  0215   562 ed 42      565		SBC	HL,BC		;CARRY IS ZERO !!
         0  0217   563 c1         566		POP	BC			;GET ^PROC TO BE LINKED
         0  0218   564 fd 71 04   567		LD	(IY+PCBDLK),C	;INSERT NEW ITEM (BC^)
         0  021b   565 fd 70 05   568		LD	(IY+PCBDLK+1),B
         0  021e   566 c5         569		PUSH	BC			;SWAP BC,IX
         0  021f   567 dd e5      570		PUSH	IX
         0  0221   568 c1         571		POP	BC
         0  0222   569 dd e1      572		POP	IX
         0  0224   570 dd 71 04   573		LD	(IX+PCBDLK),C	;^SUCCESSOR TO INSERTED
         0  0227   571 dd 70 05   574		LD	(IX+PCBDLK+1),B
         0  022a   572 dd 75 02   575		LD	(IX+PCBDLY),L	;SET DELAY FOR INSERTED
         0  022d   573 dd 74 03   576		LD	(IX+PCBDLY+1),H
         0  0230   574 dd cb 0b   577		SET	STTDLY,(IX+PCBSTT)
                                             de      
         0  0234   575 c9         578		RET
                   576            579	 
                   577            580	;=======
                   578            581	; Z$FRDQ - REMOVE (BC^) FROM DELAY-QUEUE
                   579            582	;
                   580            583	; ACCEPTS: BC = ^PROC TO BE REMOVED
                   581            584	;=======
                   582            585	 
                   583            586	Z$FRDQ
         0  0235   584 dd 21 40   587		LD	IX,Z$DQUE-PCBDLK
                                             00      

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
13

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
14

                   585            588	FRDQ10
         0  0239   586 dd 6e 04   589		LD	L,(IX+PCBDLK)	;HL:=^PROC IN Z$DQUE
         0  023c   587 dd 66 05   590		LD	H,(IX+PCBDLK+1)
         0  023f   588 a7         591		AND	A			;CLEAR CY
         0  0240   589 ed 42      592		SBC	HL,BC		;HL = ^PROC TO BE REM. ?
         0  0242   590 28 06      593		JR	Z,FRDQ20		;YES, REMOVE
         0  0244   591 09         594		ADD	HL,BC		;RESTORE HL
         0  0245   592 e5         595		PUSH	HL			;IX := HL
         0  0246   593 dd e1      596		POP	IX
         0  0248   594 18 ef      597		JR	FRDQ10
                   595            598	FRDQ20
         0  024a   596 c5         599		PUSH	BC			;IY:=^PROC TO BE REMOVED
         0  024b   597 fd e1      600		POP	IY
         0  024d   598 fd cb 0b   601		RES	STTDLY,(IY+PCBSTT)
                                             9e      
         0  0251   599 fd 6e 04   602		LD	L,(IY+PCBDLK)	;HL:=^PROC AFTER (BC^)
         0  0254   600 fd 66 05   603		LD	H,(IY+PCBDLK+1)
         0  0257   601 dd 75 04   604		LD	(IX+PCBDLK),L	;PROC.PCBDLK (BEFORE BC^)
         0  025a   602 dd 74 05   605		LD	(IX+PCBDLK+1),H;  := ^PROC AFTER (BC^)
         0  025d   603 7d         606		LD	A,L			;(BC^) LAST PROC IN Z$DQUE ?
         0  025e   604 b4         607		OR	H
         0  025f   605 c8         608		RET	Z			;YES
         0  0260   606 23         609		INC	HL			;NO, HL:=^PROC (BC^).TIME
         0  0261   607 23         610		INC	HL
         0  0262   608 7e         611		LD	A,(HL)		;FIX PCBDLY FOR (HL^)
         0  0263   609 fd 86 02   612		ADD	A,(IY+PCBDLY)
         0  0266   610 77         613		LD	(HL),A
         0  0267   611 23         614		INC	HL
         0  0268   612 7e         615		LD	A,(HL)
         0  0269   613 fd 8e 03   616		ADC	A,(IY+PCBDLY+1)
         0  026c   614 77         617		LD	(HL),A
         0  026d   615 c9         618		RET
                   616            619	 
                   617            620	;=======
                   618            621	; Z$ENQ - APPEND TO QUEUE
                   619            622	;
                   620            623	; ACCEPTS: HL = ^QUEUE-HEAD
                   621            624	;          DE = ^ITEM TO BE APPENDED
                   622            625	;
                   623            626	; AFFECTS: AF,HL
                   624            627	;=======
                   625            628	 
                   626            629		GLOBAL	Z$ENQ
                   627            630	 
                   628            631	Z$ENQ
         0  026e   629 7e         632		LD	A,(HL)
         0  026f   630 23         633		INC	HL
         0  0270   631 b6         634		OR	(HL)			;LAST ITEM ?
         0  0271   632 28 06      635		JR	Z,ENQ50		;YES, HL -> BC = 0
         0  0273   633 7e         636		LD	A,(HL)		;NO, HL:=^NEXT ITEM
         0  0274   634 2b         637		DEC	HL
         0  0275   635 6e         638		LD	L,(HL)
         0  0276   636 67         639		LD	H,A
         0  0277   637 18 f5      640		JR	Z$ENQ
                   638            641	ENQ50
         0  0279   639 72         642		LD	(HL),D		;FIX HL -> DE
         0  027a   640 2b         643		DEC	HL
         0  027b   641 73         644		LD	(HL),E

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
14

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
15

         0  027c   642 12         645		LD	(DE),A		;FIX DE -> 0
         0  027d   643 13         646		INC	DE
         0  027e   644 12         647		LD	(DE),A
         0  027f   645 1b         648		DEC	DE
         0  0280   646 c9         649		RET
                   647            650	 
                   648            651	;=======
                   649            652	; Z$TOXQ - LINK PROCESS TO EXECUTION QUEUE
                   650            653	;
                   651            654	; ACCEPTS: BC = ^PCB TO BE LINKED
                   652            655	;
                   653            656	; AFFECTS: A,BC,DE,HL,IX
                   654            657	;=======
                   655            658	 
                   656            659		GLOBAL	Z$TOXQ
                   657            660	 
                   658            661	Z$TOXQ
         0  0281   659 21 0a 00   662		LD	HL,PCBPTY		;HL:=^PROC.PTY (TO BE LINKED)
         0  0284   660 09         663		ADD	HL,BC
         0  0285   661 7e         664		LD	A,(HL)		;A:=PROC.PTY (TO BE LINKED)
         0  0286   662 21 40 00   665		LD	HL,Z$XQUE
         0  0289   663 dd 2a 40   666		LD	IX,(Z$XQUE)	;IX:=^XQUE.1ST
                                             00      
                   664            667	TOXQ50
         0  028d   665 dd be 0a   668		CP	(IX+PCBPTY)	;PROC.PTY ">" XQUE.CUR.PTY ?
         0  0290   666 38 0e      669		JR	C,TOXQ70		;YES
         0  0292   667 dd 5e 00   670		LD	E,(IX+PCBLNK)	;DE:=^XQUE.NXT
         0  0295   668 dd 56 01   671		LD	D,(IX+PCBLNK+1)
         0  0298   669 dd e5      672		PUSH	IX			;HL:=^XQUE.CUR
         0  029a   670 e1         673		POP	HL
         0  029b   671 d5         674		PUSH	DE			;IX:=^XQUE.NXT
         0  029c   672 dd e1      675		POP	IX
         0  029e   673 18 ed      676		JR	TOXQ50
                   674            677	TOXQ70
         0  02a0   675 71         678		LD	(HL),C		;INSERT BC^ BEFORE IX^
         0  02a1   676 23         679		INC	HL
         0  02a2   677 70         680		LD	(HL),B
         0  02a3   678 69         681		LD	L,C			;HL:=^PROC (INSERTED)
         0  02a4   679 60         682		LD	H,B
         0  02a5   680 dd e5      683		PUSH	IX			;BC:=^PROC AFTER INSERTED
         0  02a7   681 c1         684		POP	BC
         0  02a8   682 71         685		LD	(HL),C
         0  02a9   683 23         686		INC	HL
         0  02aa   684 70         687		LD	(HL),B
         0  02ab   685 c9         688		RET
                   686            689	 
                   687            690	;=======
                   688            691	; Z$FRXQ - REMOVE RUNNING PROCESS FROM EXECUTION QUEUE
                   689            692	;
                   690            693	; AFFECTS: A,HL
                   691            694	;=======
                   692            695	 
                   693            696		GLOBAL	Z$FRXQ
                   694            697	 
                   695            698	Z$FRXQ
         0  02ac   696 2a 40 00   699		LD	HL,(Z$XQUE)	;HL:=^XQUE.1ST
         0  02af   697 7e         700		LD	A,(HL)		;A:=^XQUE.2ND(LOWBYTE)
         0  02b0   698 32 40 00   701		LD	(Z$XQUE),A	;OLD 2ND:=NEW 1ST (LOWBYTE)

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
15

rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
16

         0  02b3   699 23         702		INC	HL
         0  02b4   700 7e         703		LD	A,(HL)		;A:=^XQUE.2ND(HIGHBYTE)
         0  02b5   701 32 41 00   704		LD	(Z$XQUE+1),A	;OLD 2ND:=NEW 1ST (HIGHBYTE)
         0  02b8   702 c9         705		RET
                   703            706	 
                   704            707	;=======
                   705            708	; Z_GETM - ALLOCATE MEMORY
                   706            709	;
                   707            710	; ACCEPTS: HL = # OF REQUESTED BYTES
                   708            711	;
                   709            712	; RETURNS: HL     =  ^ALLOCATED MEMORY (LOWEST ADDRESS)
                   710            713	;          Z_EOMF =  0 IF OK
                   711            714	;                 <> 0 IF END OF MEMORY
                   712            715	;=======
                   713            716	 
                   714            717		GLOBAL	Z_GETM
                   715            718		EXTERNAL	Z_HEAP
                   716            719	 
                   717            720	Z_GETM
         0  02b9   718 d5         721		PUSH	DE			;SAVE DE
         0  02ba   719 f3         722		DI
         0  02bb   720 ed 5b 00   723		LD	DE,(Z_HEAP)	;DE:=^FIRST FREE SPACE
                                             00      
         0  02bf   721 19         724		ADD	HL,DE		;ALLOCATE !
         0  02c0   722 22 00 00   725		LD	(Z_HEAP),HL
         0  02c3   723 fb         726		EI
         0  02c4   724 f5         727		PUSH	AF			;CHECK IF END OF MEMORY
         0  02c5   725 36 aa      728		LD	(HL),0AAH
         0  02c7   726 7e         729		LD	A,(HL)
         0  02c8   727 d6 aa      730		SUB	0AAH
         0  02ca   728 32 a8 00   731		LD	(Z_EOMF),A	;SET IF EOM
         0  02cd   729 f1         732		POP	AF
         0  02ce   730 eb         733		EX	DE,HL		;HL:=^ALLOCATED MEMEORY
         0  02cf   731 d1         734		POP	DE			;RESTORE DE
         0  02d0   732 c9         735		RET
                   733            736	 
                   734            737	;=======
                   735            738	; WAIBRK - CHECK IF DEBUGGER IS PRESENT
                   736            739	; SIGBRK
                   737            740	;
                   738            741	; AFFECTS: BC,AF
                   739            742	;=======
                   740            743	 
                   741            744	WAIBRK
         0  02d1   742 ed 4b af   745		LD	BC,(Z$WABP)
                                             00      
         0  02d5   743 18 04      746		JR	SIGB10
                   744            747	SIGBRK
         0  02d7   745 ed 4b ad   748		LD	BC,(Z$SIBP)
                                             00      
                   746            749	SIGB10
         0  02db   747 79         750		LD	A,C
         0  02dc   748 b0         751		OR	B
         0  02dd   749 c8         752		RET	Z
         0  02de   750 c5         753		PUSH	BC
         0  02df   751 c9         754		RET



rtz.s                    RTZ.SBR                                                   Tue Feb  7 17:21:34 1984
16

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
17

                   752            756	;UPDATED: 811129 / PH
                   753            757	;REV:     2.00
                   754            758	 
                   755            759	;=======
                   756            760	; Z_POLL
                   757            761	;
                   758            762	; ACCEPTS: DE = ^SEMAPHORE
                   759            763	; RETURNS: HL = ^MESSAGE IF ANY
                   760            764	;          HL = 0 IF NO MESSAGE AT SEMAPHORE
                   761            765	;=======
                   762            766	 
                   763            767	Z_POLL
         0  02e0   764 4b         768		LD	C,E			;BC:=^SEMAPHORE
         0  02e1   765 42         769		LD	B,D
         0  02e2   766 eb         770		EX	DE,HL		;DE:=^TIME-OUT
                   767            771	 
                   768            772	; CHECK IF THERE IS ANY MESSAGE AT SEM (BC^) BEFORE
                   769            773	 
         0  02e3   770 0a         774		LD	A,(BC)		;HL:=^MSGQUE.1ST
         0  02e4   771 6f         775		LD	L,A
         0  02e5   772 03         776		INC	BC
         0  02e6   773 0a         777		LD	A,(BC)
         0  02e7   774 67         778		LD	H,A
         0  02e8   775 b5         779		OR	L			;ANY MESSAGE AT SEM ?
         0  02e9   776 28 4e      780		JR	Z,RTZ250		;YES, RETURN WITH HL=0
         0  02eb   777 18 45      781		JR	RTZ200
                   778            782	 
                   779            783	;=======
                   780            784	; Z_EWAI - RTZ-CALL "EWAI"
                   781            785	;
                   782            786	; ACCEPTS: DE = ^SEMAPHORE
                   783            787	; RETURNS: HL = ^MESSAGE
                   784            788	;=======
                   785            789	 
                   786            790		GLOBAL	Z_EWAI
                   787            791	 
                   788            792	Z_EWAI
         0  02ed   789 cd ae 01   793		CALL	Z$SREG		;SAVE REGISTERS
         0  02f0   790 cd d1 02   794		CALL	WAIBRK
         0  02f3   791 dd 73 06   795		LD	(IX+PCBSEM),E	;UPDATE DEFAULT SEMAPHORE
         0  02f6   792 dd 72 07   796		LD	(IX+PCBSEM+1),D
         0  02f9   793 21 00 00   797		LD	HL,0			;WAIT FOR EVER IF NO MESSAGE
         0  02fc   794 18 10      798		JR	WAIT05
                   795            799	 
                   796            800	;=======
                   797            801	; Z_WAIT - RTZ-CALL "WAIT"
                   798            802	;
                   799            803	; ACCEPTS: DE = ^SEMAPHORE
                   800            804	;          HL = TIME-LIMIT
                   801            805	; RETURNS: HL = ^MESSAGE
                   802            806	;=======
                   803            807	 
                   804            808		GLOBAL	Z_WAIT
                   805            809	 
                   806            810	Z_WAIT
         0  02fe   807 cd ae 01   811		CALL	Z$SREG		;SAVE REGISTERS
         0  0301   808 cd d1 02   812		CALL	WAIBRK
         0  0304   809 dd 73 06   813		LD	(IX+PCBSEM),E	;UPDATE DEFAULT SEMAPHORE

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
17

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
18

         0  0307   810 dd 72 07   814		LD	(IX+PCBSEM+1),D
         0  030a   811 7d         815		LD	A,L			;CHECK IF A POLL REQUEST
         0  030b   812 b4         816		OR	H
         0  030c   813 28 d2      817		JR	Z,Z_POLL
                   814            818	WAIT05
         0  030e   815 4b         819		LD	C,E			;BC:=^SEMAPHORE
         0  030f   816 42         820		LD	B,D
         0  0310   817 eb         821		EX	DE,HL		;DE:=^TIME-OUT
                   818            822	 
                   819            823	; CHECK IF THERE IS ANY MESSAGE AT SEM (BC^) BEFORE
                   820            824	 
         0  0311   821 0a         825		LD	A,(BC)		;HL:=^MGQ.1ST
         0  0312   822 6f         826		LD	L,A
         0  0313   823 03         827		INC	BC
         0  0314   824 0a         828		LD	A,(BC)
         0  0315   825 67         829		LD	H,A
         0  0316   826 b5         830		OR	L			;ANY MESSAGE AT SEM ?
         0  0317   827 20 19      831		JR	NZ,RTZ200		;YES
                   828            832	 
                   829            833	; LINK PROCESS TO SEMAPHORE
                   830            834	 
         0  0319   831 03         835		INC	BC			;BC:=^SEM.PRQ
         0  031a   832 c5         836		PUSH	BC
         0  031b   833 ed 4b 40   837		LD	BC,(Z$XQUE)	;BC:=^PROC(RUNNING)
                                             00      
         0  031f   834 cd ac 02   838		CALL	Z$FRXQ		;REMOVE PROC(RUNNING)
         0  0322   835 e1         839		POP	HL			;HL:=^SEM.PRQ
         0  0323   836 d5         840		PUSH	DE			;SAVE TIME-LIMIT
         0  0324   837 59         841		LD	E,C			;DE:=PROC(RUNNING)
         0  0325   838 50         842		LD	D,B
         0  0326   839 cd 6e 02   843		CALL	Z$ENQ
         0  0329   840 d1         844		POP	DE
         0  032a   841 7b         845		LD	A,E			;CHECK IF TIMED WAIT
         0  032b   842 b2         846		OR	D
         0  032c   843 c4 e2 01   847		CALL	NZ,Z$TODQ		;YES. LINK TO DELAY-QUEUE
         0  032f   844 c3 6d 01   848		JP	Z$SCED
                   845            849	 
                   846            850	; REMOVE MESSAGE FROM SEMAPHORE AND GIVE IT TO
                   847            851	; RUNNING PROCESS
                   848            852	; BC = ^SEM.MGQ+1
                   849            853	; HL = ^MGQ.1ST
                   850            854	 
                   851            855	RTZ200
         0  0332   852 23         856		INC	HL			;HL:=^MGQ.1ST+1
         0  0333   853 7e         857		LD	A,(HL)		;SEM.MGQ:=^MGQ.2ND
         0  0334   854 02         858		LD	(BC),A
         0  0335   855 2b         859		DEC	HL
         0  0336   856 0b         860		DEC	BC
         0  0337   857 7e         861		LD	A,(HL)
         0  0338   858 02         862		LD	(BC),A
                   859            863	RTZ250
         0  0339   860 dd 4e 08   864		LD	C,(IX+PCBSP)	;BC:=SP(RUNNING)
         0  033c   861 dd 46 09   865		LD	B,(IX+PCBSP+1)
         0  033f   862 c5         866		PUSH	BC			;IX:=SP(RUNNING)
         0  0340   863 dd e1      867		POP	IX
         0  0342   864 dd 75 0a   868		LD	(IX+STCKHL),L	;HL IN STACK:=^MESSAGE
         0  0345   865 dd 74 0b   869		LD	(IX+STCKHL+1),H
         0  0348   866 23         870		INC	HL			;HL:=^OPCODE-FIELD

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
18

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
19

         0  0349   867 23         871		INC	HL
         0  034a   868 23         872		INC	HL
         0  034b   869 7e         873		LD	A,(HL)		;SET A AND FLAGS
         0  034c   870 b7         874		OR	A
         0  034d   871 f5         875		PUSH	AF
         0  034e   872 e1         876		POP	HL
         0  034f   873 dd 75 08   877		LD	(IX+STCKAF),L
         0  0352   874 dd 74 09   878		LD	(IX+STCKAF+1),H
         0  0355   875 c3 6d 01   879		JP	Z$SCED
                   876            880	 
                   877            881	;=======
                   878            882	; Z_SGNL - RTZ-CALL "SIGNAL"
                   879            883	;
                   880            884	; ACCEPTS: DE = ^SEM
                   881            885	;          HL = ^MSG
                   882            886	;=======
                   883            887	 
                   884            888		GLOBAL	Z_SGNL
                   885            889	 
                   886            890	Z_SGNL
         0  0358   887 cd ae 01   891		CALL	Z$SREG		;SAVE REGISTERS
         0  035b   888 cd d7 02   892		CALL	SIGBRK
                   889            893	 
                   890            894	; CHECK IF THERE IS ANY PROCESS AT SEM (DE^) BEFORE
                   891            895	 
         0  035e   892 d5         896		PUSH	DE			;PUSH ^SEM.MGQ
         0  035f   893 13         897		INC	DE			;HL:=^SEM.PRQ
         0  0360   894 13         898		INC	DE
         0  0361   895 eb         899		EX	DE,HL		;DE:=^MESSAGE
         0  0362   896 7e         900		LD	A,(HL)		;HL:=^PRQ.1ST
         0  0363   897 23         901		INC	HL
         0  0364   898 66         902		LD	H,(HL)
         0  0365   899 6f         903		LD	L,A
         0  0366   900 b4         904		OR	H			;ANY PROCESS AT SEM ?
         0  0367   901 20 07      905		JR	NZ,RTZ400		;YES
                   902            906	 
                   903            907	; LINK MESSAGE TO SEMAPHORE
                   904            908	 
         0  0369   905 e1         909		POP	HL			;HL:=^SEM.MGQ
         0  036a   906 cd 6e 02   910		CALL	Z$ENQ
         0  036d   907 c3 6d 01   911		JP	Z$SCED		;  AND DISPATCH
                   908            912	 
                   909            913	; REMOVE PROCESS FROM SEMAPHORE WITH MESSAGE
                   910            914	; DE = ^MESSAGE
                   911            915	; HL = ^PRQ.1ST (^PROCESS TO BE REMOVED)
                   912            916	; TS = ^SEMAPHORE
                   913            917	 
                   914            918	RTZ400
         0  0370   915 c1         919		POP	BC			;BC:=^SEM.PRQ
         0  0371   916 03         920		INC	BC
         0  0372   917 03         921		INC	BC
         0  0373   918 7e         922		LD	A,(HL)		;SEM.PRQ:=^WQUE.2ND
         0  0374   919 02         923		LD	(BC),A
         0  0375   920 23         924		INC	HL
         0  0376   921 03         925		INC	BC
         0  0377   922 7e         926		LD	A,(HL)
         0  0378   923 02         927		LD	(BC),A
         0  0379   924 2b         928		DEC	HL

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
19

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
20

         0  037a   925 4d         929		LD	C,L			;BC:=^PROC(REMOVED)
         0  037b   926 44         930		LD	B,H
         0  037c   927 e5         931		PUSH	HL			;IX:=^PROC(REMOVED)
         0  037d   928 dd e1      932		POP	IX
         0  037f   929 dd 6e 08   933		LD	L,(IX+PCBSP)	;HL:=SP(REMOVED)
         0  0382   930 dd 66 09   934		LD	H,(IX+PCBSP+1)
         0  0385   931 e5         935		PUSH	HL			;IY:=SP(REMOVED)
         0  0386   932 fd e1      936		POP	IY
         0  0388   933 fd 73 0a   937		LD	(IY+STCKHL),E	;HL IN STACK:=^MESSAGE
         0  038b   934 fd 72 0b   938		LD	(IY+STCKHL+1),D
         0  038e   935 13         939		INC	DE			;DE:=^OPCODE-FIELD
         0  038f   936 13         940		INC	DE
         0  0390   937 13         941		INC	DE
         0  0391   938 1a         942		LD	A,(DE)		;SET A AND FLAGS
         0  0392   939 b7         943		OR	A
         0  0393   940 f5         944		PUSH	AF
         0  0394   941 e1         945		POP	HL
         0  0395   942 fd 75 08   946		LD	(IY+STCKAF),L
         0  0398   943 fd 74 09   947		LD	(IY+STCKAF+1),H
         0  039b   944 dd cb 0b   948		BIT	STTDLY,(IX+PCBSTT);IS REM. PROC IN DELAYQUE ?
                                             5e      
         0  039f   945 c4 35 02   949		CALL	NZ,Z$FRDQ		;YES, REMOVE IT
         0  03a2   946 cd 81 02   950		CALL	Z$TOXQ		;LINK IT TO Z$XQUE
         0  03a5   947 c3 6d 01   951		JP	Z$SCED		;  AND DISPATCH
                   948            952	 
                   949            953	;=======
                   950            954	; Z_LDCW - RTZ-CALL "LOAD CONTROL WORD FOR Z-80 --
                   951            955	;                    DEVICE"
                   952            956	;
                   953            957	; ACCEPTS: DE = ^CONTROL VECTOR
                   954            958	;=======
                   955            959	 
                   956            960		GLOBAL	Z_LDCW
                   957            961	 
                   958            962	Z_LDCW
         0  03a8   959 f5         963		PUSH	AF
         0  03a9   960 c5         964		PUSH	BC
         0  03aa   961 e5         965		PUSH	HL
         0  03ab   962 eb         966		EX	DE,HL
         0  03ac   963 4e         967		LD	C,(HL)		;C:=PORT ADDRESS
         0  03ad   964 23         968		INC	HL
         0  03ae   965 46         969		LD	B,(HL)		;B:=# OF CONTROL BYTES
         0  03af   966 23         970		INC	HL
         0  03b0   967 f3         971		DI
         0  03b1   968 ed b3      972		OTIR
         0  03b3   969 fb         973		EI
         0  03b4   970 eb         974		EX	DE,HL
         0  03b5   971 e1         975		POP	HL
         0  03b6   972 c1         976		POP	BC
         0  03b7   973 f1         977		POP	AF
         0  03b8   974 c9         978		RET
                   975            979	 
                   976            980	;=======
                   977            981	; Z_SEVC - SET VECTOR FOR DIRECT INTERRUPT
                   978            982	;
                   979            983	; ACCEPTS: DE = INTERRUPT LEVEL
                   980            984	;          HL = INTERRUPT VECTOR
                   981            985	;=======

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
20

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
21

                   982            986	 
                   983            987		GLOBAL	Z_SEVC
                   984            988	 
                   985            989	Z_SEVC
         0  03b9   986 c5         990		PUSH	BC
         0  03ba   987 e5         991		PUSH	HL
         0  03bb   988 4d         992		LD	C,L			;BC:=^SERVICE ROUTINE
         0  03bc   989 44         993		LD	B,H
         0  03bd   990 21 00 00   994		LD	HL,Z_00VC
         0  03c0   991 19         995		ADD	HL,DE		;HL:=^LOCATION OF I-VECTOR
         0  03c1   992 19         996		ADD	HL,DE
         0  03c2   993 f3         997		DI
         0  03c3   994 71         998		LD	(HL),C		;LOAD I-VECTOR
         0  03c4   995 23         999		INC	HL
         0  03c5   996 70        1000		LD	(HL),B
         0  03c6   997 fb        1001		EI
         0  03c7   998 e1        1002		POP	HL
         0  03c8   999 c1        1003		POP	BC
         0  03c9  1000 c9        1004		RET
                  1001           1005	 
                  1002           1006	;=======
                  1003           1007	; Z_SPTY - SET PROCESS PRIORITY
                  1004           1008	;
                  1005           1009	; ACCEPTS: DE = ^PCB
                  1006           1010	;           L = NEW PRIORITY
                  1007           1011	;=======
                  1008           1012	 
                  1009           1013		GLOBAL	Z_SPTY
                  1010           1014	 
                  1011           1015	Z_SPTY
         0  03ca  1012 cd ae 01  1016		CALL	Z$SREG
         0  03cd  1013 4b        1017		LD	C,E			;BC:=^PCB
         0  03ce  1014 42        1018		LD	B,D
         0  03cf  1015 e5        1019		PUSH	HL
         0  03d0  1016 cd ac 02  1020		CALL	Z$FRXQ		;REMOVE FROM XQUE
         0  03d3  1017 e1        1021		POP	HL
         0  03d4  1018 dd 75 0a  1022		LD	(IX+PCBPTY),L	;LOAD NEW PRIORITY
         0  03d7  1019 cd 81 02  1023		CALL	Z$TOXQ		;INSERT IN XQUE AGAIN
         0  03da  1020 c3 6d 01  1024		JP	Z$SCED
                  1021           1025	 
                  1022           1026	;=======
                  1023           1027	; Z_CPRO - CREATE PROCESS
                  1024           1028	;
                  1025           1029	; ACCEPTS: DE = ^INITIAL PROCESS CONTROL BLOCK
                  1026           1030	;=======
                  1027           1031	 
                  1028           1032		GLOBAL	Z_CPRO
                  1029           1033	 
                  1030           1034	Z_CPRO
         0  03dd  1031 cd ae 01  1035		CALL	Z$SREG
         0  03e0  1032 d5        1036		PUSH	DE			;IX:=^IPCB
         0  03e1  1033 dd e1     1037		POP	IX
         0  03e3  1034 cd e6 00  1038		CALL	INIPCB
         0  03e6  1035 cd 81 02  1039		CALL	Z$TOXQ		;LINK BC^ TO XQUE
         0  03e9  1036 c3 6d 01  1040		JP	Z$SCED
                  1037           1041	 
                  1038           1042	;=======
                  1039           1043	; Z_CSEM - CREATE SEMAPHORE

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
21

rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
22

                  1040           1044	;
                  1041           1045	; ACCEPTS: DE = ^SEMAPHORE
                  1042           1046	;=======
                  1043           1047	 
                  1044           1048		GLOBAL	Z_CSEM
                  1045           1049	 
                  1046           1050	Z_CSEM
         0  03ec  1047 cd ae 01  1051		CALL	Z$SREG
         0  03ef  1048 eb        1052		EX	DE,HL		;HL:=^SEMAPHORE
         0  03f0  1049 cd 56 01  1053		CALL	INISEM
         0  03f3  1050 c3 6d 01  1054		JP	Z$SCED
















































rtz.s                    RTZ.CALLS                                                 Tue Feb  7 17:21:34 1984
22

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
23

                  1051           1056	;UPDATED: 820120 / PH
                  1052           1057	;REV:     2.00
                  1053           1058	 
                  1054           1059	;=======
                  1055           1060	; SYSRPT - SYSTEM CLOCK INTERRUPT
                  1056           1061	;=======
                  1057           1062	 
                  1058           1063	SYSRPT
         0  03f6  1059 f5        1064		PUSH	AF			;SAVE AF
         0  03f7  1060 3a 8a 00  1065		LD	A,(Z$STAT)
         0  03fa  1061 b7        1066		OR	A			;IN RTZ ?
         0  03fb  1062 3e ff     1067		LD	A,-1			;A:=INTERRUPT #SYS
         0  03fd  1063 c2 ec 04  1068		JP	NZ,R00R55		;YES
         0  0400  1064 f1        1069		POP	AF			;NO, JUST GO ON
         0  0401  1065 cd ae 01  1070		CALL	Z$SREG
                  1066           1071	 
                  1067           1072	; HANDLE TIME-SLICING IF ANY
                  1068           1073	 
                  1069           1074	SYSCLK
         0  0404  1070 3a a9 00  1075		LD	A,(Z_SLCF)
         0  0407  1071 b7        1076		OR	A			;SLICE ENABLED ?
         0  0408  1072 28 1c     1077		JR	Z,NOSLIC		;NO
         0  040a  1073 3a ac 00  1078		LD	A,(Z_SLCP)	;A:=SLICE PRIORITY
         0  040d  1074 dd be 0a  1079		CP	(IX+PCBPTY)	;RUNNING PROC.ON SLICE PTY ?
         0  0410  1075 20 14     1080		JR	NZ,NOSLIC		;NO
         0  0412  1076 21 aa 00  1081		LD	HL,Z$SLCC		;YES, HL:=^SLICE-COUNT
         0  0415  1077 34        1082		INC	(HL)
         0  0416  1078 3a ab 00  1083		LD	A,(Z_SLCT)	;A:=SLICE TIME
         0  0419  1079 96        1084		SUB	(HL)			;TIME FOR SLICE ?
         0  041a  1080 20 0a     1085		JR	NZ,NOSLIC		;NO
         0  041c  1081 77        1086		LD	(HL),A		;YES, RESET SLICE-COUNTER
         0  041d  1082 cd ac 02  1087		CALL	Z$FRXQ		;YES, REMOVE AND
         0  0420  1083 dd e5     1088		PUSH	IX			;  INSERT
         0  0422  1084 c1        1089		POP	BC			;BC:=IX
         0  0423  1085 cd 81 02  1090		CALL	Z$TOXQ
                  1086           1091	NOSLIC
                  1087           1092	 
                  1088           1093	; HANDLE SYSTEM TICK
                  1089           1094	 
         0  0426  1090 2a 44 00  1095		LD	HL,(Z$DQUE)	;HL:=^DQUE.1ST
         0  0429  1091 7d        1096		LD	A,L			;DELAY-QUEUE EMPTY ?
         0  042a  1092 b4        1097		OR	H
         0  042b  1093 ca 6d 01  1098		JP	Z,Z$SCED		;YES, DISPATCH
         0  042e  1094 23        1099		INC	HL			;NO
         0  042f  1095 23        1100		INC	HL			;HL:=^TIME-LIMIT OF 1ST
         0  0430  1096 5e        1101		LD	E,(HL)		;DE:=TIME-LIMIT
         0  0431  1097 23        1102		INC	HL
         0  0432  1098 56        1103		LD	D,(HL)
         0  0433  1099 1b        1104		DEC	DE			;ONE TICK !!
         0  0434  1100 7b        1105		LD	A,E			;TIME OUT ?
         0  0435  1101 b2        1106		OR	D
         0  0436  1102 72        1107		LD	(HL),D		;STORE DECREASED TIME-LIMIT
         0  0437  1103 2b        1108		DEC	HL
         0  0438  1104 73        1109		LD	(HL),E
         0  0439  1105 c2 6d 01  1110		JP	NZ,Z$SCED		;NO TIME-OUT, DISPATCH
         0  043c  1106 23        1111		INC	HL
                  1107           1112	 
                  1108           1113	; REMOVE PROCESS FROM DELAY QUEUE (TIME-OUT)

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
23

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
24

                  1109           1114	 
                  1110           1115	SYSR10
         0  043d  1111 23        1116		INC	HL			;HL:=^DLINK OF 1ST
         0  043e  1112 5e        1117		LD	E,(HL)		;DE:=^DQUE.2ND
         0  043f  1113 23        1118		INC	HL
         0  0440  1114 56        1119		LD	D,(HL)
         0  0441  1115 ed 4b 44  1120		LD	BC,(Z$DQUE)	;BC:=^PROC(REM.FROM Z_DQUE)
                                             00      
         0  0445  1116 ed 53 44  1121		LD	(Z$DQUE),DE
                                             00      
         0  0449  1117 c5        1122		PUSH	BC			;IX:=^PROC
         0  044a  1118 dd e1     1123		POP	IX
         0  044c  1119 dd cb 0b  1124		RES	STTDLY,(IX+PCBSTT)
                                             9e      
                  1120           1125	 
                  1121           1126	; REMOVE PROCESS (BC^ = IX^) FROM SEMAPHORE TOO
                  1122           1127	 
         0  0450  1123 dd 6e 06  1128		LD	L,(IX+PCBSEM)	;HL:=^SEM
         0  0453  1124 dd 66 07  1129		LD	H,(IX+PCBSEM+1)
         0  0456  1125 23        1130		INC	HL			;HL:=^SEMPRQ.1ST
         0  0457  1126 23        1131		INC	HL
                  1127           1132	SYSR20  ;FIND PROCESS (TO BE REMOVED) IN SEMPRQ
         0  0458  1128 5e        1133		LD	E,(HL)		;DE:=^PROC.NEXT
         0  0459  1129 23        1134		INC	HL
         0  045a  1130 56        1135		LD	D,(HL)
         0  045b  1131 eb        1136		EX	DE,HL		;HL:=^PROC.NEXT,DE:=^SEMPRQ.1ST+1
         0  045c  1132 a7        1137		AND	A			;CLEAR CY
         0  045d  1133 ed 42     1138		SBC	HL,BC		;WANTED PROCESS ?
         0  045f  1134 28 03     1139		JR	Z,SYSR50		;YES
         0  0461  1135 09        1140		ADD	HL,BC		;NO, RESTORE HL
         0  0462  1136 18 f4     1141		JR	SYSR20
                  1137           1142	SYSR50				;(DE) -> (BC) -> (HL)
         0  0464  1138 03        1143		INC	BC			;BC:=^PROC+1
         0  0465  1139 0a        1144		LD	A,(BC)		;(DE) -> (HL)  HIGHBYTE
         0  0466  1140 12        1145		LD	(DE),A
         0  0467  1141 0b        1146		DEC	BC
         0  0468  1142 1b        1147		DEC	DE
         0  0469  1143 0a        1148		LD	A,(BC)		;(DE) -> (HL) LOWBYTE
         0  046a  1144 12        1149		LD	(DE),A
                  1145           1150	 
                  1146           1151	; LINK TIME-OUT MESSAGE TO PROCESS (BC^ = IX^)
                  1147           1152	 
         0  046b  1148 dd 6e 08  1153		LD	L,(IX+PCBSP)	;HL:=SP (PROC TO BE REMOVED)
         0  046e  1149 dd 66 09  1154		LD	H,(IX+PCBSP+1)
         0  0471  1150 e5        1155		PUSH	HL			;IX:=SP (PROC TO BE REMOVED)
         0  0472  1151 dd e1     1156		POP	IX
         0  0474  1152 21 9d 04  1157		LD	HL,TOUTMG		;HL:=^TIME-OUT MESSAGE
         0  0477  1153 dd 75 0a  1158		LD	(IX+STCKHL),L	;HL IN STACK:=^MESSAGE
         0  047a  1154 dd 74 0b  1159		LD	(IX+STCKHL+1),H
         0  047d  1155 3e 80     1160		LD	A,ZRCTO		;A:=TIME-OUT RETURN CODE
         0  047f  1156 b7        1161		OR	A
         0  0480  1157 f5        1162		PUSH	AF
         0  0481  1158 e1        1163		POP	HL
         0  0482  1159 dd 75 08  1164		LD	(IX+STCKAF),L
         0  0485  1160 dd 74 09  1165		LD	(IX+STCKAF+1),H
                  1161           1166	 
         0  0488  1162 cd 81 02  1167		CALL	Z$TOXQ		;LINK TO EXECUTION QUEUE
         0  048b  1163 2a 44 00  1168		LD	HL,(Z$DQUE)	;HL:=^DQUE.1ST

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
24

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
25

         0  048e  1164 7d        1169		LD	A,L			;DELAY-QUEUE EMPTY ?
         0  048f  1165 b4        1170		OR	H
         0  0490  1166 ca 6d 01  1171		JP	Z,Z$SCED		;YES, DISPATCH
                  1167           1172	 
         0  0493  1168 23        1173		INC	HL			;NO
         0  0494  1169 23        1174		INC	HL			;HL:=^TIME-LIMIT OF 1ST
         0  0495  1170 7e        1175		LD	A,(HL)		;CHECK IF ANOTHER TIME-OUT
         0  0496  1171 23        1176		INC	HL
         0  0497  1172 b6        1177		OR	(HL)
         0  0498  1173 c2 6d 01  1178		JP	NZ,Z$SCED		;NO, DISPATCH
         0  049b  1174 18 a0     1179		JR	SYSR10		;YES
                  1175           1180	 
                  1176           1181	;-------
                  1177           1182	; TOUTMG - TIME-OUT MESSAGE
                  1178           1183	;-------
                  1179           1184	 
                  1180           1185	TOUTMG
         0  049d  1181 00 00     1186		DEFW	0			;NO LINK
         0  049f  1182 00        1187		DEFB	0			;NO REQUEST CODE
         0  04a0  1183 80        1188		DEFB	ZRCTO		;TIME-OUT
         0  04a1  1184 06 00     1189		DEFW	6			;6 BYTES
                  1185           1190	 
                  1186           1191	;=======
                  1187           1192	; R00RPT - SYSTEM CTC0 INTERRUPT
                  1188           1193	;=======
                  1189           1194	 
                  1190           1195		EXTERNAL	Z_00SM
                  1191           1196	 
                  1192           1197	R00RPT
         0  04a3  1193 f5        1198		PUSH	AF			;SAVE AF
         0  04a4  1194 3a 8a 00  1199		LD	A,(Z$STAT)
         0  04a7  1195 b7        1200		OR	A			;IN RTZ ?
         0  04a8  1196 20 41     1201		JR	NZ,R00R50		;YES
         0  04aa  1197 f1        1202		POP	AF			;NO, RESTORE AF
         0  04ab  1198 cd ae 01  1203		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  04ae  1199 dd 21 00  1204		LD	IX,Z_00SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
                  1200           1205	R00R05
         0  04b2  1201 dd 36 09  1206		LD	(IX+SEMIMG+MSGRC),ZRCINT;ASSUME NO MISSED RUPT
                                             00      
         0  04b6  1202 dd 6e 02  1207		LD	L,(IX+SEMPRQ)	;HL:=^SEMPRQ.1ST
         0  04b9  1203 dd 66 03  1208		LD	H,(IX+SEMPRQ+1)
         0  04bc  1204 7d        1209		LD	A,L
         0  04bd  1205 b4        1210		OR	H			;ANY PROCESS AT SEM ?
         0  04be  1206 20 1e     1211		JR	NZ,R00R20		;YES
                  1207           1212	 
                  1208           1213	; LINK INTERRUPT-MESSAGE TO SEMAPHORE
                  1209           1214	 
         0  04c0  1210 dd 7e 00  1215		LD	A,(IX+SEMMGQ)	;ANY MSG HERE BEFORE ?
         0  04c3  1211 dd b6 01  1216		OR	(IX+SEMMGQ+1)
         0  04c6  1212 28 07     1217		JR	Z,R00R10		;NO
         0  04c8  1213 dd 36 09  1218		LD	(IX+SEMIMG+MSGRC),ZRCMIS;YES, MISSED RUPT
                                             44      
         0  04cc  1214 c3 6d 01  1219		JP	Z$SCED
                  1215           1220	R00R10
         0  04cf  1216 dd e5     1221		PUSH	IX			;HL:=^INTERRUPT SEMAPHORE
         0  04d1  1217 e1        1222		POP	HL
         0  04d2  1218 3e 06     1223		LD	A,SEMIMG		;MESSAGE TO SEMAPHORE

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
25

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
26

         0  04d4  1219 85        1224		ADD	A,L
         0  04d5  1220 77        1225		LD	(HL),A
         0  04d6  1221 3e 00     1226		LD	A,0
         0  04d8  1222 8c        1227		ADC	A,H
         0  04d9  1223 23        1228		INC	HL
         0  04da  1224 77        1229		LD	(HL),A
         0  04db  1225 c3 6d 01  1230		JP	Z$SCED
                  1226           1231	 
                  1227           1232	; REMOVE PROCESS FROM SEMAPHORE "IX^"
                  1228           1233	 
                  1229           1234	R00R20
         0  04de  1230 dd e5     1235		PUSH	IX			;TS:=^SEM
         0  04e0  1231 01 06 00  1236		LD	BC,SEMIMG		;PREP FOR RTZ400
         0  04e3  1232 dd 09     1237		ADD	IX,BC
         0  04e5  1233 dd e5     1238		PUSH	IX
         0  04e7  1234 d1        1239		POP	DE			;DE:=IX+SEMIMG
         0  04e8  1235 c3 70 03  1240		JP	RTZ400
                  1236           1241	 
                  1237           1242	; ALREADY IN RTZ !!
                  1238           1243	 
                  1239           1244	R00R50
         0  04eb  1240 af        1245		XOR	A			;INTERRUPT LEVEL #0
                  1241           1246	R00R55
         0  04ec  1242 e5        1247		PUSH	HL			;SAVE HL ALSO
         0  04ed  1243 f5        1248		PUSH	AF			;SAVE LEVEL #
         0  04ee  1244 21 8b 00  1249		LD	HL,Z$ICNT
         0  04f1  1245 7e        1250		LD	A,(HL)
         0  04f2  1246 fe 15     1251		CP	21			;MORE THAN 20 PENDING RUPTS ?
         0  04f4  1247 30 0d     1252		JR	NC,R00R57		;YES, SKIP THIS ONE
         0  04f6  1248 34        1253		INC	(HL)			;NO, ONE MORE RUPT PENDING
         0  04f7  1249 21 8c 00  1254		LD	HL,Z$ISTK		;HL:=^STACK OF PENDING RUPTS
         0  04fa  1250 85        1255		ADD	A,L
         0  04fb  1251 6f        1256		LD	L,A
         0  04fc  1252 30 01     1257		JR	NC,R00R56
         0  04fe  1253 24        1258		INC	H
                  1254           1259	R00R56
         0  04ff  1255 f1        1260		POP	AF
         0  0500  1256 77        1261		LD	(HL),A
         0  0501  1257 18 01     1262		JR	R00R58
                  1258           1263	R00R57
         0  0503  1259 f1        1264		POP	AF
                  1260           1265	R00R58
         0  0504  1261 e1        1266		POP	HL
         0  0505  1262 f1        1267		POP	AF
         0  0506  1263 fb        1268		EI
         0  0507  1264 ed 4d     1269		RETI
                  1265           1270	 
                  1266           1271	;=======
                  1267           1272	; R01RPT - SYSTEM CTC1 INTERRUPT
                  1268           1273	;=======
                  1269           1274	 
                  1270           1275		EXTERNAL	Z_01SM
                  1271           1276	 
                  1272           1277	R01RPT
         0  0509  1273 f5        1278		PUSH	AF			;SAVE AF
         0  050a  1274 3a 8a 00  1279		LD	A,(Z$STAT)
         0  050d  1275 b7        1280		OR	A			;IN RTZ ?
         0  050e  1276 3e 01     1281		LD	A,1			;  INTERRUPT LEVEL #1

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
26

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
27

         0  0510  1277 c2 ec 04  1282		JP	NZ,R00R55		;YES
         0  0513  1278 f1        1283		POP	AF			;NO, RESTORE AF
         0  0514  1279 cd ae 01  1284		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0517  1280 dd 21 00  1285		LD	IX,Z_01SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  051b  1281 c3 b2 04  1286		JP	R00R05
                  1282 00 15     1287	RPTSIZ	EQU	$-R01RPT
                  1283           1288	 
                  1284           1289	;=======
                  1285           1290	; R02RPT - SYSTEM CTC2 INTERRUPT
                  1286           1291	;=======
                  1287           1292	 
                  1288           1293		EXTERNAL	Z_02SM
                  1289           1294	 
                  1290           1295	R02RPT
         0  051e  1291 f5        1296		PUSH	AF			;SAVE AF
         0  051f  1292 3a 8a 00  1297		LD	A,(Z$STAT)
         0  0522  1293 b7        1298		OR	A			;IN RTZ ?
         0  0523  1294 3e 02     1299		LD	A,2			;  INTERRUPT LEVEL #2
         0  0525  1295 c2 ec 04  1300		JP	NZ,R00R55		;YES
         0  0528  1296 f1        1301		POP	AF			;NO, RESTORE AF
         0  0529  1297 cd ae 01  1302		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  052c  1298 dd 21 00  1303		LD	IX,Z_02SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0530  1299 c3 b2 04  1304		JP	R00R05
                  1300           1305	 
                  1301           1306	;=======
                  1302           1307	; R03RPT - SYSTEM CTC3 INTERRUPT
                  1303           1308	;=======
                  1304           1309	 
                  1305           1310		EXTERNAL	Z_03SM
                  1306           1311	 
                  1307           1312	R03RPT
         0  0533  1308 f5        1313		PUSH	AF			;SAVE AF
         0  0534  1309 3a 8a 00  1314		LD	A,(Z$STAT)
         0  0537  1310 b7        1315		OR	A			;IN RTZ ?
         0  0538  1311 3e 03     1316		LD	A,3			;  INTERRUPT LEVEL #3
         0  053a  1312 c2 ec 04  1317		JP	NZ,R00R55		;YES
         0  053d  1313 f1        1318		POP	AF			;NO, RESTORE AF
         0  053e  1314 cd ae 01  1319		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0541  1315 dd 21 00  1320		LD	IX,Z_03SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0545  1316 c3 b2 04  1321		JP	R00R05
                  1317           1322	 
                  1318           1323		if	RTZSIZ>4
                  1319           1324	 
                  1320           1325	;=======
                  1321           1326	; R04RPT - SYSTEM LEVEL 4 INTERRUPT
                  1322           1327	;=======
                  1323           1328	 
                  1324           1329		EXTERNAL	Z_04SM
                  1325           1330	 
                  1326           1331	R04RPT
         0  0548  1327 f5        1332		PUSH	AF			;SAVE AF
         0  0549  1328 3a 8a 00  1333		LD	A,(Z$STAT)
         0  054c  1329 b7        1334		OR	A			;IN RTZ ?
         0  054d  1330 3e 04     1335		LD	A,4			;  A:=INTERRUPT #4
         0  054f  1331 c2 ec 04  1336		JP	NZ,R00R55		;YES

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
27

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
28

         0  0552  1332 f1        1337		POP	AF			;NO, RESTORE AF
         0  0553  1333 cd ae 01  1338		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0556  1334 dd 21 00  1339		LD	IX,Z_04SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  055a  1335 c3 b2 04  1340		JP	R00R05
                  1336           1341	 
                  1337           1342	;=======
                  1338           1343	; R05RPT - SYSTEM LEVEL 5 INTERRUPT
                  1339           1344	;=======
                  1340           1345	 
                  1341           1346		EXTERNAL	Z_05SM
                  1342           1347	 
                  1343           1348	R05RPT
         0  055d  1344 f5        1349		PUSH	AF			;SAVE AF
         0  055e  1345 3a 8a 00  1350		LD	A,(Z$STAT)
         0  0561  1346 b7        1351		OR	A			;IN RTZ ?
         0  0562  1347 3e 05     1352		LD	A,5			;  INTERRUPT LEVEL #5
         0  0564  1348 c2 ec 04  1353		JP	NZ,R00R55		;YES
         0  0567  1349 f1        1354		POP	AF			;NO, RESTORE AF
         0  0568  1350 cd ae 01  1355		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  056b  1351 dd 21 00  1356		LD	IX,Z_05SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  056f  1352 c3 b2 04  1357		JP	R00R05
                  1353           1358	 
                  1354           1359	;=======
                  1355           1360	; R06RPT - SYSTEM LEVEL 6 INTERRUPT
                  1356           1361	;=======
                  1357           1362	 
                  1358           1363		EXTERNAL	Z_06SM
                  1359           1364	 
                  1360           1365	R06RPT
         0  0572  1361 f5        1366		PUSH	AF			;SAVE AF
         0  0573  1362 3a 8a 00  1367		LD	A,(Z$STAT)
         0  0576  1363 b7        1368		OR	A			;IN RTZ ?
         0  0577  1364 3e 06     1369		LD	A,6			;  INTERRUPT LEVEL #6
         0  0579  1365 c2 ec 04  1370		JP	NZ,R00R55		;YES
         0  057c  1366 f1        1371		POP	AF			;NO, RESTORE AF
         0  057d  1367 cd ae 01  1372		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0580  1368 dd 21 00  1373		LD	IX,Z_06SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0584  1369 c3 b2 04  1374		JP	R00R05
                  1370           1375	 
                  1371           1376	;=======
                  1372           1377	; R07RPT - SYSTEM LEVEL 7 INTERRUPT
                  1373           1378	;=======
                  1374           1379	 
                  1375           1380		EXTERNAL	Z_07SM
                  1376           1381	 
                  1377           1382	R07RPT
         0  0587  1378 f5        1383		PUSH	AF			;SAVE AF
         0  0588  1379 3a 8a 00  1384		LD	A,(Z$STAT)
         0  058b  1380 b7        1385		OR	A			;IN RTZ ?
         0  058c  1381 3e 07     1386		LD	A,7			;  INTERRUPT LEVEL #7
         0  058e  1382 c2 ec 04  1387		JP	NZ,R00R55		;YES
         0  0591  1383 f1        1388		POP	AF			;NO, RESTORE AF
         0  0592  1384 cd ae 01  1389		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0595  1385 dd 21 00  1390		LD	IX,Z_07SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
28

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
29

         0  0599  1386 c3 b2 04  1391		JP	R00R05
                  1387           1392	 
                  1388           1393		if	RTZSIZ>8
                  1389           1394	 
                  1390           1395	;=======
                  1391           1396	; R08RPT - SYSTEM LEVEL 8 INTERRUPT
                  1392           1397	;=======
                  1393           1398	 
                  1394           1399		EXTERNAL	Z_08SM
                  1395           1400	 
                  1396           1401	R08RPT
         0  059c  1397 f5        1402		PUSH	AF			;SAVE AF
         0  059d  1398 3a 8a 00  1403		LD	A,(Z$STAT)
         0  05a0  1399 b7        1404		OR	A			;IN RTZ ?
         0  05a1  1400 3e 08     1405		LD	A,8			;  INTERRUPT LEVEL #8
         0  05a3  1401 c2 ec 04  1406		JP	NZ,R00R55		;YES
         0  05a6  1402 f1        1407		POP	AF			;NO, RESTORE AF
         0  05a7  1403 cd ae 01  1408		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  05aa  1404 dd 21 00  1409		LD	IX,Z_08SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  05ae  1405 c3 b2 04  1410		JP	R00R05
                  1406           1411	 
                  1407           1412	;=======
                  1408           1413	; R09RPT - SYSTEM LEVEL 9 INTERRUPT
                  1409           1414	;=======
                  1410           1415	 
                  1411           1416		EXTERNAL	Z_09SM
                  1412           1417	 
                  1413           1418	R09RPT
         0  05b1  1414 f5        1419		PUSH	AF			;SAVE AF
         0  05b2  1415 3a 8a 00  1420		LD	A,(Z$STAT)
         0  05b5  1416 b7        1421		OR	A			;IN RTZ ?
         0  05b6  1417 3e 09     1422		LD	A,9			;  INTERRUPT LEVEL #9
         0  05b8  1418 c2 ec 04  1423		JP	NZ,R00R55		;YES
         0  05bb  1419 f1        1424		POP	AF			;NO, RESTORE AF
         0  05bc  1420 cd ae 01  1425		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  05bf  1421 dd 21 00  1426		LD	IX,Z_09SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  05c3  1422 c3 b2 04  1427		JP	R00R05
                  1423           1428	 
                  1424           1429	;=======
                  1425           1430	; R10RPT - SYSTEM LEVEL 10 INTERRUPT
                  1426           1431	;=======
                  1427           1432	 
                  1428           1433		EXTERNAL	Z_10SM
                  1429           1434	 
                  1430           1435	R10RPT
         0  05c6  1431 f5        1436		PUSH	AF			;SAVE AF
         0  05c7  1432 3a 8a 00  1437		LD	A,(Z$STAT)
         0  05ca  1433 b7        1438		OR	A			;IN RTZ ?
         0  05cb  1434 3e 0a     1439		LD	A,10			;  INTERRUPT LEVEL #10
         0  05cd  1435 c2 ec 04  1440		JP	NZ,R00R55		;YES
         0  05d0  1436 f1        1441		POP	AF			;NO, RESTORE AF
         0  05d1  1437 cd ae 01  1442		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  05d4  1438 dd 21 00  1443		LD	IX,Z_10SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  05d8  1439 c3 b2 04  1444		JP	R00R05
                  1440           1445	 

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
29

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
30

                  1441           1446	;=======
                  1442           1447	; R11RPT - SYSTEM LEVEL 11 INTERRUPT
                  1443           1448	;=======
                  1444           1449	 
                  1445           1450		EXTERNAL	Z_11SM
                  1446           1451	 
                  1447           1452	R11RPT
         0  05db  1448 f5        1453		PUSH	AF			;SAVE AF
         0  05dc  1449 3a 8a 00  1454		LD	A,(Z$STAT)
         0  05df  1450 b7        1455		OR	A			;IN RTZ ?
         0  05e0  1451 3e 0b     1456		LD	A,11			;  INTERRUPT LEVEL #11
         0  05e2  1452 c2 ec 04  1457		JP	NZ,R00R55		;YES
         0  05e5  1453 f1        1458		POP	AF			;NO, RESTORE AF
         0  05e6  1454 cd ae 01  1459		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  05e9  1455 dd 21 00  1460		LD	IX,Z_11SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  05ed  1456 c3 b2 04  1461		JP	R00R05
                  1457           1462	 
                  1458           1463	;=======
                  1459           1464	; R12RPT - SYSTEM LEVEL 12 INTERRUPT
                  1460           1465	;=======
                  1461           1466	 
                  1462           1467		EXTERNAL	Z_12SM
                  1463           1468	 
                  1464           1469	R12RPT
         0  05f0  1465 f5        1470		PUSH	AF			;SAVE AF
         0  05f1  1466 3a 8a 00  1471		LD	A,(Z$STAT)
         0  05f4  1467 b7        1472		OR	A			;IN RTZ ?
         0  05f5  1468 3e 0c     1473		LD	A,12			;  INTERRUPT LEVEL #12
         0  05f7  1469 c2 ec 04  1474		JP	NZ,R00R55		;YES
         0  05fa  1470 f1        1475		POP	AF			;NO, RESTORE AF
         0  05fb  1471 cd ae 01  1476		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  05fe  1472 dd 21 00  1477		LD	IX,Z_12SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0602  1473 c3 b2 04  1478		JP	R00R05
                  1474           1479	 
                  1475           1480	;=======
                  1476           1481	; R13RPT - SYSTEM LEVEL 13 INTERRUPT
                  1477           1482	;=======
                  1478           1483	 
                  1479           1484		EXTERNAL	Z_13SM
                  1480           1485	 
                  1481           1486	R13RPT
         0  0605  1482 f5        1487		PUSH	AF			;SAVE AF
         0  0606  1483 3a 8a 00  1488		LD	A,(Z$STAT)
         0  0609  1484 b7        1489		OR	A			;IN RTZ ?
         0  060a  1485 3e 0d     1490		LD	A,13			;  INTERRUPT LEVEL #13
         0  060c  1486 c2 ec 04  1491		JP	NZ,R00R55		;YES
         0  060f  1487 f1        1492		POP	AF			;NO, RESTORE AF
         0  0610  1488 cd ae 01  1493		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0613  1489 dd 21 00  1494		LD	IX,Z_13SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0617  1490 c3 b2 04  1495		JP	R00R05
                  1491           1496	 
                  1492           1497	;=======
                  1493           1498	; R14RPT - SYSTEM LEVEL 14 INTERRUPT
                  1494           1499	;=======
                  1495           1500	 

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
30

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
31

                  1496           1501		EXTERNAL	Z_14SM
                  1497           1502	 
                  1498           1503	R14RPT
         0  061a  1499 f5        1504		PUSH	AF			;SAVE AF
         0  061b  1500 3a 8a 00  1505		LD	A,(Z$STAT)
         0  061e  1501 b7        1506		OR	A			;IN RTZ ?
         0  061f  1502 3e 0e     1507		LD	A,14			;  INTERRUPT LEVEL #14
         0  0621  1503 c2 ec 04  1508		JP	NZ,R00R55		;YES
         0  0624  1504 f1        1509		POP	AF			;NO, RESTORE AF
         0  0625  1505 cd ae 01  1510		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0628  1506 dd 21 00  1511		LD	IX,Z_14SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  062c  1507 c3 b2 04  1512		JP	R00R05
                  1508           1513	 
                  1509           1514	;=======
                  1510           1515	; R15RPT - SYSTEM LEVEL 15 INTERRUPT
                  1511           1516	;=======
                  1512           1517	 
                  1513           1518		EXTERNAL	Z_15SM
                  1514           1519	 
                  1515           1520	R15RPT
         0  062f  1516 f5        1521		PUSH	AF			;SAVE AF
         0  0630  1517 3a 8a 00  1522		LD	A,(Z$STAT)
         0  0633  1518 b7        1523		OR	A			;IN RTZ ?
         0  0634  1519 3e 0f     1524		LD	A,15			;  INTERRUPT LEVEL #15
         0  0636  1520 c2 ec 04  1525		JP	NZ,R00R55		;YES
         0  0639  1521 f1        1526		POP	AF			;NO, RESTORE AF
         0  063a  1522 cd ae 01  1527		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  063d  1523 dd 21 00  1528		LD	IX,Z_15SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0641  1524 c3 b2 04  1529		JP	R00R05
                  1525           1530	 
                  1526           1531		if	RTZSIZ>16
                  1527           1532	 
                  1528           1533	;=======
                  1529           1534	; R16RPT - SYSTEM LEVEL 16 INTERRUPT
                  1530           1535	;=======
                  1531           1536	 
                  1532           1537		EXTERNAL	Z_16SM
                  1533           1538	 
                  1534           1539	R16RPT
         0  0644  1535 f5        1540		PUSH	AF			;SAVE AF
         0  0645  1536 3a 8a 00  1541		LD	A,(Z$STAT)
         0  0648  1537 b7        1542		OR	A			;IN RTZ ?
         0  0649  1538 3e 10     1543		LD	A,16			;  INTERRUPT LEVEL #16
         0  064b  1539 c2 ec 04  1544		JP	NZ,R00R55		;YES
         0  064e  1540 f1        1545		POP	AF			;NO, RESTORE AF
         0  064f  1541 cd ae 01  1546		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0652  1542 dd 21 00  1547		LD	IX,Z_16SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0656  1543 c3 b2 04  1548		JP	R00R05
                  1544           1549	 
                  1545           1550	;=======
                  1546           1551	; R17RPT - SYSTEM LEVEL 17 INTERRUPT
                  1547           1552	;=======
                  1548           1553	 
                  1549           1554		EXTERNAL	Z_17SM
                  1550           1555	 

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
31

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
32

                  1551           1556	R17RPT
         0  0659  1552 f5        1557		PUSH	AF			;SAVE AF
         0  065a  1553 3a 8a 00  1558		LD	A,(Z$STAT)
         0  065d  1554 b7        1559		OR	A			;IN RTZ ?
         0  065e  1555 3e 11     1560		LD	A,17			;  INTERRUPT LEVEL #17
         0  0660  1556 c2 ec 04  1561		JP	NZ,R00R55		;YES
         0  0663  1557 f1        1562		POP	AF			;NO, RESTORE AF
         0  0664  1558 cd ae 01  1563		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0667  1559 dd 21 00  1564		LD	IX,Z_17SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  066b  1560 c3 b2 04  1565		JP	R00R05
                  1561           1566	 
                  1562           1567	;=======
                  1563           1568	; R18RPT - SYSTEM LEVEL 18 INTERRUPT
                  1564           1569	;=======
                  1565           1570	 
                  1566           1571		EXTERNAL	Z_18SM
                  1567           1572	 
                  1568           1573	R18RPT
         0  066e  1569 f5        1574		PUSH	AF			;SAVE AF
         0  066f  1570 3a 8a 00  1575		LD	A,(Z$STAT)
         0  0672  1571 b7        1576		OR	A			;IN RTZ ?
         0  0673  1572 3e 12     1577		LD	A,18			;  INTERRUPT LEVEL #18
         0  0675  1573 c2 ec 04  1578		JP	NZ,R00R55		;YES
         0  0678  1574 f1        1579		POP	AF			;NO, RESTORE AF
         0  0679  1575 cd ae 01  1580		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  067c  1576 dd 21 00  1581		LD	IX,Z_18SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0680  1577 c3 b2 04  1582		JP	R00R05
                  1578           1583	 
                  1579           1584	;=======
                  1580           1585	; R19RPT - SYSTEM LEVEL 19 INTERRUPT
                  1581           1586	;=======
                  1582           1587	 
                  1583           1588		EXTERNAL	Z_19SM
                  1584           1589	 
                  1585           1590	R19RPT
         0  0683  1586 f5        1591		PUSH	AF			;SAVE AF
         0  0684  1587 3a 8a 00  1592		LD	A,(Z$STAT)
         0  0687  1588 b7        1593		OR	A			;IN RTZ ?
         0  0688  1589 3e 13     1594		LD	A,19			;  INTERRUPT LEVEL #19
         0  068a  1590 c2 ec 04  1595		JP	NZ,R00R55		;YES
         0  068d  1591 f1        1596		POP	AF			;NO, RESTORE AF
         0  068e  1592 cd ae 01  1597		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0691  1593 dd 21 00  1598		LD	IX,Z_19SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0695  1594 c3 b2 04  1599		JP	R00R05
                  1595           1600	 
                  1596           1601		if	RTZSIZ>20
                  1597           1602	 
                  1598           1603	;=======
                  1599           1604	; R20RPT - SYSTEM LEVEL 20 INTERRUPT
                  1600           1605	;=======
                  1601           1606	 
                  1602           1607		EXTERNAL	Z_20SM
                  1603           1608	 
                  1604           1609	R20RPT
         0  0698  1605 f5        1610		PUSH	AF			;SAVE AF

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
32

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
33

         0  0699  1606 3a 8a 00  1611		LD	A,(Z$STAT)
         0  069c  1607 b7        1612		OR	A			;IN RTZ ?
         0  069d  1608 3e 14     1613		LD	A,20			;  INTERRUPT LEVEL #20
         0  069f  1609 c2 ec 04  1614		JP	NZ,R00R55		;YES
         0  06a2  1610 f1        1615		POP	AF			;NO, RESTORE AF
         0  06a3  1611 cd ae 01  1616		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  06a6  1612 dd 21 00  1617		LD	IX,Z_20SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  06aa  1613 c3 b2 04  1618		JP	R00R05
                  1614           1619	 
                  1615           1620	;=======
                  1616           1621	; R21RPT - SYSTEM LEVEL 21 INTERRUPT
                  1617           1622	;=======
                  1618           1623	 
                  1619           1624		EXTERNAL	Z_21SM
                  1620           1625	 
                  1621           1626	R21RPT
         0  06ad  1622 f5        1627		PUSH	AF			;SAVE AF
         0  06ae  1623 3a 8a 00  1628		LD	A,(Z$STAT)
         0  06b1  1624 b7        1629		OR	A			;IN RTZ ?
         0  06b2  1625 3e 15     1630		LD	A,21			;  INTERRUPT LEVEL #21
         0  06b4  1626 c2 ec 04  1631		JP	NZ,R00R55		;YES
         0  06b7  1627 f1        1632		POP	AF			;NO, RESTORE AF
         0  06b8  1628 cd ae 01  1633		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  06bb  1629 dd 21 00  1634		LD	IX,Z_21SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  06bf  1630 c3 b2 04  1635		JP	R00R05
                  1631           1636	 
                  1632           1637	;=======
                  1633           1638	; R22RPT - SYSTEM LEVEL 22 INTERRUPT
                  1634           1639	;=======
                  1635           1640	 
                  1636           1641		EXTERNAL	Z_22SM
                  1637           1642	 
                  1638           1643	R22RPT
         0  06c2  1639 f5        1644		PUSH	AF			;SAVE AF
         0  06c3  1640 3a 8a 00  1645		LD	A,(Z$STAT)
         0  06c6  1641 b7        1646		OR	A			;IN RTZ ?
         0  06c7  1642 3e 16     1647		LD	A,22			;  INTERRUPT LEVEL #22
         0  06c9  1643 c2 ec 04  1648		JP	NZ,R00R55		;YES
         0  06cc  1644 f1        1649		POP	AF			;NO, RESTORE AF
         0  06cd  1645 cd ae 01  1650		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  06d0  1646 dd 21 00  1651		LD	IX,Z_22SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  06d4  1647 c3 b2 04  1652		JP	R00R05
                  1648           1653	 
                  1649           1654	;=======
                  1650           1655	; R23RPT - SYSTEM LEVEL 23 INTERRUPT
                  1651           1656	;=======
                  1652           1657	 
                  1653           1658		EXTERNAL	Z_23SM
                  1654           1659	 
                  1655           1660	R23RPT
         0  06d7  1656 f5        1661		PUSH	AF			;SAVE AF
         0  06d8  1657 3a 8a 00  1662		LD	A,(Z$STAT)
         0  06db  1658 b7        1663		OR	A			;IN RTZ ?
         0  06dc  1659 3e 17     1664		LD	A,23			;  INTERRUPT LEVEL #23
         0  06de  1660 c2 ec 04  1665		JP	NZ,R00R55		;YES

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
33

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
34

         0  06e1  1661 f1        1666		POP	AF			;NO, RESTORE AF
         0  06e2  1662 cd ae 01  1667		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  06e5  1663 dd 21 00  1668		LD	IX,Z_23SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  06e9  1664 c3 b2 04  1669		JP	R00R05
                  1665           1670	 
                  1666           1671	;=======
                  1667           1672	; R24RPT - SYSTEM LEVEL 24 INTERRUPT
                  1668           1673	;=======
                  1669           1674	 
                  1670           1675		EXTERNAL	Z_24SM
                  1671           1676	 
                  1672           1677	R24RPT
         0  06ec  1673 f5        1678		PUSH	AF			;SAVE AF
         0  06ed  1674 3a 8a 00  1679		LD	A,(Z$STAT)
         0  06f0  1675 b7        1680		OR	A			;IN RTZ ?
         0  06f1  1676 3e 18     1681		LD	A,24			;  INTERRUPT LEVEL #24
         0  06f3  1677 c2 ec 04  1682		JP	NZ,R00R55		;YES
         0  06f6  1678 f1        1683		POP	AF			;NO, RESTORE AF
         0  06f7  1679 cd ae 01  1684		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  06fa  1680 dd 21 00  1685		LD	IX,Z_24SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  06fe  1681 c3 b2 04  1686		JP	R00R05
                  1682           1687	 
                  1683           1688	;=======
                  1684           1689	; R25RPT - SYSTEM LEVEL 25 INTERRUPT
                  1685           1690	;=======
                  1686           1691	 
                  1687           1692		EXTERNAL	Z_25SM
                  1688           1693	 
                  1689           1694	R25RPT
         0  0701  1690 f5        1695		PUSH	AF			;SAVE AF
         0  0702  1691 3a 8a 00  1696		LD	A,(Z$STAT)
         0  0705  1692 b7        1697		OR	A			;IN RTZ ?
         0  0706  1693 3e 19     1698		LD	A,25			;  INTERRUPT LEVEL #25
         0  0708  1694 c2 ec 04  1699		JP	NZ,R00R55		;YES
         0  070b  1695 f1        1700		POP	AF			;NO, RESTORE AF
         0  070c  1696 cd ae 01  1701		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  070f  1697 dd 21 00  1702		LD	IX,Z_25SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0713  1698 c3 b2 04  1703		JP	R00R05
                  1699           1704	 
                  1700           1705	;=======
                  1701           1706	; R26RPT - SYSTEM LEVEL 26 INTERRUPT
                  1702           1707	;=======
                  1703           1708	 
                  1704           1709		EXTERNAL	Z_26SM
                  1705           1710	 
                  1706           1711	R26RPT
         0  0716  1707 f5        1712		PUSH	AF			;SAVE AF
         0  0717  1708 3a 8a 00  1713		LD	A,(Z$STAT)
         0  071a  1709 b7        1714		OR	A			;IN RTZ ?
         0  071b  1710 3e 1a     1715		LD	A,26			;  INTERRUPT LEVEL #26
         0  071d  1711 c2 ec 04  1716		JP	NZ,R00R55		;YES
         0  0720  1712 f1        1717		POP	AF			;NO, RESTORE AF
         0  0721  1713 cd ae 01  1718		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0724  1714 dd 21 00  1719		LD	IX,Z_26SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
34

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
35

         0  0728  1715 c3 b2 04  1720		JP	R00R05
                  1716           1721	 
                  1717           1722	;=======
                  1718           1723	; R27RPT - SYSTEM LEVEL 27 INTERRUPT
                  1719           1724	;=======
                  1720           1725	 
                  1721           1726		EXTERNAL	Z_27SM
                  1722           1727	 
                  1723           1728	R27RPT
         0  072b  1724 f5        1729		PUSH	AF			;SAVE AF
         0  072c  1725 3a 8a 00  1730		LD	A,(Z$STAT)
         0  072f  1726 b7        1731		OR	A			;IN RTZ ?
         0  0730  1727 3e 1b     1732		LD	A,27			;  INTERRUPT LEVEL #27
         0  0732  1728 c2 ec 04  1733		JP	NZ,R00R55		;YES
         0  0735  1729 f1        1734		POP	AF			;NO, RESTORE AF
         0  0736  1730 cd ae 01  1735		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0739  1731 dd 21 00  1736		LD	IX,Z_27SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  073d  1732 c3 b2 04  1737		JP	R00R05
                  1733           1738	 
                  1734           1739	;=======
                  1735           1740	; R28RPT - SYSTEM LEVEL 28 INTERRUPT
                  1736           1741	;=======
                  1737           1742	 
                  1738           1743		EXTERNAL	Z_28SM
                  1739           1744	 
                  1740           1745	R28RPT
         0  0740  1741 f5        1746		PUSH	AF			;SAVE AF
         0  0741  1742 3a 8a 00  1747		LD	A,(Z$STAT)
         0  0744  1743 b7        1748		OR	A			;IN RTZ ?
         0  0745  1744 3e 1c     1749		LD	A,28			;  INTERRUPT LEVEL #28
         0  0747  1745 c2 ec 04  1750		JP	NZ,R00R55		;YES
         0  074a  1746 f1        1751		POP	AF			;NO, RESTORE AF
         0  074b  1747 cd ae 01  1752		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  074e  1748 dd 21 00  1753		LD	IX,Z_28SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0752  1749 c3 b2 04  1754		JP	R00R05
                  1750           1755	 
                  1751           1756	;=======
                  1752           1757	; R29RPT - SYSTEM LEVEL 29 INTERRUPT
                  1753           1758	;=======
                  1754           1759	 
                  1755           1760		EXTERNAL	Z_29SM
                  1756           1761	 
                  1757           1762	R29RPT
         0  0755  1758 f5        1763		PUSH	AF			;SAVE AF
         0  0756  1759 3a 8a 00  1764		LD	A,(Z$STAT)
         0  0759  1760 b7        1765		OR	A			;IN RTZ ?
         0  075a  1761 3e 1d     1766		LD	A,29			;  INTERRUPT LEVEL #29
         0  075c  1762 c2 ec 04  1767		JP	NZ,R00R55		;YES
         0  075f  1763 f1        1768		POP	AF			;NO, RESTORE AF
         0  0760  1764 cd ae 01  1769		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0763  1765 dd 21 00  1770		LD	IX,Z_29SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0767  1766 c3 b2 04  1771		JP	R00R05
                  1767           1772	 
                  1768           1773	;=======
                  1769           1774	; R30RPT - SYSTEM LEVEL 30 INTERRUPT

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
35

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
36

                  1770           1775	;=======
                  1771           1776	 
                  1772           1777		EXTERNAL	Z_30SM
                  1773           1778	 
                  1774           1779	R30RPT
         0  076a  1775 f5        1780		PUSH	AF			;SAVE AF
         0  076b  1776 3a 8a 00  1781		LD	A,(Z$STAT)
         0  076e  1777 b7        1782		OR	A			;IN RTZ ?
         0  076f  1778 3e 1e     1783		LD	A,30			;  INTERRUPT LEVEL #30
         0  0771  1779 c2 ec 04  1784		JP	NZ,R00R55		;YES
         0  0774  1780 f1        1785		POP	AF			;NO, RESTORE AF
         0  0775  1781 cd ae 01  1786		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  0778  1782 dd 21 00  1787		LD	IX,Z_30SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  077c  1783 c3 b2 04  1788		JP	R00R05
                  1784           1789	 
                  1785           1790	;=======
                  1786           1791	; R31RPT - SYSTEM LEVEL 31 INTERRUPT
                  1787           1792	;=======
                  1788           1793	 
                  1789           1794		EXTERNAL	Z_31SM
                  1790           1795	 
                  1791           1796	R31RPT
         0  077f  1792 f5        1797		PUSH	AF			;SAVE AF
         0  0780  1793 3a 8a 00  1798		LD	A,(Z$STAT)
         0  0783  1794 b7        1799		OR	A			;IN RTZ ?
         0  0784  1795 3e 1f     1800		LD	A,31			;  INTERRUPT LEVEL #31
         0  0786  1796 c2 ec 04  1801		JP	NZ,R00R55		;YES
         0  0789  1797 f1        1802		POP	AF			;NO, RESTORE AF
         0  078a  1798 cd ae 01  1803		CALL	Z$SREG		;  AND SAVE ALL REGISTERS
         0  078d  1799 dd 21 00  1804		LD	IX,Z_31SM		;IX:=^CURRENT I-SEMAPHORE
                                             00      
         0  0791  1800 c3 b2 04  1805		JP	R00R05
                  1801           1806		endif
                  1802           1807		endif
                  1803           1808		endif
                  1804           1809		endif
                  1805           1810	;=======
                  1806           1811	; Z_ISGL - SIGNAL FROM DIRECT INTERRUPT
                  1807           1812	;
                  1808           1813	; ACCEPTS: WORD AFTER CALL = INTERRUPT SEMAPHORE
                  1809           1814	;=======
                  1810           1815	 
                  1811           1816		GLOBAL	Z_ISGL
                  1812           1817	 
                  1813           1818	Z_ISGL
         0  0794  1814 e3        1819		EX	(SP),HL		;PUSH HL, HL:=^PARAMETERS
         0  0795  1815 f3        1820		DI
         0  0796  1816 f5        1821		PUSH	AF
         0  0797  1817 c5        1822		PUSH	BC			;SAVE USER BC
         0  0798  1818 3a 8a 00  1823		LD	A,(Z$STAT)
         0  079b  1819 b7        1824		OR	A			;IN RTZ ?
         0  079c  1820 20 14     1825		JR	NZ,ISGL10		;YES
                  1821           1826	 
                  1822           1827	; NOT IN RTZ
                  1823           1828	 
         0  079e  1824 3c        1829		INC	A			;NOW WE'RE IN RTZ
         0  079f  1825 32 8a 00  1830		LD	(Z$STAT),A

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
36

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
37

         0  07a2  1826 fb        1831		EI
         0  07a3  1827 4e        1832		LD	C,(HL)		;BC:=SEMAPHORE ADDRESS
         0  07a4  1828 23        1833		INC	HL
         0  07a5  1829 46        1834		LD	B,(HL)
         0  07a6  1830 21 ac 07  1835		LD	HL,ISGL20		;FIX FOR Z$SREG
         0  07a9  1831 c3 b7 01  1836		JP	SREGDE		;COMPLETE Z$SREG
                  1832           1837	ISGL20
         0  07ac  1833 c5        1838		PUSH	BC			;IX:=^INTERRUPT SEMAPHORE
         0  07ad  1834 dd e1     1839		POP	IX
         0  07af  1835 c3 b2 04  1840		JP	R00R05		;GO TO SYSTEM INTERRUPT
                  1836           1841	 
                  1837           1842	; ALREADY IN RTZ
                  1838           1843	 
                  1839           1844	ISGL10
         0  07b2  1840 23        1845		INC	HL			;HL:=^INTERRUPT #
         0  07b3  1841 23        1846		INC	HL
         0  07b4  1842 46        1847		LD	B,(HL)		;B:=INTERRUPT #
         0  07b5  1843 21 8b 00  1848		LD	HL,Z$ICNT
         0  07b8  1844 7e        1849		LD	A,(HL)
         0  07b9  1845 fe 15     1850		CP	21			;MORE THAN 20 PENDING RUPTS ?
         0  07bb  1846 30 0a     1851		JR	NC,ISGL15		;YES, SKIP THIS ONE
         0  07bd  1847 34        1852		INC	(HL)			;NO, ONE MORE RUPT PENDING
         0  07be  1848 21 8c 00  1853		LD	HL,Z$ISTK		;HL:=^STACK OF PENDING RUPTS
         0  07c1  1849 85        1854		ADD	A,L
         0  07c2  1850 6f        1855		LD	L,A
         0  07c3  1851 30 01     1856		JR	NC,ISGL18
         0  07c5  1852 24        1857		INC	H
                  1853           1858	ISGL18
         0  07c6  1854 70        1859		LD	(HL),B
                  1855           1860	ISGL15
         0  07c7  1856 c1        1861		POP	BC
         0  07c8  1857 f1        1862		POP	AF
         0  07c9  1858 e1        1863		POP	HL
         0  07ca  1859 fb        1864		EI
         0  07cb  1860 ed 4d     1865		RETI
                  1861           1866	 
                  1862           1867	;-------
                  1863           1868	; ISEMTB - TABLE OF ALL INTERRUPT SEMAPHORES
                  1864           1869	;-------
                  1865           1870	 
                  1866           1871	ISEMTB
         0  07cd  1867 00 00     1872		DEFW	Z_00SM
         0  07cf  1868 00 00     1873		DEFW	Z_01SM
         0  07d1  1869 00 00     1874		DEFW	Z_02SM
         0  07d3  1870 00 00     1875		DEFW	Z_03SM
                  1871           1876		if	RTZSIZ>4
         0  07d5  1872 00 00     1877		DEFW	Z_04SM
         0  07d7  1873 00 00     1878		DEFW	Z_05SM
         0  07d9  1874 00 00     1879		DEFW	Z_06SM
         0  07db  1875 00 00     1880		DEFW	Z_07SM
                  1876           1881		if	RTZSIZ>8
         0  07dd  1877 00 00     1882		DEFW	Z_08SM
         0  07df  1878 00 00     1883		DEFW	Z_09SM
         0  07e1  1879 00 00     1884		DEFW	Z_10SM
         0  07e3  1880 00 00     1885		DEFW	Z_11SM
         0  07e5  1881 00 00     1886		DEFW	Z_12SM
         0  07e7  1882 00 00     1887		DEFW	Z_13SM
         0  07e9  1883 00 00     1888		DEFW	Z_14SM

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
37

rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
38

         0  07eb  1884 00 00     1889		DEFW	Z_15SM
                  1885           1890		if	RTZSIZ>16
         0  07ed  1886 00 00     1891		DEFW	Z_16SM
         0  07ef  1887 00 00     1892		DEFW	Z_17SM
         0  07f1  1888 00 00     1893		DEFW	Z_18SM
         0  07f3  1889 00 00     1894		DEFW	Z_19SM
                  1890           1895		if	RTZSIZ>20
         0  07f5  1891 00 00     1896		DEFW	Z_20SM
         0  07f7  1892 00 00     1897		DEFW	Z_21SM
         0  07f9  1893 00 00     1898		DEFW	Z_22SM
         0  07fb  1894 00 00     1899		DEFW	Z_23SM
         0  07fd  1895 00 00     1900		DEFW	Z_24SM
         0  07ff  1896 00 00     1901		DEFW	Z_25SM
         0  0801  1897 00 00     1902		DEFW	Z_26SM
         0  0803  1898 00 00     1903		DEFW	Z_27SM
         0  0805  1899 00 00     1904		DEFW	Z_28SM
         0  0807  1900 00 00     1905		DEFW	Z_29SM
         0  0809  1901 00 00     1906		DEFW	Z_30SM
         0  080b  1902 00 00     1907		DEFW	Z_31SM
                  1903           1908		endif
                  1904           1909		endif
                  1905           1910		endif
                  1906           1911		endif
                  1907 20        1912	ISEMCT	EQU	RTZSIZ



































rtz.s                    RTZ.RUPT                                                  Tue Feb  7 17:21:34 1984
38

rtz.s                    RTZ.RAM                                                   Tue Feb  7 17:21:34 1984
39

                  1908           1914		begin	1
                  1909           1915	;UPDATED: 820120 / PH
                  1910           1916	 
                  1911           1917	;=======
                  1912           1918	; RTZ SYSTEM RAM
                  1913           1919	;
                  1914           1920	; 2.00: 8111xx
                  1915           1921	;=======
                  1916           1922	 
                  1917           1923		GLOBAL	Z_00VC
                  1918           1924		GLOBAL	Z_RUNP,Z$XQUE,Z$DQUE
                  1919           1925	 
         1  0000  1920           1926	Z_00VC	DEFS	RTZSIZ*2	;INTERRUPT VECTORS
                  1921           1927	Z_RUNP
         1  0040  1922           1928	Z$XQUE	DEFS	2		;HEAD OF EXECUTION QUEUE
         1  0042  1923           1929	      	DEFS	2		;=0 DUMMY TIMELIMIT
         1  0044  1924           1930	Z$DQUE	DEFS	2		;HEAD OF DELAY QUEUE
         1  0046  1925           1931	Z$IRAM	DEFS	18+SZISTK	;PCB AND STACK FOR Z$IDLE
                  1926           1932	 
                  1927           1933		GLOBAL	Z$STAT,Z_EOMF
                  1928           1934		GLOBAL	Z$FPCB,Z$LPCB,Z$FSEM,Z$LSEM
                  1929           1935	 
         1  008a  1930           1936	Z$STAT	DEFS	1		;=FF IF IN RTZ
         1  008b  1931           1937	Z$ICNT	DEFS	1		;# OF PENDING RUPTS
         1  008c  1932           1938	Z$ISTK	DEFS	20		;"INTERRUPT STACK"
         1  00a0  1933           1939	Z$FPCB	DEFS	2		;^FIRST ITEM IN PCB-LIST
         1  00a2  1934           1940	Z$LPCB	DEFS	2		;^LAST ITEM IN PCB-LIST
         1  00a4  1935           1941	Z$FSEM	DEFS	2		;^FIRST ITEM IN SEM-LIST
         1  00a6  1936           1942	Z$LSEM	DEFS	2		;^LAST ITEM IN SEM-LIST
         1  00a8  1937           1943	Z_EOMF	DEFS	1		;END OF MEMORY FLAG
                  1938           1944	 
                  1939           1945	;-------
                  1940           1946	; TIME-SLICE VARIABLES
                  1941           1947	;-------
                  1942           1948	 
                  1943           1949		GLOBAL	Z_SLCF,Z_SLCT,Z_SLCP
                  1944           1950	 
         1  00a9  1945           1951	Z_SLCF	DEFS	1		;0=NOSLICE (DEFAULT)
         1  00aa  1946           1952	Z$SLCC	DEFS	1		;SLICE COUNTER
         1  00ab  1947           1953	Z_SLCT	DEFS	1		;TIME (*TICK) (DEFAULT=8)
         1  00ac  1948           1954	Z_SLCP	DEFS	1		;PRIORITY (DEFAULT=200)
                  1949           1955	 
                  1950           1956	;-------
                  1951           1957	; DEBUGGER DEPENDENT VARIABLES
                  1952           1958	;-------
                  1953           1959	 
                  1954           1960		GLOBAL	Z$SIBP,Z$WABP
                  1955           1961	 
         1  00ad  1956           1962	Z$SIBP	DEFS	2		;^ROUTINE IN RTZ.DBG IF <> 0
         1  00af  1957           1963	Z$WABP	DEFS	2		;^ROUTINE IN RTZ.DBG IF <> 0
                  1958           1964	
         1  00b1  1959           1965		end





the number of errors detected in this assembly is 0

rtz.s                    RTZ.RAM                                                   Tue Feb  7 17:21:34 1984
39
