
rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
1

                     1              2	;UPDATED: 811124 / PH
                     2              3	 
                     3              4	;FILE:    RTZ.EQU.S
                     4              5	;UPDATED: 820120 / PH
                     5              6	 
                     6              7	;=======
                     7              8	; ALL INTERNAL EQUATES FOR RTZ/2
                     8              9	;=======
                     9             10	 
                    10             11	;-------
                    11             12	; Initial Process Control Block
                    12             13	;-------
                    13             14	 
                    14 00          15	IPCNAM	EQU	0		;PROCESS NAME
                    15 06          16	IPCENT	EQU	6		;PROCESS ENTRY
                    16 08          17	IPCSTZ	EQU	8		;STACK SIZE
                    17 0a          18	IPCPTY	EQU	10		;PROCESS PRIORITY
                    18             19	 
                    19             20	;-------
                    20             21	; Initial Semaphore
                    21             22	;-------
                    22             23	 
                    23 00          24	ISMADR	EQU	0		;SEMAPHORE ADDRESS
                    24             25	 
                    25             26	;-------
                    26             27	; Configuration Table - Z$CRTB
                    27             28	;-------
                    28             29	 
                    29 00          30	CNFIPT	EQU	0		;^INITIAL PROCESS TABLE
                    30 02          31	CNFNOP	EQU	2		;# OF IPCB:S IN IPT
                    31 03          32	CNFIST	EQU	3		;^INITIAL  SEMAPHORE TABLE
                    32 05          33	CNFNOS	EQU	5		;# OF ISEM:S IN IST
                    33             34	 
                    34             35	;-------
                    35             36	; Process Control Block
                    36             37	;-------
                    37             38	 
                    38 00          39	PCBLNK	EQU	0		;LINK FIELD
                    39 02          40	PCBDLY	EQU	2		;DELAY TIME
                    40 04          41	PCBDLK	EQU	4		;DELAY LINK FIELD
                    41 06          42	PCBSEM	EQU	6		;SEMAPHORE
                    42 08          43	PCBSP 	EQU	8		;STACK POINTER
                    43 0a          44	PCBPTY	EQU	10		;PROCESS PRIORITY
                    44 0b          45	PCBSTT	EQU	11		;STATUS BITS
                    45 0c          46	PCBNAM	EQU	12		;^NAME
                    46 0e          47	PCBRND	EQU	14		;RANDOM FIELD
                    47 10          48	PCBPCB	EQU	16		;STATIC PCB-LINK
                    48             49	 
                    49             50	;-------
                    50             51	; Semaphore
                    51             52	;-------
                    52             53	 
                    53 00          54	SEMMGQ	EQU	0		;MESSAGE QUEUE
                    54 02          55	SEMPRQ	EQU	2		;PROCESS (WAITING) QUEUE
                    55 04          56	SEMSEM	EQU	4		;STATIC SEMAPHORE-LINK
                    56             57	 
                    57 06          58	SEMIMG	EQU	6		;INTERRUPT MESSAGE
                    58             59	 

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
1

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
2

                    59             60	;-------
                    60             61	; Minimum Message
                    61             62	;-------
                    62             63	 
                    63 00          64	MSGLNK	EQU	0		;QUEUE LINK
                    64 02          65	MSGRQC	EQU	2		;REQUEST CODE
                    65 03          66	MSGRC 	EQU	3		;RETURN CODE
                    66 04          67	MSGLEN	EQU	4		;LENGTH
                    67 06          68	MSGRSM	EQU	6		;RESPONSE SEMAPHORE
                    68             69	 
                    69             70	;-------
                    70             71	; Device Request Message
                    71             72	;-------
                    72             73	 
                    73 08          74	MSGBAD	EQU	8		;BUFFER ADDRESS
                    74 0a          75	MSGBSZ	EQU	10		;BUFFER SIZE
                    75 0c          76	MSGBCN	EQU	12		;BYTE COUNT
                    76             77	 
                    77 08          78	MSGSEC	EQU	8		;SECONDS
                    78 09          79	MSGMIN	EQU	9		;MINUTES
                    79 0a          80	MSGHRS	EQU	10		;HOURS
                    80             81	 
                    81 08          82	MSGWL 	EQU	8		;WANTED LENGTH
                    82 0a          83	MSGSPC	EQU	10		;MAX SPACE OR ^FREE SPACE
                    83             84	 
                    84             85	;-------
                    85             86	; Device Request Bits
                    86             87	;-------
                    87             88	 
                    88 01          89	ZQBRD 	EQU	1		;00.. ..01 READ
                    89             90	;ZQbRD 	EQU	0
                    90 02          91	ZQBWRT	EQU	2		;00.. ..10 WRITE
                    91             92	;ZQbWRT	EQU	1
                    92 00          93	ZQBASC	EQU	0		;00.. .0.. ASCII
                    93 04          94	ZQBBIN	EQU	4		;00.. .1.. BINARY
                    94             95	;ZQbBIN	EQU	2
                    95 08          96	ZQBSTT	EQU	8		;00.. 1... STATUS
                    96             97	;ZQbSTT	EQU	4
                    97             98	 
                    98             99	;-------
                    99            100	; Device Request Codes
                   100            101	;-------
                   101            102	 
                   102            103	      						;00xx xxxx COMMON CODES
                   103 01         104	ZQCRDA	EQU	ZQBRD+ZQBASC		;READ ASCII
                   104 05         105	ZQCRDB	EQU	ZQBRD+ZQBBIN		;READ BINARY
                   105 02         106	ZQCWRA	EQU	ZQBWRT+ZQBASC		;WRITE ASCII
                   106 06         107	ZQCWRB	EQU	ZQBWRT+ZQBBIN		;WRITE BINARY
                   107 09         108	ZQCRDS	EQU	ZQBRD+ZQBSTT		;READ STATUS
                   108 0a         109	ZQCWRS	EQU	ZQBWRT+ZQBSTT		;WRITE STATUS
                   109            110	 
                   110            111	      				;01xx xxxx COMMAND CODES
                   111 61         112	ZQCRDC	EQU	61H		;READ CLOCK
                   112 62         113	ZQCWRC	EQU	62H		;WRITE CLOCK
                   113 63         114	ZQCWAT	EQU	63H		;WAKE AT
                   114 64         115	ZQCWAF	EQU	64H		;WAKE AFTER
                   115            116	 
                   116 68         117	ZQCMCF	EQU	68H		;CONDITIONAL, FAST

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
2

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
3

                   117 69         118	ZQCMCB	EQU	69H		;CONDITIONAL, BEST
                   118 6a         119	ZQCMUF	EQU	6AH		;UNCONDITIONAL, FAST
                   119 6b         120	ZQCMUB	EQU	6BH		;UNCONDITIONAL, BEST
                   120            121	 
                   121            122	;-------
                   122            123	; System Return Codes
                   123            124	;-------
                   124            125	 
                   125 00         126	ZRCINT	EQU	0		;INTERRUPT MESSAGE
                   126 44         127	ZRCMIS	EQU	44H		;MISSED INTERRUPT
                   127 00 80      128	ZRCTO 	EQU	80H		;1... .... TIME-OUT
                   128            129	 
                   129            130	;-------
                   130            131	; Device Return Codes
                   131            132	;-------
                   132            133	 
                   133 00         134	ZRCOK 	EQU	0		;NORMAL TERMINATION
                   134 41         135	ZRCUNK	EQU	41H		;UNKNOWN REQUEST CODE
                   135 42         136	ZRCERR	EQU	42H		;UNSPECIFIED ERROR
                   136 43         137	ZRCBSY	EQU	43H		;DEVICE BUSY
                   137 45         138	ZRCOVF	EQU	45H		;DATA OVERFLOW
                   138 46         139	ZRCEOF	EQU	46H		;END OF FILE
                   139 47         140	ZRCDWN	EQU	47H		;DEVICE OFF LINE
                   140 48         141	ZRCEOM	EQU	48H		;END OF MEDIA
                   141            142	 
                   142            143	;-------
                   143            144	; HELP EQUATES
                   144            145	;-------
                   145            146	 
                   146 03         147	STTDLY	EQU	3		;BIT 3 IN PCBSTT
                   147 08         148	STCKAF	EQU	8		;OFFSET TO AF IN STACK
                   148 0a         149	STCKHL	EQU	10		;OFFSET TO HL IN STACK
                   149 0c         150	STCKPC	EQU	12		;OFFSET TO PC IN STACK
                   150 32         151	SZISTK	EQU	50		;SIZE OF IDLE STACK
                   151            152	 
                   152            153	;FILE:    RTZ.CON.EQU.S
                   153            154	;UPDATED: 811201 / PH
                   154            155	 
                   155            156	;-------
                   156            157	; STTTAB - OFFSETS IN STATUS-TABLE
                   157            158	;-------
                   158            159	 
                   159 00         160	CHRDEL	EQU	0
                   160 01         161	LINDEL	EQU	1
                   161 02         162	INPDEL	EQU	2
                   162 03         163	ANC   	EQU	3		;ACCEPT NEXT CHARACTER
                   163 04         164	SUSPND	EQU	4
                   164 05         165	RESUME	EQU	5
                   165 06         166	KILL  	EQU	6
                   166 07         167	LFCNT 	EQU	7
                   167 08         168	NULLCT	EQU	8
                   168 09         169	ECHO  	EQU	9
                   169 0a         170	DRUM  	EQU	10		;^TAB DRUM
                   170 0c         171	EDRUM 	EQU	12
                   171            172	 
                   172 0e         173	KEYSM 	EQU	14
                   173 10         174	KEYSAV	EQU	16
                   174 12         175	SCHR  	EQU	18

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
3

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
4

                   175 14         176	GCHR  	EQU	20
                   176 16         177	CONSTT	EQU	22
                   177 17         178	OUTSTT	EQU	23
                   178 18         179	CURSOR	EQU	24
                   179            180	 
                   180 1a         181	IQ    	EQU	26
                   181 1c         182	TIQ   	EQU	28
                   182 1e         183	FIQ   	EQU	30
                   183 20         184	EIQ   	EQU	32
                   184 22         185	LIQ   	EQU	34
                   185            186	 
                   186            187	;-------
                   187            188	; BITS IN CONSTT
                   188            189	;-------
                   189            190	 
                   190 03         191	B_READ	EQU	3		;BIT 3 IN CONSTT
                   191 04         192	ECHOCR	EQU	4		;    4
                   192 06         193	IA    	EQU	6		;    6  (1="READ", 0="WRITE")
                   193 07         194	HFDUP 	EQU	7		;    7
                   194            195	 
                   195            196	;-------
                   196            197	; HELP EQUATES
                   197            198	;-------
                   198            199	 
                   199 0e         200	LSTT  	EQU	14		;LENGTH OF USER ACCESSIBLE STATUS-TABLE
                   200 00 ff      201	EOFMRK	EQU	0FFH
                   201            202	 
                   202            203	;=======
                   203            204	; ASCII-characters
                   204            205	;=======
                   205            206	 
                   206 04         207	ASCEOT	EQU	4		;^D
                   207 08         208	ASCIBS	EQU	8		;^H
                   208 09         209	ASCIHT	EQU	9		;^I  (TAB)
                   209 0a         210	ASCILF	EQU	0AH
                   210 0d         211	ASCICR	EQU	0DH
                   211 1b         212	ASCESC	EQU	1BH		;ESCAPE
                   212 7f         213	ASCDEL	EQU	7FH		;DELETE
                   213            214	 
                   214            215	;=======
                   215            216	; Z_CON0 - HANDLER FOR CONSOLE # 0
                   216            217	;=======
                   217            218	 
                   218            219		GLOBAL	Z_CON0
                   219            220		EXTERNAL	Z_SGNL,Z_CPRO
                   220            221		EXTERNAL	Z_CON,Z_CINI,Z_C0SM
                   221            222		EXTERNAL	Z_C0RZ,Z_C0GS,Z_INI0
                   222            223	 
                   223            224	Z_CON0
         0  0000   224 11 00 00   225		LD	DE,Z_C0ST		;LOAD DEFAULT STATUS-TABLE
         0  0003   225 21 44 00   226		LD	HL,STTTAB
         0  0006   226 01 24 00   227		LD	BC,LSTTAB
         0  0009   227 ed b0      228		LDIR
         0  000b   228 2a 00 00   229		LD	HL,(Z_C0GS)	;RECEIVE INTERRUPT SEMAPHORE
         0  000e   229 22 14 00   230		LD	(Z_C0ST+GCHR),HL
                   230            231	 
         0  0011   231 dd 21 00   232		LD	IX,Z_C0ST		;SET TABS
                                             00      

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
4

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
5

         0  0015   232 2a 00 00   233		LD	HL,(Z_C0RZ)	;  AND ALLOCATE TYPE-AHEAD RING
         0  0018   233 cd 00 00   234		CALL	Z_CINI		;  AND CREATE KEY-SEMAPHORE
                   234            235	 
         0  001b   235 11 3e 00   236		LD	DE,Z_KEY0		;SEND "KEY" TO Z_KEY0
         0  001e   236 21 46 00   237		LD	HL,Z_KMG0
         0  0021   237 cd 00 00   238		CALL	Z_SGNL
         0  0024   238 11 39 00   239		LD	DE,IPCBAX		;BC:=^IPCB FOR Z_ALM0
         0  0027   239 cd 00 00   240		CALL	Z_CPRO		;CREATE Z_ALM0
         0  002a   240 cd 00 00   241		CALL	Z_INI0		;DO USER-SUPPLIED INIT
                   241            242	 
                   242            243	; MAIN LOOP
                   243            244	 
         0  002d   244 dd 21 00   245		LD	IX,Z_C0ST		;IX:=^STATUS-TABLE
                                             00      
                   245            246	CONLOP
         0  0031   246 11 00 00   247		LD	DE,Z_C0SM		;WAIT AT REQUEST-SEMAPHORE
         0  0034   247 cd 00 00   248		CALL	Z_CON
         0  0037   248 18 f8      249		JR	CONLOP
                   249            250	 
                   250            251	;-------
                   251            252	; IPCBAX - INITIAL PCB FOR Z_ALM0
                   252            253	;-------
                   253            254	 
                   254            255	IPCBAX
         0  0039   255 5a 5f      256		text	'Z_ALM0'
         0  003b       41 4c   
         0  003d       4d 30   
         0  003f   256 68 00      257		DEFW	Z_ALM0
         0  0041   257 3e 00      258		DEFW	62			;STACK SIZE
         0  0043   258 64         259		DEFB	100			;PRIORITY
                   259            260	 
                   260            261	;=======
                   261            262	; STTTAB - DEFAULT IMPURE AREA FOR CONSOLE  # 0
                   262            263	;
                   263            264	; ACCESSED BY OFFSET TO IX
                   264            265	;=======
                   265            266	 
                   266            267		EXTERNAL	Z_SCH0
                   267            268	 
                   268            269	STTTAB
         0  0044   269 08         270		DEFB	ASCIBS		;CHRDEL
         0  0045   270 7f         271		DEFB	ASCDEL		;LINDEL
         0  0046   271 18         272		DEFB	18H			;INPDEL (^X)
         0  0047   272 10         273		DEFB	10H			;DLE (^P)
         0  0048   273 13         274		DEFB	13H			;XOFF (^S)
         0  0049   274 11         275		DEFB	11H			;XON (^Q)
         0  004a   275 0f         276		DEFB	0FH			;KILL (^O)
         0  004b   276 01         277		DEFB	1			;LFCNT
         0  004c   277 01         278		DEFB	1			;NULLCT
         0  004d   278 ff         279		DEFB	0FFH			;ECHO (ON)
         0  004e   279 48 00      280		DEFW	Z_DRM0		;DRUM (TAB-DRUM)
         0  0050   280 a2 00      281		DEFW	Z_EDR0		;EDRUM (END OF TAB-DRUM)
         0  0052   281 3e 00      282		DEFW	Z_KEY0		;KEYSM
         0  0054   282 44 00      283		DEFW	Z_KES0		;KEYSAV
         0  0056   283 00 00      284		DEFW	Z_SCH0		;SCHR
         0  0058   284 00 00      285		DEFW	0			;GCHR
         0  005a   285 26         286		DEFB	26H			;CONSTT
         0  005b   286 00         287		DEFB	0			;OUTSTT

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
5

rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
6

         0  005c   287 00         288		DEFB	0			;CURSOR
         0  005d   288 00         289		DEFB	0			;--
                   289 00 1a      290	ASTTAB	EQU	$-STTTAB
                   290            291	 
         0  005e   291 00 00      292		DEFW	0			;IQ (TYPE AHEAD RING)
         0  0060   292 00 00      293		DEFW	0			;TIQ (TOP OF Z_IQ0)
         0  0062   293 00 00      294		DEFW	0			;FIQ (^FRONT OF RING)
         0  0064   294 00 00      295		DEFW	0			;EIQ (^END OF RING)
         0  0066   295 00 00      296		DEFW	0			;LIQ (LENGTH OF RING)
                   296 00 24      297	LSTTAB	EQU	$-STTTAB
                   297            298	 
                   298            299	;=======
                   299            300	; Z_ALM0 - WRITE ALARM ON CONSOLE # 0
                   300            301	;=======
                   301            302	 
                   302            303		GLOBAL	Z_ALM0
                   303            304		EXTERNAL	Z_SGNL
                   304            305		EXTERNAL	Z_A0SM
                   305            306	Z_ALM0
         0  0068   306 11 24 00   307		LD	DE,Z_A0ST		;LOAD DEFAULT STATUS-TABLE
         0  006b   307 21 44 00   308		LD	HL,STTTAB
         0  006e   308 01 1a 00   309		LD	BC,ASTTAB
         0  0071   309 ed b0      310		LDIR
         0  0073   310 21 3b 00   311		LD	HL,Z_A0ST+OUTSTT
         0  0076   311 cb c6      312		SET	0,(HL)		;THIS IS AN ALARM PROCESS
                   312            313	 
                   313            314	; MAIN LOOP
                   314            315	 
         0  0078   315 dd 21 24   316		LD	IX,Z_A0ST		;IX:=^STATUS-TABLE
                                             00      
                   316            317	ALMLOP
         0  007c   317 11 00 00   318		LD	DE,Z_A0SM		;WAIT AT ALARM-SEMAPHORE
         0  007f   318 cd 00 00   319		CALL	Z_CON
         0  0082   319 18 f8      320		JR	ALMLOP
                   320            321	 
                   321            322	;-------
                   322            323	; Z_GCI0 - RECEIVE HANDLING
                   323            324	;
                   324            325	; RETURNS: CY = 1  IF CONTROL CHARACTER RECOGNIZED
                   325            326	;          CY = 0  IF NOT
                   326            327	;
                   327            328	; TO BE CALLED BY RECEIVE-INTERRUPT
                   328            329	;-------
                   329            330	 
                   330            331		GLOBAL	Z_GCI0
                   331            332		EXTERNAL	Z_GCI
                   332            333	 
                   333            334	Z_GCI0
         0  0084   334 dd e5      335		PUSH	IX
         0  0086   335 dd 21 00   336		LD	IX,Z_C0ST
                                             00      
         0  008a   336 c3 00 00   337		JP	Z_GCI







rtzcon0.s                RTZ.CON.0                                             LER     Tue Feb  7 17:50:15 1984
6

rtzcon0.s                RTZ.CON.0.RAM                                         LER     Tue Feb  7 17:50:15 1984
7

                   337            339	;UPDATED: 811124 / PH
                   338            340	 
                   339            341	;=======
                   340            342	; RAM FOR CONSOLE # 0
                   341            343	;=======
                   342            344	 
                   343            345		begin	1
                   344            346	
         1  0000   345            347	Z_C0ST	DEFS	36		;STATUS-TABLE
         1  0024   346            348	Z_A0ST	DEFS	26		;STATUS-TABLE FOR ALARM
         1  003e   347            349	Z_KEY0	DEFS	6		;SEM. HOLDING KEY TO SCREEN
         1  0044   348            350	Z_KES0	DEFS	2		;SAVE AREA FOR KEY
         1  0046   349            351	Z_KMG0	DEFS	2		;"KEY" TO SCREEN
         1  0048   350            352	Z_DRM0	DEFS	90		;TAB-DRUM
                   351            353	Z_EDR0
                   352            354	
         1  00a2   353            355		end





the number of errors detected in this assembly is 0




































rtzcon0.s                RTZ.CON.0.RAM                                         LER     Tue Feb  7 17:50:15 1984
7

rtzcon0.s                c r o s s - r e f e r e n c e   l i s t i n g       8

name       type       value       defn       references

almlop      lab        007c        316           319
anc         lab        03          162       
ascdel      lab        7f          212           270
asceot      lab        04          206       
ascesc      lab        1b          211       
ascibs      lab        08          207           269
ascicr      lab        0d          210       
asciht      lab        09          208       
ascilf      lab        0a          209       
asttab      lab        001a        289           308
b_read      lab        03          190       
chrdel      lab        00          159       
cnfipt      lab        00           29       
cnfist      lab        03           31       
cnfnop      lab        02           30       
cnfnos      lab        05           32       
conlop      lab        0031        245           248
constt      lab        16          176       
cursor      lab        18          178       
drum        lab        0a          169       
echo        lab        09          168       
echocr      lab        04          191       
edrum       lab        0c          170       
eiq         lab        20          183       
eofmrk      lab        00ff        200       
fiq         lab        1e          182       
gchr        lab        14          175           229
hfdup       lab        07          193       
ia          lab        06          192       
inpdel      lab        02          161       
ipcbax      lab        0039        254           238
ipcent      lab        06           15       
ipcnam      lab        00           14       
ipcpty      lab        0a           17       
ipcstz      lab        08           16       
iq          lab        1a          180       
ismadr      lab        00           23       
keysav      lab        10          173       
keysm       lab        0e          172       
kill        lab        06          165       
lfcnt       lab        07          166       
lindel      lab        01          160       
liq         lab        22          184       
lstt        lab        0e          199       
lsttab      lab        0024        296           226
msgbad      lab        08           73       
msgbcn      lab        0c           75       
msgbsz      lab        0a           74       
msghrs      lab        0a           79       
msglen      lab        04           66       
msglnk      lab        00           63       
msgmin      lab        09           78       
msgrc       lab        03           65       
msgrqc      lab        02           64       
msgrsm      lab        06           67       
msgsec      lab        08           77       

rtzcon0.s                c r o s s - r e f e r e n c e   l i s t i n g       8

rtzcon0.s                c r o s s - r e f e r e n c e   l i s t i n g       9

name       type       value       defn       references

msgspc      lab        0a           82       
msgwl       lab        08           81       
nullct      lab        08          167       
outstt      lab        17          177           310
pcbdlk      lab        04           40       
pcbdly      lab        02           39       
pcblnk      lab        00           38       
pcbnam      lab        0c           45       
pcbpcb      lab        10           47       
pcbpty      lab        0a           43       
pcbrnd      lab        0e           46       
pcbsem      lab        06           41       
pcbsp       lab        08           42       
pcbstt      lab        0b           44       
resume      lab        05          164       
schr        lab        12          174       
semimg      lab        06           57       
semmgq      lab        00           53       
semprq      lab        02           54       
semsem      lab        04           55       
stckaf      lab        08          147       
stckhl      lab        0a          148       
stckpc      lab        0c          149       
sttdly      lab        03          146       
stttab      lab        0044        268           225    289    296    307
suspnd      lab        04          163       
szistk      lab        32          150       
tiq         lab        1c          181       
z_a0sm      ext                                  304    317
z_a0st      lab        0024        346           306    310    315
z_alm0      ent        0068        305           256    302
z_c0gs      ext                                  221    228
z_c0rz      ext                                  221    232
z_c0sm      ext                                  220    246
z_c0st      lab        0000        345           224    229    231    244    335
z_cini      ext                                  220    233
z_con       ext                                  220    247    318
z_con0      ent        0000        223           218
z_cpro      ext                                  219    239
z_drm0      lab        0048        350           279
z_edr0      lab        00a2        351           280
z_gci       ext                                  331    336
z_gci0      ent        0084        333           330
z_ini0      ext                                  221    240
z_kes0      lab        0044        348           282
z_key0      lab        003e        347           235    281
z_kmg0      lab        0046        349           236
z_sch0      ext                                  266    283
z_sgnl      ext                                  219    237    303
zqbasc      lab        00           92           103    105
zqbbin      lab        04           93           104    106
zqbrd       lab        01           88           103    104    107
zqbstt      lab        08           95           107    108
zqbwrt      lab        02           90           105    106    108
zqcmcb      lab        69          117       
zqcmcf      lab        68          116       

rtzcon0.s                c r o s s - r e f e r e n c e   l i s t i n g       9

rtzcon0.s                c r o s s - r e f e r e n c e   l i s t i n g       10

name       type       value       defn       references

zqcmub      lab        6b          119       
zqcmuf      lab        6a          118       
zqcrda      lab        01          103       
zqcrdb      lab        05          104       
zqcrdc      lab        61          111       
zqcrds      lab        09          107       
zqcwaf      lab        64          114       
zqcwat      lab        63          113       
zqcwra      lab        02          105       
zqcwrb      lab        06          106       
zqcwrc      lab        62          112       
zqcwrs      lab        0a          108       
zrcbsy      lab        43          136       
zrcdwn      lab        47          139       
zrceof      lab        46          138       
zrceom      lab        48          140       
zrcerr      lab        42          135       
zrcint      lab        00          125       
zrcmis      lab        44          126       
zrcok       lab        00          133       
zrcovf      lab        45          137       
zrcto       lab        0080        127       
zrcunk      lab        41          134       


































rtzcon0.s                c r o s s - r e f e r e n c e   l i s t i n g       10
