
rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
1

                     1              2	;UPDATED: 811201 / PH
                     2              3	;REV:     2.00
                     3              4	 
                     4              5	;=======
                     5              6	; RTZ.CON - MULTI-CONSOLE DRIVER
                     6              7	;           MAIN MODULE
                     7              8	;
                     8              9	; COPYRIGHT: DIGITAILOR AB, SWEDEN
                     9             10	;
                    10             11	; REV. 2.00:  RELEASED 8111xx
                    11             12	;
                    12             13	; Accepts: IX = ^IMPURE AREA
                    13             14	;=======
                    14             15	 
                    15             16	;FILE:    RTZ.EQU.S
                    16             17	;UPDATED: 820120 / PH
                    17             18	 
                    18             19	;=======
                    19             20	; ALL INTERNAL EQUATES FOR RTZ/2
                    20             21	;=======
                    21             22	 
                    22             23	;-------
                    23             24	; Initial Process Control Block
                    24             25	;-------
                    25             26	 
                    26 00          27	IPCNAM	EQU	0		;PROCESS NAME
                    27 06          28	IPCENT	EQU	6		;PROCESS ENTRY
                    28 08          29	IPCSTZ	EQU	8		;STACK SIZE
                    29 0a          30	IPCPTY	EQU	10		;PROCESS PRIORITY
                    30             31	 
                    31             32	;-------
                    32             33	; Initial Semaphore
                    33             34	;-------
                    34             35	 
                    35 00          36	ISMADR	EQU	0		;SEMAPHORE ADDRESS
                    36             37	 
                    37             38	;-------
                    38             39	; Configuration Table - Z$CRTB
                    39             40	;-------
                    40             41	 
                    41 00          42	CNFIPT	EQU	0		;^INITIAL PROCESS TABLE
                    42 02          43	CNFNOP	EQU	2		;# OF IPCB:S IN IPT
                    43 03          44	CNFIST	EQU	3		;^INITIAL  SEMAPHORE TABLE
                    44 05          45	CNFNOS	EQU	5		;# OF ISEM:S IN IST
                    45             46	 
                    46             47	;-------
                    47             48	; Process Control Block
                    48             49	;-------
                    49             50	 
                    50 00          51	PCBLNK	EQU	0		;LINK FIELD
                    51 02          52	PCBDLY	EQU	2		;DELAY TIME
                    52 04          53	PCBDLK	EQU	4		;DELAY LINK FIELD
                    53 06          54	PCBSEM	EQU	6		;SEMAPHORE
                    54 08          55	PCBSP 	EQU	8		;STACK POINTER
                    55 0a          56	PCBPTY	EQU	10		;PROCESS PRIORITY
                    56 0b          57	PCBSTT	EQU	11		;STATUS BITS
                    57 0c          58	PCBNAM	EQU	12		;^NAME
                    58 0e          59	PCBRND	EQU	14		;RANDOM FIELD

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
1

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
2

                    59 10          60	PCBPCB	EQU	16		;STATIC PCB-LINK
                    60             61	 
                    61             62	;-------
                    62             63	; Semaphore
                    63             64	;-------
                    64             65	 
                    65 00          66	SEMMGQ	EQU	0		;MESSAGE QUEUE
                    66 02          67	SEMPRQ	EQU	2		;PROCESS (WAITING) QUEUE
                    67 04          68	SEMSEM	EQU	4		;STATIC SEMAPHORE-LINK
                    68             69	 
                    69 06          70	SEMIMG	EQU	6		;INTERRUPT MESSAGE
                    70             71	 
                    71             72	;-------
                    72             73	; Minimum Message
                    73             74	;-------
                    74             75	 
                    75 00          76	MSGLNK	EQU	0		;QUEUE LINK
                    76 02          77	MSGRQC	EQU	2		;REQUEST CODE
                    77 03          78	MSGRC 	EQU	3		;RETURN CODE
                    78 04          79	MSGLEN	EQU	4		;LENGTH
                    79 06          80	MSGRSM	EQU	6		;RESPONSE SEMAPHORE
                    80             81	 
                    81             82	;-------
                    82             83	; Device Request Message
                    83             84	;-------
                    84             85	 
                    85 08          86	MSGBAD	EQU	8		;BUFFER ADDRESS
                    86 0a          87	MSGBSZ	EQU	10		;BUFFER SIZE
                    87 0c          88	MSGBCN	EQU	12		;BYTE COUNT
                    88             89	 
                    89 08          90	MSGSEC	EQU	8		;SECONDS
                    90 09          91	MSGMIN	EQU	9		;MINUTES
                    91 0a          92	MSGHRS	EQU	10		;HOURS
                    92             93	 
                    93 08          94	MSGWL 	EQU	8		;WANTED LENGTH
                    94 0a          95	MSGSPC	EQU	10		;MAX SPACE OR ^FREE SPACE
                    95             96	 
                    96             97	;-------
                    97             98	; Device Request Bits
                    98             99	;-------
                    99            100	 
                   100            101	;ZQBRD 	EQU	1		;00.. ..01 READ
                   101 00         102	ZQbRD 	EQU	0
                   102            103	;ZQBWRT	EQU	2		;00.. ..10 WRITE
                   103 01         104	ZQbWRT	EQU	1
                   104 00         105	ZQBASC	EQU	0		;00.. .0.. ASCII
                   105            106	;ZQBBIN	EQU	4		;00.. .1.. BINARY
                   106 02         107	ZQbBIN	EQU	2
                   107            108	;ZQBSTT	EQU	8		;00.. 1... STATUS
                   108 03         109	ZQbSTT	EQU	3
                   109            110	
                   110            111	;-------
                   111            112	; Device Request Codes
                   112            113	;-------
                   113            114	 
                   114            115	      						;00xx xxxx COMMON CODES
                   115 01         116	ZQCRDA	EQU	1		;READ ASCII
                   116 05         117	ZQCRDB	EQU	5		;READ BINARY

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
2

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
3

                   117 02         118	ZQCWRA	EQU	2		;WRITE ASCII
                   118 06         119	ZQCWRB	EQU	6		;WRITE BINARY
                   119 09         120	ZQCRDS	EQU	9		;READ STATUS
                   120 0a         121	ZQCWRS	EQU	10		;WRITE STATUS
                   121            122	 
                   122            123	      				;01xx xxxx COMMAND CODES
                   123 61         124	ZQCRDC	EQU	61H		;READ CLOCK
                   124 62         125	ZQCWRC	EQU	62H		;WRITE CLOCK
                   125 63         126	ZQCWAT	EQU	63H		;WAKE AT
                   126 64         127	ZQCWAF	EQU	64H		;WAKE AFTER
                   127            128	 
                   128 68         129	ZQCMCF	EQU	68H		;CONDITIONAL, FAST
                   129 69         130	ZQCMCB	EQU	69H		;CONDITIONAL, BEST
                   130 6a         131	ZQCMUF	EQU	6AH		;UNCONDITIONAL, FAST
                   131 6b         132	ZQCMUB	EQU	6BH		;UNCONDITIONAL, BEST
                   132            133	 
                   133            134	;-------
                   134            135	; System Return Codes
                   135            136	;-------
                   136            137	 
                   137 00         138	ZRCINT	EQU	0		;INTERRUPT MESSAGE
                   138 44         139	ZRCMIS	EQU	44H		;MISSED INTERRUPT
                   139 00 80      140	ZRCTO 	EQU	80H		;1... .... TIME-OUT
                   140            141	 
                   141            142	;-------
                   142            143	; Device Return Codes
                   143            144	;-------
                   144            145	 
                   145 00         146	ZRCOK 	EQU	0		;NORMAL TERMINATION
                   146 41         147	ZRCUNK	EQU	41H		;UNKNOWN REQUEST CODE
                   147 42         148	ZRCERR	EQU	42H		;UNSPECIFIED ERROR
                   148 43         149	ZRCBSY	EQU	43H		;DEVICE BUSY
                   149 45         150	ZRCOVF	EQU	45H		;DATA OVERFLOW
                   150 46         151	ZRCEOF	EQU	46H		;END OF FILE
                   151 47         152	ZRCDWN	EQU	47H		;DEVICE OFF LINE
                   152 48         153	ZRCEOM	EQU	48H		;END OF MEDIA
                   153            154	 
                   154            155	;-------
                   155            156	; HELP EQUATES
                   156            157	;-------
                   157            158	 
                   158 03         159	STTDLY	EQU	3		;BIT 3 IN PCBSTT
                   159 08         160	STCKAF	EQU	8		;OFFSET TO AF IN STACK
                   160 0a         161	STCKHL	EQU	10		;OFFSET TO HL IN STACK
                   161 0c         162	STCKPC	EQU	12		;OFFSET TO PC IN STACK
                   162 32         163	SZISTK	EQU	50		;SIZE OF IDLE STACK
                   163            164	 
                   164            165	;FILE:    RTZ.CON.EQU.S
                   165            166	;UPDATED: 811201 / PH
                   166            167	 
                   167            168	;-------
                   168            169	; STTTAB - OFFSETS IN STATUS-TABLE
                   169            170	;-------
                   170            171	 
                   171 00         172	CHRDEL	EQU	0
                   172 01         173	LINDEL	EQU	1
                   173 02         174	INPDEL	EQU	2
                   174 03         175	ANC   	EQU	3		;ACCEPT NEXT CHARACTER

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
3

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
4

                   175 04         176	SUSPND	EQU	4
                   176 05         177	RESUME	EQU	5
                   177 06         178	KILL  	EQU	6
                   178 07         179	LFCNT 	EQU	7
                   179 08         180	NULLCT	EQU	8
                   180 09         181	ECHO  	EQU	9
                   181 0a         182	DRUM  	EQU	10		;^TAB DRUM
                   182 0c         183	EDRUM 	EQU	12
                   183            184	 
                   184 0e         185	KEYSM 	EQU	14
                   185 10         186	KEYSAV	EQU	16
                   186 12         187	SCHR  	EQU	18
                   187 14         188	GCHR  	EQU	20
                   188 16         189	CONSTT	EQU	22
                   189 17         190	OUTSTT	EQU	23
                   190 18         191	CURSOR	EQU	24
                   191            192	 
                   192 1a         193	IQ    	EQU	26
                   193 1c         194	TIQ   	EQU	28
                   194 1e         195	FIQ   	EQU	30
                   195 20         196	EIQ   	EQU	32
                   196 22         197	LIQ   	EQU	34
                   197            198	 
                   198            199	;-------
                   199            200	; BITS IN CONSTT
                   200            201	;-------
                   201            202	 
                   202 03         203	B_READ	EQU	3		;BIT 3 IN CONSTT
                   203 04         204	ECHOCR	EQU	4		;    4
                   204 06         205	IA    	EQU	6		;    6  (1="READ", 0="WRITE")
                   205 07         206	HFDUP 	EQU	7		;    7
                   206            207	 
                   207            208	;-------
                   208            209	; HELP EQUATES
                   209            210	;-------
                   210            211	 
                   211 0e         212	LSTT  	EQU	14		;LENGTH OF USER ACCESSIBLE STATUS-TABLE
                   212 00 ff      213	EOFMRK	EQU	0FFH
                   213            214	 
                   214            215	;=======
                   215            216	; ASCII-characters
                   216            217	;=======
                   217            218	 
                   218 04         219	ASCEOT	EQU	4		;^D
                   219 08         220	ASCIBS	EQU	8		;^H
                   220 09         221	ASCIHT	EQU	9		;^I  (TAB)
                   221 0a         222	ASCILF	EQU	0AH
                   222 0d         223	ASCICR	EQU	0DH
                   223 1b         224	ASCESC	EQU	1BH		;ESCAPE
                   224 7f         225	ASCDEL	EQU	7FH		;DELETE
                   225            226	 
                   226            227		GLOBAL	Z_CON
                   227            228		EXTERNAL	Z_EWAI,Z_SGNL,Z_CSEM
                   228            229	 
         0  0000   229 52 54      230		text	'RTZ.CON 2.00'
         0  0002       5a 2e   
         0  0004       43 4f   
         0  0006       4e 20   

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
4

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
5

         0  0008       32 2e   
         0  000a       30 30   

























































rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
5

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
6

                   230            232	 
                   231            233	Z_CON
         0  000c   232 cd 00 00   234		CALL	Z_EWAI
         0  000f   233 e5         235		PUSH	HL			;SAVE ^REQUEST
         0  0010   234 e5         236		PUSH	HL			;IY:=^REQUEST MESSAGE
         0  0011   235 fd e1      237		POP	IY
                   236            238	CONBEG
         0  0013   237 fd 6e 08   239		LD	L,(IY+MSGBAD)	;HL:=BAD
         0  0016   238 fd 66 09   240		LD	H,(IY+MSGBAD+1)
         0  0019   239 fd 4e 0a   241		LD	C,(IY+MSGBSZ)	;BC:=BSZ
         0  001c   240 fd 46 0b   242		LD	B,(IY+MSGBSZ+1)
         0  001f   241 fd 7e 02   243		LD	A,(IY+MSGRQC)	;A:=REQUEST CODE
         0  0022   242 fe 01      244		CP	ZQCRDA
         0  0024   243 28 46      245		JR	Z,GOODOP
         0  0026   244 fe 05      246		CP	ZQCRDB
         0  0028   245 28 42      247		JR	Z,GOODOP
         0  002a   246 fe 02      248		CP	ZQCWRA
         0  002c   247 28 3e      249		JR	Z,GOODOP
         0  002e   248 fe 06      250		CP	ZQCWRB
         0  0030   249 28 3a      251		JR	Z,GOODOP
         0  0032   250 fe 09      252		CP	ZQCRDS
         0  0034   251 28 18      253		JR	Z,RWSTT
         0  0036   252 fe 0a      254		CP	ZQCWRS
         0  0038   253 28 14      255		JR	Z,RWSTT
                   254            256		
                   255            257	BADOP
         0  003a   256 fd 36 03   258		LD	(IY+MSGRC),ZRCUNK
                                             41      
         0  003e   257 18 04      259		JR	EXIT10
                   258            260	 
                   259            261	; TERMINATION OF CON
                   260            262	 
                   261            263	EXIT
         0  0040   262 fd 36 03   264		LD	(IY+MSGRC),ZRCOK
                                             00      
                   263            265	EXIT10
         0  0044   264 e1         266		POP	HL			;HL:=^REQUEST
         0  0045   265 fd 5e 06   267		LD	E,(IY+MSGRSM)	;DE:=^RESPONSE SEMAPHORE
         0  0048   266 fd 56 07   268		LD	D,(IY+MSGRSM+1)
         0  004b   267 c3 00 00   269		JP	Z_SGNL
                   268            270		
                   269            271	;=======
                   270            272	; READ AND WRITE STATUS
                   271            273	;=======
                   272            274		
                   273            275	RWSTT
         0  004e   274 eb         276		EX	DE,HL		;DE:=BAD
         0  004f   275 21 0e 00   277		LD	HL,LSTT
         0  0052   276 a7         278		AND	A
         0  0053   277 ed 42      279		SBC	HL,BC
         0  0055   278 30 03      280		JR	NC,RWST10
         0  0057   279 01 0e 00   281		LD	BC,LSTT
                   280            282	RWST10
         0  005a   281 fd 71 0c   283		LD	(IY+MSGBCN),C
         0  005d   282 fd 70 0d   284		LD	(IY+MSGBCN+1),B
         0  0060   283 dd e5      285		PUSH	IX			;HL:=^Z_CXST
         0  0062   284 e1         286		POP	HL
         0  0063   285 fe 09      287		CP	ZQCRDS

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
6

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
7

         0  0065   286 28 01      288		JR	Z,RWST20
         0  0067   287 eb         289		EX	DE,HL
                   288            290	RWST20
         0  0068   289 ed b0      291		LDIR
         0  006a   290 18 d4      292		JR	EXIT
                   291            293	 
                   292            294	GOODOP
         0  006c   293 79         295		LD	A,C			;BSZ = 0 ?
         0  006d   294 b0         296		OR	B
         0  006e   295 20 08      297		JR	NZ,GOOD10		;NO
         0  0070   296 fd 71 0c   298		LD	(IY+MSGBCN),C
         0  0073   297 fd 70 0d   299		LD	(IY+MSGBCN+1),B
         0  0076   298 18 c8      300		JR	EXIT
                   299            301	GOOD10
         0  0078   300 fd cb 02   302		BIT	ZQbRD,(IY+MSGRQC)
                                             46      
         0  007c   301 c2 fa 00   303		JP	NZ,READ
                   302            304	 
                   303            305	;=======
                   304            306	; WRITE OPERATION
                   305            307	;=======
                   306            308		
                   307            309	WRITE
         0  007f   308 dd cb 16   310		RES	IA,(IX+CONSTT)	;INDICATE WRITE OPERATION
                                             b6      
         0  0083   309 dd cb 16   311		RES	B_READ,(IX+CONSTT)
                                             9e      
         0  0087   310 d5         312		PUSH	DE			;GET ACCESS TO SCREEN
         0  0088   311 e5         313		PUSH	HL
         0  0089   312 dd 5e 0e   314		LD	E,(IX+KEYSM)
         0  008c   313 dd 56 0f   315		LD	D,(IX+KEYSM+1)
         0  008f   314 cd 00 00   316		CALL	Z_EWAI
         0  0092   315 dd 75 10   317		LD	(IX+KEYSAV),L
         0  0095   316 dd 74 11   318		LD	(IX+KEYSAV+1),H
         0  0098   317 e1         319		POP	HL
         0  0099   318 d1         320		POP	DE
                   319            321	WRTLP
         0  009a   320 7e         322		LD	A,(HL)		;A:=CHAR TO BE WRITTEN
         0  009b   321 fe ff      323		CP	EOFMRK		;END OF FILE ?
         0  009d   322 20 06      324		JR	NZ,WRT20
         0  009f   323 fd cb 02   325		BIT	ZQbBIN,(IY+MSGRQC);YES, BINARY ?
                                             56      
         0  00a3   324 20 0e      326		JR	NZ,TTYDON		;YES, TERMINATE
                   325            327	WRT20
         0  00a5   326 cd 1d 02   328		CALL	TTYOUT
         0  00a8   327 23         329		INC	HL
         0  00a9   328 0b         330		DEC	BC
         0  00aa   329 fe 0d      331		CP	ASCICR		;LAST CHAR IS <CR> ?
         0  00ac   330 cc d8 00   332		CALL	Z,FINLIN		;YES
         0  00af   331 79         333		LD	A,C			;NO, ALL CHARS WRITTEN ?
         0  00b0   332 b0         334		OR	B
         0  00b1   333 20 e7      335		JR	NZ,WRTLP		;NO, GO ON
                   334            336	TTYDON
         0  00b3   335 d5         337		PUSH	DE
         0  00b4   336 e5         338		PUSH	HL
         0  00b5   337 dd 5e 0e   339		LD	E,(IX+KEYSM)	;RETURN SCREEN
         0  00b8   338 dd 56 0f   340		LD	D,(IX+KEYSM+1)
         0  00bb   339 dd 6e 10   341		LD	L,(IX+KEYSAV)

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
7

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
8

         0  00be   340 dd 66 11   342		LD	H,(IX+KEYSAV+1)
         0  00c1   341 cd 00 00   343		CALL	Z_SGNL
         0  00c4   342 e1         344		POP	HL
         0  00c5   343 d1         345		POP	DE
                   344            346	TTYD10
         0  00c6   345 fd 6e 0a   347		LD	L,(IY+MSGBSZ)	;HL:=REQUESTED BYTE COUNT
         0  00c9   346 fd 66 0b   348		LD	H,(IY+MSGBSZ+1)
         0  00cc   347 a7         349		AND	A
         0  00cd   348 ed 42      350		SBC	HL,BC		;BCN:=# OF CHARS WRITTEN
         0  00cf   349 fd 75 0c   351		LD	(IY+MSGBCN),L
         0  00d2   350 fd 74 0d   352		LD	(IY+MSGBCN+1),H
         0  00d5   351 c3 40 00   353		JP	EXIT
                   352            354	 
                   353            355	;=======
                   354            356	; FINLIN
                   355            357	;=======
                   356            358		
                   357            359	FINLIN
         0  00d8   358 c5         360		PUSH	BC
         0  00d9   359 dd 7e 16   361		LD	A,(IX+CONSTT)	;A:=CONSTT
         0  00dc   360 f5         362		PUSH	AF
         0  00dd   361 dd cb 16   363		RES	IA,(IX+CONSTT)
                                             b6      
         0  00e1   362 cd bd 02   364		CALL	LFS
         0  00e4   363 cd a7 02   365		CALL	NULLS
         0  00e7   364 f1         366		POP	AF
         0  00e8   365 dd 77 16   367		LD	(IX+CONSTT),A
         0  00eb   366 c1         368		POP	BC
         0  00ec   367 fd cb 02   369		BIT	ZQbBIN,(IY+MSGRQC);BINARY REQUEST ?
                                             56      
         0  00f0   368 c0         370		RET	NZ			;YES, GO ON
         0  00f1   369 e1         371		POP	HL			;NO, SKIP RETURN FROM FINLIN
         0  00f2   370 dd cb 16   372		BIT	B_READ,(IX+CONSTT)
                                             5e      
         0  00f6   371 20 ce      373		JR	NZ,TTYD10
         0  00f8   372 18 b9      374		JR	TTYDON		;TERMINATE CON
                   373            375	 
                   374            376	;=======
                   375            377	; READ OPERATION
                   376            378	;=======
                   377            379		
                   378            380	READ
         0  00fa   379 dd cb 17   381		BIT	0,(IX+OUTSTT)	;ALARM ?
                                             46      
         0  00fe   380 c2 3a 00   382		JP	NZ,BADOP		;YES, READ NOT ALLOWED
         0  0101   381 dd cb 16   383		SET	IA,(IX+CONSTT)	;INDICATE READ OPERATION
                                             f6      
         0  0105   382 dd cb 16   384		SET	B_READ,(IX+CONSTT)
                                             de      
         0  0109   383 e5         385		PUSH	HL			;SAVE BAD PUSH-1
                   384            386	RDLOOP
         0  010a   385 cd 32 03   387		CALL	GECHR		;NO, READ CHAR
         0  010d   386 dd be 03   388		CP	(IX+ANC)		;ACCEPT NEXT CHARACTER (^P) ?
         0  0110   387 20 0e      389		JR	NZ,RD20
                   388            390	 
                   389            391	; HANDLE "ACCEPT NEXT CHARACTER"
                   390            392	 
         0  0112   391 dd cb 09   393		BIT	0,(IX+ECHO)	;ECHO ?

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
8

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
9

                                             46      
         0  0116   392 c4 91 02   394		CALL	NZ,KEYOUT		;YES, WRITE BACKSLASH
         0  0119   393 cd 32 03   395		CALL	GECHR
         0  011c   394 77         396		LD	(HL),A
         0  011d   395 c3 fb 01   397		JP	NODEL4
                   396            398	RD20
         0  0120   397 dd be 02   399		CP	(IX+INPDEL)	;INPUT DELETE ?
         0  0123   398 20 18      400		JR	NZ,RD25		;NO
                   399            401	 
                   400            402	; HANDLE INPUT DELETE
                   401            403	 
         0  0125   402 e1         404		POP	HL			;YES, GET BAD POP-1
         0  0126   403 dd cb 16   405		RES	IA,(IX+CONSTT)
                                             b6      
         0  012a   404 3e 5c      406		LD	A,'\'
         0  012c   405 cd 91 02   407		CALL	KEYOUT
         0  012f   406 3e 0d      408		LD	A,ASCICR
         0  0131   407 cd 91 02   409		CALL	KEYOUT
         0  0134   408 cd bd 02   410		CALL	LFS
         0  0137   409 cd a7 02   411		CALL	NULLS
         0  013a   410 c3 13 00   412		JP	CONBEG
                   411            413	 
                   412            414	RD25
         0  013d   413 77         415		LD	(HL),A
         0  013e   414 e5         416		PUSH	HL			;BAD.CUR, PUSH-2
         0  013f   415 dd be 00   417		CP	(IX+CHRDEL)	;CHARACTER DELETE ?
         0  0142   416 20 33      418		JR	NZ,LD?
                   417            419	 
                   418            420	; HANDLE CHARACTER DELETE
                   419            421	 
         0  0144   420 d1         422		POP	DE			;DE:=BAD.CUR  POP-2
         0  0145   421 e1         423		POP	HL			;HL:=BAD  POP-1
         0  0146   422 e5         424		PUSH	HL			;PUSH-1
         0  0147   423 a7         425		AND	A
         0  0148   424 ed 52      426		SBC	HL,DE		;BUFFER EMPTY ?
         0  014a   425 eb         427		EX	DE,HL		;  HL:=BAD.CUR
         0  014b   426 28 bd      428		JR	Z,RDLOOP		;YES, DO NOTHING
         0  014d   427 dd cb 09   429		BIT	0,(IX+ECHO)
                                             46      
         0  0151   428 2b         430		DEC	HL
         0  0152   429 28 20      431		JR	Z,DELC20
         0  0154   430 7e         432		LD	A,(HL)
         0  0155   431 fe 09      433		CP	ASCIHT		;DELETE TAB ?
         0  0157   432 c5         434		PUSH	BC
         0  0158   433 06 01      435		LD	B,1			;  ASSUME NO
         0  015a   434 20 06      436		JR	NZ,DELC05		;NO
         0  015c   435 cd c7 02   437		CALL	GETCNT		;YES
         0  015f   436 47         438		LD	B,A
         0  0160   437 18 04      439		JR	DELC10
                   438            440	DELC05
         0  0162   439 fe 20      441		CP	20H			;DELETE CONTROL CHARACTER ?
         0  0164   440 38 0d      442		JR	C,DELC15		;YES
                   441            443	DELC10
         0  0166   442 cd e7 02   444		CALL	DELCH
         0  0169   443 dd cb 16   445		RES	IA,(IX+CONSTT)
                                             b6      
         0  016d   444 10 f7      446		DJNZ	DELC10
         0  016f   445 dd cb 16   447		SET	IA,(IX+CONSTT)

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
9

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
10

                                             f6      
                   446            448	DELC15
         0  0173   447 c1         449		POP	BC
                   448            450	DELC20
         0  0174   449 03         451		INC	BC
         0  0175   450 18 93      452		JR	RDLOOP
                   451            453	 
                   452            454	LD?
         0  0177   453 dd be 01   455		CP	(IX+LINDEL)	;LINE DELETE ?
         0  017a   454 20 36      456		JR	NZ,NODEL
                   455            457	 
                   456            458	; HANDLE LINE DELETE
                   457            459	 
                   458            460	DELL05
         0  017c   459 e1         461		POP	HL
         0  017d   460 d1         462		POP	DE
         0  017e   461 d5         463		PUSH	DE
         0  017f   462 a7         464		AND	A
         0  0180   463 ed 52      465		SBC	HL,DE
         0  0182   464 19         466		ADD	HL,DE
         0  0183   465 2b         467		DEC	HL
         0  0184   466 28 28      468		JR	Z,DELL10
         0  0186   467 7e         469		LD	A,(HL)
         0  0187   468 fe 0d      470		CP	ASCICR
         0  0189   469 28 23      471		JR	Z,DELL10
         0  018b   470 e5         472		PUSH	HL
         0  018c   471 03         473		INC	BC
         0  018d   472 c5         474		PUSH	BC
         0  018e   473 06 01      475		LD	B,1
         0  0190   474 fe 09      476		CP	ASCIHT
         0  0192   475 20 06      477		JR	NZ,DELL12
         0  0194   476 cd c7 02   478		CALL	GETCNT
         0  0197   477 47         479		LD	B,A
         0  0198   478 18 04      480		JR	DELL15
                   479            481	DELL12
         0  019a   480 fe 20      482		CP	20H
         0  019c   481 38 0d      483		JR	C,DELL17
                   482            484	DELL15
         0  019e   483 dd cb 16   485		RES	IA,(IX+CONSTT)
                                             b6      
         0  01a2   484 cd e7 02   486		CALL	DELCH
         0  01a5   485 10 f7      487		DJNZ	DELL15
         0  01a7   486 dd cb 16   488		SET	IA,(IX+CONSTT)
                                             f6      
                   487            489	DELL17
         0  01ab   488 c1         490		POP	BC
         0  01ac   489 18 ce      491		JR	DELL05
                   490            492	DELL10
         0  01ae   491 23         493		INC	HL
         0  01af   492 c3 0a 01   494		JP	RDLOOP
                   493            495	 
                   494            496	NODEL
         0  01b2   495 fe 04      497		CP	ASCEOT
         0  01b4   496 20 21      498		JR	NZ,NODEL2
                   497            499	 
                   498            500	; HANDLE END OF TEXT (^D)
                   499            501	 
         0  01b6   500 fd cb 02   502		BIT	ZQbBIN,(IY+MSGRQC);BINARY REQUEST ?

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
10

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
11

                                             56      
         0  01ba   501 28 1b      503		JR	Z,NODEL2		;NO, SKIP EOT-HANDLING
         0  01bc   502 e1         504		POP	HL			;HL:=BAD.CUR, POP-2
         0  01bd   503 36 ff      505		LD	(HL),EOFMRK
         0  01bf   504 0b         506		DEC	BC
         0  01c0   505 d1         507		POP	DE			;POP-1
         0  01c1   506 fd 6e 0a   508		LD	L,(IY+MSGBSZ)
         0  01c4   507 fd 66 0b   509		LD	H,(IY+MSGBSZ+1)
         0  01c7   508 a7         510		AND	A
         0  01c8   509 ed 42      511		SBC	HL,BC
         0  01ca   510 fd 75 0a   512		LD	(IY+MSGBSZ),L
         0  01cd   511 fd 74 0b   513		LD	(IY+MSGBSZ+1),H
         0  01d0   512 fd 36 03   514		LD	(IY+MSGRC),ZRCEOF
                                             46      
         0  01d4   513 c3 44 00   515		JP	EXIT10
                   514            516	 
                   515            517	NODEL2
         0  01d7   516 fe 14      518		CP	14H
         0  01d9   517 20 1f      519		JR	NZ,NODEL3
                   518            520	 
                   519            521	; HANDLE ^T
                   520            522	 
         0  01db   521 cd 32 03   523		CALL	GECHR
         0  01de   522 fe 20      524		CP	' '
         0  01e0   523 3e 01      525		LD	A,1
         0  01e2   524 20 01      526		JR	NZ,TABSET
         0  01e4   525 af         527		XOR	A
                   526            528	TABSET
         0  01e5   527 d5         529		PUSH	DE
         0  01e6   528 e5         530		PUSH	HL
         0  01e7   529 dd 6e 18   531		LD	L,(IX+CURSOR)	;HL:=CURSOR
         0  01ea   530 26 00      532		LD	H,0
         0  01ec   531 dd 5e 0a   533		LD	E,(IX+DRUM)
         0  01ef   532 dd 56 0b   534		LD	D,(IX+DRUM+1)
         0  01f2   533 19         535		ADD	HL,DE
         0  01f3   534 77         536		LD	(HL),A
         0  01f4   535 e1         537		POP	HL
         0  01f5   536 d1         538		POP	DE
         0  01f6   537 e1         539		POP	HL
         0  01f7   538 c3 0a 01   540		JP	RDLOOP
                   539            541	 
                   540            542	; HANDLE USUAL CHARACTER
                   541            543	 
                   542            544	NODEL3
         0  01fa   543 e1         545		POP	HL			;POP-2
                   544            546	NODEL4
         0  01fb   545 23         547		INC	HL			;NEXT POS IN BAD
         0  01fc   546 0b         548		DEC	BC
         0  01fd   547 fe 0d      549		CP	ASCICR
         0  01ff   548 20 06      550		JR	NZ,RD70
                   549            551	 
                   550            552	; HANDLE <CR>
                   551            553	 
         0  0201   552 dd cb 16   554		BIT	ECHOCR,(IX+CONSTT)
                                             66      
         0  0205   553 20 07      555		JR	NZ,RD80
                   554            556	RD70
         0  0207   555 dd cb 09   557		BIT	0,(IX+ECHO)

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
11

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
12

                                             46      
         0  020b   556 c4 91 02   558		CALL	NZ,KEYOUT
                   557            559	RD80
         0  020e   558 fe 0d      560		CP	ASCICR
         0  0210   559 d1         561		POP	DE			;POP-1
         0  0211   560 cc d8 00   562		CALL	Z,FINLIN
         0  0214   561 79         563		LD	A,C
         0  0215   562 b0         564		OR	B
         0  0216   563 ca c6 00   565		JP	Z,TTYD10
         0  0219   564 d5         566		PUSH	DE			;PUSH-1
         0  021a   565 c3 0a 01   567		JP	RDLOOP
                   566            568	 
                   567            569	 
                   568            570	;=======
                   569            571	; TTYOUT
                   570            572	;
                   571            573	; OUTPUT CHAR IN "A"
                   572            574	;=======
                   573            575	 
                   574            576	TTYOUT
         0  021d   575 f5         577		PUSH	AF			;SAVE CHAR
         0  021e   576 fe 20      578		CP	20H			;PRINTABLE CHAR OR DEL ?
         0  0220   577 30 59      579		JR	NC,ED50		;YES
         0  0222   578 fe 0d      580		CP	ASCICR		;NO, <CR> ?
         0  0224   579 20 06      581		JR	NZ,ED20		;NO
                   580            582	 
                   581            583	; HANDLE <CR>
                   582            584	 
         0  0226   583 dd 36 18   585		LD	(IX+CURSOR),0	;YES, RESET CURSOR
                                             00      
         0  022a   584 18 56      586		JR	ED90
                   585            587	 
                   586            588	ED20
         0  022c   587 fe 09      589		CP	ASCIHT		;TAB ?
         0  022e   588 20 41      590		JR	NZ,ED30
                   589            591	 
                   590            592	; HANDLE TABS
                   591            593	 
         0  0230   592 c5         594		PUSH	BC
         0  0231   593 d5         595		PUSH	DE
         0  0232   594 e5         596		PUSH	HL
         0  0233   595 dd 5e 18   597		LD	E,(IX+CURSOR)	;DE:=CURSOR
         0  0236   596 16 00      598		LD	D,0
         0  0238   597 dd 6e 0a   599		LD	L,(IX+DRUM)	;DE:=HL:=POS IN DRUM
         0  023b   598 dd 66 0b   600		LD	H,(IX+DRUM+1)
         0  023e   599 19         601		ADD	HL,DE
         0  023f   600 54         602		LD	D,H
         0  0240   601 5d         603		LD	E,L
         0  0241   602 dd 7e 16   604		LD	A,(IX+CONSTT)	;SAVE CONSTT
         0  0244   603 f5         605		PUSH	AF
         0  0245   604 dd cb 16   606		RES	IA,(IX+CONSTT)
                                             b6      
                   605            607	ED22
         0  0249   606 3e 20      608		LD	A,' '
         0  024b   607 cd 1d 02   609		CALL	TTYOUT
         0  024e   608 23         610		INC	HL			;HL:=NEXT POS IN DRUM
         0  024f   609 d5         611		PUSH	DE
         0  0250   610 dd 5e 0c   612		LD	E,(IX+EDRUM)

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
12

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
13

         0  0253   611 dd 56 0d   613		LD	D,(IX+EDRUM+1)
         0  0256   612 e5         614		PUSH	HL
         0  0257   613 a7         615		AND	A
         0  0258   614 ed 52      616		SBC	HL,DE		;OUT OF DRUM ?
         0  025a   615 e1         617		POP	HL			;  HL:=NEXT POS IN DRUM
         0  025b   616 d1         618		POP	DE			;  DE:=POS IN DRUM
         0  025c   617 30 0a      619		JR	NC,ED25		;YES, LEAVE TAB-HANDLING
         0  025e   618 7e         620		LD	A,(HL)		;NEXT POS IN DRUM = 0 ?
         0  025f   619 b7         621		OR	A
         0  0260   620 28 e7      622		JR	Z,ED22		;YES, EXAMINE NEXT POS
         0  0262   621 e5         623		PUSH	HL
         0  0263   622 ed 52      624		SBC	HL,DE		;HL:=TAB OFFSET
         0  0265   623 7d         625		LD	A,L
         0  0266   624 e1         626		POP	HL			;POS IN DRUM:=TAB OFFSET
         0  0267   625 77         627		LD	(HL),A
                   626            628	ED25
         0  0268   627 f1         629		POP	AF			;RESTORE CONSTT
         0  0269   628 dd 77 16   630		LD	(IX+CONSTT),A
         0  026c   629 e1         631		POP	HL
         0  026d   630 d1         632		POP	DE
         0  026e   631 c1         633		POP	BC
         0  026f   632 f1         634		POP	AF
         0  0270   633 c9         635		RET	
                   634            636		
                   635            637	ED30
         0  0271   636 dd be 00   638		CP	(IX+CHRDEL)	;BACKSPACE ?
         0  0274   637 20 0c      639		JR	NZ,ED90		;NO
                   638            640	 
                   639            641	; HANDLE BACK-SPACE
                   640            642	 
         0  0276   641 dd 35 18   643		DEC	(IX+CURSOR)
         0  0279   642 18 07      644		JR	ED90
                   643            645	 
                   644            646	; HANDLE USUAL CHARACTER AND DELETE
                   645            647	 
                   646            648	ED50
         0  027b   647 fe 7f      649		CP	ASCDEL		;DELETE ?
         0  027d   648 28 03      650		JR	Z,ED90
         0  027f   649 dd 34 18   651		INC	(IX+CURSOR)	;NO, INCREMENT CURSOR
                   650            652	ED90
         0  0282   651 f1         653		POP	AF			;A:=CHARACTER
         0  0283   652 dd cb 16   654		BIT	IA,(IX+CONSTT)		;WRITE OPERATION ?
                                             76      
         0  0287   653 28 04      655		JR	Z,ED95		;YES, WRITE CHARACTER
         0  0289   654 dd cb 16   656		BIT	HFDUP,(IX+CONSTT);NO, WRITE ONLY IF FULL DUPLEX
                                             7e      
                   655            657	ED95
         0  028d   656 ca ff 02   658		JP	Z,SECHR
         0  0290   657 c9         659		RET	
                   658            660	 
                   659            661	;=======
                   660            662	; KEYOUT - ASSIGN SCREEN AND "TTYOUT"
                   661            663	;=======
                   662            664	 
                   663            665	KEYOUT
         0  0291   664 d5         666		PUSH	DE
         0  0292   665 e5         667		PUSH	HL
         0  0293   666 f5         668		PUSH	AF

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
13

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
14

         0  0294   667 dd 5e 0e   669		LD	E,(IX+KEYSM)
         0  0297   668 dd 56 0f   670		LD	D,(IX+KEYSM+1)
         0  029a   669 cd 00 00   671		CALL	Z_EWAI
         0  029d   670 f1         672		POP	AF
         0  029e   671 cd 1d 02   673		CALL	TTYOUT
         0  02a1   672 cd 00 00   674		CALL	Z_SGNL
         0  02a4   673 e1         675		POP	HL
         0  02a5   674 d1         676		POP	DE
         0  02a6   675 c9         677		RET
                   676            678	 
                   677            679	;=======
                   678            680	; NULLS
                   679            681	;=======
                   680            682		
                   681            683	NULLS
         0  02a7   682 dd 7e 08   684		LD	A,(IX+NULLCT)
         0  02aa   683 b7         685		OR	A
         0  02ab   684 c8         686		RET	Z
         0  02ac   685 47         687		LD	B,A
         0  02ad   686 af         688		XOR	A			;A:=NULL
                   687            689	NULLIT
         0  02ae   688 dd cb 16   690		BIT	B_READ,(IX+CONSTT)
                                             5e      
         0  02b2   689 f5         691		PUSH	AF
         0  02b3   690 c4 91 02   692		CALL	NZ,KEYOUT
         0  02b6   691 f1         693		POP	AF
         0  02b7   692 cc 1d 02   694		CALL	Z,TTYOUT
         0  02ba   693 10 f2      695		DJNZ	NULLIT
         0  02bc   694 c9         696		RET	
                   695            697	 
                   696            698	;=======
                   697            699	; LFS
                   698            700	;=======
                   699            701		
                   700            702	LFS
         0  02bd   701 dd 7e 07   703		LD	A,(IX+LFCNT)
         0  02c0   702 b7         704		OR	A
         0  02c1   703 c8         705		RET	Z
         0  02c2   704 47         706		LD	B,A
         0  02c3   705 3e 0a      707		LD	A,ASCILF
         0  02c5   706 18 e7      708		JR	NULLIT
                   707            709	 
                   708            710	;=======
                   709            711	; GETCNT
                   710            712	;=======
                   711            713		
                   712            714	GETCNT
         0  02c7   713 d5         715		PUSH	DE
         0  02c8   714 e5         716		PUSH	HL
         0  02c9   715 dd 5e 0a   717		LD	E,(IX+DRUM)
         0  02cc   716 dd 56 0b   718		LD	D,(IX+DRUM+1)
         0  02cf   717 dd 6e 18   719		LD	L,(IX+CURSOR)	;HL:=CURSOR
         0  02d2   718 26 00      720		LD	H,0
         0  02d4   719 19         721		ADD	HL,DE
         0  02d5   720 dd 5e 0c   722		LD	E,(IX+EDRUM)
         0  02d8   721 dd 56 0d   723		LD	D,(IX+EDRUM+1)
         0  02db   722 a7         724		AND	A
         0  02dc   723 e5         725		PUSH	HL

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
14

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
15

         0  02dd   724 ed 52      726		SBC	HL,DE
         0  02df   725 e1         727		POP	HL
         0  02e0   726 7e         728		LD	A,(HL)
         0  02e1   727 e1         729		POP	HL
         0  02e2   728 d1         730		POP	DE
         0  02e3   729 d8         731		RET	C
         0  02e4   730 3e 01      732		LD	A,1
         0  02e6   731 c9         733		RET	
                   732            734	 
                   733            735	;=======
                   734            736	; DELCH - DELETE CHARACTER
                   735            737	;=======
                   736            738		
                   737            739	DELCH
         0  02e7   738 3e 08      740		LD	A,ASCIBS
         0  02e9   739 cd 91 02   741		CALL	KEYOUT
         0  02ec   740 3e 20      742		LD	A,' '
         0  02ee   741 dd cb 16   743		RES	IA,(IX+CONSTT)
                                             b6      
         0  02f2   742 cd 91 02   744		CALL	KEYOUT
         0  02f5   743 3e 08      745		LD	A,ASCIBS
         0  02f7   744 cd 91 02   746		CALL	KEYOUT
         0  02fa   745 dd cb 16   747		SET	IA,(IX+CONSTT)
                                             f6      
         0  02fe   746 c9         748		RET	
                   747            749	 
                   748            750	;=======
                   749            751	; SECHR
                   750            752	;=======
                   751            753	 
                   752            754	SECHR
         0  02ff   753 c5         755		PUSH	BC
         0  0300   754 d5         756		PUSH	DE
         0  0301   755 e5         757		PUSH	HL
                   756            758	SCHR10
         0  0302   757 dd 6e 12   759		LD	L,(IX+SCHR)
         0  0305   758 dd 66 13   760		LD	H,(IX+SCHR+1)
         0  0308   759 dd cb 17   761		BIT	0,(IX+OUTSTT)	;ALARM OUTPUT ?
                                             46      
         0  030c   760 20 1a      762		JR	NZ,SCHR20		;YES
         0  030e   761 dd cb 16   763		BIT	B_READ,(IX+CONSTT);READ REQUEST ?
                                             5e      
         0  0312   762 20 14      764		JR	NZ,SCHR20		;YES
         0  0314   763 dd cb 17   765		BIT	5,(IX+OUTSTT)	;OUTPUT KILLED ?
                                             6e      
         0  0318   764 20 13      766		JR	NZ,SCHR40		;YES
         0  031a   765 dd cb 17   767		BIT	6,(IX+OUTSTT)	;OUTPUT SUSPENDED ?
                                             76      
         0  031e   766 28 08      768		JR	Z,SCHR20		;NO
         0  0320   767 f5         769		PUSH	AF			;YES, SAVE CHAR
         0  0321   768 af         770		XOR	A			;A:=NULL
         0  0322   769 cd 31 03   771		CALL	JPHL			;CALL USER OUTPUT
         0  0325   770 f1         772		POP	AF			;RESTORE CHAR
         0  0326   771 18 da      773		JR	SCHR10
                   772            774	SCHR20
         0  0328   773 f5         775		PUSH	AF			;SAVE CHARACTER
         0  0329   774 cd 31 03   776		CALL	JPHL
         0  032c   775 f1         777		POP	AF			;RESTORE CHAR

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
15

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
16

                   776            778	SCHR40
         0  032d   777 e1         779		POP	HL
         0  032e   778 d1         780		POP	DE
         0  032f   779 c1         781		POP	BC
         0  0330   780 c9         782		RET
                   781            783	 
                   782            784	JPHL
         0  0331   783 e9         785		JP	(HL)
                   784            786	 
                   785            787	;=======
                   786            788	; GECHR - GET CHARACTER
                   787            789	;
                   788            790	; RETURNS: A  = ASCII CHARACTER WITH PARITY RESET
                   789            791	;=======
                   790            792	 
                   791            793	GECHR
         0  0332   792 d5         794		PUSH	DE
         0  0333   793 e5         795		PUSH	HL
                   794            796	RMIQ00
         0  0334   795 dd 5e 1e   797		LD	E,(IX+FIQ)	;DE:=^FRONT OF QUEUE
         0  0337   796 dd 56 1f   798		LD	D,(IX+FIQ+1)
         0  033a   797 f3         799		DI
         0  033b   798 dd 6e 20   800		LD	L,(IX+EIQ)	;HL:=^END OF QUEUE
         0  033e   799 dd 66 21   801		LD	H,(IX+EIQ+1)
         0  0341   800 a7         802		AND	A
         0  0342   801 ed 52      803		SBC	HL,DE		;QUEUE EMPTY ?
         0  0344   802 20 0c      804		JR	NZ,RMIQ10		;NO
         0  0346   803 fb         805		EI
         0  0347   804 dd 5e 14   806		LD	E,(IX+GCHR)	;YES, WAIT FOR INTERRUPT
         0  034a   805 dd 56 15   807		LD	D,(IX+GCHR+1)
         0  034d   806 cd 00 00   808		CALL	Z_EWAI
         0  0350   807 18 e2      809		JR	RMIQ00
                   808            810	RMIQ10
         0  0352   809 1a         811		LD	A,(DE)		;A:=FIRST ITEM IN QUEUE
         0  0353   810 e6 7f      812		AND	7FH			;RESET PARITY. CY:=0
         0  0355   811 13         813		INC	DE			;UPDATE Z_FIQ
         0  0356   812 dd 6e 1c   814		LD	L,(IX+TIQ)	;WRAPAROUND TEST
         0  0359   813 dd 66 1d   815		LD	H,(IX+TIQ+1)
         0  035c   814 ed 52      816		SBC	HL,DE		;Z_FIQ = Z_TIQ ?
         0  035e   815 20 06      817		JR	NZ,RMIQ20		;NO
         0  0360   816 dd 5e 1a   818		LD	E,(IX+IQ)		;YES, Z_FIQ:=Z_IQ
         0  0363   817 dd 56 1b   819		LD	D,(IX+IQ+1)
                   818            820	RMIQ20
         0  0366   819 dd 73 1e   821		LD	(IX+FIQ),E	;RESTORE Z_FIQ
         0  0369   820 dd 72 1f   822		LD	(IX+FIQ+1),D
         0  036c   821 fb         823		EI
         0  036d   822 e1         824		POP	HL
         0  036e   823 d1         825		POP	DE
         0  036f   824 c9         826		RET	
                   825            827	 
                   826            828	;-------
                   827            829	; Z_GCI - RECEIVE HANDLING
                   828            830	;
                   829            831	; RETURNS: CY = 1  IF CONTROL CHARACTER RECOGNIZED
                   830            832	;          CY = 0  IF NOT
                   831            833	;
                   832            834	; TO BE CALLED BY RECEIVE-INTERRUPT
                   833            835	;-------

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
16

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
17

                   834            836	 
                   835            837		GLOBAL	Z_GCI
                   836            838	 
                   837            839	Z_GCI
         0  0370   838 e6 7f      840		AND	7FH
         0  0372   839 dd be 04   841		CP	(IX+SUSPND)	;SUSPEND OUTPUT ?
         0  0375   840 20 08      842		JR	NZ,GCI10
         0  0377   841 dd cb 17   843		SET	6,(IX+OUTSTT)	;YES, SUSPEND OUTPUT
                                             f6      
                   842            844	GCI15
         0  037b   843 dd e1      845		POP	IX
         0  037d   844 37         846		SCF
         0  037e   845 c9         847		RET
                   846            848	GCI10
         0  037f   847 dd be 05   849		CP	(IX+RESUME)	;RESUME OUTPUT ?
         0  0382   848 20 06      850		JR	NZ,GCI20
         0  0384   849 dd cb 17   851		RES	6,(IX+OUTSTT)	;YES, RESUME OUTPUT
                                             b6      
         0  0388   850 18 f1      852		JR	GCI15
                   851            853	GCI20
         0  038a   852 dd be 06   854		CP	(IX+KILL)		;KILL OUTPUT ?
         0  038d   853 20 0a      855		JR	NZ,GCI30		;NO
         0  038f   854 dd 7e 17   856		LD	A,(IX+OUTSTT)	;YES, KILL OUTPUT
         0  0392   855 ee 20      857		XOR	00100000B
         0  0394   856 dd 77 17   858		LD	(IX+OUTSTT),A
         0  0397   857 18 e2      859		JR	GCI15
                   858            860	GCI30
         0  0399   859 d5         861		PUSH	DE
         0  039a   860 e5         862		PUSH	HL
         0  039b   861 dd 5e 20   863		LD	E,(IX+EIQ)	;DE:=^END OF QUEUE
         0  039e   862 dd 56 21   864		LD	D,(IX+EIQ+1)
         0  03a1   863 12         865		LD	(DE),A		;APPEND ITEM TO QUEUE
         0  03a2   864 13         866		INC	DE			;UPDATE END OF QUEUE
         0  03a3   865 dd 6e 1c   867		LD	L,(IX+TIQ)	;WRAPAROUND TEST
         0  03a6   866 dd 66 1d   868		LD	H,(IX+TIQ+1)
         0  03a9   867 a7         869		AND	A
         0  03aa   868 ed 52      870		SBC	HL,DE		;Z_EIQ = Z_TIQ ?
         0  03ac   869 20 06      871		JR	NZ,APIQ10		;NO
         0  03ae   870 dd 5e 1a   872		LD	E,(IX+IQ)		;YES, Z_EIQ:=Z_IQ
         0  03b1   871 dd 56 1b   873		LD	D,(IX+IQ+1)
                   872            874	APIQ10
         0  03b4   873 dd 6e 1e   875		LD	L,(IX+FIQ)	;HL:=^FRONT OF QUEUE
         0  03b7   874 dd 66 1f   876		LD	H,(IX+FIQ+1)
         0  03ba   875 a7         877		AND	A
         0  03bb   876 ed 52      878		SBC	HL,DE		;QUEUE FULL ?
         0  03bd   877 28 06      879		JR	Z,APIQ20		;YES
         0  03bf   878 dd 73 20   880		LD	(IX+EIQ),E	;NO, RESTORE Z_EIQ
         0  03c2   879 dd 72 21   881		LD	(IX+EIQ+1),D
                   880            882	APIQ20
         0  03c5   881 e1         883		POP	HL
         0  03c6   882 d1         884		POP	DE
         0  03c7   883 dd e1      885		POP	IX
         0  03c9   884 a7         886		AND	A			;CLEAR CY
         0  03ca   885 c9         887		RET
                   886            888	 
                   887            889	;=======
                   888            890	; Z_CINI - REENTRANT INIT FOR ALL CONSOLES
                   889            891	;=======

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
17

rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
18

                   890            892	 
                   891            893		GLOBAL	Z_CINI
                   892            894		EXTERNAL	Z_GETM
                   893            895	 
                   894            896	Z_CINI
         0  03cb   895 5d         897		LD	E,L			;DE:=HL=RING-SIZE
         0  03cc   896 54         898		LD	D,H
         0  03cd   897 cd 00 00   899		CALL	Z_GETM		;ALLOCATE TYPE-AHEAD RING
         0  03d0   898 dd 75 1a   900		LD	(IX+IQ),L
         0  03d3   899 dd 74 1b   901		LD	(IX+IQ+1),H
         0  03d6   900 dd 75 1e   902		LD	(IX+FIQ),L
         0  03d9   901 dd 74 1f   903		LD	(IX+FIQ+1),H
         0  03dc   902 dd 75 20   904		LD	(IX+EIQ),L
         0  03df   903 dd 74 21   905		LD	(IX+EIQ+1),H
         0  03e2   904 19         906		ADD	HL,DE		;CALCULATE TOP OF RING
         0  03e3   905 dd 75 1c   907		LD	(IX+TIQ),L
         0  03e6   906 dd 74 1d   908		LD	(IX+TIQ+1),H
         0  03e9   907 dd 73 22   909		LD	(IX+LIQ),E	;STORE RING-SIZE
         0  03ec   908 dd 72 23   910		LD	(IX+LIQ+1),D
                   909            911	 
         0  03ef   910 dd 6e 0a   912		LD	L,(IX+DRUM)	;SET TABS
         0  03f2   911 dd 66 0b   913		LD	H,(IX+DRUM+1)
         0  03f5   912 e5         914		PUSH	HL
         0  03f6   913 5d         915		LD	E,L
         0  03f7   914 54         916		LD	D,H
         0  03f8   915 13         917		INC	DE
         0  03f9   916 36 00      918		LD	(HL),0
         0  03fb   917 01 07 00   919		LD	BC,7
         0  03fe   918 ed b0      920		LDIR
         0  0400   919 36 ff      921		LD	(HL),0FFH
         0  0402   920 e1         922		POP	HL
         0  0403   921 01 48 00   923		LD	BC,9*8
         0  0406   922 ed b0      924		LDIR
                   923            925	 
         0  0408   924 dd 5e 0e   926		LD	E,(IX+KEYSM)	;CREATE KEY-SEMAPHORE
         0  040b   925 dd 56 0f   927		LD	D,(IX+KEYSM+1)
         0  040e   926 c3 00 00   928		JP	Z_CSEM
                   927            929	
         0  0411   928            930		end





the number of errors detected in this assembly is 0














rtzconm.s                RTZ.CON.MAIN                                          LER     Tue Feb  7 13:55:35 1984
18
