
rtzrtc.s                 RTZ.RTC                                               ER     Tue Feb  7 17:03:10 1984
1

                     1              2	;Updated: 831012 / OL
                     2              3	;Created: <810624 / Peter Holmgren, DIGITAILOR AB
                     3              4	 
                     4              5	;=======
                     5              6	; Z_RTCK - REAL-TIME CLOCK
                     6              7	;
                     7              8	; RTC 2.00: Released 820125
                     8              9	;     2.01: Released 821212
                     9             10	;     2.02: Released 830921
                    10             11	;           Adjustable for different system ticks
                    11             12	;           Lots of globals replaced by equates
                    12             13	;           Better handling of multiple time-outs
                    13             14	;     2.03: Each 'ZQCWAF' generated 1 sek more delay!
                    14             15	;           Shorter SUBTIM
                    15             16	;=======
                    16             17	 
                    17             18	;FILE:    RTZ.EQU.S
                    18             19	;UPDATED: 820120 / PH
                    19             20	 
                    20             21	;=======
                    21             22	; ALL INTERNAL EQUATES FOR RTZ/2
                    22             23	;=======
                    23             24	 
                    24             25	;-------
                    25             26	; Initial Process Control Block
                    26             27	;-------
                    27             28	 
                    28 00          29	IPCNAM	EQU	0		;PROCESS NAME
                    29 06          30	IPCENT	EQU	6		;PROCESS ENTRY
                    30 08          31	IPCSTZ	EQU	8		;STACK SIZE
                    31 0a          32	IPCPTY	EQU	10		;PROCESS PRIORITY
                    32             33	 
                    33             34	;-------
                    34             35	; Initial Semaphore
                    35             36	;-------
                    36             37	 
                    37 00          38	ISMADR	EQU	0		;SEMAPHORE ADDRESS
                    38             39	 
                    39             40	;-------
                    40             41	; Configuration Table - Z$CRTB
                    41             42	;-------
                    42             43	 
                    43 00          44	CNFIPT	EQU	0		;^INITIAL PROCESS TABLE
                    44 02          45	CNFNOP	EQU	2		;# OF IPCB:S IN IPT
                    45 03          46	CNFIST	EQU	3		;^INITIAL  SEMAPHORE TABLE
                    46 05          47	CNFNOS	EQU	5		;# OF ISEM:S IN IST
                    47             48	 
                    48             49	;-------
                    49             50	; Process Control Block
                    50             51	;-------
                    51             52	 
                    52 00          53	PCBLNK	EQU	0		;LINK FIELD
                    53 02          54	PCBDLY	EQU	2		;DELAY TIME
                    54 04          55	PCBDLK	EQU	4		;DELAY LINK FIELD
                    55 06          56	PCBSEM	EQU	6		;SEMAPHORE
                    56 08          57	PCBSP 	EQU	8		;STACK POINTER
                    57 0a          58	PCBPTY	EQU	10		;PROCESS PRIORITY
                    58 0b          59	PCBSTT	EQU	11		;STATUS BITS

rtzrtc.s                 RTZ.RTC                                               ER     Tue Feb  7 17:03:10 1984
1

rtzrtc.s                 RTZ.RTC                                               ER     Tue Feb  7 17:03:10 1984
2

                    59 0c          60	PCBNAM	EQU	12		;^NAME
                    60 0e          61	PCBRND	EQU	14		;RANDOM FIELD
                    61 10          62	PCBPCB	EQU	16		;STATIC PCB-LINK
                    62             63	 
                    63             64	;-------
                    64             65	; Semaphore
                    65             66	;-------
                    66             67	 
                    67 00          68	SEMMGQ	EQU	0		;MESSAGE QUEUE
                    68 02          69	SEMPRQ	EQU	2		;PROCESS (WAITING) QUEUE
                    69 04          70	SEMSEM	EQU	4		;STATIC SEMAPHORE-LINK
                    70             71	 
                    71 06          72	SEMIMG	EQU	6		;INTERRUPT MESSAGE
                    72             73	 
                    73             74	;-------
                    74             75	; Minimum Message
                    75             76	;-------
                    76             77	 
                    77 00          78	MSGLNK	EQU	0		;QUEUE LINK
                    78 02          79	MSGRQC	EQU	2		;REQUEST CODE
                    79 03          80	MSGRC 	EQU	3		;RETURN CODE
                    80 04          81	MSGLEN	EQU	4		;LENGTH
                    81 06          82	MSGRSM	EQU	6		;RESPONSE SEMAPHORE
                    82             83	 
                    83             84	;-------
                    84             85	; Device Request Message
                    85             86	;-------
                    86             87	 
                    87 08          88	MSGBAD	EQU	8		;BUFFER ADDRESS
                    88 0a          89	MSGBSZ	EQU	10		;BUFFER SIZE
                    89 0c          90	MSGBCN	EQU	12		;BYTE COUNT
                    90             91	 
                    91 08          92	MSGSEC	EQU	8		;SECONDS
                    92 09          93	MSGMIN	EQU	9		;MINUTES
                    93 0a          94	MSGHRS	EQU	10		;HOURS
                    94             95	 
                    95 08          96	MSGWL 	EQU	8		;WANTED LENGTH
                    96 0a          97	MSGSPC	EQU	10		;MAX SPACE OR ^FREE SPACE
                    97             98	 
                    98             99	;-------
                    99            100	; Device Request Bits
                   100            101	;-------
                   101            102	 
                   102 01         103	ZQBRD 	EQU	1		;00.. ..01 READ
                   103            104	;ZQbRD 	EQU	0
                   104 02         105	ZQBWRT	EQU	2		;00.. ..10 WRITE
                   105            106	;ZQbWRT	EQU	1
                   106 00         107	ZQBASC	EQU	0		;00.. .0.. ASCII
                   107 04         108	ZQBBIN	EQU	4		;00.. .1.. BINARY
                   108            109	;ZQbBIN	EQU	2
                   109 08         110	ZQBSTT	EQU	8		;00.. 1... STATUS
                   110            111	;ZQbSTT	EQU	3
                   111            112	 
                   112            113	;-------
                   113            114	; Device Request Codes
                   114            115	;-------
                   115            116	 
                   116            117	      						;00xx xxxx COMMON CODES

rtzrtc.s                 RTZ.RTC                                               ER     Tue Feb  7 17:03:10 1984
2

rtzrtc.s                 RTZ.RTC                                               ER     Tue Feb  7 17:03:10 1984
3

                   117 01         118	ZQCRDA	EQU	ZQBRD+ZQBASC		;READ ASCII
                   118 05         119	ZQCRDB	EQU	ZQBRD+ZQBBIN		;READ BINARY
                   119 02         120	ZQCWRA	EQU	ZQBWRT+ZQBASC		;WRITE ASCII
                   120 06         121	ZQCWRB	EQU	ZQBWRT+ZQBBIN		;WRITE BINARY
                   121 09         122	ZQCRDS	EQU	ZQBRD+ZQBSTT		;READ STATUS
                   122 0a         123	ZQCWRS	EQU	ZQBWRT+ZQBSTT		;WRITE STATUS
                   123            124	 
                   124            125	      				;01xx xxxx COMMAND CODES
                   125 61         126	ZQCRDC	EQU	61H		;READ CLOCK
                   126 62         127	ZQCWRC	EQU	62H		;WRITE CLOCK
                   127 63         128	ZQCWAT	EQU	63H		;WAKE AT
                   128 64         129	ZQCWAF	EQU	64H		;WAKE AFTER
                   129            130	 
                   130 68         131	ZQCMCF	EQU	68H		;CONDITIONAL, FAST
                   131 69         132	ZQCMCB	EQU	69H		;CONDITIONAL, BEST
                   132 6a         133	ZQCMUF	EQU	6AH		;UNCONDITIONAL, FAST
                   133 6b         134	ZQCMUB	EQU	6BH		;UNCONDITIONAL, BEST
                   134            135	 
                   135            136	;-------
                   136            137	; System Return Codes
                   137            138	;-------
                   138            139	 
                   139 00         140	ZRCINT	EQU	0		;INTERRUPT MESSAGE
                   140 44         141	ZRCMIS	EQU	44H		;MISSED INTERRUPT
                   141 00 80      142	ZRCTO 	EQU	80H		;1... .... TIME-OUT
                   142            143	 
                   143            144	;-------
                   144            145	; Device Return Codes
                   145            146	;-------
                   146            147	 
                   147 00         148	ZRCOK 	EQU	0		;NORMAL TERMINATION
                   148 41         149	ZRCUNK	EQU	41H		;UNKNOWN REQUEST CODE
                   149 42         150	ZRCERR	EQU	42H		;UNSPECIFIED ERROR
                   150 43         151	ZRCBSY	EQU	43H		;DEVICE BUSY
                   151 45         152	ZRCOVF	EQU	45H		;DATA OVERFLOW
                   152 46         153	ZRCEOF	EQU	46H		;END OF FILE
                   153 47         154	ZRCDWN	EQU	47H		;DEVICE OFF LINE
                   154 48         155	ZRCEOM	EQU	48H		;END OF MEDIA
                   155            156	 
                   156            157	;-------
                   157            158	; HELP EQUATES
                   158            159	;-------
                   159            160	 
                   160 03         161	STTDLY	EQU	3		;BIT 3 IN PCBSTT
                   161 08         162	STCKAF	EQU	8		;OFFSET TO AF IN STACK
                   162 0a         163	STCKHL	EQU	10		;OFFSET TO HL IN STACK
                   163 0c         164	STCKPC	EQU	12		;OFFSET TO PC IN STACK
                   164 32         165	SZISTK	EQU	50		;SIZE OF IDLE STACK
                   165            166	 
                   166            167	 
                   167 ff         168	Z$PRSC	equ	-1			;prescaler (0.2 s)
                   168 03         169	Z$RTQU	equ	3			;head of "wake at" queue
                   169 05         170	Z$RTDQ	equ	Z$RTQU+2		;head of "wake after" queue
                   170            171	 
                   171            172	; Up to here is cleared before start
                   172            173	 
                   173 07         174	Z$TKMG	equ	Z$RTDQ+2		;tick (0.2 s) message
                   174 09         175	Z$TISM	equ	Z$TKMG+2		;pretick semaphore

rtzrtc.s                 RTZ.RTC                                               ER     Tue Feb  7 17:03:10 1984
3

rtzrtc.s                 RTZ.RTC                                               ER     Tue Feb  7 17:03:10 1984
4

                   175 0f         176	Z$CBSM	equ	Z$TISM+6		;tick (0.2 s) semaphore
                   176            177	 
                   177 15         178	Z$ACTM	equ	Z$CBSM+6		;help for "tortdq"
                   178 18         179	Z$ACTT	equ	Z$ACTM+3		;      - " -
                   179            180	 
                   180 1b         181	RTCSIZ	equ	Z$ACTT+3
                   181            182	 
                   182            183		global	Z_RTCK
                   183            184		external	Z_SGNL,Z_WAIT,Z_EWAI,Z_CSEM,Z_CPRO
                   184            185		external	Z_CKSM,Z_RTCP
                   185            186	 
         0  0000   186 52 54      187		text	'RTZ.RTC 2.03'
         0  0002       5a 2e   
         0  0004       52 54   
         0  0006       43 20   
         0  0008       32 2e   
         0  000a       30 33   










































rtzrtc.s                 RTZ.RTC                                               ER     Tue Feb  7 17:03:10 1984
4

rtzrtc.s                 Z_RTCK                                                ER     Tue Feb  7 17:03:10 1984
5

                   187            189	Z_RTCK
         0  000c   188 11 0c 00   190		LD	DE,Z_SECS+Z$TISM;CREATE NECESSARY SEMAPHORES
         0  000f   189 cd 00 00   191		CALL	Z_CSEM
         0  0012   190 11 12 00   192		LD	DE,Z_SECS+Z$CBSM
         0  0015   191 cd 00 00   193		CALL	Z_CSEM
         0  0018   192 11 5e 02   194		LD	DE,IPCBCB		;CREATE BUFFER-PROCESS
         0  001b   193 cd 00 00   195		CALL	Z_CPRO
                   194            196	 
         0  001e   195 af         197		XOR	A			;CLEAR CLOCK
         0  001f   196 21 00 00   198		LD	HL,Z_CKUP		;  ^DISPLAY ROUTINES
         0  0022   197 06 07      199		LD	B,Z$TKMG+3	;  QUEUE HEADS
                   198            200	CLOC05
         0  0024   199 77         201		LD	(HL),A
         0  0025   200 23         202		INC	HL
         0  0026   201 10 fc      203		DJNZ	CLOC05
                   202            204	 
                   203            205	;-------
                   204            206	; MAIN LOOP
                   205            207	;-------
                   206            208	 
                   207            209	CLOC10
         0  0028   208 11 12 00   210		LD	DE,Z_SECS+Z$CBSM;WAIT FOR TICK
         0  002b   209 cd 00 00   211		CALL	Z_EWAI
         0  002e   210 21 02 00   212		LD	HL,Z_SECS+Z$PRSC;COUNT 200 MS:S
         0  0031   211 34         213		INC	(HL)
         0  0032   212 7e         214		LD	A,(HL)
         0  0033   213 fe 05      215		CP	5			;NEW SECOND ?
         0  0035   214 da b9 00   216		JP	C,REQEST		;NO - RETURN
         0  0038   215 cd 3b 02   217		CALL	CLOCUP
         0  003b   216 38 2b      218		JR	C,UPDATE
         0  003d   217 cd 3b 02   219		CALL	CLOCUP
         0  0040   218 38 26      220		JR	C,UPDATE
         0  0042   219 cd 3b 02   221		CALL	CLOCUP
         0  0045   220 fe 24      222		CP	24H			;NEW DAY ?
         0  0047   221 38 1f      223		JR	C,UPDATE
         0  0049   222 36 00      224		LD	(HL),0		;CLEAR HOURS
         0  004b   223 dd 2a 06   225		LD	IX,(Z_SECS+Z$RTQU);IX:=^RTQU.1ST
                                             00      
                   224            226	CLOC20
         0  004f   225 dd         227		DEFB	0DDH			;RTQU EMPTY ?
         0  0050   226 7d         228		LD	A,L
         0  0051   227 dd         229		DEFB	0DDH
         0  0052   228 b4         230		OR	H
         0  0053   229 28 13      231		JR	Z,UPDATE		;YES
         0  0055   230 dd 7e 0a   232		LD	A,(IX+MSGHRS)	;NO, SET TIME TO TODAY
         0  0058   231 d6 24      233		SUB	24H
         0  005a   232 dd 77 0a   234		LD	(IX+MSGHRS),A
         0  005d   233 dd 6e 00   235		LD	L,(IX+0)		;IX:=^RTQU.NEXT
         0  0060   234 dd 66 01   236		LD	H,(IX+1)
         0  0063   235 e5         237		PUSH	HL
         0  0064   236 dd e1      238		POP	IX
         0  0066   237 18 e7      239		JR	CLOC20
                   238            240	 
                   239            241	;-------
                   240            242	; UPDATE DISPLAY
                   241            243	;-------
                   242            244	 
                   243            245	UPDATE:

rtzrtc.s                 Z_RTCK                                                ER     Tue Feb  7 17:03:10 1984
5

rtzrtc.s                 Z_RTCK                                                ER     Tue Feb  7 17:03:10 1984
6

         0  0068   244 2a 00 00   246		LD	HL,(Z_CKUP)	;HL:=^DISPLAY ROUTINE IF ANY
         0  006b   245 7d         247		LD	A,L
         0  006c   246 b4         248		OR	H			;DISPLAY ?
         0  006d   247 c4 46 02   249		CALL	NZ,JPHL		;YES, CALL ROUTINE
                   248            250	 
                   249            251	;-------
                   250            252	; CHECK IF TIME-OUT
                   251            253	;-------
                   252            254	 
                   253            255	CLOC25
         0  0070   254 dd 2a 06   256		LD	IX,(Z_SECS+Z$RTQU);IX:=^RTQU.1ST
                                             00      
         0  0074   255 dd         257		DEFB	0DDH			;RTQU EMPTY ?
         0  0075   256 7d         258		LD	A,L
         0  0076   257 dd         259		DEFB	0DDH
         0  0077   258 b4         260		OR	H
         0  0078   259 28 0d      261		JR	Z,CLOC27
         0  007a   260 cd 22 02   262		CALL	CPTIME		;TIME-OUT ?
         0  007d   261 20 08      263		JR	NZ,CLOC27		;NO, GO ON
         0  007f   262 21 06 00   264		LD	HL,Z_SECS+Z$RTQU
         0  0082   263 cd 2f 01   265		CALL	FRQUEU		;YES, REMOVE ITEM FROM RTQU
         0  0085   264 18 e9      266		JR	CLOC25		;CHECK IF MORE TIME-OUTS
                   265            267	 
                   266            268	CLOC27
         0  0087   267 2a 08 00   269		LD	HL,(Z_SECS+Z$RTDQ);HL:=^RTDQ.1ST
         0  008a   268 7d         270		LD	A,L			;RTDQ EMPTY ?
         0  008b   269 b4         271		OR	H
         0  008c   270 28 2b      272		JR	Z,REQEST		;YES
         0  008e   271 e5         273		PUSH	HL			;NO, TICK ONE SECOND
         0  008f   272 dd e1      274		POP	IX			;IX:=^RTDQ.1ST
         0  0091   273 11 08 00   275		LD	DE,MSGSEC		;DE:=^RTDQ.1ST.TIME
         0  0094   274 19         276		ADD	HL,DE
         0  0095   275 eb         277		EX	DE,HL
         0  0096   276 21 47 02   278		LD	HL,ONESEC
         0  0099   277 cd ed 01   279		CALL	SUBTIM
         0  009c   278 38 0b      280		JR	C,CLOC29		;Timeout
                   279            281	 
                   280            282	CLOC28:
         0  009e   281 dd 7e 08   283		LD	A,(IX+MSGSEC)
         0  00a1   282 dd b6 09   284		OR	(IX+MSGMIN)
         0  00a4   283 dd b6 0a   285		OR	(IX+MSGHRS)
         0  00a7   284 20 10      286		JR	NZ,REQEST	;No timeout
                   285            287	 
                   286            288	CLOC29:
         0  00a9   287 21 08 00   289		LD	HL,Z_SECS+Z$RTDQ
         0  00ac   288 cd 2f 01   290		CALL	FRQUEU		;REMOVE ITEM FROM RTDQ
         0  00af   289 2a 08 00   291		LD	HL,(Z_SECS+Z$RTDQ);check if more time-outs
         0  00b2   290 7d         292		LD	A,L
         0  00b3   291 b4         293		OR	H
         0  00b4   292 e5         294		PUSH	HL
         0  00b5   293 dd e1      295		POP	IX
         0  00b7   294 20 e5      296		JR	NZ,CLOC28		;Queue is not empty
                   295            297	 
                   296            298	;-------
                   297            299	; CHECK IF ANY REQUEST
                   298            300	;-------
                   299            301	 
                   300            302	REQEST

rtzrtc.s                 Z_RTCK                                                ER     Tue Feb  7 17:03:10 1984
6

rtzrtc.s                 Z_RTCK                                                ER     Tue Feb  7 17:03:10 1984
7

         0  00b9   301 11 00 00   303		LD	DE,Z_CKSM		;ANY REQUEST ?
         0  00bc   302 21 00 00   304		LD	HL,0			;POLL
         0  00bf   303 cd 00 00   305		CALL	Z_WAIT
         0  00c2   304 7d         306		LD	A,L
         0  00c3   305 b4         307		OR	H
         0  00c4   306 ca 28 00   308		JP	Z,CLOC10		;NO
         0  00c7   307 e5         309		PUSH	HL			;SAVE ^REQUEST-MESSAGE
         0  00c8   308 23         310		INC	HL			;HL:=^CLCKMG.MSGRQC
         0  00c9   309 23         311		INC	HL
         0  00ca   310 7e         312		LD	A,(HL)		;A:=CLCKMG.MSGRQC
         0  00cb   311 23         313		INC	HL
         0  00cc   312 36 00      314		LD	(HL),ZRCOK	;ASSUME GOOD RQC
         0  00ce   313 23         315		INC	HL			;HL:=^CLKMSG.RSM
         0  00cf   314 23         316		INC	HL
         0  00d0   315 23         317		INC	HL
         0  00d1   316 4e         318		LD	C,(HL)		;BC:=^RESPONSE SEMAPHORE
         0  00d2   317 23         319		INC	HL
         0  00d3   318 46         320		LD	B,(HL)
         0  00d4   319 23         321		INC	HL			;HL:=^CLCKMG.SS
         0  00d5   320 fe 61      322		CP	ZQCRDC
         0  00d7   321 20 12      323		JR	NZ,CLOC60
                   322            324	 
                   323            325	;-------
                   324            326	; WHAT TIME IS IT ?
                   325            327	;-------
                   326            328	 
         0  00d9   327 11 03 00   329		LD	DE,Z_SECS		;DE:=^SECOND
         0  00dc   328 eb         330		EX	DE,HL
                   329            331	CLOC55
         0  00dd   330 c5         332		PUSH	BC
         0  00de   331 01 03 00   333		LD	BC,3
         0  00e1   332 ed b0      334		LDIR
         0  00e3   333 d1         335		POP	DE
         0  00e4   334 e1         336		POP	HL			;HL:=^CLCKMG
         0  00e5   335 cd 00 00   337		CALL	Z_SGNL
         0  00e8   336 c3 28 00   338		JP	CLOC10
                   337            339	 
                   338            340	CLOC60
         0  00eb   339 fe 62      341		CP	ZQCWRC
         0  00ed   340 20 08      342		JR	NZ,CLOC70
                   341            343	 
                   342            344	;-------
                   343            345	; SET TIME
                   344            346	;-------
                   345            347	 
         0  00ef   346 11 02 00   348		LD	DE,Z_SECS+Z$PRSC;DE:=^PRESCALER
         0  00f2   347 af         349		XOR	A			;CLEAR PRESCALER
         0  00f3   348 12         350		LD	(DE),A
         0  00f4   349 13         351		INC	DE			;DE:=^SECOND
         0  00f5   350 18 e6      352		JR	CLOC55
                   351            353	 
                   352            354	CLOC70
         0  00f7   353 fe 63      355		CP	ZQCWAT
         0  00f9   354 20 18      356		JR	NZ,CLOC80
                   355            357	 
                   356            358	;-------
                   357            359	; WAKE ME AT "HH.MM.SS"
                   358            360	;-------

rtzrtc.s                 Z_RTCK                                                ER     Tue Feb  7 17:03:10 1984
7

rtzrtc.s                 Z_RTCK                                                ER     Tue Feb  7 17:03:10 1984
8

                   359            361	 
         0  00fb   360 dd e1      362		POP	IX			;IX:=^REQUEST MESSAGE
         0  00fd   361 cd 22 02   363		CALL	CPTIME		;TODAY ?
         0  0100   362 38 08      364		JR	C,CLOC75		;YES
         0  0102   363 dd 7e 0a   365		LD	A,(IX+MSGHRS)	;NO, MAKE IT TOMORROW
         0  0105   364 c6 24      366		ADD	A,24H
         0  0107   365 dd 77 0a   367		LD	(IX+MSGHRS),A
                   366            368	CLOC75
         0  010a   367 dd e5      369		PUSH	IX			;LINK IX^ TO RTQU
         0  010c   368 c1         370		POP	BC
         0  010d   369 cd 44 01   371		CALL	TORTQU
         0  0110   370 c3 28 00   372		JP	CLOC10
                   371            373	 
                   372            374	CLOC80
         0  0113   373 fe 64      375		CP	ZQCWAF
         0  0115   374 20 07      376		JR	NZ,CLOC90
                   375            377	 
                   376            378	;-------
                   377            379	; WAKE ME AFTER "HH.MM.SS"
                   378            380	;-------
                   379            381	 
         0  0117   380 c1         382		POP	BC			;BC:=^REQUEST  MESSAGE
         0  0118   381 cd 71 01   383		CALL	TORTDQ
         0  011b   382 c3 28 00   384		JP	CLOC10
                   383            385	 
                   384            386	;-------
                   385            387	; UNKNOWN OPCODE
                   386            388	;-------
                   387            389	 
                   388            390	CLOC90
         0  011e   389 e1         391		POP	HL			;HL:=^REQUEST MESSAGE
         0  011f   390 5d         392		LD	E,L			;DE:=^REQUEST MESSAGE.MSGRC
         0  0120   391 54         393		LD	D,H
         0  0121   392 13         394		INC	DE
         0  0122   393 13         395		INC	DE
         0  0123   394 13         396		INC	DE
         0  0124   395 3e 41      397		LD	A,ZRCUNK
         0  0126   396 12         398		LD	(DE),A
         0  0127   397 59         399		LD	E,C
         0  0128   398 50         400		LD	D,B
         0  0129   399 cd 00 00   401		CALL	Z_SGNL
         0  012c   400 c3 28 00   402		JP	CLOC10

















rtzrtc.s                 Z_RTCK                                                ER     Tue Feb  7 17:03:10 1984
8

rtzrtc.s                 FRQUEU                                                ER     Tue Feb  7 17:03:10 1984
9

                   401            404	;=======
                   402            405	; FRQUEU - REMOVE MESSAGE FROM Z$RTQU OR Z$RTDQ
                   403            406	;
                   404            407	; ACCEPTS: HL = ^QUEUE-HEAD
                   405            408	;          IX = ^ITEM TO BE REMOVED (1ST IN QUEUE)
                   406            409	;=======
                   407            410	 
                   408            411	FRQUEU
         0  012f   409 dd 5e 00   412		LD	E,(IX+0)		;DE:=^QUEUE.2ND
         0  0132   410 dd 56 01   413		LD	D,(IX+1)
         0  0135   411 73         414		LD	(HL),E		;MAKE IT 1ST
         0  0136   412 23         415		INC	HL
         0  0137   413 72         416		LD	(HL),D
         0  0138   414 dd 5e 06   417		LD	E,(IX+MSGRSM)	;DE:=^RESPONSE SEMAPHORE
         0  013b   415 dd 56 07   418		LD	D,(IX+MSGRSM+1)
         0  013e   416 dd e5      419		PUSH	IX			;HL:=^MESSAGE
         0  0140   417 e1         420		POP	HL
         0  0141   418 c3 00 00   421		JP	Z_SGNL
                   419            422	 
                   420            423	;=======
                   421            424	; TORTQU - LINK TO Z$RTQU
                   422            425	;
                   423            426	; ACCEPTS: BC = ^ITEM TO BE LINKED
                   424            427	;=======
                   425            428	 
                   426            429	TORTQU
         0  0144   427 c5         430		PUSH	BC			;IY:=^ITEM TO BE LINKED
         0  0145   428 fd e1      431		POP	IY
         0  0147   429 21 06 00   432		LD	HL,Z_SECS+Z$RTQU;HL:=^RTQU.HEAD
         0  014a   430 ed 5b 06   433		LD	DE,(Z_SECS+Z$RTQU);DE:=^RTQU.1ST
                                             00      
                   431            434	TORT10
         0  014e   432 d5         435		PUSH	DE			;IX:=^RTQU.NEXT
         0  014f   433 dd e1      436		POP	IX
         0  0151   434 7b         437		LD	A,E			;RTQU ENDED ?
         0  0152   435 b2         438		OR	D
         0  0153   436 28 10      439		JR	Z,INSERT		;YES
         0  0155   437 cd 26 02   440		CALL	CPTIMS		;NEW.HOUR < CUR.HOUR ?
         0  0158   438 38 0b      441		JR	C,INSERT		;YES, INSERT
         0  015a   439 dd 5e 00   442		LD	E,(IX+0)		;DE:=^RTQU.NEXT
         0  015d   440 dd 56 01   443		LD	D,(IX+1)
         0  0160   441 dd e5      444		PUSH	IX			;HL:=^RTQU.OLD
         0  0162   442 e1         445		POP	HL
         0  0163   443 18 e9      446		JR	TORT10
                   444            447	INSERT
         0  0165   445 71         448		LD	(HL),C		;(HL) --> (BC)
         0  0166   446 23         449		INC	HL
         0  0167   447 70         450		LD	(HL),B
         0  0168   448 69         451		LD	L,C			;(BC) --> (IX)
         0  0169   449 60         452		LD	H,B
         0  016a   450 dd e5      453		PUSH	IX
         0  016c   451 c1         454		POP	BC
         0  016d   452 71         455		LD	(HL),C
         0  016e   453 23         456		INC	HL
         0  016f   454 70         457		LD	(HL),B
         0  0170   455 c9         458		RET



rtzrtc.s                 FRQUEU                                                ER     Tue Feb  7 17:03:10 1984
9

rtzrtc.s                 TORTDQ                                                ER     Tue Feb  7 17:03:10 1984
10

                   456            460	;=======
                   457            461	; TORTDQ - LINK TO Z$RTDQ
                   458            462	;
                   459            463	; ACCEPTS: BC = ^REQUEST-MESSAGE (TO BE LINKED)
                   460            464	;=======
                   461            465	 
                   462            466	TORTDQ
         0  0171   463 21 00 00   467		LD	HL,0			;CLEAR Z$ACTT
         0  0174   464 22 1b 00   468		LD	(Z_SECS+Z$ACTT),HL
         0  0177   465 22 1c 00   469		LD	(Z_SECS+Z$ACTT+1),HL
         0  017a   466 dd 21 08   470		LD	IX,Z_SECS+Z$RTDQ;IX := ^HEAD OF DELAY-QUEUE
                                             00      
         0  017e   467 18 31      471		JR	TODQ15
                   468            472	TODQ10
         0  0180   469 e5         473		PUSH	HL			;IX:=^DQUE.CUR
         0  0181   470 dd e1      474		POP	IX
         0  0183   471 7d         475		LD	A,L			;CHECK IF ANY ITEM LEFT
         0  0184   472 b4         476		OR	H
         0  0185   473 28 4d      477		JR	Z,TODQ50		;NO ITEM LEFT, LINK !
         0  0187   474 21 1b 00   478		LD	HL,Z_SECS+Z$ACTT;Z$ACTT := Z$ACTT + IX^.TIME
         0  018a   475 dd 7e 08   479		LD	A,(IX+MSGSEC)
         0  018d   476 a7         480		AND	A
         0  018e   477 cd 10 02   481		CALL	ADDDIG
         0  0191   478 dd 7e 09   482		LD	A,(IX+MSGMIN)
         0  0194   479 cd 10 02   483		CALL	ADDDIG
         0  0197   480 dd 7e 0a   484		LD	A,(IX+MSGHRS)
         0  019a   481 cd 10 02   485		CALL	ADDDIG
         0  019d   482 fd e5      486		PUSH	IY			;SAVE IX & IY
         0  019f   483 dd e5      487		PUSH	IX
         0  01a1   484 fd 21 13   488		LD	IY,Z_SECS+Z$ACTT-MSGSEC
                                             00      
         0  01a5   485 c5         489		PUSH	BC			; Compare Z$ACTT - ITEM.TIME
         0  01a6   486 dd e1      490		POP	IX
         0  01a8   487 cd 26 02   491		CALL	CPTIMS
         0  01ab   488 dd e1      492		POP	IX
         0  01ad   489 fd e1      493		POP	IY
         0  01af   490 30 19      494		JR	NC,TODQ30		;INSERT IF Z$ACTM >= ITEM.TIME
                   491            495	TODQ15:
         0  01b1   492 11 18 00   496		LD	DE,Z_SECS+Z$ACTM;UPDATE ACCUMULATED DELAY
         0  01b4   493 21 1b 00   497		LD	HL,Z_SECS+Z$ACTT
         0  01b7   494 c5         498		PUSH	BC
         0  01b8   495 01 03 00   499		LD	BC,3
         0  01bb   496 ed b0      500		LDIR
         0  01bd   497 c1         501		POP	BC
         0  01be   498 dd e5      502		PUSH	IX			;IY:=^PREDECESSOR TO ITEM TO --
         0  01c0   499 fd e1      503		POP	IY			;  BE LINKED
         0  01c2   500 dd 6e 00   504		LD	L,(IX+0)		;HL:=^NEXT ITEM IN Z$RTDQ
         0  01c5   501 dd 66 01   505		LD	H,(IX+1)
         0  01c8   502 18 b6      506		JR	TODQ10
                   503            507	TODQ30
         0  01ca   504 11 1b 00   508		LD	DE,Z_SECS+Z$ACTT;SET UP FOR  SUBTIM
         0  01cd   505 21 08 00   509		LD	HL,MSGSEC
         0  01d0   506 09         510		ADD	HL,BC
         0  01d1   507 cd ed 01   511		CALL	SUBTIM		;IX^.TIME:=Z$ACTM-ITEM.TIME
                   508            512	TODQ50
         0  01d4   509 fd 71 00   513		LD	(IY+0),C		;FIX ^INSERTED ITEM
         0  01d7   510 fd 70 01   514		LD	(IY+1),B
         0  01da   511 69         515		LD	L,C			;FIX ^SUCCESSOR

rtzrtc.s                 TORTDQ                                                ER     Tue Feb  7 17:03:10 1984
10

rtzrtc.s                 TORTDQ                                                ER     Tue Feb  7 17:03:10 1984
11

         0  01db   512 60         516		LD	H,B
         0  01dc   513 dd e5      517		PUSH	IX
         0  01de   514 d1         518		POP	DE
         0  01df   515 73         519		LD	(HL),E
         0  01e0   516 23         520		INC	HL
         0  01e1   517 72         521		LD	(HL),D
         0  01e2   518 21 08 00   522		LD	HL,MSGSEC		;SET UP FOR SUBTIM
         0  01e5   519 09         523		ADD	HL,BC
         0  01e6   520 eb         524		EX	DE,HL
         0  01e7   521 21 18 00   525		LD	HL,Z_SECS+Z$ACTM
         0  01ea   522 c5         526		PUSH	BC
         0  01eb   523 dd e1      527		POP	IX















































rtzrtc.s                 TORTDQ                                                ER     Tue Feb  7 17:03:10 1984
11

rtzrtc.s                 SUBTIM                                                ER     Tue Feb  7 17:03:10 1984
12

                   524            529	;=======
                   525            530	; SUBTIM - SUBTRACT TIMES
                   526            531	;
                   527            532	; Accepts: DE = ^SUBTRACTOR
                   528            533	;          HL = ^SUBTRAHEND
                   529            534	;          IX = ^DIFFERENCE-SEC (SEC=8)
                   530            535	;
                   531            536	; Affects: A,F,DE,HL
                   532            537	;=======
                   533            538	 
                   534            539	SUBTIM
         0  01ed   535 1a         540		LD	A,(DE)
         0  01ee   536 96         541		SUB	(HL)
         0  01ef   537 27         542		DAA
         0  01f0   538 30 02      543		JR	NC,SUBT10
         0  01f2   539 c6 c0      544		ADD	A,-40H
                   540            545	SUBT10
         0  01f4   541 dd 77 08   546		LD	(IX+MSGSEC),A
         0  01f7   542 13         547		INC	DE
         0  01f8   543 23         548		INC	HL
         0  01f9   544 1a         549		LD	A,(DE)
         0  01fa   545 9e         550		SBC	A,(HL)
         0  01fb   546 27         551		DAA
         0  01fc   547 30 02      552		JR	NC,SUBT20
         0  01fe   548 c6 c0      553		ADD	A,-40H
                   549            554	SUBT20:
         0  0200   550 dd 77 09   555		LD	(IX+MSGMIN),A
         0  0203   551 13         556		INC	DE
         0  0204   552 23         557		INC	HL
         0  0205   553 1a         558		LD	A,(DE)
         0  0206   554 9e         559		SBC	A,(HL)
         0  0207   555 27         560		DAA
         0  0208   556 30 02      561		JR	NC,SUBT30
         0  020a   557 c6 8a      562		ADD	A,-76H
                   558            563	SUBT30
         0  020c   559 dd 77 0a   564		LD	(IX+MSGHRS),A
         0  020f   560 c9         565		RET
                   561            566	 
                   562            567	;-------
                   563            568	; ADDDIG - add part of time
                   564            569	;-------
                   565            570	 
                   566            571	ADDDIG:
         0  0210   567 8e         572		ADC	A,(HL)
         0  0211   568 27         573		DAA
         0  0212   569 38 07      574		JR	C,ADDD10
         0  0214   570 fe 60      575		CP	60H
         0  0216   571 30 03      576		JR	NC,ADDD10
         0  0218   572 a7         577		AND	A
         0  0219   573 18 04      578		JR	ADDD20
                   574            579	ADDD10:
         0  021b   575 c6 40      580		ADD	A,40H
         0  021d   576 27         581		DAA
         0  021e   577 37         582		SCF
                   578            583	ADDD20:
         0  021f   579 77         584		LD	(HL),A
         0  0220   580 23         585		INC	HL
         0  0221   581 c9         586		RET

rtzrtc.s                 SUBTIM                                                ER     Tue Feb  7 17:03:10 1984
12

rtzrtc.s                 SUBTIM                                                ER     Tue Feb  7 17:03:10 1984
13

                   582            587	 
                   583            588	;=======
                   584            589	; CPTIME - COMPARE WITH TIME
                   585            590	; CPTIMS - COMPARE TIMES
                   586            591	;
                   587            592	; ACCEPTS: IX = ^RTCK-MESSAGE
                   588            593	;          IY = ^RTCK-MESSAGE (CPTIMS ONLY)
                   589            594	;=======
                   590            595	 
                   591            596	CPTIME
         0  0222   592 fd 21 fb   597		LD	IY,Z_SECS-MSGSEC
                                             ff      
                   593            598	CPTIMS
         0  0226   594 fd 7e 0a   599		LD	A,(IY+MSGHRS)	;A:=HOUR
         0  0229   595 dd be 0a   600		CP	(IX+MSGHRS)	;DIFFERENCE IN HOURS ?
         0  022c   596 c0         601		RET	NZ			;YES
         0  022d   597 fd 7e 09   602		LD	A,(IY+MSGMIN)	;A:=MINUTE
         0  0230   598 dd be 09   603		CP	(IX+MSGMIN)	;DIFFERENCE IN MINUTES ?
         0  0233   599 c0         604		RET	NZ			;YES
         0  0234   600 fd 7e 08   605		LD	A,(IY+MSGSEC)	;A:=SECOND
         0  0237   601 dd be 08   606		CP	(IX+MSGSEC)
         0  023a   602 c9         607		RET
                   603            608	 
                   604            609	;=======
                   605            610	; CLOCUP - UPDATE HL^ OF CLOCK
                   606            611	;=======
                   607            612	 
                   608            613	CLOCUP
         0  023b   609 36 00      614		LD	(HL),0		;CLEAR HL^
         0  023d   610 23         615		INC	HL			;HL:=^NEXT TIME-UNIT
         0  023e   611 7e         616		LD	A,(HL)
         0  023f   612 c6 01      617		ADD	A,1			;ONE MORE TICK
         0  0241   613 27         618		DAA
         0  0242   614 77         619		LD	(HL),A
         0  0243   615 fe 60      620		CP	60H
         0  0245   616 c9         621		RET
                   617            622	 
                   618            623	;-------
                   619            624	; JPHL - CALL (HL)
                   620            625	;-------
                   621            626	 
                   622            627	JPHL
         0  0246   623 e9         628		JP	(HL)
                   624            629	 
                   625            630	;-------
                   626            631	; CONSTANT
                   627            632	;-------
                   628            633	 
                   629            634	ONESEC
         0  0247   630 01         635		DEFB	1
         0  0248   631 00 00      636		DEFW	0
                   632            637	 
                   633            638	 
                   634            639	;=======
                   635            640	; Z_RCBF - BUFFER-PROCESS FOR KEEPING PACE WITH TIME
                   636            641	;=======
                   637            642	 
                   638            643	Z_RCBF

rtzrtc.s                 SUBTIM                                                ER     Tue Feb  7 17:03:10 1984
13

rtzrtc.s                 SUBTIM                                                ER     Tue Feb  7 17:03:10 1984
14

         0  024a   639 11 0c 00   644		LD	DE,Z_SECS+Z$TISM;WAIT FOR TICK
         0  024d   640 2a 00 00   645		LD	HL,(Z_RTCP)	;get RTC prescaler
         0  0250   641 cd 00 00   646		CALL	Z_WAIT
         0  0253   642 11 12 00   647		LD	DE,Z_SECS+Z$CBSM;TRIGG RT-CLOCK
         0  0256   643 21 0a 00   648		LD	HL,Z_SECS+Z$TKMG
         0  0259   644 cd 00 00   649		CALL	Z_SGNL
         0  025c   645 18 ec      650		JR	Z_RCBF
                   646            651	 
                   647            652	IPCBCB
         0  025e   648 5a 5f      653		text	'Z_RCBF'
         0  0260       52 43   
         0  0262       42 46   
         0  0264   649 4a 02      654		DEFW	Z_RCBF
         0  0266   650 28 00      655		DEFW	40
         0  0268   651 01         656		DEFB	1
                   652            657	 











































rtzrtc.s                 SUBTIM                                                ER     Tue Feb  7 17:03:10 1984
14

rtzrtc.s                 RTZ.RTC.RAM                                           ER     Tue Feb  7 17:03:10 1984
15

                   653            659	;Updated: 830921 / PH
                   654            660	;Created: <810624 / Peter Holmgren, DIGITAILOR AB
                   655            661	 
                   656            662	;=======
                   657            663	; RAM-area for RTZ-utilty RTZ.RTC
                   658            664	;
                   659            665	; RTC 2.02: Released 830921
                   660            666	;           Lots of globals replaced by equates
                   661            667	;=======
                   662            668	 
                   663            669		begin	1
                   664            670		global	Z_CKUP,Z_SECS
                   665            671	 
         1  0000   666            672	Z_CKUP	DEFS	2		;ENTRY FOR CLOCK DISPLAY
         1  0002   667            673	PRSC	DEFS	1		;RT-CLOCK
         1  0003   668            674	Z_SECS	DEFS	3
         1  0006   669            675	RTQU	DEFS	2		;HEAD OF TIME-QUEUE
         1  0008   670            676	RTDQ	DEFS	2		;HEAD OF DELAY-QUEUE
                   671            677	 
                   672            678	; Up to here is cleared before start
                   673            679	 
         1  000a   674            680	TKMG	DEFS	2		;tick (0.2 s) message
         1  000c   675            681	TISM	DEFS	6		;pretick semaphore
         1  0012   676            682	CBSM	DEFS	6		;tick (0.2 s) semaphore
                   677            683	 
         1  0018   678            684	ACTM	DEFS	3		;help for "tortdq"
         1  001b   679            685	ACTT	DEFS	3
                   680            686	 
         1  001e   681            687		end





the number of errors detected in this assembly is 0
























rtzrtc.s                 RTZ.RTC.RAM                                           ER     Tue Feb  7 17:03:10 1984
15
